-- MISSION SPECIFIC

function missionMenuItems ( input )

	if input.choice == gMissionOptions.sayThis["English"].menu_items.startMission then
		createRunningMission ( input ) 
		loadFriendlySorties ( input )
		loadEnemyPositions ( input )
		determinePlayers ( input )
		doRadioCommand (input) 
		sayMissionPlan ( input )
		--if Debugging == true then printDebug ("EventHandler" ,"Mission Menu Item"  , 10 ) end 
	end 
	
	if input.choice == gMissionOptions.sayThis["English"].menu_items.options then
		doOptions ( input )
	end 
	
end

function loadMissionLanguages ()
	local myNameEnglish = "Thunderbolts Over the Pacific"
	local myNameSpanish = "Rayos Sobre el Pacifico"
	
	gMissionOptions.sayThis["English"].welcome = "Welcome to " .. myNameEnglish .. " mission version  " .. gMissionOptions.Version  -- .. "\n" 
	gMissionOptions.sayThis["English"].mission_lead_to = "I will lead you to objective"
	gMissionOptions.sayThis["English"].mission_targets_moving = "The submarine is preparing to dive."
	gMissionOptions.sayThis["English"].mission_targets_damaged = "The submarine is too damaged and cannot dive "
	gMissionOptions.sayThis["English"].mission_damage_dove = "The submarine has taken damage and tried to dive"
	gMissionOptions.sayThis["English"].mission_evaded = "The submarine has dived and evaded our attack"
	gMissionOptions.sayThis["English"].mission_target_destroyed = "The submarine has been destroyed"
	
	gMissionOptions.sayThis["Spanish"].welcome = "Bienvenido a " .. myNameSpanish .. " versión " .. gMissionOptions.Version  --- .. "\n" 
	gMissionOptions.sayThis["Spanish"].mission_lead_to = "Te llevaré al objetivo"
	gMissionOptions.sayThis["Spanish"].mission_targets_moving = "El submarino se prepara para bucear"
	gMissionOptions.sayThis["Spanish"].mission_targets_damaged = "El submarino está demasiado dañado y no puede sumergirse"
	gMissionOptions.sayThis["Spanish"].mission_damage_dove = "El submarino ha sufrido daños e intentó sumergirse"
	gMissionOptions.sayThis["Spanish"].mission_evaded = "El submarino se ha sumergido y evadido nuestro ataque"
	gMissionOptions.sayThis["Spanish"].mission_target_destroyed = "El submarino es destruido"
	

	
end 

-- CREATING THE MISSION
function createRunningMission ( input ) 
--	local myDistance = math.random(10,15) * MILES_TO_METERS --20000 -- 11265

	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 5 , text=gMissionOptions.sayThis[input.language].gamepause })
	local myValidGroups = validPlayerGroups ()
	local myUnit = myValidGroups[input.group]:getUnit(1)
	input.unit = Unit.getName(myUnit)
	input.spawnPosition = centerUnitCoordinates ( input.unit )
	input.coalition = Group.getCoalition(myValidGroups[input.group])
	input.type = Unit.getTypeName(Unit.getByName ( input.unit ) )
	--input.tasks = {}
	--input.tasks[#input.tasks+1] = {["enabled"] = true,["auto"] = false,["id"] = "WrappedAction",["number"] = #input.tasks+1,["params"] = {["action"] = {["id"] = "Option",["params"] = {["name"] = 0 ,["value"] = AI.Option.Ground.val.ROE.OPEN_FIRE,},},}}

	local mySides = getOppositeSide ( {group=input.group} )
	local myRatio = 3
	local myFirstAngle =  math.random(1,6)
	
	if myUnit:inAir() then
		local myHeading = doGetUnitHeading ({name=input.unit}) 
		local myRandom = {[1]=.5 , [2]=1 , [3]=1.4 , [4]=0, [5]=-.5 , [6]=-1 , [7]=-1.5 }
		local myRandomChoice = myRandom[math.random(1,#myRandom)]
		myFirstAngle = myHeading.angle + myRandomChoice
		--if Debugging == true then printDebug ("EventHandler" , "Random " .. myRandomChoice , 10 ) end
	end 

	local mySecondAngle = myFirstAngle + ((math.pi/myRatio) * math.random(-1,1))
	local myThirdAngle = myFirstAngle + ((math.pi/myRatio) * math.random(-1,1))
	-- local mySecondAngle = myStartingAngle
	
	local myDistance = math.random(gMissionOptions.flightDistance[gPlayerGroups[input.group].preferences.flight_distance],gMissionOptions.flightDistance[gPlayerGroups[input.group].preferences.flight_distance]+7)
	local myUnitDesc = Unit.getDescByName(input.type)
	input.visualRange = gMissionOptions.visualRange
	if myUnitDesc.category == Group.Category.HELICOPTER then  
		myDistance = myDistance /2 
		input.visualRange = input.visualRange / 2
	end 
	
	if Debugging == true then printDebug ("EventHandler" , "Distance " .. myDistance  , 10 ) end
	local myPostion1 = getPointOnRadian ( { radius=myDistance , pos=input.spawnPosition , angle = myFirstAngle})
	local myPostion2 = getPointOnRadian ( { radius=myDistance , pos=myPostion1 , angle = mySecondAngle })
	local myPostion3 = getPointOnRadian ( { radius=myDistance , pos=myPostion2 , angle = myThirdAngle })
	
	-- local myPostion2 = centerZoneCoordinates ( gMissionOptions.myZone1 )
	-- local myPostion3 = centerZoneCoordinates ( gMissionOptions.myZone2 )
	
	local myAirport = findClosestAirbase ({position=input.spawnPosition ,coalition=mySides.friendlycoa })
	
	gMissionOptions.runningMissions[input.group] = { 
														group = input.group , 
														description="My Desc" , 
														position=myPostion1, 
														airbaseName=myAirport.name, 
														airbase=myAirport.id, 
														tasks={} , 
														sorties={} ,
														following=true ,
														friendlyGroups={} , 
														enemyGroups={},
														groupsHolding={} ,													
														enemyCoalition=mySides.enemycoa, 
														friendlyCoalition=mySides.friendlycoa,
														coalition=mySides.friendlycoa,
														followGroups = {} , 
														enterservice=gPlayerGroups[input.group].enterservice , 
														retired=gPlayerGroups[input.group].retired ,
														straightLevelTimer=timer.getTime() ,
														startTime = timer.getTime() ,
													
		areas= { 
				[1] = { group=input.group, position=myPostion1 , radius=input.visualRange , zoneAction=gMissionOptions.combatZones.Zone1 , alerted=false , holdingAlt=gMissionOptions.transitionAlt } ,
				[2] = { group=input.group, position=myPostion2 , radius=input.visualRange , zoneAction=gMissionOptions.combatZones.Zone2 , alerted=false , holdingAlt=gMissionOptions.transitionAlt } ,
				[3] = { group=input.group, position=myPostion3 , radius=input.visualRange , zoneAction=gMissionOptions.combatZones.Zone3 , alerted=false , holdingAlt=gMissionOptions.transitionAlt } ,
				[4] = { group=input.group, position=myAirport.point , radius=gMissionOptions.visualRange , zoneAction=gMissionOptions.combatZones.RTB , alerted=false , holdingAlt=gMissionOptions.transitionAlt } ,
			}
	}
	
	gMissionOptions.runningMissions[input.group].areas[1].activated = true --ACTIVATE THE FIRST AREA OR ZONE TO MOVE TOWARDS
	gMissionOptions.runningMissions[input.group].activeArea = 1 -- HOLD ON TO THE FIRST ACTGIVE AREA
	-- local ref = trigger.misc.getZone(gMissionOptions.myZone1)
	-- trigger.action.circleToAll(-1 , 1, ref.point , 10000 , {0, 0, 0, .10 } , {1, 0, 1, .10 } , 0 , true , "My Target Area" )
end

function loadFriendlySorties ( input )
	local mySeparation = 700
	local mySides = getOppositeSide ( { group=input.group} )
	local myPlayers = validPlayerGroups ( input )
	local myPlayerUnit = myPlayers[input.group]:getUnit(1)
	local myPlayerType = Unit.getTypeName(myPlayerUnit) 
	local myPlayerKey = string.upper(myPlayerType:gsub('[%p%c%s]', '') )
	

	gMissionOptions.runningMissions[input.group].tempTransitionAlt = gMissionOptions.transitionAlt  -- if spawning player is airborne 
	local myUnitDesc = Unit.getDescByName(myPlayerType)
	if myUnitDesc.category == Group.Category.HELICOPTER then gMissionOptions.runningMissions[input.group].tempTransitionAlt = gMissionOptions.transitionAltRotary end 
	gMissionOptions.friendlySortie = {}
	
	-- GET WAYPOINTS COMMENT ALL OUT TO FLY TO NEAREST ENEMY AIRPORT
	local myWaypoints = {}
	-- for waypointKey , waypointValue in ipairs(gMissionOptions.runningMissions[input.group].areas) do
		-- myWaypoints[#myWaypoints+1] = { action = "Fly Over Point" , pos=waypointValue.position }
		-- if Debugging == true then printDebug ("EventHandler" , "Spawn group flies to " .. waypointValue.zoneAction  , 10 ) end
		
	-- end

	myWaypoints[#myWaypoints+1] = { action = "Fly Over Point" , pos=gMissionOptions.runningMissions[input.group].position }

	local myAircraftType = {}
	-- myAircraftType.type = AircraftType.P47D40.type
	-- myAircraftType.pylons = AircraftType.P47D40.gpylons
	-- myAircraftType.livery = AircraftType.P47D40.blivery
	myAircraftType.type = Targets[myPlayerKey].type
	myAircraftType.pylons = Targets[myPlayerKey].gpylons
	myAircraftType.livery = Targets[myPlayerKey].blivery
	
	if myPlayerType == AircraftType.TF51D.type then 
		myAircraftType.type = AircraftType.P47D40.type
		myAircraftType.pylons = AircraftType.P47D40.gpylons
		myAircraftType.livery = AircraftType.P47D40.blivery
	end 

	if 	(mySides.friendlycoa == coalition.side.RED)
	then
		myAircraftType.livery = Targets[myPlayerKey].rlivery
	end
	
	-- if mySides.friendlycoa == coalition.side.BLUE and Targets[myPlayerKey].retired <=1991 then
		-- -- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].type = AircraftType.AV8BNA.type
		-- -- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].pylons = AircraftType.AV8BNA.gpylons
		-- -- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].livery = AircraftType.AV8BNA.blivery
		-- myAircraftType.type = myPlayerType
		-- myAircraftType.pylons = Targets[myPlayerKey].gpylons
		-- myAircraftType.livery = Targets[myPlayerKey].rlivery
	-- end
	
	-- if Targets[myPlayerKey].retired <=1991 or Targets[myPlayerKey].wing == "rotary" then -- IF THE PLAYER THAT SELECTS FLYING NON-HARM EQUIPED AIRCRAFT
		-- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].type = myPlayerType
		-- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].pylons = Targets[myPlayerKey].gpylons
		-- gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].livery = Targets[myPlayerKey].blivery
	-- --	gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].targetTypes = {[1] = "AAA", }  -- SWITCH THE TARGET TYPES TO ANY AIRDEFENCE
	-- end 
	
	
	----------------------------------------------------------------
	--	EXAMPLE GROUP 1 ( A SPECIFIED TYPE OF AIRCRAFT )
	----------------------------------------------------------------
	gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie+1] = {
	group = input.group , 
	groupName = gMissionOptions.friendlyGroups.F1 , -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
	groupCount = gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
	unitCount = gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
	unitDistance = 10 , -- DISTANCE BETWEEN UNITS WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
	groupDistance = 10 , --100 -- DISTANCE BETWEEN GROUPS WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
	speedmodifier = 1 , -- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
	formation = gFormationType.WWIIFighterTight ,  -- WHAT KIND OF FORMATION DO YOU WANT WWIIFighterTight FingerFourClose AbreastClose
	targetTypes = {[1] = "Ships" , [2]="All" , } ,
	--targetTypes = {[1] = "Ships" , [2] = "AAA" , [3]="Unarmed vehicles" , } , -- TARGETS THIS GROUP IS ALLOWED TO ATTACK IN PRECIDENCE
	-- targetTypes = { [1] = "AAA" , [2]="Unarmed vehicles" , [3]="All" } , -- TARGETS THIS GROUP IS ALLOWED TO ATTACK IN PRECIDENCE
	noTargetTypes = {} , --{[1] = "Tanks", [2] = "Armored vehicles", [3]="Modern Tanks"} , --WHAT TARGETS THEY CANNOT ATTACK
	task = "SEAD" , -- DCS TASK TYPES IE "AFAC" "SEAD" , "HARM", "CAS" etc.  I think this is important but cannot recall what for
	altMod = 1 , -- IF YOU WANT TO MODIFY UP OR DOWN THE HORIZONTIAL SPAWN LOCATION  FOR AIRBORNE SPAWN DEFAULT IS PLUS 100 FEET
	callsign = 2 , -- 2 = SPRINGFIELD 4 = COLT 7 = CHEVY etc
	skill = gPlayerGroups[input.group].preferences.friendlySkill, -- Average Good High Excellent
	type = myAircraftType.type, -- AIRCRAFT TYPE
	pylons = myAircraftType.pylons, -- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
	livery = myAircraftType.livery , -- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
	sortie = gMissionOptions.friendlyGroups.F1, -- WHICH SORTIE IN LOCAL VARIABLES THIS MATCHES TO
	}

	gMissionOptions.runningMissions[input.group].sorties[gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].sortie] = {  }
	
	----------------------------------------------------------------
	--	EXAMPLE GROUP 2 ( SAME TYPE AS GROUP THAT CALLS THEM
	----------------------------------------------------------------
	gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie+1] = {
		group = input.group , 
		groupName = gMissionOptions.friendlyGroups.F2, -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
		groupCount = gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
		unitCount = gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
		unitDistance = 10 ,-- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
		groupDistance = 0 ,--100 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
		speedmodifier = 1 ,-- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
		--tasks = formation.WWIIFighterTight ,-- formation always comes first in task list or will crash game
		formation = gFormationType.WWIIFighterTight , 
		targetTypes = {[1] = "Ships" , [2]="All" , } ,
		--targetTypes = {[1] = "Ships" , [2] = "Unarmed vehicles" , [3]="All" ,  } ,
		-- targetTypes = { [1] = "AAA" , [2]="Unarmed vehicles" , [3]="All" } , -- TARGETS THIS GROUP IS ALLOWED TO ATTACK IN PRECIDENCE
		noTargetTypes = { [1] = "SAM SR"}, -- {[1] = "SAM SR", [2] = "SAM TR", [3] = "EWR", [4] = "AAA",} ,
		task = "Ground Attack" ,
		altMod = 50 , -- IF YOU WANT TO MODIFY UP OR DOWN THE HORIZONTIAL SPAWN LOCATION  FOR AIRBORNE SPAWN DEFAULT IS PLUS 100 FEET
		callsign = 4 , -- COLT
		skill = gPlayerGroups[input.group].preferences.friendlySkill , -- Average Good High Excellent
		type = myAircraftType.type  , -- myPlayerType , -- myPlayerType THIS TYPE MATCHES THE PLAYER TYPE THAT SPAWNED IT
		livery = myAircraftType.livery ,-- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
		pylons = myAircraftType.pylons ,-- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
		sortie = gMissionOptions.friendlyGroups.F2,
	}

	gMissionOptions.runningMissions[input.group].sorties[gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].sortie] = {  }

	
	----------------------------------------------------------------
	--	EXAMPLE GROUP 3 ( SAME TYPE AS GROUP THAT CALLS THEM
	----------------------------------------------------------------
	gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie+1] = {
		group = input.group , 
		groupName = gMissionOptions.friendlyGroups.F3, -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
		groupCount = gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
		unitCount = gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
		unitDistance = 10 ,-- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
		groupDistance = 0 ,--100 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
		speedmodifier = 1 ,-- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
		--tasks = formation.WWIIFighterTight ,-- formation always comes first in task list or will crash game
		formation = gFormationType.WWIIFighterTight , 
		targetTypes = {[1] = "Ships" , [2]="All" , } ,
		--targetTypes = {[1] = "Ships" , [2] = "AAA" , [3]="All" , } ,
		--targetTypes = { [1] = "AAA" , [2]="Unarmed vehicles" , [3]="All" } , -- TARGETS THIS GROUP IS ALLOWED TO ATTACK IN PRECIDENCE
		noTargetTypes = {}, -- {[1] = "SAM SR", [2] = "SAM TR", [3] = "EWR", [4] = "AAA",} ,
		task = "Ground Attack" ,
		altMod = 50 , -- IF YOU WANT TO MODIFY UP OR DOWN THE HORIZONTIAL SPAWN LOCATION  FOR AIRBORNE SPAWN DEFAULT IS PLUS 100 FEET
		callsign = 4 , -- COLT
		skill = gPlayerGroups[input.group].preferences.friendlySkill , -- Average Good High Excellent
		type =  myAircraftType.type , -- myPlayerType THIS TYPE MATCHES THE PLAYER TYPE THAT SPAWNED IT
		livery = myAircraftType.livery ,-- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
		pylons = myAircraftType.pylons,-- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
		sortie = gMissionOptions.friendlyGroups.F3,
	}

	gMissionOptions.runningMissions[input.group].sorties[gMissionOptions.friendlySortie[#gMissionOptions.friendlySortie].sortie] = {  }
	
	-- DO TO ALL SORTIES
	-- local myLeaderDistance = 
	
	-- table.insert(a, 1, 15)
	if myWaypoints ~= nil and Unit.inAir(myPlayerUnit) then
		local myTurnDistance = #gMissionOptions.friendlySortie *mySeparation + 200
		local myTurnPosition  = getPointOnRadian ( { radius=myTurnDistance , pos=input.spawnPosition , angle = input.heading.angle })
		local myWaypoint = { action = "Fly Over Point" , pos=myTurnPosition }
		table.insert(myWaypoints, 1, myWaypoint)
	end
	for count = 1, #gMissionOptions.friendlySortie do	
		gMissionOptions.friendlySortie[count].spawnDistance = ((#gMissionOptions.friendlySortie)*mySeparation) - ((count-1) * mySeparation)
		if myWaypoints ~= nil then
			gMissionOptions.friendlySortie[count].waypoints = myWaypoints
			--if Debugging == true then printDebug ("EventHandler" , "Put in waypoints " ..  gMissionOptions.friendlySortie[count].type , 10 ) end
		end 
	
		gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie] = {}
		--gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].savedTargets = { }
		gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].targets = { }
		gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].noTargets = { }
		for targetKey, targetValue in ipairs (gMissionOptions.friendlySortie[count].targetTypes) do
			--gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].savedTargets[targetKey] = targetValue
			gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].targets[targetKey] = targetValue
		end 
		for targetKey, targetValue in ipairs (gMissionOptions.friendlySortie[count].noTargetTypes) do
			gMissionOptions.runningMissions[input.group].tasks[gMissionOptions.friendlySortie[count].sortie].noTargets[targetKey] = targetValue
		end 
	end 
	
	 -- if gMissionOptions.runningMissions ~= nil then 
	 -- for missionKey, missionValue in pairs (gMissionOptions.runningMissions) do
		-- for sortieKey, sortieValue in pairs (missionValue.tasks) do
			-- for tasksKey, tasksValue in pairs (sortieValue) do
				-- for targetsKey, targetsValue in pairs (tasksValue) do
					-- if Debugging == true then printDebug ("EventHandler" , "targetsKey " .. tasksKey .. " " .. targetsValue, 10 ) end
				-- end 
			-- end 
		-- end 
	 -- end
 -- end

end 

function loadEnemyPositions ( input )
	local myValidGroups = validPlayerGroups ()
	-- input.unit = Unit.getName( myValidGroups[input.group]:getUnit(1)  )
	-- input.spawnPosition = centerUnitCoordinates ( input.unit )
	-- input.coalition = Group.getCoalition(myValidGroups[input.group])
	-- input.type = Unit.getTypeName(Unit.getByName ( input.unit ) )
	--local mySurfaceTypes = {[1]="Land" , [2]="Water" } 
	local mySurfaceTypes = {[1]="Water" , } 
	local myRandomDistance = 2000
	local myPrecision = 2000 -- how big the water and land must be to decide on it
	local mySpeedModifier = 1 --.85
	--- DO ANY TARGET ADJUSTMENTS
	Targets.SCHNELLBOOTTYPES130.retired = 2050
	Targets.USSSAMUELCHASE.retired = 2050
	Targets.UBOATVIIC.retired = 2050
	
	-- CALULATE ANY DIFFICULTY
	local myDifficulty = gPlayerGroups[input.group].preferences.difficulty
	local myUnitCount = 1
	local myGroupCount  = 1
	local myGroupDistance = 1
	local myUnitDistance = 1
	local myROE = AI.Option.Naval.val.ROE.OPEN_FIRE
	if myDifficulty == 1 then myROE = AI.Option.Naval.val.ROE.WEAPON_HOLD end 
	if myDifficulty > 4 then 
		myGroupCount = 2
		myGroupDistance = 100
		myUnitDistance = 1
	end
	--if myDifficulty == 3 or myDifficulty == 5  then myUnitCount = 2 end
	--if Debugging == true then printDebug ("EventHandler" , "Difficulty " .. myDifficulty , 10 ) end
	--local myTargetDifficulty = { [1]=MissionCombat.SMALLBOAT.category,[2]=MissionCombat.SUBMARINE.category,[3]=MissionCombat.FASTATTACK.category,[4]=MissionCombat.CARGOSHIP.category,[5]=MissionCombat.CARGOSHIP.category, }
	--local myTargetDifficulty = { [1]=MissionCombat.SMALLBOAT.category,[2]=MissionCombat.SUBMARINE.category,[3]=MissionCombat.FASTATTACK.category ,[4]=MissionCombat.CARGOSHIP.category,[5]=MissionCombat.CARGOSHIP.category,}
	local myTargetDifficulty = { [1]=MissionCombat.SUBMARINE.category,[2]=MissionCombat.SUBMARINE.category,[3]=MissionCombat.SUBMARINE.category ,[4]=MissionCombat.SUBMARINE.category,[5]=MissionCombat.SUBMARINE.category,}
	
	local myTargetFound = getTarget ( { group=input.group , category=myTargetDifficulty[myDifficulty] , accurate=true, assetpack=gMissionOptions.WWIIassets  } ) --all=true returns all vs one.  samecountry=true returns same country as unit that called this
	if myTargetFound ~= nil then 
		-- for targetKey, targetValue in pairs (myTargetFound) do
			-- if targetKey == "type" then 
				-- --if Debugging == true then printDebug ("EventHandler" , "Correct Target Key " .. targetKey .. " " .. targetValue , 10 ) end
			-- end 
		-- end
	else -- THIS WOULD BE THE DEFAULT TO ALWAYS FIND SOMETHING
		myTargetFound = getTarget ( { group=input.group , category=myTargetDifficulty[myDifficulty] , accurate=false, assetpack=false , retired=2050} ) --all=true returns all vs one.  samecountry=true returns same country as unit that called this
		if Debugging == true then printDebug ("EventHandler" , "Default Target Key " .. myTargetFound.type  , 10 ) end
	end
	
	
	
	local myTargetOneSpawn = { 	type=myTargetFound.type , 
								radius= 1,  
								action="Off Road",
								groupName="E", 
								alt=-20,
								speed=myTargetFound.speed*mySpeedModifier, 
								group=input.group, 
								coalition=input.enemycoa, 
								spawncountry=input.enemycountryid, 
								unitCount=myUnitCount ,
								unitDistance=myUnitDistance ,
								groupCount=myGroupCount , 
								groupDistance=myGroupDistance,
								lateActivation=true ,
								}
	
	local myTasks = {}
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = myROE ,["name"] = AI.Option.Naval.id.ROE, },},} } --ENGAGEMENT RANGE MAX_RANGE  HALF_WAY_RMAX_NEZ
	--myTargetOneSpawn.tasks = { [1] = {["number"] = 1,["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Naval.val.WEAPON_HOLD ,["name"] = AI.Option.Naval.id.ROE, },},} } }  -- RULES OF ENGAGMENT
	myTargetOneSpawn.tasks = myTasks					
	--timer.scheduleFunction(delaySpawn, mySpawn , myDeployFriendlyTime )
	for i=1,#gMissionOptions.runningMissions[input.group].areas-1 do --LAST ONE SHOULD BE RTB SO MINUS ONE
		-- local myPoint = gMissionOptions.runningMissions[input.group].areas[i].position
		local myRandomAngle = {[1]=math.pi , [2]=math.pi/2 , [3]=(math.pi/2)*3 , [4]=0}
		local myPoint = getPointOnRadian ( { radius=myRandomDistance , pos=gMissionOptions.runningMissions[input.group].areas[i].position , angle=myRandomAngle[math.random(1,#myRandomAngle)]})
		
		gMissionOptions.runningMissions[input.group].areas[i].spawnGroups = {}
		local myStartingPosition = findMatchingSurfacePoints ( {position=myPoint ,surfacetypes=mySurfaceTypes, distance=myRandomDistance , samples=12, precision=myPrecision,  } ) --allpoints=true , unit=
		-- local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceTypes, distance=myRandomDistance , samples=12, precision=myPrecision,  } )
		local myEndingPosition = findMatchingSurfacePoints ( {position=myStartingPosition.position ,surfacetypes=mySurfaceTypes, distance=50 , samples=12, precision=myPrecision,  } )
		myTargetOneSpawn.spawnPosition = {x=myStartingPosition.position.x , z=myStartingPosition.position.z }
		--myTargetOneSpawn.moveToPosition = {x=myEndingPosition.position.x , z=myEndingPosition.position.z }
		myTargetOneSpawn.waypoints = {[1]={action="Off Road", pos={x=myEndingPosition.position.x , z=myEndingPosition.position.z },alt=0 , speed=myTargetOneSpawn.spawnPosition.speed, altType="BARO" ,}}	
		
		
		local myReturn = mySpawn ( myTargetOneSpawn  )
		gMissionOptions.runningMissions[input.group].enemyGroups[#gMissionOptions.runningMissions[input.group].enemyGroups+1] = myReturn --GETS ADDED TO ALL THE GROUPS

		for returnKey=1,#myReturn do
			gMissionOptions.runningMissions[input.group].areas[i].spawnGroups[returnKey] = {group=myReturn[returnKey].group , type=myReturn[returnKey].type }
			--if Debugging == true then printDebug ("EventHandler" , "Area " .. returnKey .. " " .. myReturn[returnKey].group  .. " type " .. myReturn[returnKey].type , 10 ) end
		end 
		--deReference (myStartingPosition)
	end 
	
	-- deReference ( input )
	-- myDrop = getTarget ( { group=myGroupName, category=MissionCombat.LTARMORED.category, samecountry=true, accurate=true , assetpack = gMissionOptions.WWIIassets  } )
	-- myDefense = getTarget ( { group=myGroupName, category=MissionCombat.LTARMORED.category, accurate=true , all=true, assetpack = gMissionOptions.WWIIassets  } )

end

function sayMissionPlan ( input )
	--if Debugging == true then printDebug ("EventHandler" , "Leader " .. gMissionOptions.runningMissions[input.group].followGroups[1].group , 10 ) end
	-- gMissionOptions.runningMissions[input.group].followGroups[1].group 
	local function myDelaySay ( input )
		input.sayThis.who = Unit.getName ( Group.getUnit( Group.getByName(gMissionOptions.runningMissions[input.sayThis.group].leader) , 1) )
		sayInMission (input.sayThis )
	end 
	local myUnitObject = Group.getByName(input.group):getUnit(1) 
	local myFirstDesc = gMissionOptions.runningMissions[input.group].areas[1].zoneAction
	if Object.inAir(myUnitObject) then 
		local myFirstArea = gMissionOptions.runningMissions[input.group].areas[1].position

		local myBearing = getBearingToPoint(input.unit , myFirstArea)
		
		local myDirection = PointLeftOrRight ( {unit=input.unit ,position=myFirstArea } )
		local mySpeed = getAirspeed ( input.unit )
		local myAppend = gMissionOptions.sayThis[input.language].continue .. " " .. myFirstDesc
		
		local myAngleToTarget = getAngleBetweenTwoPointsV2( centerUnitCoordinates ( input.unit ), myFirstArea) 
		local myHeading = doGetUnitHeading ({name=input.unit })
		local myHeadingDiff = math.abs( myAngleToTarget - myHeading.angle )
		local myWhatToSay = "turn"
		if myHeadingDiff < .25 then myWhatToSay = "fly"  myDirection = nil end 
		local mySayThis =  { what={[1]=myWhatToSay, [2]=myDirection, }  , group=input.group ,  speedAt=mySpeed, heading=myBearing, append=myAppend, duration=20 } 
		timer.scheduleFunction(myDelaySay, {sayThis=mySayThis}, timer.getTime() + 1 )   
		if Debugging == true then printDebug ("EventHandler" , "Difference " .. myHeadingDiff .. " " .. myWhatToSay, 10 ) end
	else
		local mySayThis =  { what={[1]="joinup", [2]="period",  [3]="mission_lead_to" }  , append=myFirstDesc, group=input.group , speedAt=myTaxiSpeed , duration=20 } 
		timer.scheduleFunction(myDelaySay, {sayThis=mySayThis}, timer.getTime() + 1 )   
	end
							
end 

-- TASKING 
function getTasking ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "Get tasking for Sortie " .. input.sortie   , 10 ) end
	--gMissionOptions.runningMissions[input.group].tasks[input.sortie].noTargetsRemain = nil --WE START OUT WITH AI THINKING THERE ARE TARGETS
	local myTargets = gMissionOptions.runningMissions[input.group].tasks[input.sortie].targets
	--local myTargets = {[1] = "All",}
	local myNotTargets = gMissionOptions.runningMissions[input.group].tasks[input.sortie].noTargets
	-- local myNotTargets = {}
	local myTargeting  = {}
	local myTasks = ""
	local myPriority = 0 
	for key , value in ipairs(myTargets) do
		myTasks = myTasks .. " " .. value 
		local myLocalTargets = { [1]=value , }
		myTargeting[#myTargeting+1] = {["number"] = #myTargeting+1 ,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes=myLocalTargets , noTargetTypes=myNotTargets, priority = myPriority , } }
		myPriority = myPriority + 1
	end 
	--if Debugging == true then printDebug ("EventHandler" , "Tasking for sortie " .. input.sortie  .. " " ..  myTasks , 10 ) end

	myTargeting[#myTargeting+1] = {["number"] = #myTargeting+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE HALF_WAY_RMAX_NEZ
	myTargeting[#myTargeting+1] = {["number"] = #myTargeting+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.RTB_ON_BINGO, },},} } --NO RTB BINGO
	myTargeting[#myTargeting+1] = {["number"] = #myTargeting+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.PROHIBIT_JETT, },},} } --NO JETTISON WHEN UNDER THREAT

														
	if input.chatter ~= nil then 				
		-- if Debugging == true then printDebug ("EventHandler" , "Start talking after new task " ..  input.sortie , 10 ) end
		myTargeting[#myTargeting+1]  = {["number"] = #myTargeting+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO RTB BINGO
	else
		myTargeting[#myTargeting+1]  = {["number"] = #myTargeting+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO RTB BINGO
	end


	
	return myTargeting 
end

function groupHasLostTask ( input )
	
	if gMissionOptions.runningMissions[input.group].lostTasks == nil then 
		gMissionOptions.runningMissions[input.group].lostTasks = {}
	end
	
	if gMissionOptions.runningMissions[input.group].lostTasks[input.groups] ~= nil then 
		if (timer.getTime() - gMissionOptions.runningMissions[input.group].lostTasks[input.groups].timer ) > 20  then 
			--if Debugging == true then printDebug ( "EventHandler" , input.groups .. " " .. input.sortie .. " starting reissue " , 10 ) end
			local myTasks = ""
			for taskKey, taskValue in ipairs ( gMissionOptions.runningMissions[input.group].tasks[input.sortie].targets ) do
				myTasks = myTasks ..  " " .. taskValue 
			end
			
			if #gMissionOptions.runningMissions[input.group].tasks[input.sortie].targets > 1 then 
				table.remove(gMissionOptions.runningMissions[input.group].tasks[input.sortie].targets, 1)
				--if Debugging == true then printDebug ( "EventHandler" , input.groups .. " " .. input.sortie .. " has removed stale and reissued tasks " .. myTasks , 10 ) end
				unHoldGroup ({group=input.group, holdingGroup=input.sortie , chatter=false ,})


			else -- NO TARGETS LEFT	
				local myClosestAreaDistance = math.huge
				local myClosestAreaName
				local myClosestPostion = {}
				-- local myHoldingAlt = gMissionOptions.transitionAlt 
				local myHoldingAlt = gMissionOptions.runningMissions[input.group].tempTransitionAlt
				local myUnit = Group.getByName(input.groups):getUnit(1) 
				local myUnitName = Unit.getName ( myUnit )
				local myAreaKey = 1
				for areaKey , areaValue in pairs(gMissionOptions.runningMissions[input.group].areas) do 
					local myDistance = getDistanceBetweenUnitAndPoint( myUnitName, areaValue.position )	
					if myDistance < myClosestAreaDistance then 
						myClosestAreaDistance = myDistance
						myClosestAreaName = areaValue.zoneAction
						myClosestPostion = areaValue.position
						myHoldingAlt = areaValue.holdingAlt
						myAreaKey = areaKey
					end 
				end
				
				if gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition1 == nil then 
					local myAngle = math.random(1,6)
					gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition1 = getPointOnRadian ( { radius=gMissionOptions.holdingDistance , pos=myClosestPostion , angle = myAngle })
					gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition2 = getPointOnRadian ( { diameter=gMissionOptions.raceTrackDistance , pos=gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition1 , angle = myAngle }) 
					local myLocation1 = gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition1
					local myLocation2 = gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition2
				
					-- myLocation1.y = land.getHeight{x = myLocation1.x, y = myLocation1.z}
					-- trigger.action.smoke(myLocation1, 0 )
				
					-- myLocation2.y = land.getHeight{x = myLocation2.x, y = myLocation2.z}
					-- trigger.action.smoke(myLocation2, 1 )
				else
					-- if Debugging == true then printDebug ( "EventHandler" , myUnitName .. " Is holding at a position already known " , 10 ) end	
				end
				

				
				holdGroup ({	
					group=input.group , 
					alt=myHoldingAlt+1000, 
					position=gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition1 , 
					--racetrack_point=gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition2, 
					--speed=myHoldingSpeed , 
					chatter=true ,
					pealAway=true ,				
					holdingGroups = gMissionOptions.runningMissions[input.group].sorties[input.sortie] , 
					})
				--gMissionOptions.runningMissions[input.group].sorties[input.sortie].noTargetsRemain = true 
				if Debugging == true then printDebug ( "EventHandler" , input.groups .. " " .. input.sortie .. " is holding " .. myTasks , 10 ) end	
			end 
			
			--

										

			
			
			gMissionOptions.runningMissions[input.group].lostTasks[input.groups] = nil 
			
			
		end 
	else
		gMissionOptions.runningMissions[input.group].lostTasks[input.groups] = {timer=timer.getTime()}
		--if Debugging == true then printDebug ( "EventHandler" , input.groups .. " " .. input.sortie .. " start lost task timer" , 10 ) end
	end 
end 

-- EVENTS
function eventLoopMission ( )
	-- if Debugging == true then printDebug ("EventHandler" , "Event Loop Mission"  , 10 ) end
	
	for groupKey , groupValue in pairs(gMissionOptions.runningMissions) do
		for areasKey , areasValue in pairs(groupValue.areas) do
			local myCategory = {[1] = Object.Category.UNIT , [2]=Object.Category.WEAPON  }
			local myFoundObjects = SearchAreaForObjects ( {point=areasValue.position , radius=areasValue.radius , category=myCategory ,  } )
			

			
			if ( timer.getTime() > ( groupValue.startTime+gMissionOptions.startDelay )) then 
				if areasValue.zoneAction == gMissionOptions.combatZones.Zone1 and areasValue.activated ~= nil and areasValue.objectiveComplete == nil then
					zone1_eventLoop ( {objects=myFoundObjects , mission=areasValue, key=areasKey , } ) 					
					-- if Debugging == true then printDebug ("EventHandler" , "Found Objects " .. #myFoundObjects .. gMissionOptions.combatZones.enemyAirfield .. " at " .. areasValue.zoneAction, 10 ) end 
				end
				if areasValue.zoneAction == gMissionOptions.combatZones.Zone2 and areasValue.activated ~= nil and areasValue.objectiveComplete == nil then
					zone2_eventLoop ( {objects=myFoundObjects , mission=areasValue, key=areasKey , } ) 			
					--if Debugging == true then printDebug ("EventHandler" , "Found Objects " .. #myFoundObjects .. " at " .. areasValue.zoneAction, 10 ) end 
				end
				if areasValue.zoneAction == gMissionOptions.combatZones.Zone3 and areasValue.activated ~= nil and areasValue.objectiveComplete == nil then
					zone3_eventLoop ( {objects=myFoundObjects , mission=areasValue, key=areasKey , } ) 			
					--if Debugging == true then printDebug ("EventHandler" , "Found Objects " .. #myFoundObjects .. " at " .. areasValue.zoneAction, 10 ) end 
				end
				if areasValue.zoneAction == gMissionOptions.combatZones.RTB and areasValue.activated ~= nil and areasValue.objectiveComplete == nil then
					RTB_eventLoop ( {objects=myFoundObjects , mission=areasValue, key=areasKey , } )
					-- local myLocation = {x=areasValue.position.x , z=areasValue.position.z}
					-- myLocation.y = land.getHeight{x = myLocation.x, y = myLocation.z}
					-- trigger.action.signalFlare(myLocation, 1, math.pi )
					--areasValue.objectiveComplete = nil					
					--if Debugging == true then printDebug ("EventHandler" , "Found Objects " .. #myFoundObjects .. " at " .. areasValue.zoneAction, 10 ) end 
				end
				-- if areasValue.alerted_time ~= nil and (math.fmod (timer.getTime(), 30 )  < 1 ) then 
					-- if timer.getTime() - areasValue.alerted_time >= 30 then 
						-- gMissionOptions.runningMissions[groupKey].areas[areasKey].alerted_time = nil 
						-- enemyEvaded ( { mission=areasValue, key=areasKey , } ) 
						-- if Debugging == true then printDebug ("EventHandler" , "Crash Dive started"  , 10 ) end
					-- end 
				-- end 
			end 
		end 
	end

end

function enemyEvaded ( input ) 

	local myDiveDepth = -30
	-- LOCAL FUNCTION TO REMOVES SPAWN ONCE TIMER HAS PASSED
	local function removeSpawn ( input )
		if Unit.getByName(input.name) ~= nil then 
			local myUnitLife = input.unit:getLife()/input.spawn_life 
			local myLeaderName = Unit.getName(Group.getUnit( Group.getByName(gMissionOptions.runningMissions[input.group].leader), 1))
			-- if Debugging == true then printDebug ("EventHandler" , "Remove Spawn " .. input.group  .. " Leader " .. gMissionOptions.runningMissions[input.group].leader ,10 ) end
			local myUnitName = input.unit:getName()
			if myUnitLife > .90 then -- or (myUnitAlt < 15) then
				local myUnitAlt = getMSLfeet(input.name)
				-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. myUnitName .. " has evaded.  Depth " .. myUnitAlt ,10 ) end
				Unit.destroy(input.unit)
				--destroyUnit( {unit=myUnitName, power=500 } )
				removeUnitFromActiveTables ( {unit=myUnitName} )
				timer.scheduleFunction(sayInMission, { what={[1]="mission_evaded", } , who=myLeaderName,  group=input.group, duration=20 } , timer.getTime() + 2 ) 
			elseif  myUnitName ~= nil then 
				destroyUnit( {unit=myUnitName, power=1000 } )
				-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit:getName() .. " has taken damage and dove " .. myUnitLife , 10 ) end	
				timer.scheduleFunction(sayInMission, { what={[1]="mission_damage_dove", } , who=myLeaderName,  group=input.group, duration=20 } , timer.getTime() + 2 ) 			
			else
				timer.scheduleFunction(sayInMission, { what={[1]="mission_target_destroyed", } , who=myLeaderName,  group=input.group, duration=20 } , timer.getTime() + 2 ) 
			end
		end
		
	end
	
	local function diveBoat (input)
		if Group.getByName ( input.group ) ~= nil then 
			input.route[1].alt = -30
			timer.scheduleFunction(ResetGroupController, input.group, timer.getTime() +  .1 )   			
			timer.scheduleFunction(doScheduleFlyRoute, input, timer.getTime()   + .2 )
			if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.group .. " dive boat ", 10 ) end
		else
			if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.group .. " cannot dive boat ", 10 ) end
		end 
	end 
	 
	local function rulesOfEngagement ( input )
			SendOptionToGroup (  input.name , input.id, input.value )				
	end 
	
	for groupKey , groupValue in ipairs(gMissionOptions.runningMissions[input.mission.group].areas[input.key].spawnGroups) do
		--local myUnits = Group.getByName(groupValue.group)
		

		local myRandomDelay = math.random (20,25)
		
		local myDifficulty = gMissionOptions.difficulty
		if gPlayerGroups[input.mission.group] ~= nil then myDifficulty = gPlayerGroups[input.mission.group].preferences.difficulty end -- if they bail out while mission this prevents error
		
		local myDifficultyRange = {[1]=5, [2]=4, [3]=3, [4]=2, [5]=1, }
		
		if groupValue.alerted_time ~= nil then 
			--if Debugging == true then printDebug ("EventHandler" , " Alert time " ..  timer.getTime() - groupValue.alerted_time .. " " .. myDifficultyRange[myDifficulty]* gMissionOptions.alertTime , 1.1 ) end
			--if timer.getTime() - groupValue.alerted_time >= gMissionOptions.alertTime then  
			if (math.fmod (timer.getTime(), 10 )  < 1 ) then 
				local myTempUnit = Group.getByName(groupValue.group):getUnit(1)
				local myTempUnitName = myTempUnit:getName()
				local myTempLife = myTempUnit:getLife()/groupValue.spawn_life
				local myTempAlt = getMSLfeet(myTempUnitName)
				if Debugging == true then printDebug ("EventHandler" , myTempAlt .. " life " .. myTempLife .. " time to dive " .. myDifficultyRange[myDifficulty]* gMissionOptions.alertTime - (timer.getTime() - groupValue.alerted_time ) , 5 ) end
			end 
			if timer.getTime() - groupValue.alerted_time >= myDifficultyRange[myDifficulty]* gMissionOptions.alertTime then 
				local myTargetMoving = false
				for unitKey, unitValue in ipairs(Group.getByName(groupValue.group):getUnits()) do
					local myUnitLife = unitValue:getLife()/groupValue.spawn_life 
					--if Debugging == true then printDebug ("EventHandler" , "The units " .. Unit.getName(unitValue) .. " type " .. Unit.getTypeName(unitValue ) .. " life " .. myUnitLife .. " " .. timer.getTime() - groupValue.alerted_time .. " " .. myDifficultyRange[myDifficulty]* gMissionOptions.alertTime, 1.1 ) end
					if myUnitLife > gMissionOptions.evadePercent then
						local myUnitName = unitValue:getName()
						local myHeading = doGetUnitHeading ({name=myUnitName})
						--local myAlt = getAGLfeet(myUnitName) - 50
						-- local myAlt = getMSLfeet(myUnitName) - 500
						-- local myAlt = -100
						local myMoveToPointOne = getPointOnRadian ( { radius=1000 , pos=unitValue:getPoint() , angle = myHeading.angle })
						--local myMoveToPointTwo = getPointOnRadian ( { radius=1500 , pos=unitValue:getPoint() , angle = myHeading.angle })
						--local myMoveToPointThree = getPointOnRadian ( { radius=2000 , pos=unitValue:getPoint() , angle = myHeading.angle })
						local mySpeed = (unitValue:getDesc().speedMax) * KNOTS
						--local myHeight = land.getHeight(myMoveToPointOne)
						
						local myRoute = { }
						myRoute[#myRoute+1] = {type = "Turning Point" , action = "Turning Point" , pos=myMoveToPointOne , alt=0 , altType="BARO" , speed=mySpeed }
						--myRoute[#myRoute+1] = {type = "Turning Point" , action = "Turning Point" , pos=myMoveToPointTwo , alt=0 , altType="BARO" , speed=mySpeed }
						--myRoute[#myRoute+1] = {type = "Turning Point" , action = "Turning Point" , pos=myMoveToPointThree , alt=0 , altType="BARO" , speed=mySpeed }
						
						timer.scheduleFunction( rulesOfEngagement, {name=groupValue.group,id=AI.Option.Naval.id.ROE, value=AI.Option.Naval.val.ROE.WEAPON_HOLD} , timer.getTime()+ 1 )
								
						local myInfo = { group = groupValue.group , route=myRoute , push=true } 
						timer.scheduleFunction(ResetGroupController, groupValue.group, timer.getTime() + myRandomDelay + 2 )   			
						timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + myRandomDelay  + 3 )
						
						-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. Unit.getName(unitValue) .. " sent command seal boat", 10 ) end
						
						if myUnitLife < .10 then myInfo.route[1].speed = 0 end 
						timer.scheduleFunction(diveBoat, myInfo , timer.getTime() + myRandomDelay  + 20 )
						
						
						timer.scheduleFunction(removeSpawn, {unit=unitValue, name=myUnitName, spawn_life=groupValue.spawn_life , group=input.mission.group }, timer.getTime() + myRandomDelay + 60 )
						myTargetMoving = true

					else
						
					end
					-- ARE THE TARGET UNDERWAY
					local myLeaderName = Unit.getName(Group.getUnit( Group.getByName(gMissionOptions.runningMissions[input.mission.group].leader), 1))
					if myTargetMoving == true then 
					--	if Debugging == true then printDebug ("EventHandler" , "The unit " .. Unit.getName(unitValue) .. " type " .. Unit.getTypeName(unitValue ) .. " is underway ", 10 ) end
						timer.scheduleFunction(sayInMission, { what={[1]="mission_targets_moving", } , who=myLeaderName,  group=input.mission.group, duration=20 } , timer.getTime() + 2 ) 
					else
						timer.scheduleFunction(sayInMission, { what={[1]="mission_targets_damaged", } , who=myLeaderName,  group=input.mission.group, duration=20 } , timer.getTime() + 2 ) 
						--if Debugging == true then printDebug ("EventHandler" , "The unit " .. Unit.getName(unitValue) .. " type " .. Unit.getTypeName(unitValue ) .. " has taken damage and cannot dive "  , 10 ) end 
					end 
					
					gMissionOptions.runningMissions[input.mission.group].areas[input.key].enemy_evaded = true 
				end
			end
		end
	end 
end 

function zone1_eventLoop ( input )
	--if Debugging == true then printDebug ("EventHandler" , "How often does 1 run "  , 10 ) end 
	local myEnemyCount = 0 
	for objectKey , objectValue in pairs(input.objects) do
		input.unit = Unit.getByName(objectValue)
		--local myUnitCoa = Unit.getCoalition(input.unit)
		
		if input.unit ~= nil then 
			if Object.getCategory(input.unit) == Object.Category.UNIT then
				if Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].enemyCoalition then
					--if Debugging == true then printDebug ("EventHandler" , "Unit enemy " .. Object.getTypeName ( input.unit ) .. " " .. Group.getName (Unit.getGroup(input.unit)) , 10 ) end 
					myEnemyCount = myEnemyCount + 1 
					if gMissionOptions.runningMissions[input.mission.group].areas[input.key].enemy_evaded == nil then enemyEvaded ( input ) end
				elseif Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].friendlyCoalition and input.mission.alerted == false then 
					--
					if Group.getName(Unit.getGroup(input.unit)) == gMissionOptions.runningMissions[input.mission.group].leader then 
						doFriendlyDetectedZone1 ( input ) 
					end 
					-- 		
				else
					-- if Debugging == true then printDebug ("EventHandler" , "Unit neutral " .. Object.getTypeName ( input.unit )  , 10 ) end
				end 
			end 
		end 
	end
	if myEnemyCount == 0 and input.mission.alerted == true then 
	
		noEnemyRemaining( input )
	end

end

function zone2_eventLoop ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "How often does 2 run "  , 10 ) end 
	local myEnemyCount = 0 
	for objectKey , objectValue in pairs(input.objects) do
		input.unit = Unit.getByName(objectValue)
		--local myUnitCoa = Unit.getCoalition(input.unit)
		if input.unit ~= nil then 
			if Object.getCategory(input.unit) == Object.Category.UNIT then
				if Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].enemyCoalition then
					-- if Debugging == true then printDebug ("EventHandler" , "Unit enemy " .. Object.getTypeName ( input.unit )  , 10 ) end 
					myEnemyCount = myEnemyCount + 1 
					if gMissionOptions.runningMissions[input.mission.group].areas[input.key].enemy_evaded == nil then enemyEvaded ( input ) end
				elseif Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].friendlyCoalition and input.mission.alerted == false then  
					--if Debugging == true then printDebug ("EventHandler" , "Unit friendly " .. Object.getTypeName ( input.unit )  , 10 ) end 
					doFriendlyDetectedZone1 ( input ) 
				else
					--if Debugging == true then printDebug ("EventHandler" , "Unit neutral " .. Object.getTypeName ( input.unit )  , 10 ) end
				end 
			end 
		end
	end
	if myEnemyCount == 0 and input.mission.alerted == true then  
		noEnemyRemaining( input )
	end
end

function zone3_eventLoop ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "How often does 3 run "  , 10 ) end 
	local myEnemyCount = 0 
	for objectKey , objectValue in pairs(input.objects) do
		input.unit = Unit.getByName(objectValue)
		--local myUnitCoa = Unit.getCoalition(input.unit)
		if input.unit ~= nil then 
			if Object.getCategory(input.unit) == Object.Category.UNIT then
				if Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].enemyCoalition then
					--if Debugging == true then printDebug ("EventHandler" , "Unit enemy " .. Object.getTypeName ( input.unit )  , 10 ) end 
					myEnemyCount = myEnemyCount + 1 
					if gMissionOptions.runningMissions[input.mission.group].areas[input.key].enemy_evaded == nil then enemyEvaded ( input ) end
				elseif Unit.getCoalition(input.unit) == gMissionOptions.runningMissions[input.mission.group].friendlyCoalition and input.mission.alerted == false then  
					--if Debugging == true then printDebug ("EventHandler" , "Unit friendly " .. Object.getTypeName ( input.unit )  , 10 ) end 
					
						doFriendlyDetectedZone1 ( input ) 
				else
					--if Debugging == true then printDebug ("EventHandler" , "Unit neutral " .. Object.getTypeName ( input.unit )  , 10 ) end
				end 
			end 
		end
	end
	if myEnemyCount == 0 and input.mission.alerted == true then  
		noEnemyRemaining( input )
	end
end

function RTB_eventLoop ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "In RTB Loop Objects: " .. #input.objects  , 10 ) end 

	for objectKey , objectValue in pairs(input.objects) do
		input.unit = Unit.getByName(objectValue)
		if input.unit ~= nil then
			if Object.getCategory(input.unit) == Object.Category.UNIT then
				if gMissionOptions.runningMissions[input.mission.group] ~= nil then 
					if Group.getName(Unit.getGroup(input.unit)) == gMissionOptions.runningMissions[input.mission.group].leader then 
						local myAirport = findClosestAirbase ({group=gMissionOptions.runningMissions[input.mission.group].leader ,coalition=gMissionOptions.runningMissions[input.mission.group].friendlyCoalition })
						for landingKey , landingGroup in pairs(gMissionOptions.friendlyGroups) do
							if Debugging == true then printDebug ("EventHandler" , "Land at base " ..  input.mission.group .. " " .. myAirport.id .. " " .. landingGroup , 10 ) end  
							landAtAirbase({group=input.mission.group, airbase=myAirport.id,	landingGroup=landingGroup })
						end
						local myLeadUnit = Group.getByName(gMissionOptions.runningMissions[input.mission.group].leader):getUnit(1)
						local myLeaderName = Unit.getName(myLeadUnit)
						timer.scheduleFunction(sayInMission, { what={[1]="mission_completed" , [2]="period" , [3]="land" } , who=myLeaderName, append= myAirport.name, group=input.mission.group, duration=20 } , timer.getTime() + 2 )
						gMissionOptions.runningMissions[input.mission.group].areas[input.key].objectiveComplete = true
						gMissionOptions.runningMissions[input.mission.group] = nil
						reloadAllMenus ( input )
					end
				end 
			end 
		end 
	end
	--if Debugging == true then printDebug ("EventHandler" , "Sorties"  , 10 ) end 
	--deReference ( gMissionOptions.runningMissions[input.mission.group].sorties )
end 

function doFriendlyDetectedZone1 ( input ) 
	gMissionOptions.runningMissions[input.mission.group].following = nil
		
	local myLeadGroupCount = #gMissionOptions.runningMissions[input.mission.group].sorties[gMissionOptions.runningMissions[input.mission.group].leadSortie]

	local myCountem = 0
	
	for i = #gMissionOptions.runningMissions[input.mission.group].followGroups, 1, -1 do
		
		local myGroupName = gMissionOptions.runningMissions[input.mission.group].followGroups[i].group
		local mySortie = gMissionOptions.runningMissions[input.mission.group].followGroups[i].sortie
		local myUnit = Group.getByName(myGroupName):getUnit(1)
		local myUnitType = Unit.getTypeName(myUnit)
		local myKey = string.upper(myUnitType:gsub('[%p%c%s]', '') )
		local myUnitName = Unit.getName(myUnit) 
		local myPosition = centerUnitCoordinates(myUnitName)
		local myHeading = doGetUnitHeading ({name=myUnitName})
		local myBehindPosition = getPointOnRadian ( { diameter=gMissionOptions.holdingDistance/2 , pos=myPosition , angle = myHeading.angle+math.pi })
		local mySpeed = gMissionOptions.topSpeed
		
		-- if  i > myLeadGroupCount then 
		-- CALCULATE WHICH GROUP SHOULD GET FIRST RUN IN
		local myCounter = gMissionOptions.runningMissions[input.mission.group].activeArea * gMissionOptions.friendlySortieGroupCount 
		-- IF GROUPS HAVE BEEN LOST ADJUST FOR LOSSES BY SENDING THE LEADER IN FIRST
		if #gMissionOptions.runningMissions[input.mission.group].followGroups < myCounter then myCounter = myLeadGroupCount end 
		
		if (i <= myCounter - gMissionOptions.friendlySortieGroupCount ) or (i > myCounter )  then 

			if Debugging == true then printDebug ("EventHandler" , "Holding " .. myUnitName .. " sortie " .. mySortie .. " counter " .. myCounter .. " i " .. i  , 10 ) end 
			local myBehindPosition = getPointOnRadian ( { diameter=gMissionOptions.holdingDistance/2 , pos=myPosition , angle = myHeading.angle-math.pi  })
			local myHolding = {	
					group=input.mission.group , 
					alt=getMSLfeet(myUnitName) + (50 * i ), 
					position=myBehindPosition , 
					--racetrack_point=gMissionOptions.runningMissions[input.group].areas[myAreaKey].holdingPosition2, 
					speed=mySpeed , 
					chatter=false ,
					pealAway=true ,				
					holdingGroups = gMissionOptions.runningMissions[input.mission.group].sorties[mySortie]  , 
					}
			--holdGroup ( myHolding )
			local myHoldDelay = (gMissionOptions.holdingDelay * myCountem ) + 2 
			myCountem = myCountem + 1 
			local myInboundDelay = myHoldDelay + (gMissionOptions.spacingDelay * myCountem ) 
			

			timer.scheduleFunction(holdGroup, myHolding, timer.getTime()+ myHoldDelay  )   
			timer.scheduleFunction(unHoldGroup, {group=input.mission.group, holdingGroup=mySortie , chatter=true ,}, timer.getTime()+ myInboundDelay )  
		else
			if Debugging == true then printDebug ("EventHandler" , "Attacking " .. myUnitName .. " sortie " .. mySortie .. " i " .. i  , 10 ) end 
			--unHoldGroup ({group=input.mission.group, holdingGroup=gMissionOptions.runningMissions[input.mission.group].followGroups[i].sorties[mySortie] , chatter=true ,})
			unHoldGroup ({group=input.mission.group, holdingGroup=mySortie , chatter=false ,})
		end 
	end

	
	gMissionOptions.runningMissions[input.mission.group].areas[input.key].alerted = true
	gMissionOptions.runningMissions[input.mission.group].areas[input.key].alerted_time = timer.getTime()


	for spawnKey , spawnValue in ipairs ( gMissionOptions.runningMissions[input.mission.group].areas[input.key].spawnGroups ) do 
		--if Debugging == true then printDebug ("EventHandler" , "Late Activate " .. spawnValue.group  , 10 ) end 
		local myGroup = Group.getByName(spawnValue.group)
		trigger.action.activateGroup(myGroup)
		gMissionOptions.runningMissions[input.mission.group].areas[input.key].spawnGroups[spawnKey].alerted_time = timer.getTime()
		gMissionOptions.runningMissions[input.mission.group].areas[input.key].spawnGroups[spawnKey].spawn_life = Group.getUnit(myGroup, 1):getLife()
	end 
	
	local myUnitFrom = Group.getByName(gMissionOptions.runningMissions[input.mission.group].leader):getUnit(1)
	local myLeaderName = Unit.getName ( myUnitFrom )
	local myUnitTo =  Group.getByName(gMissionOptions.runningMissions[input.mission.group].areas[input.key].spawnGroups[1].group):getUnit(1)
	local myEnemyUnitName = Unit.getName(myUnitTo)
	local myUnitType = Unit.getTypeName(myUnitTo)
	local myGroupBearing = getBearingToUnit(myLeaderName, myEnemyUnitName)
	local myDistance = getDistanceBetweenUnits( myLeaderName, myEnemyUnitName )	
	
	if Targets[string.upper(myUnitType:gsub('[%p%c%s]', '') )].typename ~= nil then myUnitType = Targets[string.upper(myUnitType:gsub('[%p%c%s]', '') )].typename end

	timer.scheduleFunction(sayInMission, { what={[1]="enemy_contact", [2]="type" } , type=myUnitType, who=myLeaderName,  group=input.mission.group, atdistance=myDistance, bearing=myGroupBearing, duration=20 } , timer.getTime() + 2 ) 
	
	-- if Debugging == true then printDebug ("EventHandler" , "Friendly " .. Object.getTypeName ( input.unit ) .. " attacking " .. input.mission.zoneAction .." with player group " .. gMissionOptions.runningMissions[input.mission.group].group , 10 ) end 
	
end 

function noEnemyRemaining( input )
	
	if timer.getTime() - gMissionOptions.runningMissions[input.mission.group].areas[input.key].alerted_time > 5 then 
			local myEgressTimer = 0 -- 10 ;

			gMissionOptions.runningMissions[input.mission.group].areas[input.key].objectiveComplete = true
				
			local myLeaderUnit = Unit.getName( Group.getByName(gMissionOptions.runningMissions[input.mission.group].leader):getUnit(1))
			local myLeaderPosition = centerUnitCoordinates ( myLeaderUnit )
			local myFriendlyAirport = findClosestAirbase ({position=myLeaderPosition ,coalition=gMissionOptions.runningMissions[input.mission.group].friendlyCoalition , landonly=true  })
			local myNextAreaPoint = myFriendlyAirport.point
			

			if #gMissionOptions.runningMissions[input.mission.group].areas > input.key then --THERE IS ANOTHER AREA AVALIABLE
				local myNextAreaName = gMissionOptions.runningMissions[input.mission.group].areas[input.key+1].zoneAction
				if myNextAreaName ~= gMissionOptions.RTB then 
					myNextAreaPoint = gMissionOptions.runningMissions[input.mission.group].areas[input.key+1].position
					--if Debugging == true then printDebug ("EventHandler" , "There are no enemy remaining heading towards next objective " .. myNextAreaName .. " " .. input.key , 10 ) end
				else
					--if Debugging == true then printDebug ("EventHandler" , "There are no objectives remaining land at closest base " .. myFriendlyAirport.name .. " " ..input.key , 10 ) end
					gMissionOptions.runningMissions[input.mission.group].areas[input.key+1].position = myNextAreaPoint
				end 
				
				gMissionOptions.runningMissions[input.mission.group].areas[input.key+1].activated = true 
				gMissionOptions.runningMissions[input.mission.group].activeArea = input.key+1
				
				gMissionOptions.runningMissions[input.mission.group].position = myNextAreaPoint
				-- RESET HOLDING 
				resetHoldingParameters ( {group=input.mission.group} )
				-- BUILD THE ROUTE
				local myRoute = {}
				local myTransitionAlt = gMissionOptions.runningMissions[input.mission.group].transitionAlt
				local mySpeed = gMissionOptions.runningMissions[input.mission.group].humanSpeed
				myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myNextAreaPoint , alt=myTransitionAlt , altType="BARO" , speed=mySpeed }
				local myTasking = getTasking ( {group=input.mission.group, chatter=true, sortie=gMissionOptions.runningMissions[input.mission.group].leadSortie , } )
				local myInfo = { group = gMissionOptions.runningMissions[input.mission.group].leader , route=myRoute , tasks=myTasking , push=true } 
				timer.scheduleFunction(ResetGroupController, gMissionOptions.runningMissions[input.mission.group].leader, timer.getTime()+ myEgressTimer + 0.1 )   			
				timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + myEgressTimer + 0.2 )
				timer.scheduleFunction(followGroup, {group=input.mission.group}, timer.getTime() + myEgressTimer + 0.3 )
				-- RESET THE TARGET TASKS
				for count = 1, #gMissionOptions.friendlySortie do
					gMissionOptions.runningMissions[input.mission.group].tasks[gMissionOptions.friendlySortie[count].sortie].targets = {}
					for targetKey, targetValue in ipairs (gMissionOptions.friendlySortie[count].targetTypes) do
						gMissionOptions.runningMissions[input.mission.group].tasks[gMissionOptions.friendlySortie[count].sortie].targets[targetKey] = targetValue
					end 
				end

				timer.scheduleFunction(sayInMission, { what={[1]="enemy_eliminated", [2]="period", [3]="closeto" } , who=myLeaderUnit, clearview=false, distance=gMissionOptions.holdRange, group=input.mission.group, duration=20 } , timer.getTime() + 1 ) 

				--gMissionOptions.runningMissions[input.mission.group] = nil 
			end 
	end 

	

end  	

function clearRedEnemy ( input )
	if Debugging == true then printDebug ("EventHandler" , "Clear the red coalition "  , 10 ) end
	local myEnemyCoalition = gMissionOptions.runningMissions[input.group].enemyCoalition
	if Debugging == true then printDebug ("EventHandler" , "Clear the " .. myEnemyCoalition.. " coalition "  , 10 ) end
	--local myEnemyGroups = coalition.getGroups(myEnemyCoalition ,)
	for i, gp in pairs(coalition.getGroups(myEnemyCoalition)) do
		if Debugging == true then printDebug ("EventHandler" , "Clear the " .. Group.getName(gp) .. " from coalition 1"  , 10 ) end
		trigger.action.deactivateGroup(gp)
	end
end
 
function demoAircraftSpawn( input )
	local myTankerAlt = gMissionOptions.transitionAlt
	local mySpawnFrom = "TakeOffParkingHot"
	--input.spawnPosition = centerUnitCoordinates ( input.unit )
	local myAirport = findClosestAirbase ({position=input.spawnPosition ,coalition=input.friendlycoa })
	local myTankerKey = string.upper(AircraftType[gPlayerGroups[input.group].key].tanker:gsub('[%p%c%s]', '') )
	
	-- DID THE UNIT THAT CALLED IT AIRBORNE
	if Object.inAir(Unit.getByName(input.unit) ) == true then
			myTankerAlt = getMSLfeet(input.unit) + 200
			mySpawnFrom = "Airborne"
	end 
	
	-- GET A SPEED --
	if gRefuelSpeeds[AircraftType[gPlayerGroups[input.group].key].type] ~= nil then 
		myTankerSpeed = gRefuelSpeeds[AircraftType[gPlayerGroups[input.group].key].type].speed 
	end 
	local myRefuelSpeed = myTankerSpeed + ((myTankerSpeed * 0.0175 ) * (myTankerAlt/1000 ))-- ADJUST IT FOR ALT
	
	-- IF YOU JUST WANT TO FLY SOMEPLACE DEFINE IT
	local myStartingPosition = getPointOnRadian ( { diameter=1000 , pos=input.spawnPosition , angle = input.heading.angle })
	local myMoveToPosition = getPointOnRadian ( { diameter=10000 , pos=input.spawnPosition , angle = input.heading.angle })
	local myRaceTrackPosition = getPointOnRadian ( { diameter=20000 , pos=input.spawnPosition , angle = input.heading.angle })
	
	-- TASKS ARE DEFINED AND USED IN THE myAircraft TABLE
	
	local myTasks = { }
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction", params = { ["action"] = {["id"] = "Option",["params"] = {["variantIndex"] = 1,["name"] = AI.Option.Air.id.FORMATION,["formationIndex"] = 14, ["value"] = gFormationType.WWIIBomberOpen, },},} }
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true,  ["enabled"] = true, ["id"] = "Tanker", ["params"] =  { } }
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction",["params"] = {["action"] = {["id"] = "SetImmortal",["params"] = {["value"] = true,},},},}
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction",["params"] = {["action"] = {["id"] = "SetInvisible",["params"] = {["value"] = true,},},},} 
	-- myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.RTB_ON_BINGO, },},} } --NO RTB BINGO
	-- myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.PROHIBIT_JETT, },},} } --NO JETTISON WHEN UNDER THREAT
	-- myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE MAX_RANGE  HALF_WAY_RMAX_NEZ
	-- myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO TALKING

	-- OR IF YOU WANT A SERIES OF WAYPOINTS AND TASKS UNCOMMENT IT IN THE myAircraft table
	local myOrbitTask = {[1] = {["enabled"] = true,["auto"] = false,["id"] = "Orbit",["number"] = 1,["params"] = {["altitude"] = myTankerAlt/FEET,["pattern"] = "Race-Track",["point"] = {x=myMoveToPosition.x , y=myMoveToPosition.z },["point2"] = {x=myRaceTrackPosition.x , y=myRaceTrackPosition.z },["speed"] = myRefuelSpeed/KNOTS,},},}
	local myWaypoints = {}
	myWaypoints[#myWaypoints+1] = {  action = "Fly Over Point" , pos=myMoveToPosition , alt = myTankerAlt  , altType="BARO" , speed =myRefuelSpeed }
	myWaypoints[#myWaypoints+1] = {  task = myOrbitTask , action = "Fly Over Point" , pos=myMoveToPosition , alt = myTankerAlt  , altType="BARO" , speed =myRefuelSpeed }
	--deReference ( input )
		
	local myAircraft   = {
							group = input.group , 
							groupName = "Tanker" , -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
							groupCount = 1 ,-- or use defined gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
							unitCount = 1 ,-- or used defined gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
							unitDistance = 10 ,--POTENTIAL RANDOMNESS OF UNITS WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
							groupDistance = 10 ,--100 -- POTENTIAL RANDOMNESS OF GROUPS POSITION WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
							speedmodifier = 1 ,-- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
							task = "Refueling" ,
							skill = gPlayerGroups[input.group].preferences.friendlySkill , -- Average Good High Excellent
							type = Targets[myTankerKey].type , -- THIS TYPE MATCHES THE PLAYER TYPE THAT SPAWNED IT
							livery = Targets[myTankerKey].blivery ,-- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
							pylons = Targets[myTankerKey].gpylons ,-- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
							--- ADDED
							action = "Fly Over Point" ,
							spawnFrom = mySpawnFrom ,
							spawnPosition = myStartingPosition , 
							waypoints = myWaypoints , 
							--moveToPosition = myMoveToPosition , 
							spawncountry =input.friendlycountryid, --THIS IS THE COUNTRY THE GROUP WILL SPAWN INTO
							heading = input.heading , -- THIS NEEDS TO BE THE HEADING TABLE
							speed = myRefuelSpeed ,
							airfield = myAirport.id ,
							alt =  myTankerAlt,
							tasks = myTasks ,
							--lateActivation = true , -- false or leave blank for true
			}
		
	
	local myReturn = mySpawn ( myAircraft  )
	
end 

function demoSpawnAircraft ( input )

	local myAirport = findClosestAirbase ({position=input.position ,coalition=input.friendlycoa })
	input.moveToPosition = getPointOnRadian ( { diameter=5000 , pos=input.position , angle = input.heading.angle })
	--deReference ( input )
	
	local myTasks = {}
	if input.formation ~= nil then 
		myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction", params = { ["action"] = {["id"] = "Option",["params"] = {["variantIndex"] = 1,["name"] = AI.Option.Air.id.FORMATION,["formationIndex"] = 14, ["value"] = input.formation , },},} }
	end 
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.RTB_ON_BINGO, },},} } --NO RTB BINGO
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.PROHIBIT_JETT, },},} } --NO JETTISON WHEN UNDER THREAT
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE MAX_RANGE  HALF_WAY_RMAX_NEZ
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO TALKING

	
	local myDemo  = {
		group = input.group , 
		--groupName = gMissionOptions.friendlyGroups.F2, -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
		groupCount = 1 ,-- gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
		unitCount = 1 ,--gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
		unitDistance = 100 ,-- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
		groupDistance = 100 ,--100 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
		speedmodifier = 1 ,-- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
		formation = gFormationType.WWIIFighterTight , 
		targetTypes = {} , --{[1] = "Ships" , [2] = "Unarmed vehicles" , [3]="All" ,  } ,
		noTargetTypes = {}, -- {[1] = "SAM SR", [2] = "SAM TR", [3] = "EWR", [4] = "AAA",} ,
		task = "Refueling" ,
		altMod = 50 , -- IF YOU WANT TO MODIFY UP OR DOWN THE HORIZONTIAL SPAWN LOCATION  FOR AIRBORNE SPAWN DEFAULT IS PLUS 100 FEET
		callsign = 4 , -- COLT
		skill = gPlayerGroups[input.group].preferences.friendlySkill , -- Average Good High Excellent
		type = "KC-135" , -- THIS TYPE MATCHES THE PLAYER TYPE THAT SPAWNED IT
		livery = Targets["KC135"].blivery ,-- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
		pylons = Targets["KC135"].gpylons ,-- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
		action = "Turning Point" ,
		spawnFrom = "TakeOffParkingHot" ,
		spawnPosition = input.position , 
		moveToPosition = input.moveToPosition , 
		spawncountry =input.friendlycountryid,
		heading = input.heading , -- THIS NEEDS TO BE THE HEADING TABLE
		speed = Targets["KC135"].speed/.70 ,
		skill = gPlayerGroups[input.group].preferences.friendlySkill ,
		airfield = myAirport.id ,
		alt = gMissionOptions.transitionAlt ,
	}
	
	local myReturn = mySpawn ( myDemo )
	
end 

-- THE LAST THING YOU WANT TO DO
if gMissionOptions.started == nil then 
	missionStartEvent ( )
	--preLoadTargets ( input )
	-- local myBluePlayers = coalition.getPlayers(coalition.side.BLUE )
	-- local myRedPlayers = coalition.getPlayers(coalition.side.RED )
	-- if #myBluePlayers > 0 or #myRedPlayers > 0 then
		-- local myPlayerUnit = world.getPlayer( )
		-- insertPlayerIntoMission ( {unit=Unit.getName(myPlayerUnit )} )
	-- end 
	
end 


-- function doEnemyDetectedZone1 ( input )
	-- gMissionOptions.runningMissions[input.mission.group].areas[input.key].remaining == nil then 
		-- gMissionOptions.runningMissions[input.mission.group].areas[input.key].remaining = {}
	-- end
	
	-- if gMissionOptions.runningMissions[input.mission.group].areas[input.key].remaining
-- end 

 -- if gMissionOptions.runningMissions ~= nil then 
	-- --local myValidPlayerGroups = validPlayerGroups ( input )
	 -- for groupKey, groupValue in pairs (gMissionOptions.runningMissions) do
		
		-- --deReference(groupValue.followGroups[1].sortie)
		-- --if Debugging == true then printDebug ("EventHandler" ,  groupValue.activeArea   , 10 ) end
		
		-- for followKey, followValue in pairs ( gScore.kills ) do
			-- if Debugging == true then printDebug ("EventHandler" ,  followKey .. " " .. followValue  , 10 ) end
		-- end 
		
		-- -- if gMissionOptions.runningMissions[groupKey].followGroups ~= nil then
		-- -- for followKey, followValue in pairs (groupValue.followGroups) do
			-- -- -- for enemyGroupKey, enemyGroupValue in pairs (gMissionOptions.runningMissions) do
			-- -- --local myUnit = Group.getByName(enemyGroupValue[1].group):getUnit(1)
			-- -- -- if Debugging == true then printDebug ("EventHandler" ,  followKey .. " Group " .. followValue.group  , 10 ) end
			-- -- --if Debugging == true then printDebug ("EventHandler" ,  Unit.getName(myUnit) .. " " .. getMSLfeet(Unit.getName(myUnit))   , 1.1 ) end
			
		-- -- end 
			-- -- local myUnitName = Unit.getName(Group.getUnit( Group.getByName(gMissionOptions.runningMissions[groupKey].leader), 1))
			-- -- --local myUnit = Group.getByName(gMissionOptions.runningMissions[groupKey].leader):getUnit(1)
			-- -- --myUnitName = Unit.getName(myUnit)

			-- -- -- -- for proximityCount = 1, #gMissionOptions.runningMissions[groupKey].proximityQueue do
				-- -- -- -- --if Debugging == true then printDebug ("EventHandler" ,  "checked "   , 10 ) end
				-- -- -- -- local myUnitCheckName = gMissionOptions.runningMissions[groupKey].proximityQueue[proximityCount].unit
				-- -- -- -- if  #gMissionOptions.runningMissions[groupKey].proximityQueue == 1  then 
				-- -- -- --local myUnitName = gMissionOptions.runningMissions[groupKey].proximityQueue[1].unit 
				-- -- -- --local myGroup = Unit.getGroup(Unit.getByName(myUnitName))
				-- -- -- --local myGroupName = myGroup:getName()
				-- -- -- myUnitObject = myValidPlayerGroups[groupKey]:getUnit(1)
				-- -- -- if Debugging == true then printDebug ("EventHandler" ,  "Number 1 " .. myUnitObject:getName() ..  " " , 10 ) end
					-- -- -- -- -- --myPlayersTable[myPlayerUnitName] = {group, unit=myPlayerUnitName , alt=getMSLfeet(myPlayerUnitName) , altimeter=myPlayerAltimeter }
				-- -- -- -- end 
			-- -- -- -- end
	 -- end
 -- end
 
 							-- if gMissionOptions.runningMissions[groupKey].proximityQueue ~= nil then
								-- for proximityCount = 1, #gMissionOptions.runningMissions[groupKey].proximityQueue do
									-- local myUnitCheckName = gMissionOptions.runningMissions[groupKey].proximityQueue[proximityCount].unit
									-- if ( myUnitCheckName == myPlayerUnitName ) or ( myPlayerGroupName == groupKey and #Group.getUnits(Group.getByName(groupKey)) == 1 ) then 
										-- if Debugging == true then printDebug ("EventHandler" ,  myUnitCheckName .. " needs to be checked "   , 10 ) end
										-- myPlayersTable[myPlayerUnitName] = {group, unit=myPlayerUnitName , alt=getMSLfeet(myPlayerUnitName) , altimeter=myPlayerAltimeter }
									-- end 
								-- end
							-- end 
							
  -- if gMissionOptions.runningMissions ~= nil then 
	 -- for missionKey, missionValue in pairs (gMissionOptions.runningMissions) do
		-- -- for areasKey, areasValue in ipairs (missionValue.areas) do
		-- for areasKey=1,#missionValue.areas-1 do

			-- for spawnKey, spawnValue in ipairs (missionValue.areas[areasKey].spawnGroups) do
				-- if Debugging == true then printDebug ("EventHandler" , gMissionOptions.runningMissions[missionKey].areas[areasKey].spawnGroups[spawnKey].group , 10 ) end
				-- --if Debugging == true then printDebug ("EventHandler" , areasValue.group , 10 ) end
			-- end 
			-- -- for tasksKey, tasksValue in pairs (sortieValue) do
				-- -- for targetsKey, targetsValue in pairs (tasksValue) do
					-- -- if Debugging == true then printDebug ("EventHandler" , sortieKey .. " " .. tasksKey .. " " .. targetsValue, 10 ) end
				-- -- end 
			-- -- end 
		-- end 
	 -- end
 -- end
 
	-- if (math.fmod (timer.getTime(), 20 )  < 1 ) then 
		-- if gMissionOptions.runningMissions[missionKey].following == true then
			-- if Debugging == true then printDebug ("EventHandler" , "Following true " , 5 ) end
		-- end
		-- if gMissionOptions.runningMissions[missionKey].ingressHold == true then
			-- if Debugging == true then printDebug ("EventHandler" , "ingressHold true " , 5 ) end
		-- end 
		-- if gMissionOptions.runningMissions[missionKey].toldTurn == true then
			-- if Debugging == true then printDebug ("EventHandler" , "toldTurn true " , 5 ) end
		-- end 
		-- if gMissionOptions.runningMissions[missionKey].inrangeTimer == true then
			-- if Debugging == true then printDebug ("EventHandler" , "inrangeTimer true " , 5 ) end
		-- end 
		-- if gMissionOptions.runningMissions[missionKey].speedupTimer == true then
			-- if Debugging == true then printDebug ("EventHandler" , "speedupTimer true " , 5 ) end
		-- end 
		-- if gMissionOptions.runningMissions[missionKey].straightLevelTimer == true then
			-- if Debugging == true then printDebug ("EventHandler" , "straightLevelTimer true " , 5 ) end
		-- end 
	-- end
	-- -- if gMissionOptions.runningMissions[missionKey].following == true then
		-- -- if Debugging == true then printDebug ("EventHandler" , "Following true " , 10 ) end
	-- -- end 
		-- -- gMissionOptions.runningMissions[input.group].following = true
	-- -- gMissionOptions.runningMissions[input.group]. = nil
	-- -- gMissionOptions.runningMissions[input.group]. = nil
	-- -- gMissionOptions.runningMissions[input.group]. = nil
	-- -- gMissionOptions.runningMissions[input.group].speedupTimer = nil
	-- -- gMissionOptions.runningMissions[input.group]. = timer.getTime() 
	-- -- gMissionOptions.runningMissions[missionKey].ingressHold = nil 
 -- end 
	-- --if Debugging == true then printDebug ("EventHandler" , "Group " .. gMissionOptions.runningMissions[missionKey].leader , 10 ) end
	
	-- -- local myGroups = coalition.getGroups(2)
	-- -- local myLeadGroupCount = #gMissionOptions.runningMissions[input.mission.group].sorties[#gMissionOptions.runningMissions[input.mission.group].leadSortie]
	-- -- local myLeadGroupCount = #gMissionOptions.runningMissions[missionKey].sorties[gMissionOptions.runningMissions[missionKey].leadSortie]
	-- -- if Debugging == true then printDebug ("EventHandler" , "Lead Sortie " .. myLeadGroupCount , 10 ) end
	-- for groupKey , groupValue in pairs ( gMissionOptions.runningMissions[missionKey].sorties ) do
		-- if Debugging == true then printDebug ("EventHandler" , "Sortie " .. groupKey  .. " " .. #groupValue, 10 ) end
		-- --deReference ( groupValue )
		-- --if Debugging == true then printDebug ("EventHandler" , "Group " .. Group.getName(groupValue) , 10 ) end
	-- end 
	-- -- local curPoint = Unit.getByName('Aerial-3-1')
	-- -- local lat, lon, alt = coord.LOtoLL(curPoint)
	-- -- trigger.action.outText('Bob is at the raw coordinates of \nLatitude: ' .. lat .. ' \nLongitude: ' .. lon .. '\nAltitude: ' .. alt, 20)
	
	-- -- local grid = coord.LLtoMGRS(coord.LOtoLL(Unit.getByName('Aerial-3-1')))
	-- -- local s = grid.UTMZone .. ' ' .. grid.MGRSDigraph .. ' ' .. grid.Easting .. ' ' .. grid.Northing
	-- -- trigger.action.outText(s, 20)
 -- end 
-- end 
-- gMissionOptions.runningMissions[groupKey].sorties[gMissionOptions.runningMissions[groupKey].leadSortie]

 -- for groupKey, groupValue in pairs (gPlayerGroups) do
	 -- for prefKey, prefValue in pairs (groupValue.preferences) do
		-- if prefKey == "flight_distance" then 
			-- local myDistance = gMissionOptions.flightDistance[prefValue]
			-- if Debugging == true then printDebug ("EventHandler" , "Key " .. prefKey  .. " Value " .. prefValue .. " Distance " .. myDistance ,  10 ) end
		-- end 
	 -- end
-- end
-- gPlayerGroups[input.group].preferences

-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - choice = LoadEnemyPositions
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - type = TF-51D
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - coalition = 2
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - group = Aerial-3
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - spawncountry = 80
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - heading Table
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   angle = 0.87972382781423
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   bearing = 50.404462470849
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   reverseangle = 4.021316481404
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -    end
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - unit = Aerial-3-1
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - friendlycoa = 2
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - enemycoa = 1
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - spawnPosition Table
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   y = 166.62087893982
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   x = 10898.581627561
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -   z = 14468.846735465
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning -    end
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - enemycountry = CJTF_RED
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - enemycountryid = 81
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - friendlycountryid = 80
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - friendlycountry = CJTF_BLUE
-- 2022-09-28 05:17:20.990 INFO    SCRIPTING: Spawning - language = English