-- EVENT HANDLING
MyEventHandler = {} -- Event Table
world.addEventHandler(MyEventHandler) 
function MyEventHandler:onEvent(event)
	--if Debugging == true then printDebug ("EventHandler" , "An Event has happened "  .. event.id , 10 ) end
	if event.initiator ~= nil then
		event.unit = event.initiator:getName()
		event.unitObject = event.initiator
		
		--if Unit.getGroup(event.initiator) ~= nil then 
		if Object.getCategory( event.initiator ) ~= Object.Category.SCENERY  then
			event.unit = Unit.getName(event.initiator)
			if Unit.getGroup(event.initiator) ~= nil then 
				event.group = Group.getName(Unit.getGroup(event.initiator))
				event.groupObject = Unit.getGroup(event.initiator)
				-- if event.group == nil then 
					-- if Debugging == true then printDebug ("EventHandler" , "Missing Group" , 10 ) end
				-- end 
			end 
		end 
		
		event.type = event.initiator:getTypeName()
	end 
	
	-- HIT TARGET --
	if event.id == world.event.S_EVENT_HIT then
		hitEvent ( event )
	end
	-- KILLED TARGET --
	if event.id == world.event.S_EVENT_KILL then
		killEvent ( event )
	end
	--- SHOOTING GUNS ---
	if event.id == world.event.S_EVENT_SHOOTING_START then 
		shootingStartEvent ( event )
	end
	if event.id == world.event.S_EVENT_SHOOTING_END then 
		shootingEndEvent ( event )   
	end
	--- SHOOTING MISSLES ---
	if event.id == world.event.S_EVENT_SHOT then 
		shotEvent ( event ) 
	end
	--- CRASH ---
	if event.id == world.event.S_EVENT_CRASH then
		crashEvent ( event )
	end
	-- PILOT DEAD  --
	if event.id == world.event.S_EVENT_PILOT_DEAD then
		pilotDeadEvent ( event )
	end
	-- UNIT LOST  --
	if event.id == world.event.S_EVENT_UNIT_LOST then
		unitLostEvent ( event )
	end
		-- UNIT LOST  --
	if event.id == world.event.S_EVENT_DEAD then
		unitDeadEvent ( event )
	end
	-- SCORE  --
	if event.id == world.event.S_EVENT_SCORE then
		scoreEvent ( event )
	end	
	
	--- DETAILED FAILURE ---
	if event.id == world.event.S_EVENT_DETAILED_FAILURE then
		detailedFailureEvent ( event )
	end

	--- PLAYER ENTERED UNIT ---
	if event.id == world.event.S_EVENT_PLAYER_ENTER_UNIT then
		-- currently a bug in multiplayer for connected clients use birthing method instead
		--if Debugging == true then printDebug ("EventHandler" , "Player entered unit event" , 10 ) end 
		--insertPlayerIntoMissionEvent( event )
	end
	--- PLAYER LEFT UNIT ---
	if event.id == world.event.S_EVENT_PLAYER_LEAVE_UNIT then
		--if Debugging == true then printDebug ("EventHandler" , "Player left unit event" , 10 ) end 
		removePlayerFromMissionEvent ( event )
	end
	--- BIRTH ---
	if event.id == world.event.S_EVENT_BIRTH then 
		unitBirthEvent( event )
	end
	
	if event.id == world.event.S_EVENT_BASE_CAPTURED then
		baseCapturedEvent ( event )
	end
	-- ENGINE START ---
	if event.id == world.event.S_EVENT_ENGINE_STARTUP then 
		engineStartEvent ( event ) 
	end	
	--- ENGINE STOP ---
	if event.id == world.event.S_EVENT_ENGINE_SHUTDOWN then
		engineStopEvent ( event ) 		
	end
	--- TAKING OFF ---	
	if event.id == world.event.S_EVENT_TAKEOFF then 
		takeoffEvent ( event ) 
		-- if Debugging == true then printDebug ("EventHandler" , myWhichUnit .. " is taking off"   , 10 ) end 
	end
	--- LANDING ---
	if event.id == world.event.S_EVENT_LAND then
		landingEvent ( event )
	end  
	--- EJECT ---
	if event.id == world.event.S_EVENT_EJECTION then
		ejectionEvent ( event )
	end	
	-- SEAT DETACHES --
	if event.id == world.event.S_EVENT_DISCARD_CHAIR_AFTER_EJECTION then
		seatDetachEvent ( event )
	end	
	-- PILOT LANDS AFTER EJECTION  --
	if event.id == world.event.S_EVENT_LANDING_AFTER_EJECTION then
		ejectionLandingEvent ( event )
	end
	-- WEAPON ADD --
	if event.id == world.event.S_EVENT_WEAPON_ADD then
		weaponAddEvent ( event )
	end
	-- MISSION STARTS --
	if event.id == world.event.S_EVENT_MISSION_START then
		missionStartEvent ( event )
	end 
	-- MISSION ENDS -
	-- if event.id == world.event.S_EVENT_MISSION_END then
		-- missionEndEvent ( event )
	-- end 
	
	if event.id == world.event.S_EVENT_MARK_ADDED then
		if Debugging == true then printDebug ("EventHandler" , "Mark added" , 10 ) end 
	end 
	
	if event.id == world.event.S_EVENT_MARK_REMOVE then
		if Debugging == true then printDebug ("EventHandler" , "Mark removed" , 10 ) end 
	end 
	
end 
function insertPlayerIntoMissionEvent ( input )
	-- LONG TIME BUG DOES NOT FIRE FOR CONNECTED CLIENTS IN MULTIPLAYER CALLED FROM BIRTHING EVENT
	--reloadAllMenus ( input )
	doRadioCommand ({unit=input.unit})
end 
function removePlayerFromMissionEvent ( input )
	
	removeUnitFromActiveTables ( input )
	--if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " is remove player event"   , 10 ) end 
	-- if gPlayerUnits[input.unit] ~= nil then 
		-- gPlayerUnits[input.unit] = nil 
		-- if Debugging == true then printDebug ("EventHandler" , "player " .. input.unit .. " has left a unit of group " , 10 ) end 
	-- end
	
	-- if gAllUnits[input.unit] ~= nil then 
		-- gAllUnits[input.unit] = nil 
		-- if Debugging == true then printDebug ("EventHandler" , input.unit .. " removed from all units table" , 10 ) end 
	-- end
	
	-- if gVisibleAIUnits[input.unit] ~= nil then 
		-- gVisibleAIUnits[input.unit] = nil 
		-- if Debugging == true then printDebug ("EventHandler" , input.unit .. " removed from AI table" , 10 ) end 
	-- end
	
end 
function unitBirthEvent ( input )

	local mySide = Unit.getCoalition(input.unitObject)
	local myPlayers = coalition.getPlayers(mySide)
	local myAI = true 
	for key , value in pairs(myPlayers) do
		local myUnit = Unit.getName(value)
		if myUnit == input.unit then myAI = false  end 
	end
	if myAI == true then 
		putUnitIntoActiveTables ( { unit=input.unit } )
	else

		putUnitIntoActiveTables( { unit=input.unit , human=true } )
		insertPlayerIntoMissionEvent ( input )
	end
end 
function missionStartEvent ( input )

	gMissionOptions.started = timer.getTime() -- input.time
	loadLanguages ()
	loadMissionLanguages ()
	checkPreferenceIntegrity ( input )
	
	
	local myUnits = getAllVisibleAIUnits (  ) 

	for key ,value in pairs(myUnits) do
		putUnitIntoActiveTables ( { unit=Unit.getName(value) } )
	end
	
	if gMissionOptions.traffic.randomness ~= "off" then
		-- loadAirbases()
		-- loadTraffic()
		--doPrintThis ({clearview = false  , group=input.group, duration= 10 , text="Loading random traffic - Mission may pause" })
		doPrintThis ({clearview = false  , duration= 1.5 , text="Loading random traffic - Mission may pause" }) 
		timer.scheduleFunction(loadAirbases, {} , timer.getTime()+ .25 )
		timer.scheduleFunction(loadTraffic, {} , timer.getTime()+ .26 )
	end 
	
	if #net.get_player_list( ) == 0 then
		for i=0,2 do
			for unitKey ,unitValue in pairs(coalition.getPlayers(i)) do
				local myInput = {}
				myInput.unit = Unit.getName (unitValue)
				if gPlayerUnits[myInput.unit] == nil then 
					-- if Debugging == true then printDebug ("EventHandler" , "This player needs to be manually birthed " .. myInput.unit , 10 ) end
					myInput.groupObject = Unit.getGroup(unitValue)
					myInput.unitObject=unitValue
					myInput.group = Group.getName(myInput.groupObject)
					myInput.type = unitValue:getTypeName()
					unitBirthEvent ( myInput )

				end 
				--if Debugging == true then printDebug ("EventHandler" , "Players " .. Unit.getName(coavalue)  , 10 ) end 
			end 
		end 
	
		
		
	end	
	
	
	--if Debugging == true then printDebug ("EventHandler" , "The mission has started", 10 ) end
	-- putUnitIntoAITable ( { unit=myUnitName } )
end 
function missionEndEvent ( input )
	--if Debugging == true then printDebug ("EventHandler" , "The mission has ended at. "  .. input.time .. " eventid "  .. input.id  , 10 ) end 
end
function engineStartEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has started its engines"  , 10 ) end 
end 
function engineStopEvent ( input )	
	local function scheduleDestroy ( input )
		local myPosition = centerUnitCoordinates (input.unit)
		Unit.destroy( Unit.getByName ( input.unit ) )
		removeUnitFromActiveTables ( {unit=input.unit} )
		local myFriendlyAirport = findClosestAirbase ({position=myPosition  })
		gMissionOptions.parkingMaps[myFriendlyAirport.id] = getParkingClosestToActive ({ type=104 , airfield=myFriendlyAirport.id })
		-- if Debugging == true then printDebug ("EventHandler" , "The AI unit " .. input.unit .. " is gone"  , 10 ) end
		if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " is engine stop ", 10 ) end 
	end 
	local myCoaltion = Unit.getCoalition(input.initiator)
	local myPlayers = coalition.getPlayers(myCoaltion)
	local myShutdownIsPlayer = false 
	for count = 1, #myPlayers do
		local myPlayerUnitName = Unit.getName(myPlayers[count])
		if myPlayerUnitName == input.unit then myShutdownIsPlayer = true end 
	end 
	if myShutdownIsPlayer == false then 
		timer.scheduleFunction(scheduleDestroy, {unit=input.unit}, timer.getTime() + 1 )

		-- if Debugging == true then printDebug ("EventHandler" , "The AI unit " .. input.unit .. " has shutdown its engines"  , 10 ) end
	end 
 
end 
function takeoffEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has taken off"  , 10 ) end 
end 
function landingEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has landed"  , 10 ) end \

end 
function ejectionEvent ( input )
	--if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has ejected"  , 10 ) end 
end 
function seatDetachEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has detached seat"  , 10 ) end 
end 
function ejectionLandingEvent ( input )
	if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has landed in parachute"  , 10 ) end 
end
function crashEvent ( input )
	if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has crashed event"  , 10 ) end 
	removeUnitFromActiveTables ( {unit=input.unit} )
end 
function detailedFailureEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has had a detailed failure"  , 10 ) end 
end 
function pilotDeadEvent ( input )
--	if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " is pilot dead event from group ", 10 ) end 
	removeUnitFromActiveTables ( {unit=input.unit} )

end
function unitLostEvent ( input )
	if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " is unit lost event"   , 10 ) end 
	removeUnitFromActiveTables ( {unit=input.unit} )
end 
function unitDeadEvent ( input )
	if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " is dead event" , 10 ) end 
end 
function scoreEvent ( input )
	--if Debugging == true then printDebug ("EventHandler" , "A score event occured at " .. input.time   , 10 ) end 
end 
function shotEvent ( input )
	local myCoalition = Unit.getCoalition(input.initiator)
	gScore.shots[myCoalition] = gScore.shots[myCoalition]+1
	local myDesc = Weapon.getDesc( input.weapon ) 
	if myDesc.category == Weapon.Category.MISSILE and myDesc.guidance == Weapon.GuidanceType.RADAR_PASSIVE and myDesc.missileCategory == Weapon.MissileCategory.OTHER then
		gMissionOptions.HARMS[Object.getName(input.weapon)] = Group.getName ( Unit.getGroup(Weapon.getTarget(input.weapon)) ) 
		if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has shot " .. myDesc.typeName .. " at " .. Group.getName ( Unit.getGroup(Weapon.getTarget(input.weapon)) ) , 10 ) end 
	end 
	
end 
function shootingStartEvent ( input )
	local myCoalition = Unit.getCoalition(input.initiator)
	gScore.shots[myCoalition] = gScore.shots[myCoalition]+1
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has started shooting guns"  , 10 ) end 
end 
function shootingEndEvent ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has stopped shooting guns"  , 10 ) end 
end 
function hitEvent ( input )

   -- if Object.getCategory( input.target ) ~= Object.Category.SCENERY then
		
		local myReturn = getTargetInfo ( input )
		if myReturn.coalitionUnit ~= nil then 
			gScore.hits[myReturn.coalitionUnit] = gScore.hits[myReturn.coalitionUnit]+1
		end 
		--if Debugging == true then printDebug ("EventHandler" , "HIT " .. myReturn.targetType .. " " .. myReturn.targetUnit .. " " .. myReturn.targetGroup .. " " .. 
--		myReturn.type ..  " " .. myReturn.unit .. " " .. myReturn.group .. " " .. myReturn.weapon.displayName , 10 ) end
	
	-- end 
	-- if Debugging == true then printDebug ("EventHandler" , "HIT T " .. myReturn.type ..  " U " .. myReturn.unit .. " G " .. myReturn.group .. " - T "  .. 
	-- myReturn.targetType .. " U " .. myReturn.targetUnit .. " G " .. myReturn.targetGroup .. " with " .. myReturn.weapon.displayName , 10 ) end 
	
	
end
function killEvent ( input )

	--if Object.getCategory( input.target ) ~= Object.Category.SCENERY then
		local myReturn = getTargetInfo ( input )
		if myReturn.coalitionUnit ~= nil then 
			gScore.kills[myReturn.coalitionUnit] = gScore.kills[myReturn.coalitionUnit]+1
		end 

	--	if Debugging == true then printDebug ("EventHandler" , "KILL " .. myReturn.targetType .. " " .. myReturn.targetUnit .. " " .. myReturn.targetGroup .. " " .. 
--		myReturn.type ..  " " .. myReturn.unit .. " " .. myReturn.group .. " " .. myReturn.weapon.displayName , 10 ) end
	--end 
	
	-- if Debugging == true then printDebug ("EventHandler" , "KILL T " .. myReturn.type ..  " U " .. myReturn.unit .. " G " .. myReturn.group .. " - T "  .. 
	-- myReturn.targetType .. " U " .. myReturn.targetUnit .. " G " .. myReturn.targetGroup .. " with " .. myReturn.weapon.displayName , 10 ) end 
	
	-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. myKiller .. " has killed " .. myTarget .. " with " .. input.weapon_name  , 10 ) end 
end 
function getTargetInfo ( input )
	local myReturn = {}
	myReturn.unit = "UKU"
	myReturn.group = "UKG"
	myReturn.type = "UKT"  
	myReturn.targetUnit = Object.getName ( input.target )
	myReturn.targetGroup = "UKTG"
	myReturn.targetType = "UKTT"
	myReturn.weapon = { displayName=input.weapon_name }
	
	if Object.getTypeName(input.target) ~= nil then myReturn.targetType = Object.getTypeName(input.target) end 

	if input.initiator ~= nil then
		--myUnit = input.unit 
		myReturn.unit = Unit.getName(input.initiator)
		myReturn.group = Group.getName(Unit.getGroup(input.initiator))
		myReturn.type = Unit.getTypeName(input.initiator)
		myReturn.coalitionUnit = Unit.getCoalition(input.initiator)
		if input.weapon ~= nil then myReturn.weapon = Weapon.getDesc( input.weapon ) end --NO WEAPON TABLE ON KILL EVENT
	end 
	
	if Object.getCategory( input.target ) ~= Object.Category.SCENERY then
		myReturn.targetUnit = Unit.getName ( input.target )
		if Unit.getGroup(input.target) ~= nil then 
			myReturn.targetGroup = Group.getName(Unit.getGroup(input.target))
		end 
		myReturn.targetType = Unit.getTypeName(input.target)
	end 
	-- if Debugging == true then printDebug ("EventHandler" , "T " .. myReturn.type .. " U " .. myReturn.unit .. " G " .. myReturn.group .. " hit T "  .. 
	-- myReturn.targetType .. " U " .. myReturn.targetUnit .. " G " .. myReturn.targetGroup .. " with " .. myReturn.weapon.displayName , 10 ) end 
	return myReturn 
end 
function weaponAddEvent ( input )
	--if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " has added weapon type " .. input.weapon_name    , 10 ) end 
end
function baseCapturedEvent ( input )
	local myAirbaseName = Airbase.getName(input.place)
	if input.unit == nil then input.unit = "no one" end
	--if Debugging == true then printDebug ("EventHandler" , "The airbase " .. myAirbaseName .. " has been captured at. "  .. input.time .. " by "  .. input.unit  , 10 ) end 
end 

-- LANGUAGES 
function loadLanguages ()
	gMissionOptions.sayThis["English"] = {}
	-- gMissionOptions.sayThis["English"].welcome = "Welcome to my template mission version  " .. gMissionOptions.Version  -- .. "\n" 
	gMissionOptions.sayThis["English"].menu_language = "English"
	gMissionOptions.sayThis["English"].languagenow = "The language is now English for"
	gMissionOptions.sayThis["English"].closeto = "Everyone close to within"
	gMissionOptions.sayThis["English"].wingslevel = "Wings Level"
	gMissionOptions.sayThis["English"].inrange = "Everyone is in range. Stay in tight formation"
	gMissionOptions.sayThis["English"].increase_airspeed = "Increase airspeed"
	gMissionOptions.sayThis["English"].holding = "I am holding until everyone closes to within"	
	gMissionOptions.sayThis["English"].at = "at"
	gMissionOptions.sayThis["English"].to = "to"
	gMissionOptions.sayThis["English"].feet = "feet"
	gMissionOptions.sayThis["English"].meters = "meters"
	gMissionOptions.sayThis["English"].yes = "Yes"
	gMissionOptions.sayThis["English"].no = "No"
	gMissionOptions.sayThis["English"].sayfor = "for"
	gMissionOptions.sayThis["English"].now = "now"
	gMissionOptions.sayThis["English"].was = "was"
	gMissionOptions.sayThis["English"].miles = "miles"
	gMissionOptions.sayThis["English"].kilometers = "Km"
	gMissionOptions.sayThis["English"].target = "target"
	gMissionOptions.sayThis["English"].degrees = "degrees"
	gMissionOptions.sayThis["English"].type = "type"
	gMissionOptions.sayThis["English"].period = "."
	gMissionOptions.sayThis["English"].group = "group"
	gMissionOptions.sayThis["English"].endedMission = "has ended the mission"
	gMissionOptions.sayThis["English"].indicated = "indicated"
	gMissionOptions.sayThis["English"].continue = "Follow me to objective"
	gMissionOptions.sayThis["English"].heading = "heading"
	gMissionOptions.sayThis["English"].bearing = "bearing"
	gMissionOptions.sayThis["English"].flyheading = "Fly heading"
	gMissionOptions.sayThis["English"].fly = "Fly"
	gMissionOptions.sayThis["English"].joinup = "Everyone join up with me holding airborne"
	gMissionOptions.sayThis["English"].tojoinup = "to join up with"
	gMissionOptions.sayThis["English"].enemy_contact = "Enemy contact"
	gMissionOptions.sayThis["English"].enemy_eliminated = "There are no enemy remaining"
	gMissionOptions.sayThis["English"].RTB = "return to base"
	gMissionOptions.sayThis["English"].land = "Land at airbase"
	gMissionOptions.sayThis["English"].mission_completed = "Mission completed"
	gMissionOptions.sayThis["English"].waitingSAMS = "Eliminate the SAM threat at"
	gMissionOptions.sayThis["English"].evadeSAMS = "SAMS attempt to evade incoming HARM missile"
	gMissionOptions.sayThis["English"].neutralizedSAMS = "The SAM threat is nuetralized."
	gMissionOptions.sayThis["English"].waitingCAS = "Eliminate all ground targets at"
	gMissionOptions.sayThis["English"].waitingTroops = "The airborne drop is inbound"
	gMissionOptions.sayThis["English"].airfieldDespute = "Defend the airborne forces while they seize the airfield"
	gMissionOptions.sayThis["English"].unitsDestroyed = "All the enemy ground units have been destroyed"
	gMissionOptions.sayThis["English"].airfieldTaken = "The attacking coalition has captured the airfield"
	gMissionOptions.sayThis["English"].airfieldRetaken = "The attacking coalition could not capture the airfield"
	gMissionOptions.sayThis["English"].airborneDeploy = "The Airborne forces are ready to deploy"
	gMissionOptions.sayThis["English"].areyousure = "Are you sure?"
	gMissionOptions.sayThis["English"].smokeon = "smoke marker activated"
	gMissionOptions.sayThis["English"].notclose ="You are not close enough to show wind direction"
	gMissionOptions.sayThis["English"].gamepause = "The mission may pause while I find the requested resources."
	gMissionOptions.sayThis["English"].difficulty = "Difficulty"
	gMissionOptions.sayThis["English"].tanker = "Closest Tanker is"
	gMissionOptions.sayThis["English"].promoted = "has been promoted to leader"
	gMissionOptions.sayThis["English"].turn = "Turn"
	gMissionOptions.sayThis["English"].right = "right"
	gMissionOptions.sayThis["English"].left = "left"
	gMissionOptions.sayThis["English"].intelligence = "Intelligence Report"	
	gMissionOptions.sayThis["English"].menu_measure = "Units of Measure"
	gMissionOptions.sayThis["English"].menu_enemy_skill = "Enemy Skill"
	gMissionOptions.sayThis["English"].menu_friendly_skill = "Friendly Skill"
	gMissionOptions.sayThis["English"].menu_instructions = "Instructions"
	gMissionOptions.sayThis["English"].menu_tankers = "Spawn Tanker"


	gMissionOptions.sayThis["Spanish"] = {}
	-- gMissionOptions.sayThis["Spanish"].welcome = "Bienvenido a mi versión de plantilla de misión  " .. gMissionOptions.Version  --- .. "\n" 
	gMissionOptions.sayThis["Spanish"].menu_language = "Idioma"
	gMissionOptions.sayThis["Spanish"].languagenow = "El idioma ahora es español para"
	gMissionOptions.sayThis["Spanish"].closeto = "Todos cerca de"
	gMissionOptions.sayThis["Spanish"].wingslevel = "Nivel de alas"
	gMissionOptions.sayThis["Spanish"].inrange = "Todo el mundo está dentro del alcance. Mantente en formación apretada"
	gMissionOptions.sayThis["Spanish"].increase_airspeed = "Aumentar la velocidad del aire"
	gMissionOptions.sayThis["Spanish"].holding = "Estoy aguantando hasta que todos se cierran dentro"
	gMissionOptions.sayThis["Spanish"].at = "a"
	gMissionOptions.sayThis["Spanish"].to = "a"
	gMissionOptions.sayThis["Spanish"].feet = "pies"
	gMissionOptions.sayThis["Spanish"].meters = "medidores"
	gMissionOptions.sayThis["Spanish"].yes = "Si"
	gMissionOptions.sayThis["Spanish"].no = "No"
	gMissionOptions.sayThis["Spanish"].sayfor = "para"
	gMissionOptions.sayThis["Spanish"].now = "ahora"
	gMissionOptions.sayThis["Spanish"].was = "estaba"	
	gMissionOptions.sayThis["Spanish"].miles = "millas"
	gMissionOptions.sayThis["Spanish"].kilometers = "Km"
	gMissionOptions.sayThis["Spanish"].target = "objetivo"
	gMissionOptions.sayThis["Spanish"].degrees = "grados"
	gMissionOptions.sayThis["Spanish"].type = "tipo"
	gMissionOptions.sayThis["Spanish"].period = "."
	gMissionOptions.sayThis["Spanish"].group = "grupo"
	gMissionOptions.sayThis["Spanish"].endedMission = "ha terminado la misión"
	gMissionOptions.sayThis["Spanish"].indicated = "indicado"
	gMissionOptions.sayThis["Spanish"].continue ="Sígueme hasta el objetivo"
	gMissionOptions.sayThis["Spanish"].heading = "rumbo"
	gMissionOptions.sayThis["Spanish"].bearing = "rodamiento"
	gMissionOptions.sayThis["Spanish"].flyheading = "Volar rumbo"
	gMissionOptions.sayThis["Spanish"].fly = "Volar"
	gMissionOptions.sayThis["Spanish"].joinup = "Todos se unen a mí sosteniendo en el aire"
	gMissionOptions.sayThis["Spanish"].tojoinup = "unirse a"
	gMissionOptions.sayThis["Spanish"].enemy_contact = "Contacto enemigo"
	gMissionOptions.sayThis["Spanish"].enemy_eliminated = "No queda ningún enemigo"
	gMissionOptions.sayThis["Spanish"].RTB = "volver a la base"
	gMissionOptions.sayThis["Spanish"].land = "Laterrizar en la base aérea"
	gMissionOptions.sayThis["Spanish"].mission_completed = "Misión completada"
	gMissionOptions.sayThis["Spanish"].waitingSAMS = "Elimine la amenaza SAM en"
	gMissionOptions.sayThis["Spanish"].evadeSAMS = "SAMS intenta evadir entrante misil HARM"
	gMissionOptions.sayThis["Spanish"].neutralizedSAMS = "La amenaza SAM es neutralizada."
	gMissionOptions.sayThis["Spanish"].waitingCAS = "Elimina todos los objetivos terrestres en"
	gMissionOptions.sayThis["Spanish"].waitingTroops = "La caída aérea es entrante"
	gMissionOptions.sayThis["Spanish"].airfieldDespute = "Defiende a las fuerzas aerotransportadas mientras toman el aeródromo"
	gMissionOptions.sayThis["Spanish"].unitsDestroyed = "Todas las unidades terrestres enemigas han sido destruidas."
	gMissionOptions.sayThis["Spanish"].airfieldTaken = "La coalición atacante ha capturado el aeródromo"
	gMissionOptions.sayThis["Spanish"].airfieldRetaken = "La coalición atacante no pudo capturar el aeródromo"
	gMissionOptions.sayThis["Spanish"].airborneDeploy = "Las Fuerzas Aerotransportadas están listas para desplegarse"
	gMissionOptions.sayThis["Spanish"].areyousure = "Estas seguro?"
	gMissionOptions.sayThis["Spanish"].smokeon = "Marcador de humo activado"
	gMissionOptions.sayThis["Spanish"].notclose ="No estás lo suficientemente cerca como para mostrar la dirección del viento en"
	gMissionOptions.sayThis["Spanish"].gamepause = "La misión se detendrá mientras encuentro los recursos solicitados."
	gMissionOptions.sayThis["Spanish"].difficulty = "Dificultad"
	gMissionOptions.sayThis["Spanish"].tanker = "El avión de repostaje más cercano es"
	gMissionOptions.sayThis["Spanish"].promoted = "ha sido ascendido a líder"
	gMissionOptions.sayThis["Spanish"].turn = "Gire a la"
	gMissionOptions.sayThis["Spanish"].right = "derecha"
	gMissionOptions.sayThis["Spanish"].left = "izquierda"	
	gMissionOptions.sayThis["Spanish"].intelligence = "Informe de inteligencia"	
	gMissionOptions.sayThis["Spanish"].menu_measure = "Unidades de medida"
	gMissionOptions.sayThis["Spanish"].menu_enemy_skill = "Habilidad Enemiga"
	gMissionOptions.sayThis["Spanish"].menu_friendly_skill = "Habilidad Amistosa"
	gMissionOptions.sayThis["Spanish"].menu_instructions = "Instrucciones"
	gMissionOptions.sayThis["Spanish"].menu_tankers = "Engendro Tanker"

	
	gMissionOptions.sayThis["English"].menu_items = { ["startMission" ] = "Start Mission" , ["endMission" ] = "End Mission" , ["options" ] = "Options" , ["preferences" ] = "Preferences" }
	gMissionOptions.sayThis["English"].menu_items_options = {  [3]="Show Wind Direction" ,[2]="To Closest Airfield", [1]="To Target" , [4]=gMissionOptions.sayThis["English"].menu_tankers, [5]="Intelligence Report" ,  }
	gMissionOptions.sayThis["English"].menu_items_difficulty = {  [1]="Trivial" ,[2]="Easy", [3]="Medium" ,[4]="Hard" , [5]="Challenging" }
	gMissionOptions.sayThis["English"].menu_items_skill = {  [1]="Average" ,[2]="Good", [3]="High" ,[4]="Excellent" , }
	gMissionOptions.sayThis["English"].menu_items_instructions = {  [1]="Repeating" ,[2]="Once", }
	gMissionOptions.sayThis["English"].menu_items_measure = {  [1]="Feet" ,[2]="Meters", }
	gMissionOptions.sayThis["English"].menu_items_preferences = {  [2] = "Language" , [2]="Difficulty" , [3]="Measurements" }
	
	gMissionOptions.sayThis["Spanish"].menu_items = {["startMission" ] = "Iniciar misión" , ["endMission" ] = "End Mission" , ["options" ] = "Opciones" , ["preferences" ] ="Preferencias" }
	gMissionOptions.sayThis["Spanish"].menu_items_options = {  [3]="Mostrar dirección del viento" ,[2]="Aeródromo más cercano",[1]="Al objetivo" , [4]=gMissionOptions.sayThis["Spanish"].menu_tankers, [5]="Informe de Inteligencia", }
	gMissionOptions.sayThis["Spanish"].menu_items_difficulty = {  [1]="Trivial" ,[2]="Fácil", [3]="Medio" ,[4]="Duro" , [5]="Desafiante" }
	gMissionOptions.sayThis["Spanish"].menu_items_skill = {  [1]="Promedio" ,[2]="Bueno", [3]="Alto" ,[4]="Excelente" , }
	gMissionOptions.sayThis["Spanish"].menu_items_instructions = {  [1]="Repitiendo" ,[2]="Uno vez", }
	gMissionOptions.sayThis["Spanish"].menu_items_measure = {  [1]="Pies" ,[2]="Medidores", }
	gMissionOptions.sayThis["Spanish"].menu_items_preferences = {  [1] = "Language" , [2]="Dificultad" }
	
	
	
end 

-- UNIT HANDLING TABLES
function putUnitIntoActiveTables ( input )
	local myGroupName = Group.getName ( Unit.getGroup( Unit.getByName(input.unit) ) )
	local myType = Unit.getTypeName ( Unit.getByName(input.unit)) 
	local myKey = string.upper(myType:gsub('[%p%c%s]', '') )
	local myControlled = "AI" 

	if input.human == nil then 
		if gVisibleAIUnits[input.unit] == nil then 
			gVisibleAIUnits[input.unit] = { unit=input.unit , group=myGroupName , type=myType }
			-- if Debugging == true then printDebug ("EventHandler" , "Put unit " .. input.unit .. " into visibleAI "  , 10 ) end 
		end 
	else -- ITS A HUMAN PLAYER
		-- ITS MISSING FROM THE AIRCRAFT TABLES
		if AircraftType[myKey]==nil then
			missingFromAircraftTables ({key=myKey , type=myType })
		end 
		-- THIS UNIT HASNT BEEN SAVED
		if gPlayerUnits[input.unit] == nil then 
			gPlayerUnits[input.unit] = { unit=input.unit , group=myGroupName , type=myType }
			local myGroupName = Group.getName(Unit.getGroup(Unit.getByName(input.unit)))
			-- THERE IS NO GROUP YET
			if gPlayerGroups[myGroupName] == nil then
				local myGroupPreferences = {}
				for key , value in pairs(gMissionOptions.defaultPreferences) do
					myGroupPreferences[key] = value
				end 
				--local myGroupPreferences = {language=gMissionOptions.defaultPreferences.language, measure=gMissionOptions.defaultPreferences.measure , difficulty=gMissionOptions.defaultPreferences.difficulty, enemySkill=gMissionOptions.defaultPreferences.enemySkill , friendlySkill=gMissionOptions.defaultPreferences.friendlySkill , instructions=gMissionOptions.defaultPreferences.instructions ,  }
				
				local myLastSaid = gMissionOptions.sayThis[myGroupPreferences.language].welcome
				gPlayerGroups[myGroupName] = { group=myGroupName , units={} , lastSaid="Welcome", preferences=myGroupPreferences, type=myType , key=myKey , enterservice=AircraftType[myKey].enterservice , retired=AircraftType[myKey].retired }
				preLoadTargets ( { group=myGroupName } )
			end
			gPlayerGroups[myGroupName].units[#gPlayerGroups[myGroupName].units+1] = input.unit
			-- if Debugging == true then printDebug ("EventHandler" , "Put unit " .. input.unit .. " into playerunits "  , 10 ) end 

		end 
	end 
	if gAllUnits[input.unit] == nil then 
		gAllUnits[input.unit] = { unit=input.unit , group=myGroupName , type=myType }
		gBirthCount = gBirthCount + 1
		-- if Debugging == true then printDebug ("EventHandler" , "Put unit " .. input.unit .. " into allunits "  , 10 ) end 
	end 
end 
function removeUnitFromActiveTables ( input )
	if gAllUnits[input.unit] ~= nil then 
		input.group = gAllUnits[input.unit].group
		doUnitLostEvent ( input ) 
		-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " was removed from allunits"  , 10 ) end 
	end 
	if gPlayerUnits[input.unit] ~= nil then
		local myGroupName = gPlayerUnits[input.unit].group	
		gPlayerUnits[input.unit] = nil
		--local myGroupName = Group.getName(Unit.getGroup(Unit.getByName(input.unit)))
		
		for unitkey , unitvalue in pairs(gPlayerGroups[myGroupName].units) do
			if unitvalue == input.unit then
				table.remove(gPlayerGroups[myGroupName].units, unitkey)
				-- if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " was removed from players"  , 10 ) end  
			end
		end 
		if #gPlayerGroups[myGroupName].units < 1 then gPlayerGroups[myGroupName] = nil end
	

	end
	if gVisibleAIUnits[input.unit] ~= nil then 
		gVisibleAIUnits[input.unit] = nil
		if Debugging == true then printDebug ("EventHandler" , "The unit " .. input.unit .. " was removed from visibleAI"  , 10 ) end 
	end 
	if input.unit == nil then
		if Debugging == true then printDebug ("EventHandler" , "Null unit no unit tables modified"  , 10 ) end 
	end 
end 
function getAllVisibleAIUnits ( input ) -- MAYBE THIS IS TOOLBOX ROUTINE
	local myUnits = {}
	local myPlayers = {}
	
	for i=0,2 do
		for coakey ,coavalue in pairs(coalition.getPlayers(i)) do
			myPlayers[Unit.getName(coavalue)] = { group=true }
			--if Debugging == true then printDebug ("EventHandler" , "Players " .. Unit.getName(coavalue)  , 10 ) end 
		end 
	end 
	for i=0,2 do
		local myTempGroups = coalition.getGroups( i , mySpawnType )
		if myTempGroups ~= nil then 
			for groupkey ,groupvalue in pairs(myTempGroups) do
				-- if Debugging == true then printDebug ("EventHandler" , "Groups on the map " .. Group.getName(groupvalue)  , 10 ) end 
				for unitkey, unitvalue in pairs(groupvalue:getUnits()) do 
					--local myUnitName = Unit.getName(unitvalue)
					if myPlayers[Unit.getName(unitvalue)] == nil and Unit.isActive(unitvalue) then 
						myUnits[#myUnits+1] = unitvalue
						-- putUnitIntoAITable ( { unit=myUnitName } )
						--if Debugging == true then printDebug ("EventHandler" , "AI Units on the map " .. Unit.getName (unitvalue) , 10 ) end 
					end 
				end 
			end 
		end 
	end

	return myUnits
end 
function missingFromAircraftTables ( input )
 			AircraftType[input.key] = {}
			Targets[input.key] = {}
			for key , value in pairs(MissingAircraft) do -- US THE MISSING AIRCRAFT TEMPLATE
				AircraftType[input.key][key] = value 
			end 
			local myDesc = Unit.getDescByName(input.type)
			AircraftType[input.key]["type"] = input.type
			AircraftType[input.key]["typename"] = myDesc.displayName
			AircraftType[input.key]["fuel"] = myDesc.fuel
			AircraftType[input.key]["speed"] = (myDesc.speedMax*.85)*KNOTS
			if myDesc.category == 1 then -- IS ROTARY
				AircraftType[input.key]["category"]= MissionCombat.ROTARY.category
				AircraftType[input.key]["wing"]= "rotary"
				AircraftType[input.key].catapult=TaskGroups.blueassault
			end
			for key , value in pairs(AircraftType[input.key]) do -- USE THE MISSING AIRCRAFT TEMPLATE
				Targets[input.key][key] = value 
				Targets[input.key]["retired"] = 1901 -- SO THE TYPE NEVER APPEARS IN A TARGET SEARCH
				Targets[input.key]["enterservice"] = 1900 -- SO THE TYPE NEVER APPEARS IN A TARGET SEARCH
			end 
			if Debugging == true then printDebug ("EventHandler" , "Inserted  aircraft type " .. input.type .. " into aircraft table" , 10 ) end
			
 end
-- PREFERENCES
function checkPreferenceIntegrity ( input )
	
	-- CHECK LANGUAGE
	local myErrors = {}
	gLanguage = string.lower ( tostring (gLanguage) ) 
	if gLanguage ~= "english" and gLanguage ~= "spanish" then
		myErrors[#myErrors+1] = "\Language preferences settings error. Language is now " .. gMissionOptions.language
	else
		gMissionOptions.preferences[1].language = gMissionOptions.languageChoices[gLanguage]
		gMissionOptions.preferences[2].language = gMissionOptions.languageChoices[gLanguage]
	end 
	sayInMission ( { what={[1]="welcome",}   , duration=30 } ) 
	
	-- DIFFICULTY
	gDifficulty = tonumber(gDifficulty)
	if gDifficulty == nil then gDifficulty = 0 end 
	if gDifficulty < 1 or gDifficulty > 5 then 
		myErrors[#myErrors+1] = "\ngDifficulty preferences settings error. Difficult is now " .. gMissionOptions.sayThis["English"].menu_items_difficulty[gMissionOptions.preferences[1].difficulty]
	else 
		gMissionOptions.difficulty = gDifficulty
		gMissionOptions.preferences[1].difficulty = tonumber(gDifficulty)
		gMissionOptions.preferences[2].difficulty = tonumber(gDifficulty) 
	end
	
	-- INSTRUCTIONS
	gInstructions = string.lower ( tostring (gInstructions) )
	if gInstructions ~= string.lower(gMissionOptions.sayThis["English"].menu_items_instructions[1]) and gInstructions ~= string.lower(gMissionOptions.sayThis["English"].menu_items_instructions[2]) then
		gInstructions = gMissionOptions.sayThis["English"].menu_items_instructions[1]
		myErrors[#myErrors+1] = "\ngInstructions preferences setting error. Values can be Repeating or Once. Set to " ..  gInstructions
	else
		gMissionOptions.preferences[1].instructions = gInstructions:gsub("^%l", string.upper) 
		gMissionOptions.preferences[2].instructions = gInstructions:gsub("^%l", string.upper) 
	end
	
	-- ENEMY SKILL
	--gFriendlySkill = "High"
	gEnemySkill = string.lower ( tostring (gEnemySkill) )
	if gEnemySkill ~= "average" and gEnemySkill ~= "good" and gEnemySkill ~= "high" and gEnemySkill ~= "excellent" then
		myErrors[#myErrors+1] = "\ngEnemySkill preferences error. Values can be Average, Good, High or Excellent. Set to " .. gMissionOptions.preferences[1].enemySkill
	else
		gMissionOptions.preferences[1].enemySkill = gEnemySkill:gsub("^%l", string.upper) 
		gMissionOptions.preferences[2].enemySkill = gEnemySkill:gsub("^%l", string.upper) 
	end
	
	-- FRIENDLY SKILL
	--gFriendlySkill = "High"
	gFriendlySkill = string.lower ( tostring (gFriendlySkill) )
	if gFriendlySkill ~= "average" and gFriendlySkill ~= "good" and gFriendlySkill ~= "high" and gFriendlySkill ~= "excellent" then
		myErrors[#myErrors+1] = "\ngFriendlySkill preferences error. Values can be Average, Good, High or Excellent. Set to " .. gMissionOptions.preferences[1].friendlySkill
	else
		gMissionOptions.preferences[1].friendlySkill = gFriendlySkill:gsub("^%l", string.upper) 
		gMissionOptions.preferences[2].friendlySkill = gFriendlySkill:gsub("^%l", string.upper) 
	end
	
	-- WWII ASSESTS
	if gWWIIAssets == nil then gWWIIAssets = false end
	if gWWIIAssets ~= true and gWWIIAssets ~= false then
		myErrors[#myErrors+1] = "\ngWWIIAssets assest pack preferences settings error. Setting to false" 
		gWWIIAssets = false
	end
	gMissionOptions.WWIIassets = gWWIIAssets
	
	-- MEASURE
	gUnitsOfMeasure = string.lower ( tostring (gUnitsOfMeasure) )
	if gUnitsOfMeasure ~= "feet" and gUnitsOfMeasure ~= "meters" then
		myErrors[#myErrors+1] = "\ngUnitsOfMeasure preferences setting error. Distance given in feet and miles." 
	else
		gMissionOptions.preferences[1].measure = gUnitsOfMeasure:gsub("^%l", string.upper) 
		gMissionOptions.preferences[2].measure = gUnitsOfMeasure:gsub("^%l", string.upper) 
	end 
	
		-- FLIGHT DISTANCE
	if gFlightDistance == nil then gFlightDistance = gDistance.medium end 
	gFlightDistance = string.lower ( tostring (gFlightDistance) )
	if gFlightDistance ~= "short" and gFlightDistance ~= "medium" and gFlightDistance ~= "far"  then
		myErrors[#myErrors+1] = "\ngFlightDistance preferences setting error. Distance can be short medium or far" 
	else
		-- gMissionOptions.preferences[1].flight_distance = gFlightDistance:gsub("^%l", string.upper) 
		-- gMissionOptions.preferences[2].flight_distance = gFlightDistance:gsub("^%l", string.upper) 
		gMissionOptions.preferences[1].flight_distance = gFlightDistance
		gMissionOptions.preferences[2].flight_distance = gFlightDistance
	end 
	 
	
	-- TANKERS 
	-- if gTankersAllowed == nil then gTankersAllowed = true end 
	-- if gTankersAllowed ~= true and gTankersAllowed ~= false then
		-- gTankersAllowed = true
		-- myErrors[#myErrors+1] = "\ngTankersAllowed preferences setting error. Allowing tankers." 
	-- end
	-- if gTankersAllowed == true then 
		-- gMissionOptions.allowTankers = true
	-- end 
	
		-- TANKER ATTRIBUTES
	if gTankerAttributes == nil then gTankerAttributes = { allow=true, immortal = false ,  invisible=false } end 
	if gTankerAttributes.allow ~= false and gTankerAttributes.allow ~= true then 
		myErrors[#myErrors+1] = "\ngTankerAttributes.allow preferences settings error. Tankers are allowed." 
		gTankerAttributes.allow = true
	end
	if gTankerAttributes.immortal ~= false and gTankerAttributes.immortal ~= true then 
		myErrors[#myErrors+1] = "\ngTankerAttributes.immortal preferences settings error. Tankers are now not immortal to damage." 
		gTankerAttributes.immortal = false
	end 
	if gTankerAttributes.invisible ~= false and gTankerAttributes.invisible ~= true then  
		myErrors[#myErrors+1] = "\ngTankerAttributes.invisible preferences settings error. Tankers are now visbile to all coalitions." 
		gTankerAttributes.invisible = false 
	end 
	gMissionOptions.tanker_attributes.allow = gTankerAttributes.allow
	gMissionOptions.tanker_attributes.immortal = gTankerAttributes.immortal
	gMissionOptions.tanker_attributes.invisible = gTankerAttributes.invisible
	
	-- 	TRAFFIC --
	if gTraffic ~= nil then 
		if not next(gTraffic) then
			myErrors[#myErrors+1] = "\ngTraffic table preferences missing or incomplete. Random traffic is now off." 
			gTraffic = nil
		end
	end 	
	if gTraffic == nil then
		gTraffic = {enterservice=1960 , retired=2050, randomness="off", } -- low medium high off
	end
	if gTraffic.randomness == nil then 
		myErrors[#myErrors+1] = "\ngTraffic.amount preference missing or wrong.(low medium high off ) Traffic is off."
		gMissionOptions.traffic.randomness="off"
	else
		gMissionOptions.traffic.randomness=gTraffic.randomness
	end
	if gTraffic.randomness ~= "low" and gTraffic.randomness ~= "medium" and gTraffic.randomness ~= "high" and gTraffic.randomness ~= "off" then
		myErrors[#myErrors+1] = "\ngTraffic.randomness preferences error. Random traffic is now off." 
		gMissionOptions.traffic.randomness="off"
	end
	if gTraffic.enterservice < 1903 then 
			gMissionOptions.traffic.enterservice = 1960
			myErrors[#myErrors+1] = "\ngTraffic.enterservice preference prior to year 1903. Setting to year 1960" 
	else
		gMissionOptions.traffic.enterservice=gTraffic.enterservice
	end
	if gTraffic.retired <= gTraffic.enterservice then 
		gMissionOptions.traffic.retired = 2025
		gMissionOptions.traffic.enterservice = 1960
		myErrors[#myErrors+1] = "\ngTraffic.retired prefereence year prior to enter service year. Setting range 1960-2050" 
	else
		gMissionOptions.traffic.retired=gTraffic.retired
	end
	
	gMissionOptions.traffic.counts = 2
	if gTraffic.randomness == "medium" then gMissionOptions.traffic.counts = 5 elseif gTraffic.randomness == "high" then gMissionOptions.traffic.counts = 10 end 
	
	-- ECHO ANY ERRORS BACK TO USER
	if  #myErrors ~=  0 then 
			local myErrorString = "Warnings:\n" 
			for key , value in pairs(myErrors) do
				myErrorString = myErrorString .. value
			end 
			
			doPrintThis ({clearview = false  , duration= 30 , text=myErrorString }) 

	end
	
end
function skillChange ( input ) -- CHANGES PREFERENCES FOR BOTH AI ENEMY SKILLS AND AI FRIENDLY SKILLS

	local myEnemySkillWasKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_skill , gPlayerGroups[input.group].preferences.enemySkill )
	local myFriendlySkillWasKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_skill , gPlayerGroups[input.group].preferences.friendlySkill )
	
	local myEnemySkillWas = gMissionOptions.sayThis[input.language].menu_items_skill[myEnemySkillWasKey]
	local myFriendlySkillWas = gMissionOptions.sayThis[input.language].menu_items_skill[myFriendlySkillWasKey]
	
	local mySkillNow = gMissionOptions.sayThis["English"].menu_items_skill[input.key]
	
	local mySkillText = gMissionOptions.sayThis[input.language].menu_enemy_skill 

	if input.choice == 'EnemySkillChange' then 
		gPlayerGroups[input.group].preferences.enemySkill = mySkillNow
	end 
	if input.choice == 'FriendlySkillChange' then
		local mySkillText = gMissionOptions.sayThis[input.language].menu_friendly_skill 
		gPlayerGroups[input.group].preferences.friendlySkill = mySkillNow
	end
	local myText = mySkillText .. " " .. gMissionOptions.sayThis[input.language].now .. " " .. input.changeTo .. " " .. 
				gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].group .. " " .. input.group
	doRadioCommand ({unit=input.unit})
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myText })
end 
function measurmentChange ( input )
	-- local myMeasureWas = gPlayerGroups[input.group].preferences.measure
	-- gPlayerGroups[input.group].preferences.measure = input.changeTo
	-- local myText = gMissionOptions.sayThis[input.language].menu_measure .. " " .. gMissionOptions.sayThis[input.language].now .. " " .. input.changeTo .. " " .. 
					-- gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].group .. " " .. input.group
	-- doRadioCommand ({unit=input.unit})
	-- doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myText })
	-- if Debugging == true then printDebug ("EventHandler" , "Measure " .. input.changeTo , 10 ) end 
	
	
	local myMeasureWasKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_measure , gPlayerGroups[input.group].preferences.measure )
	-- local myMeasureNowKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_measure , input.key )
	local myMeasureWas = gMissionOptions.sayThis["English"].menu_items_measure[myMeasureWasKey]
	gPlayerGroups[input.group].preferences.measure = gMissionOptions.sayThis["English"].menu_items_measure[input.key]
	local myText = gMissionOptions.sayThis[input.language].menu_measure .. " " .. gMissionOptions.sayThis[input.language].now .. " " .. input.changeTo .. " " .. 
					gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].group .. " " .. input.group
	doRadioCommand ({unit=input.unit})
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myText })
	--if Debugging == true then printDebug ("EventHandler" , myMeasureWas .. " now " .. gPlayerGroups[input.group].preferences.measure , 10 ) end
end 
function languageChange ( input )
	gMissionOptions.preferences[input.friendlycoa].language = input.changeTo
	gPlayerGroups[input.group].preferences.language = input.changeTo
	
	local myText = gMissionOptions.sayThis[input.changeTo].languagenow .. " " .. input.group
	-- doPrintThis ({clearview = gMissionOptions.clearView  , coalition=input.friendlycoa, duration= 30 , text=myText })
	doRadioCommand ({unit=input.unit})
	--reloadAllMenus ( input )
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myText })
	
	--if Debugging == true then printDebug ("EventHandler" , "Menu Choice " ..  	input.menu  , 10 ) end
end 
function difficultyChange ( input )
	gMissionOptions.preferences[input.friendlycoa].difficulty = input.changeTo
	local myDifficultyWas = gMissionOptions.sayThis[input.language].menu_items_difficulty[gPlayerGroups[input.group].preferences.difficulty]
	gPlayerGroups[input.group].preferences.difficulty = input.difficulty
	
	local myTextNow = gMissionOptions.sayThis[input.language].difficulty .. " " .. gMissionOptions.sayThis[input.language].now .. " " .. gMissionOptions.sayThis[input.language].menu_items_difficulty[input.difficulty] .. " " .. 
					gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].group .. " " .. input.group
	local myTextWas = " ( " .. gMissionOptions.sayThis[input.language].was:gsub("^%l", string.upper) .. " " ..  myDifficultyWas .. " )"
	doRadioCommand ({unit=input.unit})
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myTextNow .. myTextWas })
	--deReference ( input )
end 
function instructionsChange ( input )
	--if gPlayerGroups[input.group].preferences.instructions == nil then gPlayerGroups[input.group].preferences.instructions = gMissionOptions.sayThis["English"].menu_items_instructions[1] end
	local myInstructionsWasKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_instructions , gPlayerGroups[input.group].preferences.instructions )
	local myInstructionsWas = gMissionOptions.sayThis["English"].menu_items_instructions[myInstructionsWasKey]
	gPlayerGroups[input.group].preferences.instructions = gMissionOptions.sayThis["English"].menu_items_instructions[input.key]
	local myText = gMissionOptions.sayThis[input.language].menu_instructions .. " " .. gMissionOptions.sayThis[input.language].now .. " " .. input.changeTo .. " " .. 
					gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].group .. " " .. input.group
	doRadioCommand ({unit=input.unit})
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myText })
	
	if Debugging == true then printDebug ("EventHandler" , "Instruction was " ..  " " .. myInstructionsWas .. " now " .. gPlayerGroups[input.group].preferences.instructions , 10 ) end
end 
-- LOCAL FUNCTIONS
function getOppositeSide ( input )
	--if Debugging == true then printDebug ("EventHandler" ,  input.group , 10 ) end
	local myValidGroups = validPlayerGroups ()
	
	input.friendlycoa = Group.getCoalition(myValidGroups[input.group])
	input.friendlycountryid =  Unit.getCountry(myValidGroups[input.group]:getUnit(1))
	input.friendlycountry = country.name[input.friendlycountryid]
	
	input.enemycoa = coalition.side.RED
	input.enemycountry = gMissionOptions.redCountries[math.random(1,#gMissionOptions.redCountries)]
	input.enemycountryid = country.id[input.enemycountry] 
	
	if input.friendlycoa == coalition.side.RED then 
		input.enemycoa = coalition.side.BLUE
		input.enemycountry = gMissionOptions.blueCountries[math.random(1,#gMissionOptions.blueCountries)]
		input.enemycountryid = country.id[input.enemycountry] 
	end
	return input
end 
function clearPlayingField ( input )
		--local myRequestingGroup = input.group
		local myRequestingCoalition = gMissionOptions.runningMissions[input.group].coalition
		gMissionOptions.runningMissions[input.group].following = nil 
		local myStatement = input.mission.airbaseName
		local myRemoveGroups = {}
		--local myFriendlies = {}
		--local myFlightMembers = {}
		
		-- local myGroups = coalition.getGroups(myRequestingCoalition)
		local myUnits = coalition.getPlayers(myRequestingCoalition)
		local myGroups = {}
		
		for unitKey, unitValue in pairs (myUnits) do
			myGroups[Group.getName (Unit.getGroup( unitValue ))] = Group.getName ( Unit.getGroup( unitValue ) ) 
		end 
		for groupKey, groupValue in pairs (myGroups) do 
			if Debugging == true then printDebug ("EventHandler" , "Tell Group " .. groupValue , 10 ) end
			sayInMission ( { what={[1]="endedMission", [2]="at",}, prepend=input.group , where=myStatement, group=groupValue  , duration=60 } )
		end
		
		for enemySortie , enemySortie in pairs (input.mission.enemyGroups) do 
			for enemyKey , enemyValue in pairs (enemySortie) do 
				myRemoveGroups[enemyValue.group] = {group=enemyValue.group }
				-- if Debugging == true then printDebug ("EventHandler" , "Remove Enemy group " .. enemyValue.group , 10 ) end
			end  
		end 
		for sortieKey , sortieValue in pairs (input.mission.friendlyGroups) do 
			-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. sortieValue.group , 10 ) end
			for key , value in pairs (sortieValue) do 
				-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. value.group , 10 ) end
				myRemoveGroups[value.group] = {group=value.group }
			end  
		end 
		for key , value in pairs(gVisibleAIUnits) do
			if Debugging == true then printDebug ("EventHandler" , "Remove gVisibleAIUnits " .. value.group .. " " .. value.type , 10 ) end
			local myUnit = 	Unit.getByName(value.unit)
			local myUnitCoalition = Unit.getCoalition(myUnit)
			local myGroupName = Group.getName(Unit.getGroup(myUnit))
			local myGroundAttribute = Unit.hasAttribute(myUnit, "Ground Units" )
			local myShipAttribute = Unit.hasAttribute(myUnit, "Ships" )
			local myAirborneAttribute = Unit.hasAttribute(myUnit, "Air" )
			if (myGroundAttribute == true or myShipAttribute == true ) and myRemoveGroups[myGroupName] ~= nil then 
				Unit.destroy( Unit.getByName ( value.unit ) )
				removeUnitFromActiveTables ( {unit=value.unit} )
			end
			if myAirborneAttribute == true and myRemoveGroups[myGroupName] ~= nil then
				
				if myUnit:inAir() == false then 
					Unit.destroy( Unit.getByName ( value.unit ) )
					removeUnitFromActiveTables ( {unit=value.unit} )
				else 
					local mySpeed = gMissionOptions.runningMissions[input.group].humanSpeed
					local myAlt = gMissionOptions.runningMissions[input.group].transitionAlt
					local myLanding = {unit=value.unit ,coalition=myUnitCoalition , speed=mySpeed , alt=myAlt}
					timer.scheduleFunction(ResetUnitController, value.unit, timer.getTime()+ 1 ) 
					timer.scheduleFunction(doUnitLandClosestAirfield, myLanding , timer.getTime()+ 1.1 )
					timer.scheduleFunction(removeCancelledFriendlyGroup, {group=myGroupName} , timer.getTime()+ gMissionOptions.cancelMissionTime + math.random(1,20))
				end
			end

		end
		-- myReturnFlight = {group=input.group, memberGroups=myFlightMembers , leader=gMissionOptions.runningMissions[input.group].leader }
		-- doReturnToBase ( myReturnFlight  )
		gMissionOptions.runningMissions[input.mission.group] = nil 
end
function removeCancelledFriendlyGroup ( input )
	if Group.getByName(input.group) ~= nil then
		local myGroup = Group.getByName(input.group)
		Group.destroy(myGroup)
		if Debugging == true then printDebug ("EventHandler" , "Destroy Group " .. input.group  , 10 ) end
	end 
end 


function clearPlayingFieldOld ( input )
		--local myRequestingGroup = input.group
		local myRequestingCoalition = gMissionOptions.runningMissions[input.group].coalition
		gMissionOptions.runningMissions[input.group].following = nil 
		local myStatement = input.mission.airbaseName
		local myEnemies = {}
		local myFriendlies = {}
		local myFlightMembers = {}
		
		-- local myGroups = coalition.getGroups(myRequestingCoalition)
		local myUnits = coalition.getPlayers(myRequestingCoalition)
		local myGroups = {}
		
		for unitKey, unitValue in pairs (myUnits) do
			myGroups[Group.getName (Unit.getGroup( unitValue ))] = Group.getName ( Unit.getGroup( unitValue ) ) 
		end 
		for groupKey, groupValue in pairs (myGroups) do 
			--local myGroupName = Group.getName (groupValue)
			if Debugging == true then printDebug ("EventHandler" , "Tell Group " .. groupValue , 10 ) end
			sayInMission ( { what={[1]="endedMission", [2]="at",}, prepend=input.group , where=myStatement, group=groupValue  , duration=60 } )
		end
		
		for enemySortie , enemySortie in pairs (input.mission.enemyGroups) do 
			for enemyKey , enemyValue in pairs (enemySortie) do 
				myEnemies[enemyValue.group] = {group=enemyValue.group }
				-- if Debugging == true then printDebug ("EventHandler" , "Remove Enemy group " .. enemyValue.group , 10 ) end
			end  
		end 
		for sortieKey , sortieValue in pairs (input.mission.friendlyGroups) do 
			-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. sortieValue.group , 10 ) end
			for key , value in pairs (sortieValue) do 
				-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. value.group , 10 ) end
				myFriendlies[value.group] = {group=value.group }
			end  
		end 
		for key , value in pairs(gVisibleAIUnits) do
			local myUnit = 	Unit.getByName(value.unit)	
			local myGroupName = Group.getName(Unit.getGroup(myUnit))
			local myGroundAttribute = Unit.hasAttribute(myUnit, "Ground vehicles" )
			local myAirborneAttribute = Unit.hasAttribute(myUnit, "Air" )
			if myGroundAttribute == true and Unit.getCoalition(myUnit) ~= myRequestingCoalition and myEnemies[myGroupName] ~= nil then 
				Unit.destroy( Unit.getByName ( value.unit ) )
				removeUnitFromActiveTables ( {unit=value.unit} )
			end
			if myAirborneAttribute == true and Unit.getCoalition(myUnit) == myRequestingCoalition and myFriendlies[myGroupName] ~= nil then
				if myUnit:inAir() == false then 
					Unit.destroy( Unit.getByName ( value.unit ) )
					removeUnitFromActiveTables ( {unit=value.unit} )
				else 
					local mySpeed = gMissionOptions.runningMissions[input.group].humanSpeed
					local myAlt = gMissionOptions.runningMissions[input.group].transitionAlt
					local myLanding = {unit=value.unit ,coalition=myRequestingCoalition , speed=mySpeed , alt=myAlt}
					timer.scheduleFunction(ResetUnitController, value.unit, timer.getTime()+ 1 ) 
					timer.scheduleFunction(doUnitLandClosestAirfield, myLanding , timer.getTime()+ 1.1 )
				end
			end

		end
		-- myReturnFlight = {group=input.group, memberGroups=myFlightMembers , leader=gMissionOptions.runningMissions[input.group].leader }
		-- doReturnToBase ( myReturnFlight  )
		gMissionOptions.runningMissions[input.mission.group] = nil 
end
function uuid(input)
	local random = math.random
    local template = input.template --'xxxx'
    return string.gsub(template, '[xy]', function (c)
        local v = (c == 'x') and random(0, 0xf) or random(8, 0xb)
        return string.upper(string.format('%x', v))
    end)
end
function messageGroup ( input )
	
	
	local myBuiltText = "Group " .. input.group .. " Unit1 " .. input.unit .. " Type " .. Unit.getTypeName(Unit.getByName(input.unit))  .. " Count "  .. #Group.getUnits(Group.getByName(input.group))
	
	--if Debugging == true then printDebug ("EventHandler" , myBuiltText , 10 ) end 
	doPrintThis ({clearview = gMissionOptions.clearView  , group=input.group, duration= 30 , text=myBuiltText })

end
function doOptions ( input )
	-- deReference ( input )
	local myUnitObj = Unit.getByName(input.unit)
	local myGroupObj = Unit.getGroup (myUnitObj)
	local myPlayersGroup = Group.getName ( myGroupObj ) 
	local myOwningGroup = input.group 
	input.position = centerUnitCoordinates ( input.unit )
	local myAirport = findClosestAirbase ({position=input.position})
	local myAltimeter = AircraftType[string.upper(Unit.getTypeName(myUnitObj):gsub('[%p%c%s]', '') )].altimeter
	if input.owningGroup ~= nil then myOwningGroup = input.owningGroup end
	local myGroupMeasure = gPlayerGroups[myPlayersGroup].preferences.measure
	
	local myLocalPlayers = coalition.getPlayers(Unit.getCoalition(myUnitObj))
	local myUnits = {}
	for key , value in pairs(myLocalPlayers) do
		if Group.getName(Unit.getGroup ( value )) == myPlayersGroup then 
			myUnits[#myUnits+1] = value
			
		end 
	end 
	--local myUnits = myGroupObj:getUnits()
	
	
	--if Debugging == true then printDebug ("EventHandler" , "Units " .. #myUnits   , 10 ) end
				
	local myPrint = ""
	local myMeasureType = gMeasure.miles
	if myGroupMeasure == gMeasure.meters then 
		myMeasureType = gMeasure.kilometers				
	end 
	
	if input.menu == "Show Wind Direction" then 
		
	if myAirport.distance < 20000 then 
		local mySmokeTrigger = false 
		local myLocation = myAirport.point
		local myLocation = getPointOnRadian ( { diameter=1000 , pos=myLocation , angle = myAirport.angle })
		local myLocation = getPointOnRadian ( { diameter=200 , pos=myLocation , angle = myAirport.angle+(math.pi/2) })
		myLocation.y = land.getHeight{x = myLocation.x, y = myLocation.z}
 
		if gMissionOptions.smokeTimers == nil then gMissionOptions.smokeTimers ={} end
		if gMissionOptions.smokeTimers[myAirport.name] == nil then 
			mySmokeTrigger = true
			gMissionOptions.smokeTimers[myAirport.name] = { deployTime=timer.getTime() , }
		elseif ( timer.getTime() - gMissionOptions.smokeTimers[myAirport.name].deployTime ) > 260 then
			mySmokeTrigger = true
		end 
		if mySmokeTrigger == true then 
			trigger.action.smoke(myLocation, 2 )
		end 
		sayInMission ( { what={[1]="smokeon", [2]="at", } , where=myAirport.name , duration=20 , group=myPlayersGroup } )
	else
		sayInMission ( { what={[1]="notclose", [2]="at", } , where=myAirport.name , duration=20 , group=myPlayersGroup } )
	end 

	
	
		--if Debugging == true then printDebug ("EventHandler" , "Show Wind Direction " ..  myAirport.distance   , 10 ) end
	end 

	if input.menu == "To Closest Airfield" then 
		--if Debugging == true then printDebug ("EventHandler" , "Units " .. #myUnits   , 10 ) end
		for i=1,#myUnits do
			local myPlayerName = Unit.getPlayerName(myUnits[i])
			local myPlayerPosition = myUnits[i]:getPoint()
			local myFriendlyAirport = findClosestAirbase ({position=myPlayerPosition ,coalition=input.friendlycoa })
			local myKilometers = string.format("%.1f" , myFriendlyAirport.distance/1000)
			local myMiles = string.format("%.1f" , myFriendlyAirport.distance*MILES)
			local myBearing = string.format ("%03d", getBearingTwoPoints(myPlayerPosition , myFriendlyAirport.point))
			local myDistance = myMiles 
			if myGroupMeasure == gMeasure.meters then myDistance = myKilometers end 
			-- if Debugging == true then printDebug ("EventHandler" , "To Closest Airfield " ..  myPlayerName .. " " .. myMeasure  , 10 ) end
			myPrint = myPrint .. myPlayerName .. " - " .. gMissionOptions.sayThis[input.language].flyheading .. " " .. myBearing .. " " .. gMissionOptions.sayThis[input.language].sayfor  .. " " .. 
					  myDistance .. " " .. gMissionOptions.sayThis[input.language][myMeasureType] .. " " .. gMissionOptions.sayThis[input.language].sayfor .. " " .. myFriendlyAirport.name
			if i ~= #myUnits then myPrint = myPrint .. "\n" end 
		end
		--if Debugging == true then printDebug ("EventHandler" , "Print to group " ..  myPlayersGroup .. " from unit " .. input.unit, 10 ) end
		doPrintThis ({clearview = gMissionOptions.clearView  , group=myPlayersGroup, duration= 30 , text=myPrint })
	end 
	
	if input.menu == "To Target" then 
		-- gMissionOptions.runningMissions[input.group].
		
		local myLeaderUnit = ""
		--myLeaderUnit = Group.getByName(gMissionOptions.runningMissions[input.owningGroup].
		if Group.getByName(gMissionOptions.runningMissions[input.owningGroup].leader) == nil then 
			local myValidPlayerGroups = validPlayerGroups ( input )
			local myLeaderUnitObject = myValidPlayerGroups[input.owningGroup]:getUnit(1)
			myLeaderUnit = myLeaderUnitObject:getName()
		else
			myLeaderUnit = Unit.getName( Group.getByName(gMissionOptions.runningMissions[input.owningGroup].leader):getUnit(1))
		end 
		
		-- local myLeaderUnit = Unit.getName( Group.getByName(gMissionOptions.runningMissions[input.owningGroup].leader):getUnit(1))
		local myLeaderPosition = centerUnitCoordinates ( myLeaderUnit )
		
		for i=1,#myUnits do
			local myPlayerName = Unit.getPlayerName(myUnits[i])
			local myPlayerPosition = myUnits[i]:getPoint()
			local myBearing = string.format ("%03d", getBearingTwoPoints(myPlayerPosition , myLeaderPosition))
			local myDistance = getDistanceBetweenTwoPoints(myPlayerPosition , myLeaderPosition)
			

			local myEndingText = gMissionOptions.sayThis[input.language].tojoinup .. " " .. myLeaderUnit .. " " .. gMissionOptions.sayThis[input.language].at 
			
			if gMissionOptions.runningMissions[input.owningGroup].following ~= nil then 
				local myAlt = getMSLfeet ( myLeaderUnit )
				local myAltMeasure = gMeasure.feet
				if myGroupMeasure == gMeasure.meters then 
					myAlt = getMSLmeters ( myLeaderUnit )
					myAltMeasure = gMeasure.meters				
				end 
				myEndingText = myEndingText .. " " .. string.format ("%d",myAlt) .. " " .. myAltMeasure .. " " .. "MSL"
				--if Debugging == true then printDebug ("EventHandler" , "Join up with " ..  	gMissionOptions.runningMissions[input.owningGroup].leader .. " for group " .. input.group  , 10 ) end
			else
				myBearing = string.format ("%03d", getBearingTwoPoints(myPlayerPosition , gMissionOptions.runningMissions[input.owningGroup].position))
				myDistance = getDistanceBetweenTwoPoints(myPlayerPosition , gMissionOptions.runningMissions[input.owningGroup].position)
				local myActiveArea = gMissionOptions.runningMissions[input.owningGroup].activeArea
				myEndingText = gMissionOptions.sayThis[input.language].sayfor .. " " .. gMissionOptions.sayThis[input.language].target .. " " .. gMissionOptions.runningMissions[input.owningGroup].areas[myActiveArea].zoneAction
			--if Debugging == true then printDebug ("EventHandler" , "To Target " ..  	gMissionOptions.runningMissions[input.owningGroup].airbaseName .. " for group " .. input.group  , 10 ) end
			end 
			local myKilometers = string.format("%.1f" , myDistance/1000)
			local myMiles = string.format("%.1f" , myDistance*MILES)
			local myDistance = myMiles 
			if myGroupMeasure == gMeasure.meters then myDistance = myKilometers end
			
			myPrint = myPrint .. myPlayerName .. " - " .. gMissionOptions.sayThis[input.language].flyheading .. " " .. myBearing .. " " .. gMissionOptions.sayThis[input.language].sayfor  .. " " .. 
					  myDistance .. " " .. gMissionOptions.sayThis[input.language][myMeasureType] .. " " .. myEndingText -- gMissionOptions.sayThis[input.language].sayfor .. " " .. myFriendlyAirport.name
			if i ~= #myUnits then myPrint = myPrint .. "\n" end 
		end
		doPrintThis ({clearview = gMissionOptions.clearView  , group=myPlayersGroup, duration= 30 , text=myPrint })
	end
	
	if input.menu == gMissionOptions.sayThis["English"].intelligence then 
		doIntelligence ( input ) 
	end 
	
	if input.menu == gMissionOptions.sayThis["English"].menu_tankers then 
		doTankers ( input ) 
	end 
	-- end 
end 
function doIntelligence ( input ) 

	local myReport = {}
	local myDesc = gMissionOptions.runningMissions[input.group].description
	
	for enemyKey, enemyValue in pairs (gMissionOptions.runningMissions[input.group].enemyGroups) do 
		for groupKey, groupValue in pairs (enemyValue) do
			local myTemp = {}
			local myUnits = Group.getByName(groupValue.group):getUnits()
			
			if Object.hasAttribute(myUnits[1] , "AA_flak" ) then myTemp = { attribute="AA_flak" , category="AAA" , type=groupValue.type } end 
			if Object.hasAttribute(myUnits[1] , "SAM LL" )	then myTemp = { attribute="SAM LL" , category="Radar SAMS" , type=groupValue.type } end
			if Object.hasAttribute(myUnits[1] , "HeavyArmoredUnits" ) then myTemp = { attribute="HeavyArmoredUnits" , category="Heavy Armor" , type=groupValue.type } end
			if Object.hasAttribute(myUnits[1] , "LightArmoredUnits" ) then myTemp = { attribute="LightArmoredUnits" , category="Light Armor" , type=groupValue.type } end
			if Object.hasAttribute(myUnits[1] , "Submarines" ) then myTemp = { attribute="Submarines" , category="Submarines" , type=groupValue.type } end
			
			
			local myDescription = Unit.getDescByName(groupValue.type)

			if myReport[myTemp.attribute] ~= nil then 
				myReport[myTemp.attribute].count = myReport[myTemp.attribute].count + 1 	
			else
				myReport[myTemp.attribute] = { count = 1 , types={}, category=myTemp.category }
			end 
			
			if myReport[myTemp.attribute].types[myDescription.displayName] ~= nil then 
				myReport[myTemp.attribute].types[myDescription.displayName].count = myReport[myTemp.attribute].types[myDescription.displayName].count + 1
			else
				myReport[myTemp.attribute].types[myDescription.displayName] = {count=1}
			end 
			
		end 
	end 
	
	local myText = myDesc .. " **\n"
	for resultsKey, resultsValue in pairs (myReport) do
		myText = myText .. "\n"
		myText = myText .. resultsValue.category .. " (" .. resultsValue.count ..")\n"
		for typesKey, typesValue in pairs (resultsValue.types) do
			myText = myText .. "  " .. typesKey .. " (" .. typesValue.count ..")\n"
		end

	end 
	--if Debugging == true then printDebug ("EventHandler" , myText  , 10 ) end
	sayInMission ( { what={[1]="intelligence" , [2]="sayfor",  [3]="target", } , input.group , prepend=" **" , append=myText, duration=20 } )

end 
-- function sayInMission ( input )
	-- if Debugging == true then  printDebug ( "EventHandler" , "Broken" , 10 ) end
-- end
function sayInMission ( input )
	 
	--if Debugging == true then printDebug ("EventHandler" , input.group  , 10 ) end
	
	if input.duration == nil then input.duration = 30 end 
 
	if input.clearview == nil then input.clearview = gMissionOptions.clearView end 

	local myCoalition = 1
	local myGroupLanguage = gMissionOptions.preferences[myCoalition].language
	local myMeasure = gMissionOptions.preferences[myCoalition].measure
	
	local myValidGroups = validPlayerGroups ( input )
	

	
	if input.group ~= nil and (gMissionOptions.level == "coalition" or gMissionOptions.level == "country" or gMissionOptions.level == "mission" ) then  
			if gMissionOptions.level == "coalition" then 
				input.coalition = Group.getCoalition(myValidGroups[input.group]) 
			--	if Debugging == true then printDebug ("EventHandler" , "Coalition " .. input.coalition  , 10 ) end
			elseif gMissionOptions.level == "country" then 
				input.country = Unit.getCountry(myValidGroups[input.group]:getUnit(1))
			end 
			input.group = nil 
	end
	
	if input.group ~= nil then 
		--myCoalition = Group.getCoalition(Group.getByName(input.group))
		--local myType= Unit.getTypeName(Group.getByName(input.group):getUnit(1))
		--input.altimeter = Targets[string.upper(myType:gsub('[%p%c%s]', '') )].altimeter
		myCoalition = Group.getCoalition(myValidGroups[input.group])
		local myType= Unit.getTypeName(myValidGroups[input.group]:getUnit(1))
		input.altimeter = Targets[string.upper(myType:gsub('[%p%c%s]', '') )].altimeter
		
		if gPlayerGroups[input.group] ~= nil then 
			myGroupLanguage = gPlayerGroups[input.group].preferences.language
			myMeasure = gPlayerGroups[input.group].preferences.measure
		end 
	elseif input.country ~= nil then 
		myCoalition = coalition.getCountryCoalition(input.country)
		myGroupLanguage = gMissionOptions.preferences[myCoalition].language
		myMeasure = gMissionOptions.preferences[myCoalition].measure
	elseif input.coalition ~= nil then
		myCoalition = input.coalition
		myGroupLanguage = gMissionOptions.preferences[myCoalition].language
		myMeasure = gMissionOptions.preferences[myCoalition].measure
	end 

	local myPrint = ""
	if input.prepend ~= nil then 
		myPrint = input.prepend .. " " 
	end 
	for count = 1, #input.what do
		
		local mywhat = input.what[count]
		myPrint = myPrint .. gMissionOptions.sayThis[myGroupLanguage][mywhat]
		if mywhat == gMissionOptions.sayThis["English"].type then 
			myPrint = myPrint .. " " .. input.type
		end 
		if count ~= #input.what then
			if input.what[count+1] ~= nil then
				if input.what[count+1] ~= "period" then
					myPrint = myPrint .. " " 
				end
			end 
		end 
	
	end

	if input.where ~= nil then 
		myPrint = myPrint .. " " .. input.where
	end 
	myPrint = myPrint:gsub("^%l", string.upper)
	
	if input.altimeter == nil then input.altimeter = gMissionOptions.preferences[myCoalition].measure end 
	
	if input.who ~= nil then 
		myPrint = input.who .. ": " .. myPrint 
	end 
	
	if input.heading ~= nil then
		myPrint = myPrint .. " " .. gMissionOptions.sayThis[myGroupLanguage].heading .. " " .. string.format("%03d" ,input.heading) 
	end
	
	if input.bearing ~= nil then
		myPrint = myPrint .. " " .. gMissionOptions.sayThis[myGroupLanguage].bearing .. " " .. string.format("%03d" ,input.bearing) .. " " .. gMissionOptions.sayThis[myGroupLanguage].degrees 
	end
	
	local myUniqueStatement = myPrint -- HOLD ONTO THE UNIQUE STATEMENT TO THIS POINT
		
	if input.distance ~= nil then
		if string.lower(myMeasure) == string.lower(gMeasure.feet) then 
			--input.distance = input.distance*METERS_TO_FEET
			input.distance = math.floor((input.distance*METERS_TO_FEET)/100+ 1 * 0.5) * 100 --ROUND TO 100 FOR FEET
		else
			input.distance = math.floor((input.distance)/50+ 1 * 0.5) * 50 -- ROUND TO 5O METERS FOR METERS
		end 
		myPrint = myPrint .. " " .. string.format ("%d",input.distance) .. " " .. myMeasure
	end 
	
	if input.fordistance ~= nil or input.atdistance ~= nil then
		local myMeasureType = gMissionOptions.sayThis[myGroupLanguage].kilometers
		local mySay = gMissionOptions.sayThis[myGroupLanguage].sayfor
		
		local myDistance = 0
		if input.fordistance ~= nil then 
			myDistance = input.fordistance
		else 
			mySay = gMissionOptions.sayThis[myGroupLanguage].at 
			myDistance = input.atdistance
		end
		
		if string.lower(myMeasure) == string.lower(gMeasure.feet) then 
			myDistance = (myDistance*METERS_TO_FEET) / 5280
			myMeasureType = gMissionOptions.sayThis[myGroupLanguage].miles
		else
			myDistance = myDistance / 1000
		end 
		if Debugging == true then printDebug ("EventHandler" , "myPrint " .. myPrint  , 10 ) end
		if Debugging == true then printDebug ("EventHandler" , "mySay " .. myGroupLanguage .. " " .. mySay , 10 ) end
		if Debugging == true then printDebug ("EventHandler" , "myDistance " .. myDistance  , 10 ) end
		if Debugging == true then printDebug ("EventHandler" , "myMeasureType " .. myMeasureType  , 10 ) end
		myPrint = myPrint .. " " .. mySay .. " " .. string.format ("%d",myDistance) .. " " .. myMeasureType
	end 
	
	
	if input.speedAt ~= nil or input.speedTo ~= nil then
		local myAltimeter = gMissionOptions.sayThis[myGroupLanguage][input.altimeter]
		local myIndicated = gMissionOptions.sayThis[myGroupLanguage].indicated
		local myAtOrTo = gMissionOptions.sayThis[myGroupLanguage].to
		
		local mySpeed = {}
		if input.speedAt ~= nil then 
			myAtOrTo = gMissionOptions.sayThis[myGroupLanguage].at
			mySpeed = input.speedAt
		elseif input.speedTo ~= nil then  
			mySpeed = input.speedTo
		end

		local mySpeedMeasure = " kts "
		if input.altimeter == gMeasure.meters then 
			mySpeed.airspeed = mySpeed.airspeedmps * 3.6
			mySpeedMeasure = " kph "
		end 
		
		myPrint = myPrint .. " " .. myAtOrTo  .. " " .. string.format ("%d", mySpeed.airspeed) .. mySpeedMeasure .. myIndicated
	end
	
	if input.append ~= nil then 
		myPrint = myPrint .. " " .. input.append
	end
	
	if ( Debugging == true ) then env.info( myPrint, false ) end 
	
	

	
	if input.group ~= nil then
		--trigger.action.outTextForGroup(Group.getID(myValidGroups[input.group]), myPrint , input.duration , input.clearview )
		--if Debugging == true then  printDebug ( "EventHandler" , "Said to group" , 10 ) end
		if gPlayerGroups[input.group].lastSaid == myUniqueStatement and gPlayerGroups[input.group].preferences.instructions == gMissionOptions.sayThis["English"].menu_items_instructions[1] then  
			doPrint = true 
			-- if Debugging == true then  printDebug ( "EventHandler" , "Said to group because repeating "  , 10 ) end
		elseif gPlayerGroups[input.group].lastSaid ~= myUniqueStatement then 
			doPrint = true
			-- if Debugging == true then  printDebug ( "EventHandler" , "Said to group because unique "  , 10 ) end
		end
		if doPrint == true then 
			trigger.action.outTextForGroup(Group.getID(myValidGroups[input.group]), myPrint , input.duration , input.clearview )
			gPlayerGroups[input.group].lastSaid = myUniqueStatement
		end
	elseif input.coalition ~= nil then
		for key , value in pairs(myValidGroups) do
			local doPrint = false 
			if input.coalition == Group.getCoalition(myValidGroups[key]) then
				if gPlayerGroups[key].lastSaid == myUniqueStatement and gPlayerGroups[key].preferences.instructions == gMissionOptions.sayThis["English"].menu_items_instructions[1] then  
					doPrint = true 
					-- if Debugging == true then  printDebug ( "EventHandler" , "Said to coalition because repeating "  , 10 ) end
				elseif gPlayerGroups[key].lastSaid ~= myUniqueStatement then 
					doPrint = true
					-- if Debugging == true then  printDebug ( "EventHandler" , "Said to coalition because unique "  , 10 ) end
				end
				if doPrint == true then 
					trigger.action.outTextForGroup(Group.getID(myValidGroups[key]), myPrint , input.duration , input.clearview )
					gPlayerGroups[key].lastSaid = myUniqueStatement
					
				end 
			end 
		end 
		--trigger.action.outTextForCoalition(input.coalition , myPrint , input.duration , input.clearview )
	elseif input.country ~= nil then
		-- trigger.action.outTextForCountry(input.country , myPrint , input.duration , input.clearview )
		--if Debugging == true then  printDebug ( "EventHandler" , "Said to country" , 10 ) end
		for key , value in pairs(myValidGroups) do
			local doPrint = false 
			if input.country == Unit.getCountry(myValidGroups[key]:getUnit(1)) then
				if gPlayerGroups[key].lastSaid == myUniqueStatement and gPlayerGroups[key].preferences.instructions == gMissionOptions.sayThis["English"].menu_items_instructions[1] then  
					doPrint = true 
					if Debugging == true then  printDebug ( "EventHandler" , "Said to country because repeating "  , 10 ) end
				elseif gPlayerGroups[key].lastSaid ~= myUniqueStatement then 
					doPrint = true
					if Debugging == true then  printDebug ( "EventHandler" , "Said to country because unique "  , 10 ) end
				end
				if doPrint == true then 
					trigger.action.outTextForGroup(Group.getID(myValidGroups[key]), myPrint , input.duration , input.clearview )
					gPlayerGroups[key].lastSaid = myUniqueStatement
					
				end 
			end 
		end 
	else --OUTPUT TO MISSION
		if Debugging == true then  printDebug ( "EventHandler" , "Said to mission and always repeating" , 10 ) end
		trigger.action.outText( myPrint , input.duration , input.clearview )
		-- if Debugging == true then  printDebug ( "EventHandler" , "Said to mission always repeating" , 10 ) end
		-- for key , value in pairs(myValidGroups) do
			-- local doPrint = false 
			-- if gPlayerGroups[key].lastSaid == myUniqueStatement and gPlayerGroups[key].preferences.instructions == gMissionOptions.sayThis["English"].menu_items_instructions[1] then  
				-- doPrint = true 
				-- if Debugging == true then  printDebug ( "EventHandler" , "Said to mission because repeating "  , 10 ) end
			-- elseif gPlayerGroups[key].lastSaid ~= myUniqueStatement then 
				-- doPrint = true
				-- if Debugging == true then  printDebug ( "EventHandler" , "Said to mission because unique "  , 10 ) end
			-- end
			-- if doPrint == true then 
				-- trigger.action.outTextForGroup(Group.getID(myValidGroups[key]), myPrint , input.duration , input.clearview )
				-- gPlayerGroups[key].lastSaid = myUniqueStatement
			-- end 
		-- end 
	end 



	

	
end 


function determinePlayers ( input )
	local mySides = getOppositeSide ( { group=input.group} )
	local myValidGroups = validPlayerGroups ( )
	local myPlayers = coalition.getPlayers(mySides.friendlycoa)
	local myPlayersGroups = {}
	local myNoHumanPlayer = true
	local myPlayersAirborne = false 
	local mySpawnDelayTimer = 0
	local myPlayersInSortie = 0 
	input.playerCount = 0
	local myReturnSpeed = gMissionOptions.topSpeed
	gMissionOptions.runningMissions[input.group].topSpeedModifier = gMissionOptions.TopSpeedPercent
	-- do the parking Map
	local myFriendlyAirport = findClosestAirbase ({playerGroup=input.group ,coalition=mySides.friendlycoa })
	if gMissionOptions.parkingMaps[myFriendlyAirport.id] == nil then 
		gMissionOptions.parkingMaps[myFriendlyAirport.id] = getParkingClosestToActive ({ type=104 , airfield=myFriendlyAirport.id })
	end 
	
	for aiKey , aiValue in ipairs(gMissionOptions.friendlySortie) do
		local myAIspeed = (Targets[string.upper(aiValue.type:gsub('[%p%c%s]', '') )].speed)
		if myAIspeed < myReturnSpeed then myReturnSpeed = myAIspeed end 
		if Debugging == true then  printDebug ( "EventHandler" , "Check Speed " ..aiValue.type .. " " .. myAIspeed  , 10 ) end
	end
	
	local myHumanGroups = "humanGroupsBlue" 
	if mySides.friendlycoa == coalition.side.RED then myHumanGroups = "humanGroupsRed" end 
	
	-- DETERMINE IF ANY PLAYERS OCCUPY A SORTIE SLOT BASED ON gMissionOptions.friendlyGroups NAME MATCH
	 for playerKey , playerValue in pairs(myPlayers) do
		local myGroupName = Group.getName ( Unit.getGroup(playerValue))
		local myType = Unit.getTypeName(playerValue)
		local myTypeDescription = Unit.getDescByName(myType)
		if Object.inAir(playerValue) == true then myPlayersAirborne = true end 
		local myPlayerSpeed = (Targets[string.upper(myType:gsub('[%p%c%s]', '') )].speed)
		if myPlayerSpeed < myReturnSpeed then myReturnSpeed = myPlayerSpeed end 

		--- GET PLAYER OBJECTS SPEED

		if myTypeDescription.speedMax ~= nil then
			if myTypeDescription.speedMax < 280 or myTypeDescription.speedMax < gMissionOptions.runningMissions[input.group].topSpeedModifier then 
				gMissionOptions.runningMissions[input.group].topSpeedModifier = gMissionOptions.TopSpeedPercentProp
			end 
		end 


		-- if Debugging == true then printDebug ("EventHandler" , "Human Speed " ..  myPlayerSpeed , 10 ) end
		if gMissionOptions[myHumanGroups][myGroupName] ~= nil then -- A PLAYER IS IN ONE OF THE GROUPS
			--if Debugging == true then printDebug ("EventHandler" , "Human in sortie " .. gMissionOptions[myHumanGroups][myGroupName]  , 10 ) end
			myPlayersGroups[gMissionOptions[myHumanGroups][myGroupName]] = { group=myGroupName, type=myType, sortie=gMissionOptions[myHumanGroups][myGroupName] }
			input.playerCount = input.playerCount + 1			
		end 
	 end
	gMissionOptions.runningMissions[input.group].humanSpeed = myReturnSpeed
	if Debugging == true then  printDebug ( "EventHandler" , "Human Speed " .. gMissionOptions.runningMissions[input.group].humanSpeed , 10 ) end
	
	local myAirborne = Object.inAir(myValidGroups[input.group]:getUnit(1))
	local myCountem = 0
	input.aiCount = 0 

	if gMissionOptions.level == "coalition" then
		for count=1,#gMissionOptions.friendlySortie do
			--if Debugging == true then printDebug ("EventHandler" , "Checking ".. count .. " " ..  gMissionOptions.friendlySortie[count].sortie , 10 ) end
			-- if myPlayersGroups[aiValue.sortie] == nil or gMissionOptions.humansFill == nil then
			if myPlayersGroups[gMissionOptions.friendlySortie[count].sortie] == nil or gMissionOptions.humansFill == nil then
				input.aiCount = input.aiCount + 1
				local myDelay = input.aiCount * .1
				if myAirborne then myDelay = .1 end  
				mySpawnDelayTimer = mySpawnDelayTimer + myDelay			
				timer.scheduleFunction(spawnAircraft, gMissionOptions.friendlySortie[count] , timer.getTime()+ myDelay ) 
			end
		end
	end 

	if gMissionOptions.level == "group" then
		--local myUnits = Group.getUnits(myValidGroups[input.group])
		--local myUnits =  Group.getUnits(Group.getByName(input.group))
		--local myGroup = Group.getGroup (myValidGroups[input.group]
		-- #gMissionOptions.friendlySortie
		local myPlayerCount = 0 
		local myDifficulty = 6-(gPlayerGroups[input.group].preferences.difficulty)
		for playerKey , playerValue in pairs(myPlayers) do
			local myGroupName = Group.getName ( Unit.getGroup(playerValue))
			if myGroupName == input.group then myPlayerCount = myPlayerCount + 1 end 
		end 
		if Debugging == true then printDebug ("EventHandler" , "Difficulty " .. input.group .. " " .. myDifficulty , 10 ) end

		for count=1,#gMissionOptions.friendlySortie do
			--if (count == 1) or (count + myPlayerCount <= 4) or gMissionOptions.humansFill == nil then
			if (count == 1) or (count + myPlayerCount <= myDifficulty) or gMissionOptions.humansFill == nil then
				input.aiCount = input.aiCount + 1
				local myDelay = input.aiCount * .1
				if myAirborne then myDelay = .1 end  
				mySpawnDelayTimer = mySpawnDelayTimer + myDelay			
				timer.scheduleFunction(spawnAircraft, gMissionOptions.friendlySortie[count] , timer.getTime()+ myDelay ) 
			end 
		end
	
	end 
	
	if input.playerCount >= gMissionOptions.capacity and gMissionOptions.humansFill ~= nil then 
		if Debugging == true then printDebug ("EventHandler" , "Player Slots full "  , 10 ) end
		gMissionOptions.runningMissions[input.group].following = nil 
		gMissionOptions.runningMissions[input.group].leader = input.group
		gMissionOptions.runningMissions[input.group].atCapacity = true 
	end 
	
	--determineCapacity ( input )
	
	--if Debugging == true then printDebug ("EventHandler" , "Delay " ..  mySpawnDelayTimer , 10 ) end
	-- deReference( gMissionOptions.runningMissions[input.group] )
	if gMissionOptions.runningMissions[input.group].following ~= nil then 
		timer.scheduleFunction( followGroup ,  input , timer.getTime()+ mySpawnDelayTimer )
	end 
	
	--- PLAYERS THAT BELONG IN THE PROXIMITY QUEUE
	gMissionOptions.runningMissions[input.group].proximityQueue = {}
	for playerKey , playerValue in ipairs(myPlayers) do
		local myPlayerGroupName = Group.getName(Unit.getGroup(myPlayers[playerKey]))
		local myPlayerUnitName = Unit.getName(playerValue)
		if ( gMissionOptions.level == "group" and myPlayerGroupName == input.group ) or ( gMissionOptions.level == "coalition" ) or  ( gMissionOptions.level == "mission" ) then	
				gMissionOptions.runningMissions[input.group].proximityQueue[#gMissionOptions.runningMissions[input.group].proximityQueue+1] = {unit=myPlayerUnitName , group=myPlayerGroupName}
				local myUnitName = gMissionOptions.runningMissions[input.group].proximityQueue[#gMissionOptions.runningMissions[input.group].proximityQueue].unit
				--if Debugging == true then printDebug ("EventHandler" , myUnitName .. " belongs in proximity queue" , 10 ) end
		end
	end
	
end 
function clearEnemy ( input )
		--local myRequestingGroup = input.group
		local myRequestingCoalition = gMissionOptions.runningMissions[input.group].coalition
		local myStatement = input.mission.airbaseName
		local myEnemies = {}
		local myFriendlies = {}
		local myFlightMembers = {}
		
		-- local myGroups = coalition.getGroups(myRequestingCoalition)
		local myUnits = coalition.getPlayers(myRequestingCoalition)
		local myGroups = {}
		
		for unitKey, unitValue in pairs (myUnits) do
			myGroups[Group.getName (Unit.getGroup( unitValue ))] = Group.getName ( Unit.getGroup( unitValue ) ) 
		end 
		for groupKey, groupValue in pairs (myGroups) do 
			--local myGroupName = Group.getName (groupValue)
			if Debugging == true then printDebug ("EventHandler" , "Tell Group " .. groupValue , 10 ) end
			sayInMission ( { what={[1]="endedMission", [2]="at",}, prepend=input.group , where=myStatement, group=groupValue  , duration=60 } )
		end
		
		for enemySortie , enemySortie in pairs (input.mission.enemyGroups) do 
			for enemyKey , enemyValue in pairs (enemySortie) do 
				myEnemies[enemyValue.group] = {group=enemyValue.group }
				if Debugging == true then printDebug ("EventHandler" , "Remove Enemy group " .. enemyValue.group , 10 ) end
			end  
		end 
		for sortieKey , sortieValue in pairs (input.mission.friendlyGroups) do 
			-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. sortieValue.group , 10 ) end
			for key , value in pairs (sortieValue) do 
				-- if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. value.group , 10 ) end
				myFriendlies[value.group] = {group=value.group }
			end  
		end 
		for key , value in pairs(gVisibleAIUnits) do
			local myUnit = 	Unit.getByName(value.unit)	
			local myGroupName = Group.getName(Unit.getGroup(myUnit))
			local myGroundAttribute = Unit.hasAttribute(myUnit, "Ground vehicles" )
			local myLauncherAttribute = Unit.hasAttribute(myUnit, "SAM LL" )
			local myAirborneAttribute = Unit.hasAttribute(myUnit, "Air" )
			if myGroundAttribute == true and myLauncherAttribute == false and Unit.getCoalition(myUnit) ~= myRequestingCoalition and myEnemies[myGroupName] ~= nil then 
				if Debugging == true then printDebug ("EventHandler" , "Remove Friendly group " .. myGroupName , 10 ) end
				Unit.destroy( Unit.getByName ( value.unit ) )
				removeUnitFromActiveTables ( {unit=value.unit} )
			end
		end
end
function GroupHasTask ( input ) 
	local _group = Group.getByName(input.group)
	if _group ~= nil then 
		local _controller = Group.getController(_group) 
		local myHasTask = _controller.hasTask(_controller )
		if ( myHasTask  == true ) then 
			if Debugging == true then printDebug ( "EventHandler" , input.group .. " has task" , 10 ) end
		else 
			if Debugging == true then printDebug ( "EventHandler" , input.group .. " does not have task" , 10 ) end
		end 
	end 
	-- if Debugging == true then printDebug ( "Controller" , "Sucess Sending Control to: " .. myGroup, 10 ) end
end
function startSortie ( input )
		local myLeaderName = Unit.getName ( Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1) )
		sayInMission ( { who=myLeaderName, what={[1]="joinup",} , coalition=gMissionOptions.runningMissions[input.group].coalition  , duration=20 } ) 
end
function checkForLostTasks( input ) 
	if gMissionOptions.runningMissions ~= nil then 
		for groupKey, groupValue in pairs (gMissionOptions.runningMissions) do
			-- if Debugging == true then printDebug ("EventHandler" , "Group  " .. groupValue.group  , 1.1 ) end
			for sortieKey, sortieValue in pairs (groupValue.sorties) do
				for sortieGroupKey , sortieGroupValue in ipairs (sortieValue) do
					local _group = Group.getByName(sortieGroupValue.group)
					if _group ~= nil then 
						local _controller = Group.getController(_group) 
						local myHasTask = _controller.hasTask(_controller )
						if ( myHasTask  ~= true ) then 
							groupHasLostTask ({ group=groupKey, groups=sortieGroupValue.group , sortie=sortieKey } )
						elseif gMissionOptions.runningMissions[groupKey].lostTasks ~= nil and myHasTask == true then 
							if gMissionOptions.runningMissions[groupKey].lostTasks[sortieGroupValue.group] ~= nil then 
								gMissionOptions.runningMissions[groupKey].lostTasks[sortieGroupValue.group] = nil
							--	if Debugging == true then printDebug ("EventHandler" , "Reset   " .. sortieGroupValue.group .. " lost task. " , 10 ) end
							end
						end 
					end
				end 
			end 
		end 
	end 
end 

-- MENU COMMANDS
function doMenuItems(input) 
	local myValidGroups = validPlayerGroups ( input )

	-- TAKE INTO ACCOUNT GROUP STARTING MISSING MIGHT BE NOW EMPTY AND DIFFERENT THAN GROUP ENDING MISSION
	if myValidGroups[input.group] == nil and gMissionOptions.coalitionEnd == true and ( gMissionOptions.level == "coalition" or gMissionOptions.level == "country" or gMissionOptions.level == "mission" ) then 
		myValidGroups[input.group] = Group.getByName(input.callingGroup) -- SWAP CALLING GROUP INTO OWNING GROUP
	end 
	
	input.friendlycoa = Group.getCoalition(myValidGroups[input.group])
	input.friendlycountryid =  Unit.getCountry(myValidGroups[input.group]:getUnit(1))
	input.unit = Unit.getName( myValidGroups[input.group]:getUnit(1)  )

	input.friendlycountry = country.name[input.friendlycountryid]
	if input.language == nil then input.language = gPlayerGroups[input.group].preferences.language end
	
	input.enemycoa = coalition.side.RED
	input.enemycountry = gMissionOptions.redCountries[math.random(1,#gMissionOptions.redCountries)]
	input.enemycountryid = country.id[input.enemycountry] 
	
	if input.friendlycoa == coalition.side.RED then 
		input.enemycoa = coalition.side.BLUE
		input.enemycountry = gMissionOptions.blueCountries[math.random(1,#gMissionOptions.blueCountries)]
		input.enemycountryid = country.id[input.enemycountry] 
	end 
	
	--- GET NUMBER1 UNIT FROM THE MENU CHOICE GROUP
	-- local myUnit = Group.getByName(input.group):getUnit(1) 
	-- input.unit = Unit.getName( myUnit )
	-- input.unit = Unit.getName( myValidGroups[input.group]:getUnit(1)  )
	input.spawnPosition = centerUnitCoordinates ( input.unit )
	input.heading = doGetUnitHeading ({name=input.unit})
	input.spawncountry = input.friendlycountryid
	if input.country == "enemy" then input.spawncountry = input.enemycountryid end

	
	-- SPAWNING MENUS ---
	-- if input.choice == gMissionOptions.sayThis["English"].menu_items.startMission then
		-- spawnDefenses (input)
		-- loadFriendlySorties ( input )
		-- determinePlayers ( input )
		-- doRadioCommand (input) 
		-- sayMissionPlan ( input )
	-- end 	
	
	-- if input.choice == gMissionOptions.sayThis["English"].menu_items.options then
		-- doOptions ( input )
	-- end 
	
	if input.choice == 'LanguageChange' then
		languageChange ( input )
	end 
	if input.choice == 'MeasurmentChange' then
		measurmentChange ( input ) 
	end
	
	if input.choice == 'DifficultyChange' then
		difficultyChange ( input )
	end 
	
	if input.choice == 'EnemySkillChange' or input.choice == 'FriendlySkillChange' then
		skillChange ( input ) 
	end 
	if input.choice == 'InstructionsChange' then
		instructionsChange ( input )
	end 
	if input.choice == 'DemoAircraftSpawn' then
		demoAircraftSpawn (input)
	end

	if input.choice == 'DestroyLeader' then
		destroyLeader( input )
		--doHandleUnitRemoval ( input )
	end
	
	if input.choice == 'ReloadMenus' then
		-- if Debugging == true then printDebug ("Menus" , "Reloaded Menus "  , 10 ) end
		doRadioCommand ({unit=input.unit})
		-- reloadAllMenus ( input )
	end
	
	if input.choice == 'ReloadToolbox' then
		assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\toolbox\\toolbox.lua"))() 
	end	if input.choice == 'ReloadOnetime' then
		assert(loadfile("C:\\Users\\brad\\Saved Games\\DCS\\Missions\\Multiplayer Template\\multiplayer_onetime.lua"))() 
	end

	if input.choice == 'MessageGroup' then
		messageGroup ( input )
	end 
	
	if input.choice == 'GetTarget' then
		getTarget (input)
	end 
	
	if input.choice == 'UnHoldGroup' then
		unHoldGroup ({group=input.group, holdingGroup = gMissionOptions.friendlyGroups.WildWeasels , chatter=true ,})
	end
	
	if input.choice == 'GroupHasTask' then
		GroupHasTask ({group=gMissionOptions.runningMissions[input.group].leader ,})
	end

	if input.choice == 'TurnGroup' then

		--local myHeading = doGetUnitHeading ({name=myLeadUnit})
		-- local myAngle = getAngleBetweenTwoPointsV2(Unit.getPoint(Unit.getByName(myLeadUnit))  , gMissionOptions.runningMissions[input.group].position )
		--local myDifference = (180/math.pi ) * ( math.abs(myHeading.angle - myAngle) )
		local myLeadUnit = Unit.getName(Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1))
		local myAngle = getAngleBetweenTwoPointsV2( Unit.getPoint(Unit.getByName(myLeadUnit)), gMissionOptions.runningMissions[input.group].position )
		local myHeading = doGetUnitHeading ({name=myLeadUnit})
		local mySide = PointLeftOrRight ( {unit=myLeadUnit, position= gMissionOptions.runningMissions[input.group].position } )
		local myTurnDegrees = math.abs ( math.atan2(math.sin(myHeading.angle - myAngle ), math.cos(myHeading.angle - myAngle )))
		
		doFormationAerobaticTurn ({group=input.group , side=mySide , holdSpeed=300,  degrees=(180/math.pi)*myTurnDegrees , action="turn" , roll=35  })
	end	
	
	if input.choice == 'SpawnDefenses' then
		spawnDefenses (input)
	end

	if input.choice == 'SpawnOffensive' then
		spawnDefenses (input)
		followGroup (input)
	end
	
	if input.choice == 'LoadTraffic' then
		trafficRadarSweep( input )
		-- loadAirbases ( input )
		-- loadTraffic ({group=input.group,})
	end
	
	if  input.choice == 'ClearPlayingField' then
		clearPlayingField ( input )
		doRadioCommand (input)
	end 
	
	if  input.choice == 'ClearEnemy' then
		clearEnemy ( input )
	end 
	
	if input.choice == 'ClearRedEnemy' then 
		clearRedEnemy ( input )
	end 
	
	if input.choice == 'LoadEnemyPositions' then 
		loadEnemyPositions ( input )
	end
	
	if input.choice == 'DeReference' then
		deReference( gMissionOptions.runningMissions[input.group] )
	end 

	missionMenuItems ( input )
end
function doRadioCommand (input) 
	-- local myUnitObject = Unit.getByName(input.unit)
	-- local myCoalition = Unit.getCoalition(myUnitObject)
	-- local myGroupObject = Unit.getGroup(myUnitObject)
	-- local myGroupName = Group.getName(myGroupObject) 
	-- local myGroupID = Group.getID(myGroupObject)
	-- local myLanguage = gMissionOptions.defaultPreferences.language
	-- local myLanguage = gPlayerGroups[myGroupName].preferences.language
	
	--missionCommands.removeItemForGroup(myGroupID, nil )
	--missionCommands.removeItemForCoalition(myCoalition ,nil)
	local myValidPlayerGroups = validPlayerGroups ( input )
	
	missionCommands.removeItem( nil )
	local commandDB = {}

	for groupKey, groupValue in pairs (gPlayerGroups) do 

		local myUnitObject = myValidPlayerGroups[groupValue.group]:getUnit(1)
		local myUnitName = Unit.getName(myUnitObject)
		local myCoalition = Unit.getCoalition(myUnitObject)
		local myGroupObject = Unit.getGroup(myUnitObject)
		local myGroupName = Group.getName(myGroupObject) 
		local myGroupID = Group.getID(myGroupObject)
		local myOwningGroup = myGroupName --WE ARE USING GROUPS BUT WE WANT COALITION AS THE KEY FOR MISSIONS
				
		local myLanguage = gPlayerGroups[myGroupName].preferences.language
		local myDifficulty = gPlayerGroups[myGroupName].preferences.difficulty
		local myTankers = gPlayerGroups[myGroupName].preferences.tankers
		-- local myMeasure = gPlayerGroups[myGroupName].preferences.measure
		--local myEnemySkill = gPlayerGroups[myGroupName].preferences.enemySkill
		--local myFriendlySkill = gPlayerGroups[myGroupName].preferences.friendlySkill
		
		local myGroupDifficulty = gMissionOptions.sayThis[myLanguage].menu_items_difficulty[gPlayerGroups[myGroupName].preferences.difficulty]
		
		local myLevel = groupValue.group 
		if gMissionOptions.level == "coalition" then myLevel = myCoalition end 
		
		-- START THE MISSION
		local myRunningMission = {}
		if  gMissionOptions.runningMissions ~= nil then 
			for missionKey, missionValue in pairs (gMissionOptions.runningMissions) do
				--myRunningMission[missionValue.coalition] = {group=missionValue.group, coalition=missionValue.coalition }
				local myMissionLevel = missionValue.group
				if gMissionOptions.level == "coalition" then myMissionLevel = missionValue.coalition end  
				myRunningMission[myMissionLevel] = {group=missionValue.group, coalition=missionValue.coalition }
				-- if Debugging == true then printDebug ("EventHandler" , missionValue.coalition .. " " .. missionValue.group  , 10 ) end
			end 
		end 
		-- if myRunningMission[myCoalition] == nil then 
		if myRunningMission[myLevel] == nil then
			local menuName = gMissionOptions.sayThis[myLanguage].menu_items.startMission .. " (" .. myGroupDifficulty .. ")"
			local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice=gMissionOptions.sayThis["English"].menu_items.startMission , group=myGroupName , })
		end 
			-- DO THE CUSTOM FOR THIS MISSION
		local menuName = gMissionOptions.sayThis[myLanguage].menu_items.options
		local menu1 = missionCommands.addSubMenuForGroup(myGroupID , menuName , commandDB[menuName] )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_options do
			local myShowMenu = true 
			-- PREFEREBCE TI ALLOW SMOKE ON TARGET
			if gMissionOptions.smokeOnAirbase == nil and gMissionOptions.sayThis["English"].menu_items_options[count] == "Show Wind Direction"  then -- SMOKE ON TARGET PREF
				myShowMenu = false
			end 
			-- IS ACTIVE MISSION RUNNING SHOW VECTOR TO TARGET
			if myRunningMission[myLevel] == nil and gMissionOptions.sayThis["English"].menu_items_options[count] == "To Target"  then -- SMOKE ON TARGET PREF
				myShowMenu = false
			end
			-- SPAWN TANKER
			if gMissionOptions.sayThis["English"].menu_items_options[count] == gMissionOptions.sayThis["English"].menu_tankers then -- SMOKE ON TARGET PREF
				if Targets[gPlayerGroups[myGroupName].key].tanker == nil or gMissionOptions.tanker_attributes.allow == false then  
					myShowMenu = false
				end 
			end
			-- IS ACTIVE MISSION AND PREFERENCE TO SHOW INTELLIGENCE 
			if myRunningMission[myLevel] == nil and gMissionOptions.sayThis["English"].menu_items_options[count] == gMissionOptions.sayThis["English"].intelligence  then -- SHOW INTELLIGENCE REPORT
				myShowMenu = false
			end
			
			if myShowMenu == true then 
				local menuItem = missionCommands.addCommandForGroup(myGroupID, gMissionOptions.sayThis[myLanguage].menu_items_options[count], menu1  , doMenuItems , {choice=gMissionOptions.sayThis["English"].menu_items.options , menu=gMissionOptions.sayThis["English"].menu_items_options[count], language=myLanguage, group=myGroupName ,owningGroup=myOwningGroup })
			end
		end
		
		--- END THE MISSION
		--if myRunningMission[myCoalition] ~= nil then 
		if myRunningMission[myLevel] ~= nil then
			
			--myOwningGroup = myRunningMission[myCoalition].group
			myOwningGroup = myRunningMission[myLevel].group
			
			--if myRunningMission[myCoalition].group == myGroupName or gMissionOptions.coalitionEnd == true then 
			if myRunningMission[myLevel].group == myGroupName or gMissionOptions.coalitionEnd == true then 
				-- local myMission = gMissionOptions.runningMissions[myRunningMission[myCoalition].group]
				local myMission = gMissionOptions.runningMissions[myRunningMission[myLevel].group]
				local menuName = gMissionOptions.sayThis[myLanguage].menu_items.endMission
				local subMenu = missionCommands.addSubMenuForGroup(myGroupID , menuName, commandDB[menuName] )
				local menuName = gMissionOptions.sayThis[myLanguage].areyousure
				local subMenu = missionCommands.addSubMenuForGroup(myGroupID , menuName, subMenu )
				local menuName = gMissionOptions.sayThis[myLanguage].yes
				-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , subMenu , doMenuItems, {choice="ClearPlayingField" , language=myLanguage, group=myRunningMission[myCoalition].group , mission=myMission })
				local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , subMenu , doMenuItems, {choice="ClearPlayingField" , callingGroup=myGroupName , language=myLanguage, group=myRunningMission[myLevel].group , mission=myMission })
				-- local menu1 = missionCommands.addSubMenuForCoalition(myCoalition , menuName , commandDB[menuName] )
				
			end 
			--local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice=gMissionOptions.sayThis["English"].menu_items.startMission , group=myGroupName , })
		end 
		
		-- PREFERENCES
		local menuName = gMissionOptions.sayThis[myLanguage].menu_items.preferences
		local prefMenu = missionCommands.addSubMenuForGroup(myGroupID , menuName , commandDB[menuName] )
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID , "Language" , prefMenu )
		for menuKey, menuValue in pairs (gMissionOptions.languageChoices) do
			local menuItem = missionCommands.addCommandForGroup(myGroupID  , menuValue, subMenu , doMenuItems , {choice = "LanguageChange" , changeTo=menuValue, group=myGroupName })
		end
		-- DIFFICULTY
		local myDifficulty = gMissionOptions.sayThis[myLanguage].difficulty .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_difficulty[myDifficulty] .. ")"
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myDifficulty , prefMenu )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_difficulty do
			local menuItem = missionCommands.addCommandForGroup(myGroupID  , gMissionOptions.sayThis[myLanguage].menu_items_difficulty[count] .. " (" .. count .. ")", subMenu , doMenuItems , {choice = "DifficultyChange" ,  language=myLanguage, difficulty=count, group=myGroupName })
		end
		--- ENEMY SKILL
		local myEnemySkill = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_skill , gPlayerGroups[myGroupName].preferences.enemySkill )
		local myEnemy = gMissionOptions.sayThis[myLanguage].menu_enemy_skill .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_skill[myEnemySkill] .. ")"
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myEnemy , prefMenu )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_skill do
			local menuItem = missionCommands.addCommandForGroup(myGroupID , gMissionOptions.sayThis[myLanguage].menu_items_skill[count] , subMenu , doMenuItems , {choice = "EnemySkillChange" , key=count, changeTo=gMissionOptions.sayThis[myLanguage].menu_items_skill[count], group=myGroupName })
		end
		
		--- FRIENDLY SKILL
		local myFriendlySkill = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_skill , gPlayerGroups[myGroupName].preferences.friendlySkill )
		local myFriendly = gMissionOptions.sayThis[myLanguage].menu_friendly_skill .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_skill[myFriendlySkill] .. ")"
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myFriendly , prefMenu )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_skill do
			local menuItem = missionCommands.addCommandForGroup(myGroupID , gMissionOptions.sayThis[myLanguage].menu_items_skill[count] , subMenu , doMenuItems , {choice = "FriendlySkillChange" , key=count, changeTo=gMissionOptions.sayThis[myLanguage].menu_items_skill[count], group=myGroupName })
		end
		-- INSTRUCTIONS  --
		if  gPlayerGroups[myGroupName].preferences.instructions == nil then gPlayerGroups[myGroupName].preferences.instructions = gMissionOptions.sayThis["English"].menu_items_instructions[1] end
		local myInstructionsKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_instructions , gPlayerGroups[myGroupName].preferences.instructions )
		local myInstructions = gMissionOptions.sayThis[myLanguage].menu_instructions .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_instructions[myInstructionsKey] .. ")"
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myInstructions , prefMenu )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_instructions do
			local menuItem = missionCommands.addCommandForGroup(myGroupID , gMissionOptions.sayThis[myLanguage].menu_items_instructions[count] , subMenu , doMenuItems , {choice = "InstructionsChange" , key=count, changeTo=gMissionOptions.sayThis[myLanguage].menu_items_instructions[count], group=myGroupName })
		end
		-- UNITS OF MEASURE
		local myMeasureKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_measure , gPlayerGroups[myGroupName].preferences.measure )
		local myMeasurements = gMissionOptions.sayThis[myLanguage].menu_measure .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_measure[myMeasureKey] .. ")"
		local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myMeasurements , prefMenu )
		for count = 1, #gMissionOptions.sayThis["English"].menu_items_measure do
			local menuItem = missionCommands.addCommandForGroup(myGroupID , gMissionOptions.sayThis[myLanguage].menu_items_measure[count] , subMenu , doMenuItems , {choice = "MeasurmentChange" , key=count, changeTo=gMissionOptions.sayThis[myLanguage].menu_items_measure[count], group=myGroupName })
		end
		
		-- -- TANKERS
		-- local myTankersKey = getKeyForValue( gMissionOptions.sayThis["English"].menu_items_tankers , gPlayerGroups[myGroupName].preferences.tankers )
		-- local myTankers = gMissionOptions.sayThis[myLanguage].menu_tankers .. " (" .. gMissionOptions.sayThis[myLanguage].menu_items_tankers[myTankersKey] .. ")"
		-- local subMenu = missionCommands.addSubMenuForGroup(myGroupID ,  myMeasurements , prefMenu )
		-- for count = 1, #gMissionOptions.sayThis["English"].menu_items_measure do
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID , gMissionOptions.sayThis[myLanguage].menu_items_measure[count] , subMenu , doMenuItems , {choice = "MeasurmentChange" , key=count, changeTo=gMissionOptions.sayThis[myLanguage].menu_items_measure[count], group=myGroupName })
		-- end
		


		-- if Debugging == true then printDebug ("EventHandler" , "Reload Menu for unit " .. myUnitName .. " in group " .. myGroupID , 10 ) end
		
		if gDev ~= nil then

			local menuName = "Demo Aircraft Spawn"
			local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "DemoAircraftSpawn" , group= myGroupName ,})

			
			local menuName = "Reload Menus " .. myGroupName
			local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ReloadMenus" , group = myGroupName , })
			
			local menuName = "Destroy Leader "
			local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "DestroyLeader" , group= myGroupName ,})
			
			-- local loadEnemyPositions
			-- local menuName = "Load Enemy Positions"
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "LoadEnemyPositions" , group= myGroupName ,})
			-- local menuName = "ClearEnemy" 
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ClearEnemy" , language=myLanguage, group=myGroupName , mission=gMissionOptions.runningMissions[myGroupName] })
			-- --local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ClearEnemy" , language=myLanguage, group=myRunningMission[myCoalition].group , mission=gMissionOptions.runningMissions[myRunningMission[myCoalition].group] })
					
			local menuName = "ClearRedEnemy"
			local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ClearRedEnemy" , language=myLanguage, group=myGroupName })

			-- local menuName = "Turn Group"
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "TurnGroup" , group= myGroupName ,})
			
			-- local menuName = "GroupHasTask"
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "GroupHasTask" , group= myGroupName ,})
			
			-- local menuName = "Load Traffic"
			-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems , {choice = "LoadTraffic" , group= myGroupName ,})
			
		end 

	end

	-- if Debugging == true then printDebug ("EventHandler" , "End of the menu reload" , 10 ) end

end 
function doRadioCommandOld (input) 

	-- if Debugging == true then printDebug ("Menus" , "Reloaded Menus"   , 10 ) end
	local myUnitObject = Unit.getByName(input.unit)
	local myCoalition = Unit.getCoalition(myUnitObject)
	local myGroupObject = Unit.getGroup(myUnitObject)
	local myGroupName = Group.getName(myGroupObject) 
	local myGroupID = Group.getID(myGroupObject)
	local myLanguage = gMissionOptions.defaultPreferences.language
	local myLanguage = gPlayerGroups[myGroupName].preferences.language
	
	-- missionCommands.removeItemForGroup(myGroupID, nil )
	--missionCommands.removeItemForCoalition(myCoalition ,nil)
	missionCommands.removeItem( nil )
	local commandDB = {}
	
	-- local menuName = "Spawn Defenses"
	-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="SpawnDefenses" , group = myGroupName , })
	
	-- local menuName = "Spawn Offensive"
	-- local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="SpawnOffensive" , group = myGroupName , })
	
	local myRunningMission = {}
	if  gMissionOptions.runningMissions ~= nil then 
		for missionKey, missionValue in pairs (gMissionOptions.runningMissions) do
			myRunningMission[missionValue.coalition] = {group=missionValue.group, coalition=missionValue.coalition }
		end 
	end 
	
	if myRunningMission[myCoalition] == nil then 
		local menuName = gMissionOptions.sayThis[myLanguage].menu_items.startMission
		local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice=gMissionOptions.sayThis["English"].menu_items.startMission , group=myGroupName , })
	
	end 	
	
	local menuName = gMissionOptions.sayThis[myLanguage].menu_items.endMission
	local menu1 = missionCommands.addSubMenu(menuName, commandDB[menuName] )
	--missionCommands.addSubMenuForGroup(number groupId , string name , table path)
	 
		--local menuItem = missionCommands.addCommandForGroup(myGroupID, menu1 , commandDB[menuName] , doMenuItems, {choice=gMissionOptions.sayThis["English"].menu_items.endMission , group = myGroupName , }) 
	local menuName = gMissionOptions.sayThis[myLanguage].menu_items.options
	--local menu1 = missionCommands.addSubMenu(menuName, commandDB[menuName] )
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID , menuName , commandDB[menuName] )
	for count = 1, #gMissionOptions.sayThis["English"].menu_items_options do
		 -- if Debugging == true then printDebug ("EventHandler" , "Adding" .. gMissionOptions.sayThis["English"].menu_items_options[count] .. " in groupID " .. myGroupID , 10 ) end
		local myShowMenu = true 
		if gMissionOptions.smokeOnAirbase == nil and gMissionOptions.sayThis["English"].menu_items_options[count] == "Show Wind Direction"  then -- SMOKE ON TARGET PREF
			myShowMenu = false
		end 
		if gMissionOptions.runningMissions[myGroupName] == nil and gMissionOptions.sayThis["English"].menu_items_options[count] == "To Target"  then -- SMOKE ON TARGET PREF
			myShowMenu = false
		end 
		if myShowMenu == true then 
			-- local menuItem = missionCommands.addCommand(gMissionOptions.sayThis[myLanguage].menu_items_options[count], menu1 , doMenuItems, {choice="Options", menu=gMissionOptions.sayThis["English"].menu_items_options[count], language=myLanguage, group=myGroupName })
			local menuItem = missionCommands.addCommandForGroup(myGroupID, gMissionOptions.sayThis[myLanguage].menu_items_options[count], menu1  , doMenuItems , {choice="Options", menu=gMissionOptions.sayThis["English"].menu_items_options[count], language=myLanguage, group=myGroupName })
		end

		--local menuItem = missionCommands.addCommand(languageValue, subMenu1 , doMenuItems, {choice = "SmokeAirfield" , language=languageValue, group=myGroupName })	
	end

	local menuName = gMissionOptions.sayThis[myLanguage].menu_items.preferences
	-- local menu1 = missionCommands.addSubMenu(menuName, commandDB[menuName] )
	local menu1 = missionCommands.addSubMenuForGroup(myGroupID , menuName , commandDB[menuName] )
	local subMenu1 = missionCommands.addSubMenu("Language", menu1)
	local subMenu = missionCommands.addSubMenuForGroup(myGroupID , "Language" , commandDB[menuName] )
	for menuKey, menuValue in pairs (gMissionOptions.languageChoices) do 
		-- local menuItem = missionCommands.addCommand(menuValue, subMenu1 , doMenuItems, {choice = "LanguageChange" , language=menuValue, group=myGroupName })
		local menuItem = missionCommands.addCommandForGroup(myGroupID  , menuValue, subMenu1 , doMenuItems , {choice = "LanguageChange" , language=menuValue, group=myGroupName })
	end 

	
	local menuName = "Clear Playing Field"
	local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ClearPlayingField" , group = myGroupName , })
	
	
	local menuName = "Reload Menus"
	local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="ReloadMenus" , group = myGroupName , })
	
	local menuName = "Test Task"
	local menuItem = missionCommands.addCommandForGroup(myGroupID, menuName , commandDB[menuName] , doMenuItems, {choice="TestTask" , group = myGroupName , })

	

end
function reloadAllMenus ( input )
	for groupKey, groupValue in pairs (gPlayerGroups) do 
		local myUnitName = Unit.getName(Group.getByName(groupValue.group):getUnit(1))
		doRadioCommand ({unit=myUnitName})
	--	 if Debugging == true then printDebug ("EventHandler" , "Reload Menu for unit" .. myUnitName .. " in group " .. groupValue.group , 10 ) end
	end 
end 

-- FINDING TARGETS 
function getTarget ( input ) -- GET A OPPOSING TARGET BASED ON GROUPS AIRCRAFT TYPE

	local myRequest = {}
	local myValidGroups = validPlayerGroups ()
	if myValidGroups[input.group] == nil then myValidGroups[input.group] = Group.getByName( input.group ) end -- MAYBE A PLAYER DIDN'T REQUEST THE TARGET

	if input.assetpack == nil then myRequest.assetpack = true else myRequest.assetpack = input.assetpack end
	if input.accurate == nil then myRequest.accurate = true else myRequest.accurate = input.accurate end
	if input.category == nil then myRequest.category = MissionCombat.FIGHTER.category else myRequest.category = input.category end

	local myUnitObject = myValidGroups[input.group]:getUnit(1)
	myRequest.type = Unit.getTypeName(myUnitObject)
	local myKey = string.upper(myRequest.type:gsub('[%p%c%s]', '') ) -- only letters and numbers left in a string 
		
	myRequest.retired = Targets[myKey].retired
	myRequest.enterservice = Targets[myKey].enterservice
	myRequest.country = Targets[myKey].country
	
	if input.retired ~= nil then myRequest.retired = input.retired end -- push the retired out to always find something
	
	local myTargetTable = checkTargetTables (myRequest)
	local myActiveTarget = myTargetTable[math.random( 1, #myTargetTable )]
 	
		-- if Debugging == true then  printDebug ( "EventHandler" , "Look between: " .. myRequest.enterservice  .. " " .. myRequest.retired  , 10 ) end
	if input.samecountry ~= nil then 
		if input.samecountry == true then 
			myRequest.country = myActiveTarget.country
			myTargetTable = checkTargetTables (myRequest)
			myActiveTarget = myTargetTable[math.random( 1, #myTargetTable )]
		end 
	end 
	
	-- for targetKey,targetValue in pairs(myTargetTable) do
		-- if Debugging == true then printDebug ("EventHandler" , "Picked " .. targetValue.type , 10 ) end
	-- end
	
	local myReturn = myActiveTarget
	if input.all ~= nil then myReturn = myTargetTable end 
		
	
	return myReturn
end
function checkTargetTables (input)

		local myWWIIAssets = input.assetpack
			
		local myTargets = { } -- HOLD ALL THE TARGETS THAT MATCH SELECTED CATEGORY, YEARS, AND AIRCRAFT
		for targetKey,targetValue in pairs(Targets) do -- ITERATE THROUGH THE TARGEST TABLLE 
		-- ITERATE THROUGH LOOKING FOR MATCHING TARGETS CATEGORIES
		-- if Debugging == true then  printDebug ( "EventHandler" , "Available targets: " ..  Targets[targetKey].category .. " " .. input.mission.category , 10 ) end
		if ( string.upper(Targets[targetKey].category) == string.upper(input.category) ) or (input.category == CombatCategory.ZRandom) then -- DOES THE TARGET CATEGORY MATCH THE menu SELECTION or random
			--if Debugging == true then  printDebug ( "EventHandler" , "Available targets: " ..  Targets[targetKey].category .. " " .. input.category , 10 ) end
			local doSpawn = {year=false , historical=true , wwii=true}
	
			if ( input.enterservice >= Targets[targetKey].enterservice and input.enterservice <= Targets[targetKey].retired ) or ( Targets[targetKey].enterservice >= input.enterservice and Targets[targetKey].enterservice <= input.retired ) then
				doSpawn.year = true
				-- if Debugging == true then  printDebug ( "EventHandler" , Targets[targetKey].type , 10 ) end
			end
			
			-- CHECK FOR A HISTORICALLY ACCURATE FOE
			-- if ( gHistoricalFoes == 1 ) and (input.country == Targets[targetKey].country) then -- the player and target match countries
			if ( input.accurate == true ) and (input.country == Targets[targetKey].country) then -- the player and target match countries
				doSpawn.historical = false
			end
			
			-- CHECK FOR WWII ASSET PACK
			-- if ( gWWIIAssets == false and Targets[targetKey].asset == "WWII" ) then 
			if ( myWWIIAssets == false and Targets[targetKey].asset == "WWII" ) then 
				doSpawn.wwii = false
			end 
			
			-- check the flag for year and historical and wwii asset pack
			--if (doSpawn.year == true and doSpawn.historical == true and doSpawn.wwii == true  ) then
			if (doSpawn.year == true and doSpawn.historical == true and doSpawn.wwii == true ) then
				myTargets[#myTargets+1] =  Targets[targetKey]
				--if Debugging == true then  printDebug ( "EventHandler" , "Match: " .. Targets[targetKey].type  .. " " .. Targets[targetKey].enterservice .. " - " ..  Targets[targetKey].retired .. " Player: " .. PlayerAircraft.enterservice .. " - " .. PlayerAircraft.retired  , 10 ) end
			
			end
		end 
	end

	-- local myActiveTarget = myTargets[math.random( 1, #myTargets )]
	-- --if Debugging == true then  printDebug ( "EventHandler" , "Random Pick: " .. myActiveTarget.type  .. " " .. myActiveTarget.enterservice .. " - " ..  myActiveTarget.retired .. " Player: " .. PlayerAircraft.enterservice .. " - " .. PlayerAircraft.retired  , 10 ) end
	-- return myActiveTarget
	return myTargets
	
end
function preLoadTargets ( input )

	local myRemoval = {}
	local myEnterService = 2050
	local myRetired = 1900
	local myPreloadName = "Preload"
	
	-- local mySpawnType = Group.Category.AIRPLANE -- Group.Category.SHIP
	-- local myMedium = { [Group.Category.GROUND]="Ground" , [Group.Category.SHIP]="Water" , [Group.Category.AIRPLANE]="Airborne" , [Group.Category.HELICOPTER]="Airborne" }


	local myFoundTargets = {}
	for categoryKey , categoryValue in ipairs ( gMissionOptions.targetCategories ) do
		local myTargetFound = getTarget ( { group=input.group , category=categoryValue , accurate=true, assetpack=gMissionOptions.WWIIassets, all=true ,  } ) --all=true returns all vs one.  samecountry=true returns same country as unit that called this
		for targetKey , targetValue in ipairs ( myTargetFound ) do
			myFoundTargets[#myFoundTargets+1] = targetValue.type 
		end 
	end 
	
	local function myDelay ( )
		for targetKey, targetValue in pairs ( myFoundTargets ) do 
				local myDesc = Unit.getDescByName(targetValue )
				local mySpawn = { 	name=myPreloadName, 
									spawn_type=myDesc.category , 
									type=targetValue, 
									altType="RADIO",
									lateActivation = true ,
									}
				local myBuiltSpawn = doBuildSpawn (mySpawn)
				coalition.addGroup(80, myDesc.category , myBuiltSpawn ) --82: UN_PEACEKEEPERS
		end
		local myGroup = Group.getByName(myPreloadName)
		Group.destroy(myGroup)
	end 

	timer.scheduleFunction(myDelay, {} , timer.getTime()+ .1 )
	doPrintThis ({clearview = false , duration= 1.1 , group=input.group , text="Mission will pause as it loads objects. This step may take a long time after a DCS update" })

end 

-- AI CONTROL FUNCTIONS
function doReturnToBase ( input )
	for landingKey , landingGroup in pairs(gMissionOptions.friendlyGroups) do
		landAtAirbase({group=input.group, airbase=gMissionOptions.runningMissions[input.group].airbase,	landingGroup=landingGroup })
	end 
	
end
function unHoldGroup ( input )
		local myGroupsToRelease = {}
		if gMissionOptions.runningMissions[input.group] ~= nil then 
			if gMissionOptions.runningMissions[input.group].sorties[input.holdingGroup] ~= nil then 
				for groupKey , groupValue in pairs(gMissionOptions.runningMissions[input.group].sorties[input.holdingGroup]) do
					
					if Group.getByName(groupValue.group) ~= nil and groupValue.human == nil then 
						if Group.getByName(groupValue.group) ~= nil then 
							local myUnitObject = Group.getByName(groupValue.group):getUnit(1)
							local myUnitName = Unit.getName(myUnitObject)
							local myType= Unit.getTypeName(myUnitObject)
							local myAttackSpeed = Targets[string.upper(myType:gsub('[%p%c%s]', '') )].speed * .90
							local myAlt = getMSLfeet(myUnitName)
							if myAttackSpeed >=600 then myAttackSpeed = 600 end 
							myGroupsToRelease[#myGroupsToRelease+1] = {group=groupValue.group , speed=myAttackSpeed , alt=myAlt}
						end 
					end 
				end 
			end
		end
		
		--if Debugging == true then printDebug ("EventHandler" , "Unholding Sortie" .. input.holdingGroup, 10 ) end
		
		local myDelay = 0
		for engageKey , engageValue in pairs(myGroupsToRelease) do
			
			myDelay = myDelay + 1
			local myRoute = {}  
			local myPosition = gMissionOptions.runningMissions[input.group].position
			local myTargets = gMissionOptions.runningMissions[input.group].tasks[input.holdingGroup].targets
			local myNotTargets = gMissionOptions.runningMissions[input.group].tasks[input.holdingGroup].noTargets
			
			-- local myTargetString = ""
			-- for targetKey , targetValue in pairs(myTargets) do
				-- myTargetString = myTargetString .. " " .. targetValue
			-- end 
			-- if Debugging == true then printDebug ("EventHandler" , "Group " .. engageValue.group .. " inbound. Speed " .. engageValue.speed  .. " Alt " .. engageValue.alt .. " for " .. myTargetString ,  10 ) end
			
			local unitObj = Group.getByName(engageValue.group):getUnit(1)
			local myUnitName = Unit.getName(unitObj)
			local myHeading = doGetUnitHeading ({name=myUnitName})
			local myUnitPos = centerUnitCoordinates (myUnitName)
			local mySpeedUpPoint = getPointOnRadian ( { radius=1000 , pos=myUnitPos , angle = myHeading.angle })
			myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=mySpeedUpPoint , alt=engageValue.alt , altType="BARO" , speed=engageValue.speed }
			myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myPosition , alt =engageValue.alt  , altType="BARO" , speed=engageValue.speed }
			
			-- input.tasks = {}
			-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1 ,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes=myTargets , noTargetTypes=myNotTargets, priority = 0 , } }
			-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE
			-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.RTB_ON_BINGO, },},} } --NO RTB BINGO


			

			-- -- timer.scheduleFunction(ResetGroupController, engageValue.group, timer.getTime()+ (5*myDelay) )   			
			-- -- timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ (6*myDelay) + 0.1 )
			-- --local myChatter = { group=engageValue.group , id=AI.Option.Air.id.SILENCE , value = true } 
			-- if input.chatter ~= nil and engageKey == 1 then 				
				-- --myChatter.value = false 
				-- if Debugging == true then printDebug ("EventHandler" , "Start talking after unholding" .. engageValue.group  , 10 ) end
				-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO RTB BINGO
			-- else
				-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO RTB BINGO
			-- end
			
			local myTasks = {group=input.group, sortie=input.holdingGroup , }	
			if input.chatter ~= nil and engageKey == 1 then 
				myTasks.chatter = true
			end 
			local myTasking = getTasking ( myTasks  )
			-- local myInfo = { group = groupValue.leader , route=myRoute , tasks=myTasking , push=true } 
			
			local myInfo = {}                                                                                                             
			myInfo = { group = engageValue.group , route=myRoute , tasks=myTasking, push=true } 
			
			-- timer.scheduleFunction(scheduleSendOptionToGroup, myChatter, timer.getTime()+ 0.1  )
			-- timer.scheduleFunction(ResetGroupController, engageValue.group, timer.getTime() + 0.2 )  			
			--
			
			-- local myTargeting = { group=engageValue.group,  distance = 100000 , priority=0 , types=myTargets, notTypes=myNotTargets } --BUILD THE TRANSMISSION TABLE          
			-- timer.scheduleFunction(doEngageTargetsV2, myTargeting, timer.getTime()+ myDelay + 0.4 )
			
			timer.scheduleFunction(ResetGroupController, engageValue.group, timer.getTime() + 0.1 ) 
			timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ 0.2 )
		end

		-- local targets = ""		
		-- for targetKey , targetValue in pairs (gMissionOptions.runningMissions[input.group].tasks[input.holdingGroup].targets) do 
			-- targets = targets .. targetValue .. " "  
		-- end 
		
		-- if Debugging == true then printDebug ("EventHandler" , "Targets are " .. targets  .. "for " .. input.holdingGroup, 10 ) end
end 
function resetHoldingParameters ( input )
	if gMissionOptions.runningMissions[input.group].leader ~= input.group then 
		gMissionOptions.runningMissions[input.group].following = true
		gMissionOptions.runningMissions[input.group].ingressHold = nil
		gMissionOptions.runningMissions[input.group].toldTurn = nil
		gMissionOptions.runningMissions[input.group].inrangeTimer = nil
		gMissionOptions.runningMissions[input.group].speedupTimer = nil
		gMissionOptions.runningMissions[input.group].straightLevelTimer = timer.getTime() 
	end 
end 
function holdGroup ( input ) 
	local myGroupsToHold = {}
	-- local myHoldingPosition = gMissionOptions.runningMissions[input.group].holdingPosition
	local myHoldingPosition = input.position
	local myPealDelay = 0 
	if input.pealAway ~= nil then myPealDelay = 5 end 

	
	if input.holdingGroups ~= nil and gMissionOptions.runningMissions[input.group] ~= nil then 
		for groupKey , groupValue in pairs(input.holdingGroups) do
			--if Debugging == true then printDebug ("EventHandler" , "Holding Group " .. groupValue.group , 10 ) end 
			if Group.getByName(groupValue.group) ~= nil and groupValue.human == nil then 
				
				local myType= Unit.getTypeName(Group.getByName(groupValue.group):getUnit(1))
				local myHoldingSpeed = Targets[string.upper(myType:gsub('[%p%c%s]', '') )].speed * gMissionOptions.holdingSpeed
				if myHoldingSpeed >=300 then myHoldingSpeed = 300 end 
				if input.speed ~= nil then myHoldingSpeed = input.speed end
				myGroupsToHold[#myGroupsToHold+1] = {group=groupValue.group , speed=myHoldingSpeed }
			end 
		end 	
		--end
		 
		
		local myDelay = 0

		for holdKey , holdValue in pairs(myGroupsToHold) do
			
			gMissionOptions.runningMissions[input.group].groupsHolding[holdValue.group] = holdValue.group
			myDelay = myDelay + 1
			local myLocation = { callsign_group=holdValue.group, point=myHoldingPosition   , type = "Circle" , alt=input.alt , speed=holdValue.speed, } --racetrack_point=myPointTwo   }  -- "Race-Track" or "Circle" -- zone = "TaskGroupSpawnZone"
			
			if input.racetrack_point ~= nil then 
				myLocation.racetrack_point = input.racetrack_point
				myLocation.type = "Race-Track"
				 
			end 
			
			-- timer.scheduleFunction(ResetGroupController, holdValue.group, timer.getTime()+ (5*myDelay) )  
			-- timer.scheduleFunction(doHoldPattern, myLocation, timer.getTime() + (5*myDelay) + 0.1 )
			local myChatter = { group=holdValue.group , id=AI.Option.Air.id.SILENCE , value = true } 
			-- if holdValue.group == gMissionOptions.runningMissions[input.group].leader then 				
				-- myDelay.value = false 
				-- if Debugging == true then printDebug ("EventHandler" , "Start talking " .. holdValue.group  , 10 ) end
			-- end
			if input.chatter ~= nil and holdKey == 1 then 				
				myChatter.value = false 
				-- if Debugging == true then printDebug ("EventHandler" , "Start talking " .. holdValue.group  , 10 ) end
			end
			timer.scheduleFunction(scheduleSendOptionToGroup, myChatter, timer.getTime()+ 0.4  )
			timer.scheduleFunction(ResetGroupController, holdValue.group, timer.getTime()+ 0.5 )  
			timer.scheduleFunction(doHoldPattern, myLocation, timer.getTime()  + 0.6 + myPealDelay )
			
			


			-- if Debugging == true then printDebug ("EventHandler" , holdValue.group.. " needs to hold at " .. input.alt   , 10 ) end
		end 
	else
		if Debugging == true then printDebug ("EventHandler" , "Owning group " .. input.group.. " Improper holding command "   , 10 ) end
	end 
end
function landAtAirbase ( input )
	local myUnitsToLand = {}
	local myAirbase = input.airbase
	if input.landingGroup ~= nil then 
	
		if gMissionOptions.runningMissions[input.group].sorties[input.landingGroup] ~= nil then 
			for groupKey , groupValue in pairs(gMissionOptions.runningMissions[input.group].sorties[input.landingGroup]) do

				if Group.getByName(groupValue.group) ~= nil and groupValue.human == nil then 
					local myType= Unit.getTypeName(Group.getByName(groupValue.group):getUnit(1))
					local myLandingSpeed = Targets[string.upper(myType:gsub('[%p%c%s]', '') )].speed * .80
					if myLandingSpeed >=400 then myLandingSpeed = 400 end 
					for index, data in pairs(Group.getByName(groupValue.group):getUnits()) do
						myUnitsToLand[#myUnitsToLand+1] = {unit=Unit.getName(data) , group=groupValue.group, speed=myLandingSpeed }
					end 
					
				end 
			end 
			--if Debugging == true then printDebug ("EventHandler" , "Sending Landing command to " .. input.landingGroup .. " at " .. gMissionOptions.runningMissions[input.group].transitionAlt/FEET , 10 ) end
		end 
		--end

		local myDelay = 0

		for landingKey , landingValue in pairs(myUnitsToLand) do
			myDelay = myDelay + 1
			local myLanding = {unit=landingValue.unit ,coalition=gMissionOptions.runningMissions[input.group].coalition , speed=landingValue.speed/KNOTS , alt=gMissionOptions.runningMissions[input.group].transitionAlt/FEET }
			--local myLanding = {unit=landingValue.unit ,airbase=3, speed=landingValue.speed/KNOTS , alt=gMissionOptions.runningMissions[input.group].transitionAlt/FEET }
			if input.airbase ~= nil then myLanding.airbase = input.airbase end --DO WE ALREADY KNOW WHERE WE ARE LANDING?
			
			timer.scheduleFunction(ResetGroupController, landingValue.group, timer.getTime()+ 1 ) 
			-- timer.scheduleFunction(ResetUnitController, landingValue.unit, timer.getTime()+ 10 ) 
			
			timer.scheduleFunction(doUnitLandClosestAirfield, myLanding , timer.getTime()+ 1.1 )
		end 
	end 
	
	

end 
function doPromoteToLeader ( input )

	sayInMission ( { who=input.leader, what={[1]="promoted", } , group=input.group , duration=20 } ) 

	local myTransitionAlt = gMissionOptions.runningMissions[input.group].transitionAlt
	local myLeaderName = Unit.getName ( Group.getByName(input.leader):getUnit(1) )
	local myLeaderPosition = centerUnitCoordinates(myLeaderName)
	local myFirstWayPoint = getPointOnRadian ( { radius=1000 , pos=myLeaderPosition , angle=getAngleBetweenTwoPointsV2(myLeaderPosition , gMissionOptions.runningMissions[input.group].position) })
	local mySpeed = gMissionOptions.runningMissions[input.group].humanSpeed
	local myRoute = {}
	myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myFirstWayPoint , alt=myTransitionAlt , altType="BARO" , speed=mySpeed }
	myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=gMissionOptions.runningMissions[input.group].position , alt=myTransitionAlt , altType="BARO" , speed=mySpeed }
	
	local myTasking = getTasking ( {group=input.group, chatter=true, sortie=gMissionOptions.runningMissions[input.group].leadSortie , } )

	local myInfo = { group = gMissionOptions.runningMissions[input.group].leader , route=myRoute , tasks=myTasking , push=true } 
	timer.scheduleFunction(ResetGroupController, gMissionOptions.runningMissions[input.group].leader, timer.getTime()+ 0.1 )   			
	timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + 0.2 )
	timer.scheduleFunction(followGroup, {group=input.group}, timer.getTime() + 0.3 )
	
	if  gMissionOptions.runningMissions[input.group].ingressHold ~= nil then gMissionOptions.runningMissions[input.group].ingressHold = nil end 
	
	--sayInMission ( { who=myLeaderName, what={[1]="promoted", } , group=sayValue.group , speedAt=mySpeed , duration=20 } ) 
end 
function followGroup ( input )
	--local myLeadGroupSortie = gMissionOptions.friendlyGroups.WildWeasels
	--local myLeadGroupSortie = gMissionOptions.runningMissions[input.group].leadSortie
	--local myLeadGroupSortie = gMissionOptions.runningMissions[input.group].sorties.
	local myLeadGroup = ""
	local myFollowGroups = {}
	local myCountem = 0
	local formationTrail = -20
	local formationAbeamRotary = 40
	local formationAbeamFixed = 30
	local formationAbeam = formationAbeamFixed
	local formationAbove = 5 
	local expansionValue = 10 
	local myLeadGroupWidth = formationAbeam
	local myLeadGroupTrail = formationTrail
	
	--if Debugging == true then printDebug ("EventHandler" , "Leader Group " .. gMissionOptions.runningMissions[input.group].leader  , 10 ) end

 
	
	--for friendlyKey , friendlyValue in pairs(gMissionOptions.friendlyGroups) do  
	-- for friendlyKey , friendlyValue in pairs(gMissionOptions.friendlyGroups) do 
			-- myCountem = myCountem +1
			-- if Debugging == true then printDebug ("EventHandler" , "Friendly Group " .. friendlyKey  , 10 ) end
			-- for groupKey , groupValue in pairs(gMissionOptions.runningMissions[input.group].sorties[friendlyKey]) do
				-- if friendlyKey == myLeadGroupSortie and groupKey == 1 then 
					-- myLeadGroup = groupValue.group
				-- else
					-- myFollowGroups[#myFollowGroups+1] = {group=groupValue.group , sortie=friendlyKey }
					-- if groupValue.human ~= nil then myFollowGroups[#myFollowGroups].human = true end 
				-- end 
			-- end 
	-- end
	
	
	-- local mySortBy = { [1] = gMissionOptions.friendlyGroups.CloseAirSupport , [2]=gMissionOptions.friendlyGroups.AirDefense , [3]=gMissionOptions.friendlyGroups.Airborne } 
	-- for sort = 1 , #mySortBy do 
		-- for count=1 , #myFollowGroups do
			-- if myFollowGroups[count].sortie == mySortBy[sort] then
				-- local myGroup = myFollowGroups[count].group 
				-- local mySortie = myFollowGroups[count].sortie 
				-- local myHuman = myFollowGroups[count].human 
				-- table.remove (myFollowGroups, count)
				-- myFollowGroups[#myFollowGroups+1] = {group=myGroup , sortie=mySortie }
				-- if myHuman ~= nil then myFollowGroups[#myFollowGroups].human = true end 
			-- end 
		-- end
	-- end 
	
	-- CHECK WHAT UNITS STILL ALIVE
	for memberKey , memberValue in pairs(gMissionOptions.runningMissions[input.group].followGroups) do
		local myGroup = Group.getByName ( memberValue.group )
		--#Group.getByName(myGroup):getUnits()
		if myGroup ~= nil then 
			if memberKey == 1 then 
				gMissionOptions.runningMissions[input.group].leader = memberValue.group
				gMissionOptions.runningMissions[input.group].leadSortie = memberValue.sortie
				local myUnits = Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnits()
				local myDescription = Unit.getDesc(myUnits[1])
				
				if myDescription.box == nil then 
					--if Debugging == true then printDebug ("EventHandler" , "Box empty "  , 10 ) end
					myDescription.box= {min = {y=-3, x=-9, z=-7,},max={y=2,x=11,z=9,},}
					-- myDescription.box = {max={z=9,},} 
					-- myDescription.box = {max={x=11,},}
					-- myDescription.box = {min={x=7,},}
				end
				--deReference ( myDescription )
				
				if myDescription.category == Group.Category.HELICOPTER then
					-- formationAbeam = formationAbeamRotary
					formationTrail = formationTrail * 2
				end 
				myLeadGroupWidth = ((((myDescription.box.max.z) * 2 ) + formationAbeam) * #myUnits ) /2
				myLeadGroupTrail = formationTrail * math.ceil(#myUnits /2)
				-- if Debugging == true then printDebug ("EventHandler" , "Follow Leader " .. gMissionOptions.runningMissions[input.group].leader .. " of " ..  gMissionOptions.runningMissions[input.group].leadSortie , 10 ) end
				SendOptionToGroup ( gMissionOptions.runningMissions[input.group].leader , AI.Option.Air.id.FORMATION ,  gFormationType.WWIIFighterTight  ) 
			else
				myFollowGroups[#myFollowGroups+1] = {group=memberValue.group , sortie=memberValue.sortie }
				--if groupValue.human ~= nil then myFollowGroups[#myFollowGroups].human = true end 
				-- if Debugging == true then printDebug ("EventHandler" , "Follower " .. memberValue.group .. " of " ..  memberValue.sortie , 10 ) end
			end 
		end 
	end 
	

	
	
	for count=1 , #myFollowGroups do

		if myFollowGroups[count].human == nil and Group.getByName(myFollowGroups[count].group) ~=nil then 
			local myUnits = Group.getByName(myFollowGroups[count].group):getUnits()
			local myDescription = Unit.getDesc(myUnits[1])
			if myDescription.box == nil then 
				myDescription.box= {min = {y=-3, x=-9, z=-7,},max={y=2,x=11,z=9,},}
				-- myDescription.box = {max={z=9,},} 
				-- myDescription.box = {max={x=11,},}
				-- myDescription.box = {min={x=7,},}
			end
			
			--local myAbeamDecide = ( math.ceil ( formationAbeam + (((myDescription.box.max.z) * 2 ) * #myUnits ))) *-1
		
			local myAbeamDecide = ((((((myDescription.box.max.z) * 2 ) + formationAbeam) * #myUnits ) /2) + myLeadGroupWidth) *-1
			local myTrailDecide = myLeadGroupTrail * #myUnits
			
			local myRow = math.ceil(count /2) 
			if math.fmod ( count , 2) < 1 then 
				-- myAbeamDecide = formationAbeam 
				myAbeamDecide = myAbeamDecide *-1
			end 

			local myAbeam = math.ceil (myAbeamDecide) --+ (math.random (1,3)*10)
			local myTrail = myTrailDecide --+ (math.random (1,3)*10)
			local myAbove = formationAbove --+ (math.random (1,3)*5)
			
			local myInput = { lead=gMissionOptions.runningMissions[input.group].leader , trail=myFollowGroups[count].group, 
				center=myTrail*myRow , 
				above=myAbove*myRow , 
				behind=myAbeam*myRow,}

			timer.scheduleFunction(ResetGroupController, myFollowGroups[count].group, timer.getTime()+ .1  ) 
			timer.scheduleFunction(doFollowFormation, myInput, timer.getTime()+ .2 ) 
			--if Debugging == true then printDebug ("EventHandler" , "Send Follow " .. myFollowGroups[count].group .. " " .. myInput.lead .. " " .. input.group .. " abeam " .. myAbeam , 10 ) end
		end
	end 

end 
function doUnitLostEvent ( input )

	-- local myLeader = gMissionOptions.runningMissions[input.group].leader
	-- local myLeadGroup = Group.getByName(myLeader)
	-- local myLeadUnit = Unit.getName(myLeadGroup:getUnit(1))
	
	-- input.unit = myLeadUnit
	
	-- -- local myGroup = Unit.getGroup(input.unit)
	-- -- local 
	-- if gMissionOptions.runningMissions ~= nil then 
	-- local myNewLeader = false
	--if Debugging == true then printDebug ("EventHandler" , "Lost Unit Event " .. input.unit , 10 ) end
	
	local myUnitTable = Unit.getByName(input.unit)

	
	-- if Unit.getGroup(myUnitTable) then 
		-- local myGroupTable = Unit.getGroup(myUnitTable)
		-- local myGroup = Group.getName ( myGroupTable )
		--local myGroup = Group.getName ( Unit.getGroup(Unit.getByName(input.unit)) )
		if Debugging == true then printDebug ("EventHandler" , "Lost Unit Event " .. input.unit .. " " .. input.group , 10 ) end
		local myGroup = input.group
		for key , value in pairs(gMissionOptions.runningMissions) do
			--if value.following ~= nil then -- IF IN FOLLOWING MODE WE CHECK TO PROMOTE SOMEONE TO LEADER
				-- if myGroup == value.leader and ( #Group.getByName(myGroup):getUnits() <= 1 ) then
				if Group.getByName(myGroup) ~= nil then 
					if  #Group.getByName(myGroup):getUnits() <= 1  then
				
						for memberKey , memberValue in pairs(gMissionOptions.runningMissions[key].followGroups) do
							if myGroup == memberValue.group then 
								table.remove (gMissionOptions.runningMissions[key].followGroups, memberKey ) 
								if Debugging == true then printDebug ("EventHandler" , "Following groups were removed for group " .. memberValue.group .. " at " .. memberKey , 10 ) end
							end
						end 
					end
				end 
				
				for proximityKey , proximityValue in ipairs(gMissionOptions.runningMissions[key].proximityQueue) do 
					if #gMissionOptions.runningMissions[key].proximityQueue > 1 and proximityValue.unit == input.unit then
						table.remove (gMissionOptions.runningMissions[key].proximityQueue, proximityKey ) 
						if Debugging == true then printDebug ("EventHandler" , "The unit was removed from the promity queue " .. proximityValue.unit  , 10 ) end						
					end 
				end 
				
				if myGroup == value.leader then 
					local myPicked = false
					if #gMissionOptions.runningMissions[key].followGroups < 1 then 
						value.following = nil
						--local myValidPlayerGroups = validPlayerGroups ( input )
						local myProximityGroup = gMissionOptions.runningMissions[key].proximityQueue[1].group
						--local myLeaderUnitObject = myValidPlayerGroups[myProximityGroup]:getUnit(1)
						gMissionOptions.runningMissions[key].leader = myProximityGroup
						gMissionOptions.runningMissions[key].leadSortie = gMissionOptions.friendlySortie[1].sortie
						if Debugging == true then printDebug ("EventHandler" , "Promoting new leader " .. gMissionOptions.runningMissions[key].leader , 10 ) end
					end 
					for count=1,#gMissionOptions.runningMissions[key].followGroups do 
						if #Group.getByName(gMissionOptions.runningMissions[key].followGroups[count].group ):getUnits() >= 1 and gMissionOptions.runningMissions[key].followGroups[count].group ~= value.leader and myPicked == false then 
							gMissionOptions.runningMissions[key].leader = gMissionOptions.runningMissions[key].followGroups[count].group
							gMissionOptions.runningMissions[key].leadSortie = gMissionOptions.runningMissions[key].followGroups[count].sortie
							if Debugging == true then printDebug ("EventHandler" , "Promoting new leader " .. gMissionOptions.runningMissions[key].leader , 10 ) end
							if value.following ~= nil then -- only if following mode do we promote the leader and start the following
								doPromoteToLeader ( {group=key, leader=gMissionOptions.runningMissions[key].followGroups[count].group } )
							end 
							myPicked = true
						end 
					end 
				end 
			--end 
		end
 


	

	
	
	--deReference (input ) 
	-- end 
end 
function doUnitLostEventOld ( input )

	-- local myLeader = gMissionOptions.runningMissions[input.group].leader
	-- local myLeadGroup = Group.getByName(myLeader)
	-- local myLeadUnit = Unit.getName(myLeadGroup:getUnit(1))
	
	-- input.unit = myLeadUnit
	
	-- -- local myGroup = Unit.getGroup(input.unit)
	-- -- local 
	-- if gMissionOptions.runningMissions ~= nil then 
	local myNewLeader = false
	local myGroup = Group.getName ( Unit.getGroup(Unit.getByName(input.unit)) )
	
	for key , value in pairs(gMissionOptions.runningMissions) do
		if value.following ~= nil then 
			if myGroup == value.leader and ( #Group.getByName(myGroup):getUnits() <= 1 ) then
				-- local myWildWeasels = gMissionOptions.runningMissions[key][gMissionOptions.friendlyGroups.WildWeasels]
				-- local myAirDefense = gMissionOptions.runningMissions[key][gMissionOptions.friendlyGroups.AirDefense]
				-- local myCAS = gMissionOptions.runningMissions[key][gMissionOptions.friendlyGroups.CloseAirSupport]
				for count=1,#gMissionOptions.runningMissions[key].leaderOrder do
					for groupKey , groupValue in pairs(gMissionOptions.runningMissions[key][gMissionOptions.runningMissions[key].leaderOrder[count]]) do
						if Group.getByName( groupValue.group ) ~= nil and myNewLeader == false then 
							if groupValue.group ~= myGroup and groupValue.human == nil then
								gMissionOptions.runningMissions[key].leader = groupValue.group
								gMissionOptions.runningMissions[key].leadSortie = gMissionOptions.runningMissions[key].leaderOrder[count]
								local myLeaderWas = gMissionOptions.runningMissions[key].leadSortie
								local myTransitionAlt = gMissionOptions.runningMissions[key].transitionAlt
								local myLeaderName = Unit.getName ( Group.getByName(groupValue.group):getUnit(1) )
								local myLeaderPosition = centerUnitCoordinates(myLeaderName)
								local myFirstWayPoint = getPointOnRadian ( { radius=1000 , pos=myLeaderPosition , angle=getAngleBetweenTwoPointsV2(myLeaderPosition , gMissionOptions.runningMissions[key].position) })
								local mySpeed = gMissionOptions.runningMissions[key].returnSpeed
								local myRoute = {}
								myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myFirstWayPoint , alt=myTransitionAlt , altType="BARO" , speed=mySpeed }
								myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=gMissionOptions.runningMissions[key].position , alt=myTransitionAlt , altType="BARO" , speed=mySpeed }
								
								local myTasking = getTasking ( {group=key, chatter=true, sortie=gMissionOptions.runningMissions[key].leadSortie , } )
					
								local myInfo = { group = gMissionOptions.runningMissions[key].leader , route=myRoute , tasks=myTasking , push=true } 
								timer.scheduleFunction(ResetGroupController, gMissionOptions.runningMissions[key].leader, timer.getTime()+ 0.1 )   			
								timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + 0.2 )
								timer.scheduleFunction(followGroup, {group=key}, timer.getTime() + 0.3 )
								sayInMission ( { who=myLeaderName, what={[1]="promoted", } , group=sayValue.group , speedAt=mySpeed , duration=20 } ) 
								myNewLeader = true 
							end 
						end 
					end 
				end 	
			end 
		end 
	end 


	

	
	
	--deReference (input ) 
	-- end 
end 
function destroyLeader ( input )
	local myLeader = gMissionOptions.runningMissions[input.group].leader
	local myLeadGroup = Group.getByName(myLeader)
	local myLeadUnit = Unit.getName(myLeadGroup:getUnit(1))
	-- if Debugging == true then printDebug ("EventHandler" , "Destroy " .. myLeadUnit  , 10 ) end 
	destroyUnit( {unit=myLeadUnit, power=10 } )
end
function checkMembersLocation ( input ) 
	local myLeader = Unit.getName(Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1))
--	local gLeadFormations = { [input.group] = { leader=myLeader, holdspeed=input.holdspeed ,speed=input.holdspeed, topspeed=myTopSpeed , degrees=input.degrees , alt=myAlt , input.side="left" ,  } }
	
	local myDistanceTable = {}

	local myLeaderLocation = Unit.getPoint(Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1))
	local myLeaderHeading = doGetUnitHeading ( {name=myLeader, } )
	local myDistances = {}
	local myFormationRight = {}
	local myFormationLeft = {}
	local myReturnAll = {}
	local myReturnRight = {}
	local myReturnLeft = {}
	

	
	for formation_key ,formation_value in pairs(gMissionOptions.runningMissions[input.group].followGroups) do
			--for index, data in pairs(Group.getByName(formation_value.group):getUnits()) do 
			
				-- local myUnitName = Unit.getName (data)
				-- local myFollowLocation = Unit.getPoint(data)
				local myUnitName = formation_value.group
				local myFollowLocation = Unit.getPoint(Group.getByName(formation_value.group):getUnit(1))
				
				local myDistance = getDistanceBetweenTwoPoints( myLeaderLocation, myFollowLocation )	
				
				local myFollowAngle =  getAngleBetweenTwoPointsV2(myLeaderLocation , myFollowLocation)  -- TOOLBOX FUNCTION
				
				myFollowAngle =  ((math.pi*2 - myLeaderHeading.angle  ) + myFollowAngle )
				if myFollowAngle > math.pi*2 then myFollowAngle = myFollowAngle - (math.pi*2) end
				local myMember = {name=myUnitName , distance=myDistance , angle=myFollowAngle}
				
				if myFollowAngle > math.pi then 
					myFormationLeft[myDistance] = myMember
				else 
					myFormationRight[myDistance] = myMember
				end
		--	end 
		--if Debugging == true then printDebug ("EventHandler" ,  formation_value.name .. " distance " .. string.format("%d" , myDistance) .. " angle " ..  myFollowAngle , 10 ) end 
	end
	
	-- ANYONE ON THE RIGHT
	local mySortedRightTable= {}
	for n in pairs(myFormationRight) do table.insert(mySortedRightTable, n) end
	table.sort(mySortedRightTable)
	
	for distance_key ,distance_value in ipairs(mySortedRightTable) do
		myReturnAll[#myReturnAll+1] = {name=myFormationRight[distance_value].name }
		-- myReturnRight[myFormationRight[distance_value].name] = {name=myFormationRight[distance_value].name }
		myReturnRight[#myReturnRight+1] = {name=myFormationRight[distance_value].name }
		--if Debugging == true then printDebug ("EventHandler" , "Right " ..  myFormationRight[distance_value].name .. " distance " .. string.format("%d" , distance_value) .. " angle " ..  myFormationRight[distance_value].angle , 10 ) end 
	end 
	
	-- ANYONE ON THE LEFT
	local mySortedLeftTable= {}
	for n in pairs(myFormationLeft) do table.insert(mySortedLeftTable, n) end
	table.sort(mySortedLeftTable)
	
	for distance_key ,distance_value in ipairs(mySortedLeftTable) do
		myReturnAll[#myReturnAll+1] = {name=myFormationLeft[distance_value].name }
		--myReturnLeft[myFormationLeft[distance_value].name] = {name=myFormationLeft[distance_value].name }
		myReturnLeft[#myReturnLeft+1] = {name=myFormationLeft[distance_value].name }
		--if Debugging == true then printDebug ("EventHandler" , "Left " ..  myFormationLeft[distance_value].name .. " distance " .. string.format("%d" , distance_value) .. " angle " ..  myFormationLeft[distance_value].angle , 10 ) end 
	end 
	

	local  myReturn = {all=myReturnAll,right=myReturnRight , left=myReturnLeft }
	return myReturn 
	
end 
function doFormationAerobaticTurn ( input )
	if Debugging == true then printDebug ("EventHandler" , "Do Aerobatic turn " .. input.side .. " for " .. input.degrees , 10 ) end
			
			
			local myLeader = gMissionOptions.runningMissions[input.group].leader
			local myLeadUnit = Unit.getName(Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1))
			local myTopSpeed = gMissionOptions.runningMissions[input.group].humanSpeed
			local myAlt = gMissionOptions.runningMissions[input.group].transitionAlt
			local myWingType = Targets[string.upper(Unit.getTypeName(Group.getByName(gMissionOptions.runningMissions[input.group].leader):getUnit(1)):gsub('[%p%c%s]', '') )].wing
			
			local gLeadFormations = { } 
			gLeadFormations[input.group] = { leader=myLeader, leadUnit=myLeadUnit, holdspeed=input.holdSpeed , speed=input.holdSpeed, topspeed=myTopSpeed , degrees=input.degrees , alt=myAlt  ,  } 
			
			local myCheckAgainst = gLeadFormations[input.group].leader
			
			local myTurnDelay = 2
			local myWaitTime = .75
			local myFollowCount = 0
			local myTurnAdjust = 4
			local myRollAdjust = 2
			local mySpeedAdjust = 7
			local myDegrees = 90
			if input.degrees ~= nil then myDegrees = input.degrees end 		
			local myLeaderHeading = doGetUnitHeading ( {name=myLeadUnit, } )
			local myAlt = getMSLfeet(myLeadUnit) 
			local function mySchedule ( value ) 
				SendControlToGroup ( value.group , value.maneuver , true ) 
			end 
			
			local function myScheduleUnits ( value )
					SendControlToUnit ( value.unit, value.maneuver , true )		 
			end 

			if gLeadFormations[input.group].holdspeed >= gLeadFormations[input.group].topspeed then 
				myRollAdjust = myRollAdjust - 1 
				-- if Debugging == true then printDebug ("EventHandler" ,  "Roll adjust " .. myRollAdjust , 10 ) end
			end 
			gLeadFormations[input.group].alt = getMSLfeet ( myLeadUnit ) -- IF WE ARE TURNING WE WANT THE LEADERS ALT TO BE FIXED
			
			local myPosition = checkMembersLocation ( input )
			local myOrder = {}
			--myOrder[#myOrder+1] = {name=gLeadFormations[input.group].leader , }
			myOrder[#myOrder+1] = {name=myLeader , }
			local myDelayCountem = 0
			local myRollDelay = 0
			if input.side == "right" then
				for key , value in pairs(myPosition.right) do
					myDelayCountem = myDelayCountem + 1
					myOrder[#myOrder+1] = {name=value.name , delay=myTurnDelay*myDelayCountem , roll=myRollAdjust*myRollDelay , speed=gLeadFormations[input.group].speed - (mySpeedAdjust*myDelayCountem)  }
					myRollDelay = myRollDelay + 1
				end 
				for key , value in pairs(myPosition.left) do
					myDelayCountem = myDelayCountem + 1
					myOrder[#myOrder+1] = {name=value.name , delay=myTurnDelay*myDelayCountem  , roll=(myRollAdjust*myRollDelay) ,speed=gLeadFormations[input.group].speed + (mySpeedAdjust*myDelayCountem)  }
					myRollDelay = myRollDelay + 1
				end 
			else
				for key , value in pairs(myPosition.left) do
					myDelayCountem = myDelayCountem + 1
					myOrder[#myOrder+1] = {name=value.name , delay=myTurnDelay*myDelayCountem  , roll=myRollAdjust*myRollDelay , speed=gLeadFormations[input.group].speed - (mySpeedAdjust*myDelayCountem)  }
					myRollDelay = myRollDelay + 1
				end 
				for key , value in pairs(myPosition.right) do
					myDelayCountem = myDelayCountem + 1
					myOrder[#myOrder+1] = {name=value.name , delay=myTurnDelay*myDelayCountem  , roll=(myRollAdjust*myRollDelay) , speed=gLeadFormations[input.group].speed + (mySpeedAdjust*myDelayCountem)  }
					myRollDelay = myRollDelay + 1
				end 
			end 
			
		
				-- for key , value in pairs(gLeadFormations[input.group].groups) do
			for key , value in pairs(myOrder) do
				local mySpeed = gLeadFormations[input.group].speed
				local myLocalTurnDelay = myWaitTime
				local myTurnDegrees = myDegrees 
				--local myAlt = getMSLfeet(value.name) 
				
				local myManeuver = { id = "Aerobatics" , params = { ["maneuversSequency"] = {} , ["maneuversParams"] = {}, } }   		
				if input.action == "turn" then 
					local myTurn = AerobaticsTypes({type="turn" , side=input.side , smoke=false, roll=input.roll, degrees=string.format("%d" , myTurnDegrees) })
					local myStraight = AerobaticsTypes({type="straightflight" , duration=60, smoke=false, })
					myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = myTurn 
					myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = myStraight
				end
				if input.action == "straight" then 
					local mySmoke = false 
					if value.name == gLeadFormations[input.group].leader then mySmoke = true end
					local myStraight = AerobaticsTypes({type="straightflight" , duration=60, smoke=mySmoke, })   
					myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = myStraight
				end
				
				if value.name ~= myCheckAgainst then 
					myFollowCount = myFollowCount + 1
					local myLocalTurnAngle = ( myTurnAdjust* myFollowCount)
					-- myLocalTurnDelay = myWaitTime + value.delay 
					myLocalTurnDelay = value.delay 

					local myUnit = Unit.getByName(value.name)
					if myCheckAgainst == gLeadFormations[input.group].leader then myUnit = Group.getByName(value.name):getUnit(1) end 
					
					local myPoint = getPointOnRadian ( { diameter=10000 , pos=Unit.getPoint(myUnit) , angle = myLeaderHeading.angle })
					local myWaypoints={}
					for point_key ,point_value in ipairs(myPoint.between) do 
						myWaypoints[#myWaypoints+1] = { action = "Turning Point" , pos=point_value , alt = myAlt  , altType="BARO" , speed=gLeadFormations[input.group].speed ,}
					end
					
					local myInfo = {}                                                                                                                     
					myInfo = { route=myWaypoints , push=true }  
					if myCheckAgainst == gLeadFormations[input.group].leader then 
						myInfo.group = value.name
						timer.scheduleFunction(ResetGroupController ,value.name , timer.getTime() + .1 )
					else 
						myInfo.unit=value.name
						timer.scheduleFunction(ResetUnitController ,value.name , timer.getTime() + .1 )
					end 
											
					timer.scheduleFunction(doScheduleFlyRoute ,myInfo , timer.getTime() + .2 ) 
					myManeuver.params.maneuversSequency[1].params.SECTOR.value = myTurnDegrees + myLocalTurnAngle
					myManeuver.params.maneuversSequency[1].params.ROLL.value = input.roll + value.roll

				end

				if myCheckAgainst == gLeadFormations[input.group].leader then 
					timer.scheduleFunction(ResetGroupController ,value.name , timer.getTime() + myLocalTurnDelay  )
				else
					timer.scheduleFunction(ResetUnitController ,value.name , timer.getTime() + myLocalTurnDelay  )
				end 
				
				--if Debugging == true then printDebug ("EventHandler" ,  value.name .. " turns in  " .. myLocalTurnDelay , 10 ) end
				if myWingType == "fixed" then
					if myCheckAgainst == gLeadFormations[input.group].leader then 
						timer.scheduleFunction(mySchedule ,{group=value.name, maneuver=myManeuver} , timer.getTime() + myLocalTurnDelay ) 
					else
						timer.scheduleFunction(myScheduleUnits ,{unit=value.name, maneuver=myManeuver} , timer.getTime() + myLocalTurnDelay ) 
					end								
				else
					local myTurnAngle = math.pi*.49 -- 1.13 -- math.pi/2
					local myHeading = myLeaderHeading.angle
					if input.side == "left" then myTurnAngle = (myTurnAngle * -1) end
					myHeading = myLeaderHeading.angle + myTurnAngle
					local myPoint = getPointOnRadian ( { diameter=5000 , pos=Unit.getPoint(Unit.getByName(myLeadUnit)) , angle = myHeading })
					local myPointTwo = getPointOnRadian ( { diameter=20000 , pos=Unit.getPoint(Unit.getByName(myLeadUnit)) , angle = myHeading })
					local myPointThree = getPointOnRadian ( { diameter=200000 , pos=Unit.getPoint(Unit.getByName(myLeadUnit)) , angle = myHeading })
					
					local myAlt = getMSLfeet(myLeadUnit) 
					local mySpeed = gLeadFormations[input.group].speed 
									
					local myWaypoints={}
					myWaypoints[#myWaypoints+1] = { action = "Turning Point" , pos=myPoint , alt = myAlt  , altType="BARO" , speed=mySpeed ,}
					myWaypoints[#myWaypoints+1] = { action = "Turning Point" , pos=myPointTwo , alt = myAlt  , altType="BARO" , speed=mySpeed ,}
					myWaypoints[#myWaypoints+1] = { action = "Turning Point" , pos=myPointThree , alt = myAlt  , altType="BARO" , speed=mySpeed ,}
					
					local myInfo = {}                                                                                                                     
					-- myInfo = { group=gLeadFormations[input.group].leader, route=myWaypoints , push=true }  
					myInfo = { group=value.name, route=myWaypoints , push=true } 						
					timer.scheduleFunction(doScheduleFlyRoute ,myInfo , timer.getTime() + myLocalTurnDelay + .2 ) 
				end 
			end 
end

-- SPAWNING AI 
function spawnAircraft (input)

	local myTasks = {}
	if input.formation ~= nil then 
		myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction", params = { ["action"] = {["id"] = "Option",["params"] = {["variantIndex"] = 1,["name"] = AI.Option.Air.id.FORMATION,["formationIndex"] = 14, ["value"] = input.formation , },},} }
	end 
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = false ,["name"] = AI.Option.Air.id.RTB_ON_BINGO, },},} } --NO RTB BINGO
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.PROHIBIT_JETT, },},} } --NO JETTISON WHEN UNDER THREAT
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE MAX_RANGE  HALF_WAY_RMAX_NEZ
	myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO TALKING
--input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1 ,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes =input.targetTypes , noTargetTypes=input.noTargetTypes, priority = 0 , } }

	local mySides = getOppositeSide ( { group=input.group} )
	local myValidGroups = validPlayerGroups ( )
	local myUnitObject = myValidGroups[input.group]:getUnit(1)
	input.unit = Unit.getName( myUnitObject )
	--input.type = Unit.getTypeName(myUnitObject)
	
	input.heading = doGetUnitHeading ({name=input.unit})
	local myUnitPosition = centerUnitCoordinates ( input.unit )
	input.spawnPosition = getPointOnRadian ( { diameter=input.spawnDistance , pos=myUnitPosition , angle = input.heading.angle }) 
	
	local myKey = string.upper(input.type:gsub('[%p%c%s]', '') )

	local myEnemyAirport = findClosestAirbase ({playerGroup=input.group ,coalition=mySides.enemycoa })
	local myFriendlyAirport = findClosestAirbase ({playerGroup=input.group ,coalition=mySides.friendlycoa })
	input.airfield = myFriendlyAirport.id
	if input.waypoints == nil then -- NO WAYPOINTS JUST FLY TO CLOSEST ENEMY AIRPORT
		input.moveToPosition  = myEnemyAirport.point 
		input.transitionPosition = getPointOnRadian ( { diameter=10000 , pos=centerUnitCoordinates ( input.unit ) , angle = getAngleBetweenTwoPointsV2(myUnitPosition , myEnemyAirport.point) })
	end 
	
	--input.parking = {}
	
	-- if gMissionOptions.parkingMaps[myFriendlyAirport.id] == nil then 
		-- gMissionOptions.parkingMaps[myFriendlyAirport.id] = getParkingClosestToActive ({ type=104 , airfield=myFriendlyAirport.id })
		-- if Debugging == true then printDebug ("EventHandler" , "Parking Map Empty for " .. myFriendlyAirport.name , 10 ) end
	-- end 
	
	input.parking_landing_id = {}
	for i=1, input.unitCount do 
		--input.parking[i] = gMissionOptions.parkingMaps[input.airfield][1]
		input.parking_landing_id[i] = gMissionOptions.parkingMaps[input.airfield][#gMissionOptions.parkingMaps[input.airfield]]
		--table.remove(gMissionOptions.parkingMaps[input.airfield],1)
		table.remove(gMissionOptions.parkingMaps[input.airfield],#gMissionOptions.parkingMaps[input.airfield])
	end 
	
	input.action = "Turning Point"
	input.spawnFrom = "TakeOffParkingHot"
	local myAlt = getMSLfeet(input.unit)
	--local myTransitionAlt = myAlt + gMissionOptions.transitionAlt
	if gMissionOptions.runningMissions[input.group].tempTransitionAlt == nil then gMissionOptions.runningMissions[input.group].tempTransitionAlt = gMissionOptions.runningMissions[input.group].transitionAlt end 
	local myTransitionAlt = myAlt + gMissionOptions.runningMissions[input.group].tempTransitionAlt
	
	--input.speed = { airspeed=(Targets[myKey].speed*.80) }
	input.speed = { airspeed=(Targets[myKey].speed) }
	
	if Object.inAir(myUnitObject) == true then 
		input.spawnFrom = "Airborne"
		myTransitionAlt = myAlt + 100 + input.altMod
		input.speed = getAirspeed ( input.unit )
	end 
	if input.speed.airspeed  > gMissionOptions.topSpeed then input.speed.airspeed = gMissionOptions.topSpeed  end 
	
	local myUnitDesc = Unit.getDescByName(input.type) 
	

	if myUnitDesc.category == Group.Category.HELICOPTER then 
		input.alt = getMSLfeet(input.unit) + 300
		input.speed.airspeed = Targets[myKey].speed
	end

	gMissionOptions.runningMissions[input.group].transitionAlt = myTransitionAlt
	if input.skill == nil then input.skill = "Average"  end 

	-- input.tasks[#input.tasks+1] = {["number"] = #input.tasks+1,["auto"] = true , ["enabled"] = true, ["id"] = 'EngageTargets', params = { maxDistEnabled = true, maxDist = 100000 ,targetTypes = {[1] = "All",}, noTargetTypes = {}, priority = 0 , } }
	-- mySpawn ( input )
	-- if Debugging == true then printDebug ("EventHandler" , "Transition Alt ".. gMissionOptions.runningMissions[input.group].transitionAlt, 10 ) end
	local myGroups = { type=input.type, group=input.group, action=input.action, spawnFrom=input.spawnFrom, speedmodifier = 0 , unitDistance = input.unitDistance , groupDistance = input.groupDistance , 
							spawnPosition=input.spawnPosition  , waypoints=input.waypoints, moveToPosition=input.moveToPosition , spawncountry=mySides.friendlycountryid, groupCount=input.groupCount , unitCount=input.unitCount , 
							heading=input.heading , speed=input.speed.airspeed  , skill=input.skill , livery=input.livery , airfield=input.airfield , alt=myTransitionAlt ,  tasks=myTasks  ,
							pylons=input.pylons , speedmodifier=input.speedmodifier , task=input.task , groupName=input.groupName , parking=input.parking , parking_landing_id=input.parking_landing_id }

	
	local myReturn = mySpawn ( myGroups )
	
	--gMissionOptions.runningMissions[input.group].followGroups[myReturn[1].group] = { group=input.group , leader=myReturn[1].group , followers={} } -- to hold any flight following
	for groupKey, groupValue in pairs (myReturn) do --- FOR ALL THE GROUPS THAT COME BACK
		local SetCallsign = {  id = 'SetCallsign',  params = { callname = input.callsign , number = groupKey,  } } -- WINGMAN CALL SIGN                          
		SendCommandToGroup ( groupValue.group , SetCallsign  )
		gMissionOptions.runningMissions[input.group].followGroups[#gMissionOptions.runningMissions[input.group].followGroups+1] = { group=groupValue.group , sortie=input.sortie }
		-- end 
		-- if Debugging == true then printDebug ("EventHandler" , "Spawn the " ..  input.type .. " for " .. groupValue.group .. " " .. myReturn[1].group .. " " .. input.sortie  , 10 ) end
	end
	
	gMissionOptions.runningMissions[input.group].friendlyGroups[#gMissionOptions.runningMissions[input.group].friendlyGroups+1] = myReturn
	
	gMissionOptions.runningMissions[input.group].sorties[input.sortie] = myReturn
	
	gMissionOptions.runningMissions[input.group].homeAirfield = myFriendlyAirport.name
	
	--return myReturn 
end 
function spawnGround (input)
	
	input.moveToPosition  = getPointOnRadian ( { diameter=5000 , pos=input.spawnPosition , angle = math.random(1,6)})
	
	input.moveToPosition.x, input.moveToPosition.z = land.getClosestPointOnRoads('roads' , input.moveToPosition.x, input.moveToPosition.z ) -- FIND A CLOSE ROAD TO ENDPOINT
	
	input.spawnPosition.x, input.spawnPosition.z = land.getClosestPointOnRoads('roads' , input.spawnPosition.x, input.spawnPosition.z ) -- FIND A CLOSE ROAD TO ENDPOINT

	input.alt = (land.getHeight{x = input.spawnPosition.x, y = input.spawnPosition.z} ) * METERS_TO_FEET
	

	
	mySpawn ( input )
	
end 
function spawnNaval ( input )
	local mySurfaceTypes = {[1]="Water" } -- ADD "Land" TYPE TO THE ARRAY FOR BOTH OR EITHER
	local mySearchDistance = 10000 -- HOW FAR AWAY TO LOOK
	local mySailingDistance = 5000 
	local myPrecision = 1000 --HOW MUCH OF THE POINT MUST BE THE TYPE TO SMALL NUMBER MIGHT END UP IN A LAKE TOO LARGE MIGHT NOT FIND LAND
	input.action = "Turning Point"
	input.speedmodifier = 0 -- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
	
	local mySpawnPosition = findMatchingSurfacePoints ( {unit=input.unit ,surfacetypes=mySurfaceTypes, distance=mySearchDistance , samples=12, precision=myPrecision , } )
	local myMoveToPosition = findMatchingSurfacePoints ( {position=mySpawnPosition.position ,surfacetypes=mySurfaceTypes, distance=mySailingDistance , samples=12, precision=myPrecision , } )
	 
	input.spawnPosition = mySpawnPosition.position
	input.moveToPosition = myMoveToPosition.position
	
	input.unitDistance = 2 -- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) -- HOW FAR AWAY EACH UNIT IS IN THE GROUP AT SPAWN
	input.groupDistance = 10 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) -- HOW FAR AWAY EACH GROUP IS FROM EACH OTHER IS AT SPAWN
	
	mySpawn ( input )
	
end 
function doTankers ( input )

	local myTankerNearby = false 
	local myTankerRadius = gMissionOptions.tankerDetect
	local myHoldDistance = gMissionOptions.tankerHolding  --185200 HOW LONG IS THE HOLDING RACETRACK IN METERS/2
	local myTankerSpeed = 220 -- THIS IS THE SPEED IF NOT SPECIFIED IN gRefuelSpeeds TABLE
	local myTankerAttributes = "Tankers"
	local myTankerName = ""
	local myCategory = {[1] = Object.Category.UNIT , }
	local myFoundObjects = SearchAreaForObjects ( {point=input.position , radius=myTankerRadius , category=myCategory ,  } )
	
	for unitKey , unitValue in pairs(myFoundObjects) do
		local myUnit = Unit.getByName ( unitValue )
		if Unit.hasAttribute(myUnit, myTankerAttributes ) == true and Unit.getCoalition(myUnit) == input.friendlycoa then 
			myTankerNearby = true
			myTankerName = Group.getName(Unit.getGroup(myUnit))
			-- if Debugging == true then printDebug ("EventHandler" , "Already a tanker nearby " .. gMissionOptions.tankers[myTankerName].tacan.callsign .. " " .. gMissionOptions.tankers[myTankerName].tacan.channel.. " " .. gMissionOptions.tankers[myTankerName].tacan.mode , 10 ) end	
		end
	end
	
	local myReturn = {}
	if myTankerNearby == false then 
		-- if Debugging == true then printDebug ("EventHandler" , "No tanker nearby spawning for " .. input.group , 10 ) end	

		if gRefuelSpeeds[AircraftType[gPlayerGroups[input.group].key].type] ~= nil then 
			myTankerSpeed = gRefuelSpeeds[AircraftType[gPlayerGroups[input.group].key].type].speed 
			-- if Debugging == true then printDebug ("EventHandler" , "Tanker speed specified of " .. gRefuelSpeeds[AircraftType[gPlayerGroups[input.group].key].type].speed , 10 ) end	
		end 
		--local myDiameter = 60000

		local myTankerAlt = gMissionOptions.transitionAlt
		local mySpawnFrom = "TakeOffParkingHot"
		local myAirport = findClosestAirbase ({position=input.position ,coalition=input.friendlycoa })

		local myIsImmortal = gMissionOptions.tanker_attributes.immortal
		local myIsInvisible = gMissionOptions.tanker_attributes.invisible
				
		local myTankerLocation = centerUnitCoordinates ( input.unit )
		local myHeading = doGetUnitHeading ( {callsign=input.unit} )
		
		if Object.inAir(Unit.getByName(input.unit) ) == true then
			myTankerAlt = getMSLfeet(input.unit) + 200
			mySpawnFrom = "Airborne"
		end 

		local myHeadingAngle = myHeading.angle+((math.pi/7) * (math.random(-1,1)))
		myTankerLocation = getPointOnRadian ( { diameter=math.random(5,10)*1000 , pos=myTankerLocation , angle=myHeadingAngle })
		local myStartingLocation = myTankerLocation
		local myRaceTrackLocation = getPointOnRadian ( { diameter=myHoldDistance , pos=myTankerLocation , angle=myHeading.angle })
		
		local myTankerHeading = myHeading.bearing
		local myTankerKey = string.upper(AircraftType[gPlayerGroups[input.group].key].tanker:gsub('[%p%c%s]', '') )

		local myAngle = myHeading.angle

		--local myRefuelSpeed = (myTankerSpeed/KNOTS) --+ (myTankerAlt * 0.012) -- Targets[myTankerKey].speed --*.80
		--local myRefuelSpeed = myTankerSpeed + (myTankerAlt * 0.012) -- Targets[myTankerKey].speed --*.80
		local myRefuelSpeed = myTankerSpeed + ((myTankerSpeed * 0.0175 ) * (myTankerAlt/1000 ))-- Targets[myTankerKey].speed --*.80
		
		local myImmortalTask = {["enabled"] = true,["auto"] = false,["id"] = "WrappedAction",["number"] = 3,["params"] = {["action"] = {["id"] = "SetImmortal",["params"] = {["value"] = true,},},},}
		local myTankerTask = { ["enabled"] = true, ["auto"] = true, ["id"] = "Tanker", ["number"] = 1, ["params"] =  { } }
		local myInvisibleTask = { ["enabled"] = true,["auto"] = false,["id"] = "WrappedAction",["number"] = 4,["params"] = {["action"] = {["id"] = "SetInvisible",["params"] = {["value"] = true,},},},}
		local myOrbitTask = {[1] = {["enabled"] = true,["auto"] = false,["id"] = "Orbit",["number"] = 1,["params"] = {["altitude"] = myTankerAlt/FEET,["pattern"] = "Race-Track",["point"] = {x=myRaceTrackLocation.x , y=myRaceTrackLocation.z },["point2"] = {x=myStartingLocation.x , y=myStartingLocation.z },["speed"] = myRefuelSpeed/KNOTS,},},}

		local myTasks = { }
		myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction", params = { ["action"] = {["id"] = "Option",["params"] = {["variantIndex"] = 1,["name"] = AI.Option.Air.id.FORMATION,["formationIndex"] = 14, ["value"] = gFormationType.WWIIBomberOpen, },},} }
		myTasks[#myTasks+1] = myTankerTask
		if myIsImmortal == true then myTasks[#myTasks+1] = myImmortalTask end 
		if myIsInvisible == true then myTasks[#myTasks+1] = myInvisibleTask end 

		local myWaypoints = {}
		myWaypoints[#myWaypoints+1] = {  action = "Fly Over Point" , pos=myRaceTrackLocation , alt = myTankerAlt  , altType="BARO" , speed =myRefuelSpeed }
		myWaypoints[#myWaypoints+1] = {  task = myOrbitTask , action = "Fly Over Point" , pos=myRaceTrackLocation , alt = myTankerAlt  , altType="BARO" , speed =myRefuelSpeed }


		local myAircraft   = {
							group = input.group , 
							groupName = "Tanker" , -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
							groupCount = 1 ,-- gMissionOptions.friendlySortieGroupCount , -- NUMBER OF GROUPS SPAWNED
							unitCount = 1 ,--gMissionOptions.friendlySortieUnitCount , -- NUMBER OF UNITS SPAWNED
							unitDistance = 100 ,-- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
							groupDistance = 100 ,--100 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
							speedmodifier = 1 ,-- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
							task = "Refueling" ,
							skill = gPlayerGroups[input.group].preferences.friendlySkill , -- Average Good High Excellent
							type = Targets[myTankerKey].type , -- THIS TYPE MATCHES THE PLAYER TYPE THAT SPAWNED IT
							livery = Targets[myTankerKey].blivery ,-- AIRCRAFT LIVERY COMES FROM GLOBAL OBJECTS
							pylons = Targets[myTankerKey].gpylons ,-- AIRCRAFT PYLONS COMES FROM GLOBAL OBJECTS
							--- ADDED
							action = "Fly Over Point" ,
							spawnFrom = mySpawnFrom ,
							spawnPosition = myStartingLocation , 
							waypoints = myWaypoints , 
							spawncountry =input.friendlycountryid, --THIS IS THE COUNTRY THE GROUP WILL SPAWN INTO
							heading = input.heading , -- THIS NEEDS TO BE THE HEADING TABLE
							speed = myRefuelSpeed ,
							skill = gPlayerGroups[input.group].preferences.friendlySkill ,
							airfield = myAirport.id ,
							alt =  myTankerAlt,
							tasks = myTasks ,
							--lateActivation = true ,
			}
			

		local myReturn = mySpawn ( myAircraft  )
		myTankerName = myReturn[1].group
		if gMissionOptions.tankerFrequency > 135 then gMissionOptions.tankerFrequency = 130.0 else gMissionOptions.tankerFrequency = gMissionOptions.tankerFrequency + .5  end 
		local myRandomTACAN = doRandomTACAN ({mode="X",}) 
		gMissionOptions.tankers[myTankerName] = {name=myTankerName, frequency=gMissionOptions.tankerFrequency , tacan=myRandomTACAN }
		
		local function myActivate  ( input )
			trigger.action.activateGroup(Group.getByName(input.name))
		end 
		timer.scheduleFunction(myActivate, {name=myTankerName} , timer.getTime()+ 1 )
		
		timer.scheduleFunction( ActivateTacan, { group=gMissionOptions.tankers[myTankerName].name,
												channel=gMissionOptions.tankers[myTankerName].tacan.channel, 
												mode=gMissionOptions.tankers[myTankerName].tacan.mode, 
												callsign=gMissionOptions.tankers[myTankerName].tacan.callsign, 
												AA=true , 
												system=4 } , timer.getTime()+ 4 )
		
		local mySetFrequency = { id = 'SetFrequency', params = { frequency = gMissionOptions.tankers[myTankerName].frequency*1000000 , modulation = 0 , } }
		

		SendCommandToGroup ( gMissionOptions.tankers[myTankerName].name , mySetFrequency  )	
		SendOptionToGroup (  gMissionOptions.tankers[myTankerName].name, AI.Option.Air.id.REACTION_ON_THREAT , AI.Option.Air.val.REACTION_ON_THREAT.PASSIVE_DEFENCE ) -- TANKER won't react to threat with maneuvers
		
		--doOptions ({group=input.group, unit=input.unit,setting=gSayThis["English"].menu_options_items[2]})

		-- local myAppend = myDistance .. " " .. gMissionOptions.sayThis["English"].sayfor .. " " 

		
		--if Debugging == true then printDebug ("EventHandler" , "Tanker " .. gMissionOptions.tankers[myTankerName].tacan.callsign .. " " ..  gMissionOptions.tankers[myTankerName].tacan.channel .. " " .. gMissionOptions.tankers[myTankerName].tacan.mode , 10 ) end	
	end
	local myTankerUnit = Group.getByName(myTankerName):getUnit(1)
	local myTankerUnitName = Unit.getName(myTankerUnit)
	local myDistance = getDistanceBetweenUnits( input.unit , myTankerUnitName )
	local myBearing = getBearingToUnit( input.unit , myTankerUnitName ) 
	local mySpeed = getAirspeed ( myTankerUnitName	)	
	local myFrequency = gMissionOptions.tankerFrequency .. " MHz"
	local myTacan = myFrequency .. " - TACAN: "  ..  gMissionOptions.tankers[myTankerName].tacan.channel .. " " .. gMissionOptions.tankers[myTankerName].tacan.mode .. " "..  gMissionOptions.tankers[myTankerName].tacan.callsign 
	sayInMission ( { what={[1]="tanker",} , group=input.group,  heading=myBearing , fordistance=myDistance , speedAt=mySpeed, append= myTacan , duration=20 } ) 
end 
function mySpawn ( input )
	local myKey = string.upper(input.type:gsub('[%p%c%s]', '') ) -- only letters and numbers left in a string 
	local mySpawnTable = Targets[string.upper(input.type:gsub('[%p%c%s]', '') )]
	local myReturnGroups = {}

	local myCategory = Unit.getDescByName(input.type)
	myCategory = myCategory.category
		
	local myPayload = {}

	if myCategory == Group.Category.AIRPLANE or Group.Category.HELICOPTER then 
		local myPylons = mySpawnTable.pylons
		if input.pylons ~= nil then myPylons = input.pylons end 
		myPayload  = {  ["fuel"] = mySpawnTable.fuel , ["pylons"] = myPylons, ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 } 
		if mySpawnTable.enterservice <= 1958 then 
			myPayload.flare = 0 
			myPayload.chaff = 0 
		end 
	end
	
	local mySpeed = mySpawnTable.speed 
	if input.speed ~= nil then mySpeed = input.speed end 
	if input.speedmodifier ~= nil then mySpeed = mySpeed*input.speedmodifier end 
	if input.skill == nil then input.skill = "Average" end 

	if input.heading == nil then input.heading = { bearing = math.random (1, 360 ) }  end 
	
	local myGroupName = input.group
	if input.groupName ~= nil then myGroupName = input.groupName end 
	-- if Debugging == true and input.alt ~= nil then printDebug ("EventHandler" , "Spawn group " .. myGroupName , 10 ) end
	for groups = 1, input.groupCount do

		local myName = myGroupName .. "-" .. uuid({template="xx"}) .. groups
		
		local myGroupPosition = getPointOnRadian ( { diameter=((math.random(5,10)*input.groupDistance)*groups) , pos=input.spawnPosition , angle = math.random(1,6) })
		
		local myWaypoints={}
		-- if input.transitionPosition ~= nil then 
			-- myWaypoints[#myWaypoints+1] = { action =input.action , pos=input.transitionPosition , alt = input.alt  , altType="BARO" , speed = mySpeed , }
		-- end 
		if input.waypoints ~= nil then 
			for i=1,#input.waypoints do 
				myWaypoints[#myWaypoints+1] = { action =input.action , pos=input.waypoints[i].pos , alt = input.alt  , altType="BARO" , speed = mySpeed , }
				if input.waypoints[i].speed ~= nil then myWaypoints[#myWaypoints].speed = input.waypoints[i].speed end 
				if input.waypoints[i].alt ~= nil then myWaypoints[#myWaypoints].alt = input.waypoints[i].alt end
				if input.waypoints[i].action ~= nil then myWaypoints[#myWaypoints].action = input.waypoints[i].action end
				if input.waypoints[i].task ~= nil then myWaypoints[#myWaypoints].task = input.waypoints[i].task end
				-- if Debugging == true and input.alt ~= nil then printDebug ("EventHandler" , "Waypoints " .. input.waypoints[i].pos.z  , 10 ) end
			end 
		else
			myWaypoints[#myWaypoints+1] = { action =input.action , pos=input.moveToPosition , alt = input.alt  , altType="BARO" , speed = mySpeed , }
		end 
		
		local myUnits = {}
		for units = 1, input.unitCount do

			local myUnitPosition = getPointOnRadian ( { diameter=(math.random(5,10)*input.unitDistance)*units, pos=myGroupPosition , angle = math.random(1,6) })
			
			myUnits[#myUnits+1] = { name =myName .. "-" .. units , heading=input.heading.bearing,  spawn_type=myCategory , skill=input.skill  , type=mySpawnTable.type, position=myUnitPosition  , 
									alt=input.alt , speed=mySpeed, altType="BARO", livery_id=input.livery }
									
			if input.parking ~= nil then myUnits[#myUnits].parking = input.parking[units] end 
			if input.parking_landing_id ~= nil then myUnits[#myUnits].parking_landing_id = input.parking_landing_id[units] end 

			if myCategory == Group.Category.AIRPLANE or myCategory == Group.Category.HELICOPTER then myUnits[#myUnits].payload = myPayload  end
						
		end 
		
		
		-- SAM SITE?
		if mySpawnTable.radar ~= nil then 
			local myCountem = 0
			for key , value in pairs(mySpawnTable.radar) do
				myCountem = myCountem + 1
				local myRadarPosition = getPointOnRadian ( { diameter=100 , pos=myGroupPosition , angle = (math.pi/2) * myCountem })
				myUnits[#myUnits+1] = { name =myName .. "-R" .. myCountem , heading=input.heading.bearing,  spawn_type=myCategory , skill=input.skill , type=value, position=myRadarPosition  , 
				alt=input.alt , speed=mySpeed, altType="BARO", livery_id=input.livery , }
			end 
		end
		
		

		local mySpawn = { 	name = myName , units=myUnits, skill=input.skill , action= input.action ,  lateActivation=true , spawn_type=myCategory , airfield=input.airfield , task=input.task ,
							type=mySpawnTable.type, position=myGroupPosition , heading=input.heading.bearing, waypoints=myWaypoints, speed=mySpeed , alt=input.alt , altType="BARO", tasks=input.tasks,}
		
		if input.frequency ~= nil then 
				 mySpawn.frequency = input.frequency
				 input.frequency = input.frequency + .5 -- KEEP ADDING TO FREQUENCY FOR THE UNITS
		end 
		if input.spawnFrom ~= nil then mySpawn.spawnFrom = input.spawnFrom end 

		local myBuiltSpawn = doBuildSpawn (mySpawn)
		--deReference (myBuiltSpawn)
		coalition.addGroup(input.spawncountry, myCategory, myBuiltSpawn )
		
		if input.lateActivation == nil then 
			Group.activate(Group.getByName(mySpawn.name))
		else
			if input.lateActivation ~= true then Group.activate(Group.getByName(mySpawn.name))	end 	
		end 

		myReturnGroups[#myReturnGroups+1] = { group=mySpawn.name , type=mySpawn.type, tasks=input.tasks }
		if gMissionOptions.traffic.randomness ~= "off" then myReturnGroups[#myReturnGroups].spawn = mySpawn end --I THINK BECAUSE TRAFFIC IS LATE ACTIVATION AND USED TO SPAWN
		--if Debugging == true and input.alt ~= nil then printDebug ("EventHandler" , "group " .. mySpawn.name .. "tasks " .. #input.tasks , 10 ) end
		
	end 
	
	
	return myReturnGroups

end 

-- RANDOM TRAFFIC --
function loadAirbases ( input )

	local tmp = world.getAirbases()
	local myProblemAirfields = { } 
	myProblemAirfields["North West Field"]=true
	gMissionOptions.airports = {} 
	for i=1,#tmp do
		local myName = tmp[i]:getName()
		local myCategory = tmp[i]:getCategory()
		local myParkingMap = Airbase.getParking(tmp[i])
		if myProblemAirfields[myName] == nil then 
			if ( myCategory == 4 ) or ( myCategory == 1 and #myParkingMap > 1  ) then
				gMissionOptions.airports[myName] = {}
				gMissionOptions.airports[myName].point = tmp[i]:getPoint()
				gMissionOptions.airports[myName].category = myCategory
				gMissionOptions.airports[myName].name = myName
				gMissionOptions.airports[myName].id = tmp[i]:getID()
				gMissionOptions.airports[myName].alt_feet = gMissionOptions.airports[myName].point.y*3.280839895
			end
		end
	 end
	 if Debugging == true and input.alt ~= nil then printDebug ("EventHandler" , "Finished loading airbases" , 10 ) end
end 
function loadTraffic ( input )

	local myRandomUnitCount = 3 
	local myDensity =4 
	local myTrafficCounts = gMissionOptions.traffic.counts
	local myName="Traffic"
	local myTargetType = {}
	local myTrafficTypes = { [1] = MissionCombat.FIGHTER ,}
	local myAlt = 7000
	
	--local myTarget = getTarget ( { group=input.group, category=MissionCombat.ANTIAIR.category, accurate=true , assetpack = true , all=true } )
	
	myTargetType.enterservice = gMissionOptions.traffic.enterservice
	myTargetType.retired = gMissionOptions.traffic.retired

	myTargetType.accurate = true
	myTargetType.assetpack = true	
		
	local mySides = { [1]={searchCountry = "NATO" , coalition=coalition.side.RED , country = gMissionOptions.redCountries[1], } , [2]={searchCountry = "RUSSIA" , coalition=coalition.side.BLUE , country = gMissionOptions.blueCountries[1], }}
	if myTargetType.retired  <= 1949 then 
		mySides = { [1]={searchCountry = "ALLIED" , coalition=coalition.side.RED ,country = gMissionOptions.redCountries[1], } , [2]={searchCountry = "AXIS" , coalition=coalition.side.BLUE , country = gMissionOptions.blueCountries[1], }}
	end 
	if myTargetType.retired <= 1950 then 
		myTrafficTypes[#myTrafficTypes+1] = MissionCombat.BOMBER 
	end
	
	if myTargetType.retired >= 1968 then 
		myTrafficTypes[#myTrafficTypes+1] = MissionCombat.UNARMEDAIR
	end
	-- if myTargetType.retired >= 1967 then 
		-- myTrafficTypes[#myTrafficTypes+1] = MissionCombat.ROTARY
	-- end

	local myCarrierQualified = {red={} , blue={} }
	
	if myTargetType.retired >= 1974 then
		
		for key , value in pairs(AircraftType) do 
		
			if value.catapult ~= nil then
				if value.catapult == TaskGroups.bluefleet then 
					myCarrierQualified.blue[#myCarrierQualified.blue+1] = value
				elseif value.catapult == TaskGroups.redfleet and  myTargetType.retired >= 1995 then
					myCarrierQualified.red[#myCarrierQualified.red+1] = value
				end 
			end 
		
		end 
		
		myCarrierQualified.blue[#myCarrierQualified.blue+1] = Targets.E2C
		
		mySides[#mySides+1]={ searchCountry = "NATO" , coalition=coalition.side.RED+2 , carrieraircraft= myCarrierQualified.red ,country = gMissionOptions.redCountries[1], }
		mySides[#mySides+1]={ searchCountry = "RUSSIA" , coalition=coalition.side.BLUE+2, carrieraircraft= myCarrierQualified.blue, country = gMissionOptions.blueCountries[1],  } 
		-- if #myCarrierQualified.red >= 1 then   end 

	end 
	
	--myTrafficTypes = { [1] = MissionCombat.FIGHTER , }
	
	if  gMissionOptions.traffic.randomness ~= "off" then
		gMissionOptions.traffic.members = {}

		for key , value in pairs(mySides) do
			gMissionOptions.traffic.members[value.coalition] = {}
			myTargetType.country = value.searchCountry

			
			local myTrafficTable = {}
			for temp_key , temp_value in pairs(myTrafficTypes) do
				myTargetType.category = temp_value.category
				local myTempTable = checkTargetTables (myTargetType) -- LOOK FOR A TARGET

				for temp_key , temp_value in pairs(myTempTable) do
					if temp_value.datedlivery == nil then 
						myTrafficTable[#myTrafficTable+1] = temp_value
					end 
				end	
			end 
			
			for i=1,myTrafficCounts do
									
					if key == 3 or key == 4 then
						myTrafficTable = mySides[key].carrieraircraft
					end 
					local myTraffic=myTrafficTable[math.random( 1, #myTrafficTable )]
					local myKey = string.upper(myTraffic.type:gsub('[%p%c%s]', '') )
					
					--	gMissionOptions.friendlySortie = {}
					


	
					-- LOAD TRAFFIC
					local myAircraft = {
					--group = input.group , 
					groupName = "T" , -- LEAVE BLANK AND USES CALLING GROUP FOR START OF NAME
					groupCount = 1 ,  -- GROUPS SPAWNED
					unitCount = math.random(1,myRandomUnitCount) , -- UNITS SPAWNED
					unitDistance = 10 , -- WILL CALCUATE AS (math.random(5,10)*input.unitDistance) 
					groupDistance = 10 , --100 -- WILL CALCUATE AS (math.random(5,10)*input.groupDistance) 
					speedmodifier = 1 , -- PERCENT OF HOW MUCH TO MODIFY SPEED FROM TARGET TABLE DEFAULT 0 STOP TO 1 FULL SPEED OR REMOVE FOR DEFAULT
					formation = gFormationType.WWIIFighterTight , 
					targetTypes = {} , 
					noTargetTypes = {} , 
					task = "Nothing" , 
					altMod = 1 , 
					callsign = 8 , -- PONTIAC
					type = myTraffic.type , 
					livery = myTraffic.blivery ,
					pylons = myTraffic.gpylons ,	
					lateActivation = true ,
					action = "Turning Point" ,
					spawnFrom = "Airborne" ,
					spawnPosition = {x=0,y=0,z=0 } , 
					moveToPosition = {x=0,y=0,z=0 } , 
					spawncountry = country.id[value.country] ,
					heading={bearing=0} ,
					speed=0 ,
					skill="Average" ,
					alt = myAlt ,
					}
					
					local myTasks = {}
					myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = false, ["enabled"] = true, ["id"] = "WrappedAction", params = { ["action"] = {["id"] = "Option",["params"] = {["variantIndex"] = 1,["name"] = AI.Option.Air.id.FORMATION,["formationIndex"] = 14, ["value"] = myAircraft.formation , },},} } 
					myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.MISSILE_ATTACK.MAX_RANGE ,["name"] = AI.Option.Air.id.MISSILE_ATTACK, },},} } --ENGAGEMENT RANGE MAX_RANGE  HALF_WAY_RMAX_NEZ
					myTasks[#myTasks+1] = {["number"] = #myTasks+1, ["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = true ,["name"] = AI.Option.Air.id.SILENCE , },},} } --NO TALKING
					
					myAircraft.tasks = myTasks
					--if Debugging == true then  printDebug ( "EventHandler" , "Loading " .. myAircraft.type  , 10 ) end
					
					for i=1,myDensity do
						myAircraft.unitCount = math.random(1,myRandomUnitCount)
						local myReturn = mySpawn ( myAircraft )
						gMissionOptions.traffic.members[value.coalition][#gMissionOptions.traffic.members[value.coalition]+1] = {group=myReturn[1].name, spawn=myReturn[1].spawn, }
					end 
					
						-- -- GET A PAYLOAD
					-- local myPylons = {[1] = myTraffic.pylons , [2]=myTraffic.gpylons}
					-- local myPylonsChoice = myPylons[1]
					-- if myTraffic.gpylons ~= nil then myPylonsChoice = myPylons[math.random(1,2)] end -- SOME TARGETS ONLY HAVE ONE PYLON TYPE
					-- local myPayload  = {  ["fuel"] = myTraffic.fuel , ["pylons"] = myPylonsChoice , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
					-- if myTraffic.enterservice <= 1958 then 
						-- myPayload.flare = 0 
						-- myPayload.chaff = 0 
					-- end 
						-- -- GET A LIVERY
					-- local myLivery = myTraffic.rlivery
					-- if value.coalition == 2 then myLivery= myTraffic.blivery end 

					-- local mySpeed = 280
					-- local mySpawnType = Group.Category.AIRPLANE
					-- local myFriendlyTask =	formation.WWIIBomberOpen
					-- myFriendlyTask[2] = {["number"] = 2,["auto"] = true , ["enabled"] = true, ["id"] = 'WrappedAction', params = { ["action"] = {["id"] = "Option",["params"] = {["value"] = AI.Option.Air.val.ROE.WEAPON_HOLD ,["name"] = AI.Option.Air.id.ROE, },},} } -- RULES OF ENGAGMENT
					-- if myTraffic.wing == "rotary" then 
						-- mySpawnType = Group.Category.HELICOPTER
						-- myFriendlyTask = formation.RotaryWedge
					-- end
					
					-- gTargetsCount = gTargetsCount + 1
					-- gCurrentGroupID = gCurrentGroupID + 1
					-- local myPayload  = {  ["fuel"] = myTraffic.fuel , ["pylons"] = myPylonsChoice , ["flare"] = 200, ["chaff"] = 200, ["gun"] = 100 }
					-- local myUnits = {}
					-- local myTempName = "1"
					-- local myTempUnitCount = math.random (1, myUnitCount)
					-- if myTraffic.category == MissionCombat.UNARMEDAIR.category then myTempUnitCount = 1 end
					-- for i=1, myTempUnitCount do
						-- myUnits[#myUnits+1] = { name = myName .. " G" .. gTargetsCount .. "U" .. i , heading=myHeading,  spawn_type=mySpawnType , 
						-- skill = gFriendlySkillLevel , type=myTraffic.type, position=myPoint  , livery_id=myLivery, payload=myPayload, alt=myAlt , speed=mySpeed, altType="BARO", }
					-- end
					
					-- local mySpawn = { name=myName .. " G" .. gTargetsCount ,groupID=gCurrentGroupID, units=myUnits, skill=gFriendlySkillLevel ,
					-- action= "Fly Over Point" , lateActivation=true , spawn_type=mySpawnType , type=myTraffic.type, 
					-- position=myPoint , heading=myHeading , country=myTargetType.country ,
					-- speed=myTraffic.speed , alt=myAlt , altType="BARO", tasks=myFriendlyTask,}
					-- local myBuiltSpawn = doBuildSpawn (mySpawn)
					-- local myCountry = 2
					-- if myCoalition == 1 then myCountry = 0 end 
					

					-- coalition.addGroup(myCountry, mySpawnType , myBuiltSpawn ) 
					
					
			end 
		end 
	end
end 
function trafficRadarSweep ( input )
	--if Debugging == true then printDebug ("EventHandler" , "Radar Sweep", 10 ) end
	local mySearchRadius = 15000
	local mySpeed = 300
	
	for key , value in pairs(gMissionOptions.airports) do
		
		local myFoundObjects = SearchAreaForObjects ( {point=value.point , radius=mySearchRadius , category=Object.Category.UNIT ,  } )
		local myLocalTraffic = false 
		local myCoalition = 0
		local myPlayersNearby = false 
		local myPlayersOnground = true  
		local myTrafficNearby = false
		
		local myCountry = 0

		
		for unit_id,unit_value in pairs(myFoundObjects) do
		
			local myUnit = Unit.getByName(unit_value)
			local myGroupName = Group.getName ( Unit.getGroup(myUnit))
			
			if gPlayerGroups[myGroupName] ~= nil then 
			--	if Debugging == true then printDebug ("EventHandler" , "Players Groups " .. myGroupName, 10 ) end
				myCoalition =  Unit.getCoalition(Unit.getByName(unit_value))
				myCountry = Unit.getCountry(myUnit)
				if Unit.inAir(myUnit) == true then myPlayersOnground = false end
				local myAirbase = Airbase.getByName(key)
				local myAirbaseCoa = Airbase.getCoalition(myAirbase)
				if myAirbaseCoa == myCoalition then 
					myPlayersNearby = true 
				end
			else
				local myUnit = Unit.getByName(unit_value)
				local myType = Unit.getTypeName(myUnit)
				local myUnitDesc = Unit.getDescByName(myType)
				if (myUnitDesc.category == Unit.Category.AIRPLANE or myUnitDesc.category == Unit.Category.HELICOPTER) and Unit.isActive(myUnit) then 
				--	if Debugging == true then printDebug ("EventHandler" , "Unit Nearby " ..  unit_value , 10 ) end
					myTrafficNearby = true
				end

			end
			
		end 
		-- PLAYERS ARE NEAR BUT NO AI AROUND
		if myPlayersNearby == true and myTrafficNearby == false then
				--if Debugging == true then printDebug ("EventHandler" , "Players at Airport " .. key, 10 ) end
				local myDiameter = 10000
				local myAlt = 2000	
				local patternAlt = 1000
	
				if value.category == 1 then -- THIS AIRPORT IS AT SEA
					myCoalition	= myCoalition + 2 -- GET THE AIRCRAFT CARRIER APPROVED COALTIOIN
					--if Debugging == true then printDebug ("EventHandler" , "Over Carrier "   , 10 ) end					
				end
				
			-- CHECK FOR AVAILABLE SPAWSN ALREADY SPAWNED	
				local myTempTraffic = {}
				--for key , value in pairs(gTraffic.members) do		 
				for group_key , group_value in pairs(gMissionOptions.traffic.members[myCoalition]) do
					local myHidden = true
					if Group.getByName(group_value.spawn.name) ~= nil then 
						--if Debugging == true then printDebug ("EventHandler" , "Group Exists " .. group_value.spawn.name   , 10 ) end
						for index, data in pairs(Group.getByName(group_value.spawn.name):getUnits()) do 
							if Unit.isActive(data) == true then 
								myHidden = false  
							--	if Debugging == true then printDebug ("EventHandler" , "Active " .. Unit.getName(data )   , 10 ) end
							end 
						end
						if myHidden == true then
							myTempTraffic[#myTempTraffic+1] = group_value
						--	if Debugging == true then printDebug ("EventHandler" , "Available " .. group_value.spawn.type    , 10 ) end
						end
					end 		
				end
				--end 
				local myTraffic=myTempTraffic[math.random( 1, #myTempTraffic )]	
				--local myTraffic=gTraffic.members[myCoalition][math.random( 1, #gTraffic.members[myCoalition] )]	
				
				if #myTempTraffic >= 1 then 
					if myTraffic.spawn.spawn_type == Unit.Category.HELICOPTER then 
						myAlt = 1000 
						mySpeed = 150
						myDiameter = myDiameter/2
					end 
					
					local myPoint = getPointOnRadian ( { diameter=math.random (myDiameter,myDiameter*2) , pos=value.point , angle = math.random(1,6)*((math.pi*2)/6) })
					local myHeading = getBearingTwoPoints(myPoint , value.point)
					
					local myFlyToPoint = myPoint.between[3] 
					myTraffic.spawn.spawnFrom = "Turning Point" 
					myTraffic.spawn.airfield=nil
					if myPlayersOnground == true then
						myTraffic.spawn.spawnFrom = "TakeOff" 
						myTraffic.spawn.airfield=value.id
						myFlyToPoint = getPointOnRadian ( { diameter=math.random (myDiameter,myDiameter*2) , pos=value.point , angle = math.random(1,6)*((math.pi*2)/6) }) -- fly further away on takeoff
					end 
					

											 
					myTraffic.spawn.position = myPoint

					myTraffic.spawn.alt = value.alt_feet + myAlt  -- value.alt_feet
					local elevation = land.getHeight{x = myPoint .x, y = myPoint .z}
					myTraffic.spawn.alt = (elevation*FEET) + 1700
					myTraffic.spawn.altType ="BARO" 
					
					if elevation*FEET > myTraffic.spawn.alt then myTraffic.spawn.alt = (elevation*FEET) + 500 end -- THE AIRPORT IS CLOSE TO MOUNTAINS ?
					
					myTraffic.spawn.lateActivation = false
					myTraffic.spawn.heading = myHeading
															
					--  GET THE WAYPOINTS
					local myWaypoints={}
					--myWaypoints[#myWaypoints+1] = { action = "Turning Point", pos=myPoint , alt = myTraffic.spawn.alt  , altType="BARO" , speed = myTraffic.spawn.speed , }
					myWaypoints[#myWaypoints+1] = { action = "Turning Point", pos=myFlyToPoint , alt = myTraffic.spawn.alt  , altType="BARO" , speed = mySpeed  , }
					myWaypoints[#myWaypoints+1] = { action = "Landing", type="Land" , pos=value.point , alt = value.alt_feet + patternAlt  , altType="BARO" , speed = mySpeed  , }
					myTraffic.spawn.waypoints=myWaypoints
					
					for s_units ,s_value in pairs(myTraffic.spawn.units) do
						myTraffic.spawn.units[s_units].alt = myTraffic.spawn.alt
						myTraffic.spawn.units[s_units].position = myPoint
						myTraffic.spawn.units[s_units].heading = myHeading
						myTraffic.spawn.units[s_units].speed = mySpeed
						myTraffic.spawn.units[s_units].altType ="BARO" 
					end 

					local myBuiltSpawn = doBuildSpawn (myTraffic.spawn)
					coalition.addGroup(myCountry, myTraffic.spawn.spawn_type, myBuiltSpawn ) 
					--if Debugging == true then printDebug ("EventHandler" , "Add " ..  myTraffic.spawn.type .. " " .. myTraffic.spawn.speed .. " " .. myTraffic.spawn.units[1].alt , 10 ) end
				end 
		elseif myTrafficNearby == true and myPlayersNearby == true then 
			--if Debugging == true then printDebug ("EventHandler" , "Traffic in Pattern" , 10 ) end
		end 
			
	end 
end

-- EVENT LOOPS --
function eventLoopTemplate ()
		if (math.fmod (timer.getTime(), 10 )  < 1 ) then 
		--if Debugging == true then printDebug ("EventHandler" , "In Eventloop"  , 10 ) end 
		-- CHECK THE FOLLLOW THE LEADER LOCATION
		for groupKey , groupValue in pairs(gMissionOptions.runningMissions) do

			if groupValue.following ~= nil then 

				local myPlayerGroupCounts = {}
				
				local bluePlayers = coalition.getPlayers(groupValue.coalition)
				for i = 1, #bluePlayers do
					local myGroup = Unit.getGroup( bluePlayers[i] )
					local myGroupName = Group.getName(myGroup)
					local myUnits = myGroup:getUnits()
					-- sayInMission ( { who=myGroupName, what={[1]="closeto", }, distance=gMissionOptions.holdRange , group=myGroupName , duration=5 } ) 
					--
					if myPlayerGroupCounts[myGroupName] == nil then myPlayerGroupCounts[myGroupName] = {count = 1} else myPlayerGroupCounts[myGroupName].count = myPlayerGroupCounts[myGroupName].count + 1 end
				end
			 

				local myPlayers = coalition.getPlayers(groupValue.coalition)
				local myPlayersTable = {}
				local myPlayerGroups = {}
				local myInRange = true 
				local myPlayersAirborne = true 
				local mySlowestSpeed = gMissionOptions.topSpeed
				local myHoldingSpeed = gMissionOptions.topHoldingSpeed
			 
			 
				for count = 1, #myPlayers do

					local myPlayerUnitName = Unit.getName(myPlayers[count])
					local myPlayerGroupName = Group.getName(Unit.getGroup(myPlayers[count]))
					-- if ( gMissionOptions.level == "group" and myPlayerGroupName == groupKey ) or ( gMissionOptions.level == "coalition" ) then	
					if ( gMissionOptions.level == "group" and myPlayerGroupName == groupKey ) or ( gMissionOptions.level == "coalition" ) or  ( gMissionOptions.level == "mission" ) then							
						

						local myAircraftType = MissingAircraft
						if Unit.getByName(myPlayerUnitName) ~= nil then 
							myAircraftType = AircraftType[string.upper(Unit.getTypeName(Unit.getByName(myPlayerUnitName) ):gsub('[%p%c%s]', '') )]
						end 
						--myAltimeter = AircraftType[string.upper(Unit.getTypeName(Unit.getByName(myPlayerUnitName) ):gsub('[%p%c%s]', '') )].altimeter end
						
						myPlayerGroups[myPlayerGroupName] = { group=myPlayerGroupName , altimeter=myAircraftType.altimeter  }				
						
						-- local myTopSpeed = AircraftType[string.upper(Unit.getTypeName(Unit.getByName(myPlayerUnitName) ):gsub('[%p%c%s]', '') )].speed * gMissionOptions.runningMissions[groupKey].topSpeedModifier 
						local myTopSpeed = myAircraftType.speed * gMissionOptions.runningMissions[groupKey].topSpeedModifier 
						if myTopSpeed < mySlowestSpeed then mySlowestSpeed = myTopSpeed end 
						-- local myHolding = AircraftType[string.upper(Unit.getTypeName(Unit.getByName(myPlayerUnitName) ):gsub('[%p%c%s]', '') )].speed * (gMissionOptions.topHoldingSpeed /gMissionOptions.topSpeed )
						local myHolding = myAircraftType.speed * (gMissionOptions.topHoldingSpeed /gMissionOptions.topSpeed )
						if myHolding < myHoldingSpeed then myHoldingSpeed = myHolding end 
						
						if gMissionOptions.runningMissions[groupKey].proximityQueue ~= nil then
							for proximityCount = 1, #gMissionOptions.runningMissions[groupKey].proximityQueue do
								local myUnitCheckName = gMissionOptions.runningMissions[groupKey].proximityQueue[proximityCount].unit
								-- DO THE UNITS MATCH THE ONES WHICH STARTED MISION OR ONE PLAYER FROM GROUP THAT STARTED MISSION
								if ( myUnitCheckName == myPlayerUnitName ) or ( myPlayerGroupName == groupKey and myPlayerGroupCounts[groupKey].count == 1 ) then 
								
									-- if Debugging == true then printDebug ("EventHandler" ,  "U: " .. myUnitCheckName .. " P: " .. myPlayerUnitName .. " needs to be checked "  .. myPlayerGroupCounts[groupKey].count  , 3 ) end
									local myAlt = 0
									if Unit.getByName(myPlayerUnitName) ~= nil then myAlt = getMSLfeet(myPlayerUnitName) end 
									myPlayersTable[myPlayerUnitName] = {group, unit=myPlayerUnitName , alt=myAlt , altimeter=myPlayerAltimeter }
									if ( myUnitCheckName ~= myPlayerUnitName ) and ( myPlayerGroupName == groupKey and myPlayerGroupCounts[groupKey].count == 1 ) then
										if Debugging == true then printDebug ("EventHandler" ,   myPlayerUnitName .. " replaces " .. gMissionOptions.runningMissions[groupKey].proximityQueue[1].unit .. " for proximity " , 10 ) end
										gMissionOptions.runningMissions[groupKey].proximityQueue[1].unit = myPlayerUnitName
									end 
								end 
							end
						end 
						
						--myPlayersTable[myPlayerUnitName] = {group, unit=myPlayerUnitName , alt=getMSLfeet(myPlayerUnitName) , altimeter=myPlayerAltimeter }
						
						if Unit.getByName(myPlayerUnitName) ~= nil then 
							if Object.inAir(Unit.getByName(myPlayerUnitName) ) == false then myPlayersAirborne = false end
						end 
						
					end 
				 end
				 
				local myLeaderName = Unit.getName ( Group.getByName(groupValue.leader):getUnit(1) )
				local myLeaderPosition = centerUnitCoordinates(myLeaderName)
				local myLeaderAngleToTarget = getAngleBetweenTwoPointsV2(myLeaderPosition , groupValue.position)
				local myCategory = {[1] = Object.Category.UNIT , }
				local myLeaderAlt = getMSLfeet(myLeaderName) 
				local myHoldRange = gMissionOptions.holdRange
				local mySpeed = getAirspeed ( myLeaderName )
				local myLeaderHeading = doGetUnitHeading ({name=myLeaderName})
				local myFirstWayPoint = getPointOnRadian ( { radius=1000 , pos=myLeaderPosition , angle = myLeaderHeading.angle })
				
				if myPlayersAirborne == false then myHoldRange = gMissionOptions.holdGround end 
				
					

				local myFoundObjects = SearchAreaForObjects ( {point=myLeaderPosition , radius=myHoldRange, category=myCategory ,  } )
				for objectKey , objectValue in pairs( myFoundObjects ) do
					if myPlayersTable[objectValue] ~= nil then
						myPlayersTable[objectValue].inRange = true 
						--if Debugging == true then printDebug ("EventHandler" , "Players In Range  " , 10 ) end						
					end
				end
				for playerKey , playerValue in pairs( myPlayersTable ) do
					if playerValue.inRange == nil then
						myInRange = false 
					end 
				end 
				-- is everyone in the coalition close enough
				if myInRange == true and groupValue.ingressHold ~= nil and myPlayersAirborne == true then
					-- local myLeaderHeading = doGetUnitHeading ({name=myLeaderName})
					if groupValue.toldTurn == nil and math.fmod (timer.getTime(), 60 )  < 1  then
						for sayKey , sayValue in pairs( myPlayerGroups ) do 
							sayInMission ( { who=myLeaderName, what={[1]="inrange", } , group=sayValue.group , speedAt=mySpeed , duration=20 } ) 
						end
						if groupValue.inrangeTimer == nil then groupValue.inrangeTimer = timer.getTime() end 
					end 

					local myAngle = myLeaderHeading.angle + ( math.pi*2)
					if myAngle >= ( (myLeaderAngleToTarget+ ( math.pi*2)) - 0.78 ) and myAngle <= ( (myLeaderAngleToTarget+ ( math.pi*2)) + 0.78 ) then 
						local myAttitude = doGetPitchAndRoll ( { callsign=myLeaderName }  )
						if myAttitude.roll == "Level" then 
							local myBearing = getBearingTwoPoints(myLeaderPosition , groupValue.position)
							local myRoute = {}
							myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myFirstWayPoint , alt=groupValue.transitionAlt , altType="BARO" , speed=myHoldingSpeed }
							myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=groupValue.position , alt=groupValue.transitionAlt , altType="BARO" , speed=myHoldingSpeed }
							
							local myTasking = getTasking ( {group=groupKey, chatter=true, sortie=gMissionOptions.runningMissions[groupKey].leadSortie , } )
							
							local myInfo = { group = groupValue.leader , route=myRoute , tasks=myTasking , push=true } 
							timer.scheduleFunction(ResetGroupController, groupValue.leader, timer.getTime()+ 0.1 )   			
							timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + 0.2 )
							groupValue.ingressHold = nil 
							groupValue.speedupTimer = timer.getTime()
							--local myWhat = gMissionOptions.runningMissions[groupKey].areas[gMissionOptions.runningMissions[groupKey].activeArea].zoneAction 
							for sayKey , sayValue in pairs( myPlayerGroups ) do 
								sayInMission ( { who=myLeaderName, what={[1]="continue", } , group=sayValue.group , heading=myBearing , speedAt=mySpeed , duration=20 } )
							end
							-- if groupValue.toldTurn ~= nil then 
								-- timer.scheduleFunction( followGroup, {group=groupValue.group}, timer.getTime() + 0.3 )
								-- groupValue.toldTurn = nil
							-- end 
						end 
					-- CLOSE ENOUGH FOR SWEEPING TURN TO CORRECT HEADING
					elseif groupValue.inrangeTimer ~= nil and groupValue.toldTurn == nil then
						if ( timer.getTime() - groupValue.inrangeTimer) >= 45 then
							groupValue.inrangeTimer = nil
							groupValue.toldTurn = true 
							local mySide = PointLeftOrRight ( {unit=myLeaderName, position= groupValue.position } )
							local myTurnDegrees = math.abs ( math.atan2(math.sin(myLeaderHeading.angle - myLeaderAngleToTarget ), math.cos(myLeaderHeading.angle - myLeaderAngleToTarget )))

							-- doFormationAerobaticTurn ({group=groupValue.group , side=mySide , holdSpeed=myHoldingSpeed,  degrees=(180/math.pi)*myTurnDegrees , action="turn" , roll=35  }) -- problems if using units
							local myLeaderBearingToTarget = getBearingTwoPoints(myLeaderPosition , groupValue.position) -- problems when 
							for sayKey , sayValue in pairs( myPlayerGroups ) do
								sayInMission ( { who=myLeaderName, what={[1]="turn", [2]="left" , } , group=sayValue.group , heading=myLeaderBearingToTarget , speedAt=mySpeed , duration=20 } )
							end 
							local myFormationPosition = getPointOnRadian ( { diameter=9000 , pos=groupValue.position , angle = myLeaderAngleToTarget }) 
							holdGroup ({group=groupValue.group , alt=groupValue.transitionAlt, position=groupValue.position , racetrack_point=myFormationPosition, speed=myHoldingSpeed , chatter=true , 
											holdingGroups = gMissionOptions.runningMissions[groupKey].sorties[gMissionOptions.runningMissions[groupKey].leadSortie] })
						end  
					end 

				end 
				
				-- everyone in coalition is out of range so we are holding
				if ( myInRange == false and groupValue.ingressHold == nil) or ( groupValue.redStartHold ~= nil )  then
					if myLeaderAlt > (groupValue.transitionAlt-500) then
						for sayKey , sayValue in pairs( myPlayerGroups ) do 
							sayInMission ( { who=myLeaderName , what={[1]="holding", } , distance=gMissionOptions.holdRange , group=sayValue.group , duration=20 } ) 
						end 
						local myPositionOne = getPointOnRadian ( { diameter=1000 , pos=myLeaderPosition , angle = myLeaderAngleToTarget }) 
						local myPositionTwo = getPointOnRadian ( { diameter=gMissionOptions.raceTrackDistance , pos=myLeaderPosition , angle = myLeaderAngleToTarget }) 
						local myAlt = groupValue.transitionAlt 
						-- if Debugging == true then printDebug ("EventHandler" , "Holding speed " ..  myHoldingSpeed , 10 ) end
						holdGroup ({	group=groupValue.group , alt=myAlt, position=myPositionOne , racetrack_point=myPositionTwo, speed=myHoldingSpeed , chatter=true , 
										holdingGroups = gMissionOptions.runningMissions[groupKey].sorties[gMissionOptions.runningMissions[groupKey].leadSortie] })
						groupValue.ingressHold = true
						groupValue.straightLevelTimer = nil 
						groupValue.redStartHold = nil 
						groupValue.toldTurn = nil 
						followGroup ({group=groupValue.group, })
					end
				end 
				
				if myInRange == false and (math.fmod (timer.getTime(), 30 )  < 1 ) then	
					for sayKey , sayValue in pairs( myPlayerGroups ) do 
						sayInMission ( { who=myLeaderName , what={[1]="closeto", }, distance=gMissionOptions.holdRange , speedAt=mySpeed ,group=sayValue.group , duration=5 } ) 
					end
				end 
				
				if myInRange == true and groupValue.speedupTimer ~= nil then
					local myTimeElasped = timer.getTime() - groupValue.speedupTimer

					if myTimeElasped >= gMissionOptions.speedUpSeconds then 
						local myAttitude = doGetPitchAndRoll ( { callsign=myLeaderName }  )
						if myAttitude.roll == "Level" then 

							local myRoute = {}
														
							myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=myFirstWayPoint , alt=groupValue.transitionAlt , altType="BARO" , speed=mySlowestSpeed }
							myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pos=groupValue.position , alt=groupValue.transitionAlt , altType="BARO" , speed=mySlowestSpeed }

							local myTasking = getTasking ( {group=groupKey, chatter=true, sortie=gMissionOptions.runningMissions[groupKey].leadSortie , } )
							
							local myInfo = { group = groupValue.leader , route=myRoute , tasks=myTasking , push=true } 
							timer.scheduleFunction(ResetGroupController, groupValue.leader, timer.getTime()+ 0.01 )   			
							timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime() + 0.02 )
							groupValue.speedupTimer = nil
							groupValue.straightLevelTimer = timer.getTime()
							local myCalibratedAS =  mySpeed.airspeed + (mySlowestSpeed -  myHoldingSpeed)
							local myNewAirspeed = { airspeed=myCalibratedAS, airspeedmps=myCalibratedAS*0.514444444 }
							for sayKey , sayValue in pairs( myPlayerGroups ) do 
								sayInMission ( { who=myLeaderName, what={[1]="increase_airspeed", }  ,  group=sayValue.group , speedTo=myNewAirspeed , duration=20 } )
							end 
						end 

					end 
				end 
				
				if groupValue.straightLevelTimer ~= nil then
					if ( (timer.getTime() - groupValue.straightLevelTimer) >= 60 ) then 
						groupValue.straightLevelTimer = timer.getTime()
						for sayKey , sayValue in pairs( myPlayerGroups ) do 
							if myPlayersAirborne == true then 
								local myWhat = gMissionOptions.runningMissions[groupKey].areas[gMissionOptions.runningMissions[groupKey].activeArea].zoneAction 
								-- if Debugging == true then printDebug ("EventHandler" , "In Eventloop "  .. myWhat, 10 ) end
								sayInMission ( { who=myLeaderName, what={[1]="continue",  } , where=myWhat , group=sayValue.group , speedAt=mySpeed , duration=20 } )
							else
								local myTaxiSpeed = {airspeed=myHoldingSpeed , airspeedmps=myHoldingSpeed*0.514444444  }
								sayInMission ( { who=myLeaderName, what={[1]="joinup", }  , group=sayValue.group , speedAt=myTaxiSpeed , duration=20 } )
							end
						end 
					end 
					
				end 
				-- if Debugging == true then printDebug ("EventHandler" , groupValue.straightLevelTimer  , 10 ) end
				-- if groupValue.ingressHold ~= nil then 
					-- if Debugging == true then printDebug ("EventHandler" , "Holding "   , 10 ) end
				-- end 
			end 
		end
		-- CHECK FOR AI IN SORTIES HAVE LOST TASKS
		checkForLostTasks( input )
	
	end 
	
	if gMissionOptions.traffic.randomness ~= "off" and (math.fmod (timer.getTime(), 20 )  < 1 ) then 
		if gMissionOptions.traffic.members ~= nil then 
			trafficRadarSweep ( input )
		end 
	end 


end 
function eventLoop ( )
	eventLoopTemplate ( )
	eventLoopMission ( )
end 