-------------------------------------------
-- © 2020 Brad Dunbar, All rights reserved.
-------------------------------------------

------------------------------------
--- TOOLBOX FUNCTIONS START HERE ---
------------------------------------
--- PRINTING ROUTINE ---
function doPrintThis (myPrint)

	local myPlayers =  validPlayerGroups ( )
	local myClearview = true
	if myPrint.clearview ~= nil then myClearview = myPrint.clearview end -- are we clearing the current view
	if myPrint.group ~= nil then
		local myGroupID = Group.getID(myPlayers[myPrint.group])
		trigger.action.outTextForGroup(Group.getID(myPlayers[myPrint.group]), myPrint.text , myPrint.duration , myClearview )
		--if Debugging == true then  printDebug ( "Printing" , "Outputing To Group: " .. myPrint.text , 10 ) end 
	end

	if myPrint.country ~= nil then
		trigger.action.outTextForCountry(myPrint.country , myPrint.text , myPrint.duration , myClearview )
		--if Debugging == true then  printDebug ( "Printing" , "Outputing To Country: " .. myPrint.text , 10 ) end 
	end
	
	if myPrint.coalition ~= nil then
		trigger.action.outTextForCoalition(myPrint.coalition , myPrint.text , myPrint.duration , myClearview )
		--if Debugging == true then  printDebug ( "Printing" , "Outputing To Coalition: " .. myPrint.text , 10 ) end 
	end
	-- EVERONE IF VALUE BLANK ---
	if( myPrint.coalition == nil and myPrint.country == nil and myPrint.group == nil ) then
		trigger.action.outText( myPrint.text, myPrint.duration , myClearview )
		--if Debugging == true then  printDebug ( "Printing" , "Outputing To Everyone: " .. myPrint.text , 10 ) end 
	end

end

function validPlayerGroups ( input ) -- TOOLBOX ROUTINE
	local myPlayers = {}
	local myValidGroups = {}
	for coa = 0, 2 do
		local myLocalPlayers = coalition.getPlayers(coa)
		for pcount = 1, #myLocalPlayers do
			local myGroup = Unit.getGroup ( myLocalPlayers[pcount] )
			local myGroupName = Group.getName ( myGroup ) 
			if myValidGroups[myGroupName] == nil then myValidGroups[myGroupName] = myGroup  end 
		end 
	end 
	return myValidGroups
end 
--- GET A RANDOM CIRCLE AROUND A GROUP ---
function doSteppedGroupCircle ( myGroup , myDiameter )
	local circleRadius = myDiameter / 2 -- we want the radius
	local pos = centerUnitCoordinates(myGroup.callsign)
	local ranpos = {} -- to hold random positions variables
	local myTurnAngle = 45 -- 11.25 -- 22.5 
	
	--local myAngle = math.random() * math.pi*2
	if ( gMyAngle > 360 or gMyAngle < 0 ) then gMyAngle = 0 end 
	
	if myGroup.direction == "Left" then
		gMyAngle = gMyAngle - myTurnAngle
	else
		gMyAngle = gMyAngle + myTurnAngle
	end
	
	myAngle = gMyAngle
	myAngle = ( gMyAngle / 360 ) *  math.pi*2
	ranpos.x = pos.x + math.cos(myAngle) *  circleRadius
	ranpos.dx = pos.x + math.cos(myAngle) *  (circleRadius*2)
	ranpos.z =pos.z + math.sin(myAngle) * circleRadius
	ranpos.dz =pos.z + math.sin(myAngle) * (circleRadius*2)
	
	return ranpos
end
--- GET THE HEADING OF A GROUP --
function doGetUnitHeading ( myUnit )
	--myTurningGroup.groupName = myTurningGroup.callsign
	if myUnit.name ~= nil then myUnit.callsign = myUnit.name end
	local myUnit2 = Unit.getByName(myUnit.callsign) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = Unit.getPosition(myUnit2)
	local heading = {}
	heading.bearing = (360/(math.pi*2) ) * math.atan2(myUnit2pos.x.z , myUnit2pos.x.x )
	heading.angle = math.atan2(myUnit2pos.x.z , myUnit2pos.x.x )
	heading.reverseangle = heading.angle + math.pi 
	if heading.bearing  < 0 then
		heading.bearing  = 360 + heading.bearing 
		heading.angle = heading.angle + (math.pi*2)
	end
	if heading.reverseangle < 0 then
		heading.reverseangle = math.pi*2 - heading.reverseangle
	 end
	-- if Debugging == true then  printDebug ( "HeadingHandler" , myUnit.callsign .. "is bearing " .. string.format("%d", heading.bearing) .. " or Angle of: " .. string.format( "%3f", heading.angle  )  , 10 ) end 
	return heading
end

function firstLetterUpperCased ( input ) -- TOOLBOX ROUTING
	local myReturn = input:sub(1,1):upper()..input:sub(2)
	return myReturn
end  

function firstLetterLowerCased ( input ) -- TOOLBOX ROUTING
	local myReturn = input:sub(1,1):lower()..input:sub(2)
	return myReturn
end 

function getKeyForValue( t, value ) -- give it a table t and a value and it will return the key number
  for k,v in pairs(t) do
    if v==value then return k end
  end
  return nil
end

-- HAVE AI MAKE A SMOOTH RANDOM DIRECTION TURN
function doGroupRandomTurn ( myGroup )
	local myZone = doSteppedGroupCircle ( myGroup , 5000 ) -- GET A RANDOM CIRCLE of diameter AROUND A GROUP	
	local myWingmanRoute = {}
	myWingmanRoute[#myWingmanRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=myZone.x , pointZ=myZone.z , alt = myGroup.alt , altType="RADIO" , speed = myGroup.speed }
	local myInfo = {}
	myInfo = { group = MyWingman , route=myWingmanRoute , push=true }
	timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ .1 )
	if Debugging == true then  printDebug ( "Waypoints" ,   "doGroupRandomTurn ia scheduling a route" , 10 ) end 
	local mySpawn = {} 
	local myZone ={}
	myZone = randomUnitCircle ( MyWingman , 100 )					
	mySpawn.callsign = Speedboat
	mySpawn.task ="Nothing"
	mySpawn.starttime = "0"
	mySpawn.alt = "0"
	mySpawn.altType = "BARO"
	mySpawn.speed = "3"
	mySpawn.fuel = "1000"
	mySpawn.skill = "Average"
	mySpawn.livery = "Standard"
	mySpawn.transport = "Ground"
	mySpawn.heading = getHeadingZoneToZoneDegrees( "TaskGroupSpawnZone" , "TaskGroupTurnZone" )
	local myGroupCreated
	mySpawn.vehicletype = unitType.vehicle.unarmed.M_818
	local myGroupCreated = createGroundSpawn (mySpawn, myZone )
	coalition.addGroup(country.id.RUSSIA, Group.Category.GROUND, myGroupCreated) -- SPAWN THE Group	
end

-- HAVE THE AI MAKE A SMOOTH TURN TO A POINT
function doGroupHeadingTurn ( myTurningGroup) --, myPoint ) -- function for a one minute turn
 	-- local myTurningGroup = {}
	--if Debugging == true then  printDebug ( "EventHandler" , myTurningGroup.callsign .. " is making a group heading turn"  , 10 ) end 
	myTurningGroup.groupName = myTurningGroup.callsign
	--myTurningGroup.diameter = 5000
	local myTurnInformation = {}
	local myPoint = myTurningGroup.point
	-- myTurningGroup.zone = "TargetZone0"
	-- myTurningGroup.altType = "RADIO" 
	-- myTurningGroup.alt = 0
	-- myTurningGroup.speed  = 0
	-- myTurningGroup.delay = 5
	local diff = 0
	local turnDirection
	local turnType 
	local mySteppedTurnPoint
	local myTurningDelay = myTurningGroup.delay - myTurningGroup.delay + 3
	-- get mygroup position
 	local myUnit2 = Unit.getByName(myTurningGroup.groupName) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = Unit.getPosition(myUnit2)
	
	--trigger.action.signalFlare(myPoint, 1 , 1 )
	
	local function addWayPoint (myTurningPoint) -- local function to add a waypoint depending on number of steps in the turn
		if Debugging == true then  printDebug ( "Waypoints" , "doGroupHeadingTurn ia scheduling a route" , 10 ) end 
		turnType = "Step"
		local myWingmanRoute = {}
		myWingmanRoute[#myWingmanRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=myTurningPoint.x , pointZ=myTurningPoint.z , alt = myTurningGroup.alt , altType=myTurningGroup.altType , speed = myTurningGroup.speed }
		local myInfo = {}
		myInfo = { unit = myTurningGroup.groupName , route=myWingmanRoute , push=true }
		timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ myTurningDelay )
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Should make stepped turn to point" , 10 ) end 
		--trigger.action.signalFlare(myTurningPoint, 0 , 1 )
		myTurningDelay = myTurningDelay + myTurningGroup.delay -- increment turning group for next time
	end
	-- get target position
	local myTargetBearing = getBearingToPoint(myTurningGroup.groupName , myPoint)
	myTurnInformation.heading = string.format( "%03d", myTargetBearing ) -- hold the setting to return the bearing to target
	--local myTargetBearing = getBearingToGroup(myTurningGroup.groupName, myTarget )
	--local myTargetPosition = centerUnitCoordinates ( myTarget )
	if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Bearing " .. string.format("%d", myTargetBearing) .. " To point" , 10 ) end 
	
	--local myBearing = getBearingFromZone(myTurningGroup.zone, myTurningGroup.groupName)
	--if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Bearing to intercept " .. myBearing , 10 ) end 

	-- get the current heading and angle of myTurningGroup.groupName
	local myHeading = (360/(math.pi*2) ) * math.atan2(myUnit2pos.x.z , myUnit2pos.x.x )

	local myAngle = math.atan2(myUnit2pos.x.z , myUnit2pos.x.x )
	if myHeading < 0 then
		myHeading = 360 + myHeading
		myAngle = myAngle + (math.pi*2)
	end

	--local myAngle = math.atan2(myUnit2pos.x.z , myUnit2pos.x.x )
	--if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Heading: " ..  math.sin(myUnit2pos.x.x) , 10 ) end 
	if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Current Heading: " .. string.format( "%d", myHeading ) .. " Angle: " .. myAngle , 10 ) end 
	
	if ( myHeading > 337.5  and myHeading < 360 ) or ( myHeading >= 0 and myHeading < 22.5 ) then 
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading North" , 10 ) end 
	elseif ( myHeading > 22.5 and myHeading <  67.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading North East" , 10 ) end 
	elseif ( myHeading > 67.5 and myHeading <  112.2 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading East" , 10 ) end  
	elseif ( myHeading > 112.2 and myHeading <  157.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading South East" , 10 ) end 
	elseif ( myHeading > 157.5 and myHeading <  202.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading South" , 10 ) end
	elseif ( myHeading > 202.5 and myHeading <  247.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading South West" , 10 ) end
	elseif ( myHeading > 247.5 and myHeading <  292.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading West" , 10 ) end
	elseif ( myHeading > 292.5 and myHeading <  337.5 ) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Curently Heading North West" , 10 ) end 
	end

	 	-- WHAT SIDE OF THE AIRCRAFT IS TARGET ON
	 local diff = myTargetBearing - myHeading;
     if(diff < 0 ) then
         diff = diff + 360
	end
     if(diff > 180) then
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " has point on left side diff:" .. diff , 10 ) end 
		mySteppedFirstPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle-math.pi/4 )
		mySteppedSecondPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle-math.pi/2 )
		mySteppedThirdPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle-math.pi + (math.pi/4) )
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " angle to first turn:" .. myAngle-math.pi/2 , 10 ) end 
		myTurnInformation.direction = "Left" --RETURN DIRECTION 
     else
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " has point on right side diff:" .. diff , 10 ) end 
		mySteppedFirstPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle+math.pi/4 )
		mySteppedSecondPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle+math.pi/2 )
		mySteppedThirdPoint = specificGroupCircle ( myTurningGroup.groupName , myTurningGroup.diameter, myAngle+math.pi -(math.pi/4) )
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " angle to first turn:" .. myAngle+math.pi/2 , 10 ) end 
		myTurnInformation.direction = "Right" --RETURN DIRECTION 
	end
	local myBearingDiffLeft = myHeading - myTargetBearing
	local myBearingDiffRight = (360 - myHeading) + myTargetBearing	
	if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Left Difference to target " .. string.format( "%d", myBearingDiffLeft ) , 10 ) end 
	if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Right Difference to target " .. string.format( "%d", myBearingDiffRight ) , 10 ) end 
	-- DECIDE STEPPED TURN OR SINGLE TURN
	if ( myBearingDiffLeft > 44 or myBearingDiffLeft < -44 ) then
		addWayPoint (mySteppedFirstPoint)
	else -- just one turn
		turnType = "Single"
		if Debugging == true then  printDebug ( "HeadingHandler" , myTurningGroup.groupName .. " Should make single turn to point" , 10 ) end 
	end
	if ( myBearingDiffLeft > 90 or myBearingDiffLeft < -90 ) then
		addWayPoint (mySteppedSecondPoint)
	end
	if ( myBearingDiffLeft > 134 or myBearingDiffLeft < -134 ) then
		addWayPoint (mySteppedThirdPoint)
	end
	-- 	then turn toward the target
	local myWingmanRoute = {}
	myWingmanRoute[#myWingmanRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=myPoint.x , pointZ=myPoint.z , alt = myTurningGroup.alt , altType=myTurningGroup.altType , speed = myTurningGroup.speed }
	local myInfo = {}
	myInfo = { unit = myTurningGroup.groupName , route=myWingmanRoute , push=true }
	timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ myTurningDelay )
	if Debugging == true then  printDebug ( "Waypoints" ,  "doGroupHeadingTurn ia scheduling a route" , 10 ) end 
	myTurningDelay = myTurningDelay + myTurningGroup.delay
	myTurnInformation.delay = myTurningDelay -- RETURN HOW LONG TOOK TO MAKE TURN
	--if Debugging == true then  printDebug ( "EventHandler" , myTurningGroup.groupName .. " Bearing to intercept " .. string.format("%d", myBearing)  .. " Offset: " .. string.format("%d", diff)  , 10 ) end
	return myTurnInformation -- RETURN HOW LONG TOOK TO MAKE THOSE TURNS
	
end

-- HAVE THE AI MAKE A SLOPPY TURN TO A POINT
function doTurnGroup (myTurningGroup)
	-- local myTurningGroup = {}
	-- myTurningGroup.group = MyWingman
	-- myTurningGroup.alt = 100
	-- myTurningGroup.speed = 80
	-- myTurningGroup.direction = "north"
	myTurningGroup.directionZ = 0 -- we zero points to start
	myTurningGroup.directionX = 0 -- we zero points to start
	myTurningGroup.directionZhalf = 0
	myTurningGroup.directionXhalf = 0
	local myTurningString = myTurningGroup.group .. ": Is Turning "
	-- myTurningGroup.distance = 10000
	
	
	if (  myTurningGroup.direction == "east" ) then 
		myTurningGroup.directionZ = myTurningGroup.distance
	elseif (  myTurningGroup.direction == "west" ) then
		myTurningGroup.directionZ = -myTurningGroup.distance
	elseif (  myTurningGroup.direction == "north" ) then
		myTurningGroup.directionX = myTurningGroup.distance
	elseif (  myTurningGroup.direction == "south" ) then
		myTurningGroup.directionX = -myTurningGroup.distance
	end
	
	local myUnit2 = Unit.getByName(myTurningGroup.group) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = Unit.getPosition(myUnit2)	
	
	--if ( myUnit2pos.x.x  > .09 and  myUnit2pos.x.z < .9 ) then
	if ( myUnit2pos.x.x > 0 and  myUnit2pos.x.z > -.7 and myUnit2pos.x.x > .7 ) then
		--if Debugging == true then  printDebug ( "EventHandler" , " Curently Heading North" , 10 ) end 
		 if (  myTurningGroup.direction == "left" ) then 
			myTurningString = myTurningString .. "left"
			 myTurningGroup.directionZ = -myTurningGroup.distance
			 myTurningGroup.directionZhalf = myTurningGroup.directionZ
			 myTurningGroup.directionXhalf = (myTurningGroup.distance / 2)
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Left" , 10 ) end 
		 elseif (  myTurningGroup.direction == "right" ) then 
			myTurningString = myTurningString .. "right"
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Right" , 10 ) end 
			myTurningGroup.directionZ = myTurningGroup.distance
			myTurningGroup.directionZhalf = myTurningGroup.directionZ
			myTurningGroup.directionXhalf = (myTurningGroup.distance  / 2)
		 end
	--elseif ( myUnit2pos.x.x  < -.09 and myUnit2pos.x.z > .1 ) then
	elseif ( myUnit2pos.x.x < 0 and  myUnit2pos.x.z > -.70 and myUnit2pos.x.x < -.70  ) then 
--if Debugging == true then  printDebug ( "EventHandler" , " Curently Heading South" , 10 ) end 
		if (  myTurningGroup.direction == "left" ) then 
			myTurningString = myTurningString .. "left"
			 myTurningGroup.directionZ = myTurningGroup.distance
			 myTurningGroup.directionZhalf = myTurningGroup.directionZ
			 myTurningGroup.directionXhalf = -(myTurningGroup.distance / 2)
--if Debugging == true then  printDebug ( "EventHandler" , " Turn Left" , 10 ) end 
		elseif (  myTurningGroup.direction == "right" ) then
			myTurningString = myTurningString .. "right"
--if Debugging == true then  printDebug ( "EventHandler" , " Turn Right" , 10 ) end 
			myTurningGroup.directionZ = -myTurningGroup.distance
			myTurningGroup.directionZhalf = myTurningGroup.directionZ
			myTurningGroup.directionXhalf = -(myTurningGroup.distance / 2)
		end
	--elseif ( myUnit2pos.x.x  <= .5  and  myUnit2pos.x.z > .8 ) then
	elseif ( myUnit2pos.x.x < .70 and  myUnit2pos.x.z > 0 and myUnit2pos.x.x > -.70  ) then
		--if Debugging == true then  printDebug ( "EventHandler" , " Curently Heading East" , 10 ) end
		if (  myTurningGroup.direction == "left" ) then 
			myTurningString = myTurningString .. "left"
			 myTurningGroup.directionX = myTurningGroup.distance
			 myTurningGroup.directionXhalf = myTurningGroup.directionX
			 myTurningGroup.directionZhalf = (myTurningGroup.distance / 2)
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Left" , 10 ) end 
		elseif (  myTurningGroup.direction == "right" ) then
			myTurningString = myTurningString .. "right"
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Right" , 10 ) end 
			myTurningGroup.directionX = -myTurningGroup.distance
			myTurningGroup.directionXhalf = myTurningGroup.directionX
			 myTurningGroup.directionZhalf = (myTurningGroup.distance / 2)
		end
	--elseif ( myUnit2pos.x.x  <= .5  and  myUnit2pos.x.z < -.09 ) then
	elseif ( myUnit2pos.x.x > -.70 and  myUnit2pos.x.z < 0 and myUnit2pos.x.x > -.70) then
		--if Debugging == true then  printDebug ( "EventHandler" , " Curently Heading West" , 10 ) end
		if (  myTurningGroup.direction == "left" ) then
			myTurningString = myTurningString .. "left"
			myTurningGroup.directionX = -myTurningGroup.distance
			myTurningGroup.directionXhalf = myTurningGroup.directionX
			myTurningGroup.directionZhalf = -(myTurningGroup.distance / 2)
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Left" , 10 ) end 
		elseif (  myTurningGroup.direction == "right" ) then
			myTurningString = myTurningString .. "right"
			--if Debugging == true then  printDebug ( "EventHandler" , " Turn Right" , 10 ) end 
			myTurningGroup.directionX = myTurningGroup.distance
			myTurningGroup.directionXhalf = myTurningGroup.directionX
			myTurningGroup.directionZhalf = -(myTurningGroup.distance / 2)
		end
	end 
	local xDiffhalf = myUnit2pos.p.x + myTurningGroup.directionXhalf
    local zDiffhalf = myUnit2pos.p.z + myTurningGroup.directionZhalf
	local xDiff = myUnit2pos.p.x + myTurningGroup.directionX 
    local zDiff = myUnit2pos.p.z + myTurningGroup.directionZ 
	RememberX = xDiff
	RememberZ = zDiff
	myVec3Zone = centerUnitCoordinates(myTurningGroup.group)	
	local bearing = math.atan2(zDiff - myUnit2pos.p.z  , xDiff - myUnit2pos.p.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
	local myWingmanRoute = {}
	myWingmanRoute[#myWingmanRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=xDiff , pointZ=zDiff, alt = myTurningGroup.alt , altType=myTurningGroup.altType , speed = myTurningGroup.speed }
	local myInfo = {}
	myInfo = { group = myTurningGroup.group , route=myWingmanRoute , push=true }
	timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ myTurningGroup.delay + 10 )
			if Debugging == true then  printDebug ( "Waypoints" ,  "doTurnGroup ia scheduling a route" , 10 ) end 
	local myWingmanHalfRoute = {}
	myWingmanHalfRoute[#myWingmanHalfRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=xDiffhalf , pointZ=zDiffhalf, alt = myTurningGroup.alt , altType=altType, speed = myTurningGroup.speed }
	local myHalfInfo = {}
	myHalfInfo = { group = myTurningGroup.group , route=myWingmanHalfRoute , push=true }
	timer.scheduleFunction(doScheduleFlyRoute, myHalfInfo, timer.getTime()+ myTurningGroup.delay  )
				if Debugging == true then  printDebug ( "Waypoints" ,   "doTurnGroup ia scheduling a route" , 10 ) end 
	string.format(" pos X.X=:%d", myUnit2pos.x.x)
	if Debugging == true then  printDebug ( "Waypoints" , string.format(" pos X.X = %.5f", myUnit2pos.x.x) .. string.format(" pos X.Z = %.5f", myUnit2pos.x.z) , 10 ) end
	if Debugging == true then  printDebug ( "Waypoints" , string.format(" pos Z.Z = %.1f", myUnit2pos.z.z) .. string.format(" pos Z.Z = %.1f", myUnit2pos.z.z)  , 10 ) end
	if Debugging == true then  printDebug ( "Waypoints" , " Turn to heading: " .. bearing , 10 ) end
	printThis ( myTurningString .. " to heading " .. bearing , 10 ) 
end

--  given a group and diameter random position on that circle from that group
-- retuns two points one on the radius another twice the radius
function randomUnitCircle ( myUnit , myDiameter ) 
	local circleRadius = myDiameter / 2 -- we want the radius
	local pos = centerUnitCoordinates(myUnit)
	local ranpos = {} -- to hold random positions variables
	local myAngle = math.random() * math.pi*2
	if Debugging == true then  printDebug ( "HeadingHandler" , myUnit .. " random angle to point " .. myAngle , 10 ) end 
	ranpos.x = pos.x + math.cos(myAngle) *  circleRadius
	ranpos.dx = pos.x + math.cos(myAngle) *  (circleRadius*2)
	ranpos.z =pos.z + math.sin(myAngle) * circleRadius
	ranpos.dz =pos.z + math.sin(myAngle) * (circleRadius*2)
	return ranpos
end

--  given group diameter and angele get two points from that unit
function specificGroupCircle ( myGroup , myDiameter, myAngle )  
	local circleRadius = myDiameter / 2 -- we want the radius
	local pos = centerUnitCoordinates(myGroup)
	local myPos = {} -- to hold  positions variables
	myPos.x = pos.x + math.cos(myAngle) *  circleRadius --point for x
	myPos.dx = pos.x + math.cos(myAngle) *  (circleRadius*2) -- point for x double distance to fly past straight line for instance
	myPos.z =pos.z + math.sin(myAngle) * circleRadius --point for z
	myPos.dz =pos.z + math.sin(myAngle) * (circleRadius*2)-- point for z double distance to fly past straight line for instance
	if Debugging == true then  printDebug ( "HeadingHandler" , myGroup  .. " has found a series of points. ".. myDiameter .. " meters in diameter. At angle of: " .. string.format( "%3f", myAngle  )  , 10 ) end 
	return myPos
end

-- -- GET POINTS ON A RADIAN - GIVEN POINT, DIAMETER AND ANGLE RETURN POINTs ON progressivly larger DIAMBER AT ANGLE  
function getPointOnRadian ( myInfo )  -- TOOLBOX REPLACEMENT
	local circleRadius = 0
	if myInfo.diameter ~= nil then circleRadius = myInfo.diameter / 2 end
	if myInfo.radius ~= nil then circleRadius = myInfo.radius end 
	
	local myPos = {} -- to hold  positions variables

	local myDivisor =  circleRadius / 10 
	
	
	if myInfo.zone ~= nil then
		myInfo.pos = centerZoneCoordinates ( myInfo.zone )
	end 
	
	myPos.x = myInfo.pos.x + math.cos(myInfo.angle) *  circleRadius --point for x
	myPos.dx = myInfo.pos.x + math.cos(myInfo.angle) *  (circleRadius*2) -- point for x double distance to fly past straight line for instance
	myPos.z = myInfo.pos.z + math.sin(myInfo.angle) * circleRadius --point for z
	myPos.dz =  myInfo.pos.z + math.sin( myInfo.angle ) * (circleRadius*2)-- point for z double distance to fly past straight line for instance
	------------ series of points in straight line
	myPos.progressive = {}
	myPos.between = {}
	myPos.hashed = {}

	while #myPos.progressive < 10 do
		myPos.progressive[#myPos.progressive+1] = {}

		myPos.progressive[#myPos.progressive].x=myInfo.pos.x + math.cos(myInfo.angle) *  (circleRadius*#myPos.progressive) -- point for x double distance to fly past straight line for instance
		myPos.progressive[#myPos.progressive].z=myInfo.pos.z + math.sin(myInfo.angle) *  (circleRadius*#myPos.progressive) -- point for x double distance to fly past straight line for instance
		
		myPos.between[#myPos.between+1] = {}
		myPos.between[#myPos.between].x=myInfo.pos.x + math.cos(myInfo.angle) * (#myPos.between*myDivisor) -- point for x double distance to fly past straight line for instance
		myPos.between[#myPos.between].z=myInfo.pos.z + math.sin(myInfo.angle) * (#myPos.between*myDivisor) -- point for x double distance to fly past straight line for instance
	
	end
	
	if myInfo.hashed ~= nil then 
		local myDivided = circleRadius / myInfo.hashed
		for count=1, myInfo.hashed do
			myPos.hashed[#myPos.hashed+1] = {}
			myPos.hashed[#myPos.hashed].x=myInfo.pos.x + math.cos(myInfo.angle) * (count*myDivided) -- point for x double distance to fly past straight line for instance
			myPos.hashed[#myPos.hashed].z=myInfo.pos.z + math.sin(myInfo.angle) * (count*myDivided)  -- point for x double distance to fly past straight line for instance
			--if Debugging == true then printDebug ("EventHandler" , "Do Hash " .. (#myPos.hashed*(myDivisor))   , 10 ) end
		end 
	end 
	-----------
--	if Debugging == true then  printDebug ( "HeadingHandler" , "finding a series of points on a radian. "..  myInfo.diameter  .. " meters in diameter. Using angle of: " .. string.format( "%3f",  myInfo.angle  )  , 10 ) end 
	return myPos
end
-- given a zone a random point on the Circumference line OF THE ZONE
function randomZoneEdge ( myZone ) 
	local pos = trigger.misc.getZone(myZone)
	local ranpos = {} -- to hold random positions variables
	local myAngle = math.random() * math.pi*2
	ranpos.x = pos.point.x + math.cos(myAngle) *  pos.radius
	ranpos.z =pos.point.z + math.sin(myAngle) * pos.radius
	return ranpos
end

-- COUNT PLAYERS AMMO
function doCheckPlayerAmmo ()

	local PlayerUnit = Unit.getByName(PlayerName)
	local myAmmoTable = Unit.getAmmo(PlayerUnit)
	if ( myAmmoTable ~= nil ) then --
	for ammoKey,ammoValue in pairs(myAmmoTable) do -- ITERATE THROUGH THE TARGEST TABLLE 
		--if Debugging == true then printDebug ("EventHandler",  "Type: " .. myAmmoTable[ammoKey].desc.typeName .. " Count: " .. myAmmoTable[ammoKey].count	, 10 ) end
		-- for descKey,descValue in pairs(myAmmoTable[ammoKey].desc) do -- ITERATE THROUGH THE TARGEST TABLLE 
			-- if Debugging == true then printDebug ("EventHandler",  "Desc Key: " .. descKey , 10 ) end
		-- end
	end
	else
		--if Debugging == true then printDebug ("EventHandler",  "No Ammo Loaded"	, 10 ) end
	end
end

function doCheckUnitAmmo (myUnit)
	local myAmmoTable = Unit.getAmmo(Unit.getByName(myUnit))
	if ( myAmmoTable ~= nil ) then --
	for ammoKey,ammoValue in pairs(myAmmoTable) do -- ITERATE THROUGH THE TARGEST TABLLE 
		--if Debugging == true then printDebug ("EventHandler",  "Type: " .. myAmmoTable[ammoKey].desc.typeName .. " Count: " .. myAmmoTable[ammoKey].count	, 10 ) end
		-- for descKey,descValue in pairs(myAmmoTable[ammoKey].desc) do -- ITERATE THROUGH THE TARGEST TABLLE 
			-- if Debugging == true then printDebug ("EventHandler",  "Desc Key: " .. descKey , 10 ) end
		-- end
	end
	else
		--if Debugging == true then printDebug ("EventHandler",  "No Ammo Loaded"	, 10 ) end
	end
end

-- DESTROY  A UNIT
function destroyUnit( myUnit )
	local myVec3Zone = centerUnitCoordinates(myUnit.unit)
	trigger.action.explosion(myVec3Zone, myUnit.power)
end

-- -- FEED AT COLLITION AND BASENAME AND GET THE ID
function getAirbaseID(coa, myGroup)
--if Debugging == true then printDebug ("EventHandler",  "Looping Airbases" , 10 ) end
    local airdromes = {}
    local tmp = coalition.getAirbases(coa)
	local myOne
	--if Debugging == true then printDebug ("EventHandler",  "Looping Airbases: " .. coa	, 10 ) end
    for i=1,#tmp do
        local j = #airdromes + 1
        airdromes[j] = {}
        airdromes[j].coa = coa
        airdromes[j].name = tmp[i]:getName()
		airdromes[j].id = tmp[i]:getID()
		--if Debugging == true then printDebug ("EventHandler",  "Airbases: " .. airdromes[j].name .. " " .. airdromes[j].id , 10 ) end
		if myGroup == airdromes[j].name then myOne = airdromes[j].id  end
    end
	return myOne
end

-- -- FEED AT COLLITION AND BASENAME AND GET THE ID
function getAllAirbases(myAirbase)
    local tmp = world.getAirbases()
	local myOne
	--if Debugging == true then printDebug ("EventHandler",  "Looping All Airbases: "	, 10 ) end
    for i=1,#tmp do
		local myDesc = tmp[i]:getDesc()
		--if Debugging == true then printDebug ("EventHandler",  tmp[i]:getName() .. " ID: " .. tmp[i]:getID() .. " Category: " .. myDesc.category , 10 ) end -- print all the airport to logs
		-- if Debugging == true then printDebug ("EventHandler",  myDesc.typeName , 10 ) end
		-- if Debugging == true then printDebug ("EventHandler",  myDesc.displayName , 10 ) end
		-- for descKey,descValue in pairs(myDesc) do -- ITERATE THROUGH THE TARGEST TABLLE 
			-- --if Debugging == true then printDebug ("EventHandler", descKey .. ":"  , 10 ) end
		-- end
		if myAirbase == tmp[i]:getName() then 
			myOne = tmp[i]:getID() 
			--if Debugging == true then printDebug ("EventHandler", "Returning ID for: " ..  tmp[i]:getName() .. " ID: " .. tmp[i]:getID() .. " Category: " .. myDesc.category , 10 ) end -- print the match to logs
		end
    end
	return myOne
end

-- -- FIND THE CLOSEST AIRBASE WHEN myLocation.group or myLocation.zone IS PASSED
function findClosestAirbase (myLocation)

    local tmp = {}
	if myLocation.coalition ~= nil then
		tmp = coalition.getAirbases(myLocation.coalition )
		if #tmp < 1 then 
			tmp = world.getAirbases()  -- NO AIRBASES BETTER TO FIND ALL THAN NONE
		end 
	elseif myLocation.notcoalition ~= nil then
		local myholdtemp = world.getAirbases()
		local myCountem = 0
		for key ,value in pairs(myholdtemp) do
			if Airbase.getCoalition(value) ~= myLocation.notcoalition then 
				myCountem = myCountem + 1
				tmp[myCountem] = value 
			end 
		end
		--if Debugging == true then printDebug ("EventHandler",  "Finding airbases according to not of coalition " .. myLocation.notcoalition	.. " " .. #tmp , 10 ) end
	else 	
		tmp = world.getAirbases()
		--if Debugging == true then printDebug ("EventHandler",  "Getting all the airbases " .. " " .. #tmp , 10 ) end
	end

	local myClosestAirport = {}
	local myFromPosition = {}
	local myGroup ={}
	
	if myLocation.zone ~= nil then
		if Debugging == true then printDebug ("Waypoints",  "Found " .. #tmp .. " airbases closest to zone: " .. myLocation.zone	, 10 ) end
		myFromPosition = centerZoneCoordinates ( myLocation.zone )
	end
	
	if myLocation.position ~= nil then
		if Debugging == true then printDebug ("Waypoints",  "Found " .. #tmp .. " airbases closest to position: " , 10 ) end
		myFromPosition =  myLocation.position
	end
	
	if myLocation.group ~= nil then
		myGroup = Group.getByName( myLocation.group) 
		local myUnits = Group.getUnits(myGroup)
		for i=1,#myUnits do -- loop through all units one
			local myUnitName = myUnits[i]:getName() 
			myFromPosition = centerUnitCoordinates ( myUnitName )		
		end
		if Debugging == true then printDebug ("Waypoints",  "Found " .. #tmp .. " airbases closest to group: " .. myLocation.group	, 10 ) end
	end
	if myLocation.playerGroup ~= nil then
		local myValidGroups = validPlayerGroups ()
		myGroup = myValidGroups[myLocation.playerGroup] 
		local myUnits = Group.getUnits(myGroup)
		for i=1,#myUnits do -- loop through all units one
			local myUnitName = myUnits[i]:getName() 
			myFromPosition = centerUnitCoordinates ( myUnitName )		
		end
		if Debugging == true then printDebug ("Waypoints",  "Found " .. #tmp .. " airbases closest to players group: " .. myLocation.playerGroup	, 10 ) end
	end
	
	
	if myLocation.furtherthan == nil then -- if we specify minimum distance away
		myLocation.furtherthan = 0
	end

	-- myClosestAirport.distance = getDistanceBetweenTwoPoints( myFromPosition , tmp[1]:getPoint() ) -- start out with first being shortest distance
	myClosestAirport.distance = 1000000
	myClosestAirport.name = tmp[1]:getName()
	myClosestAirport.id = tmp[1]:getID()
	myClosestAirport.airport = tmp[i]
    for i=1,#tmp do
		--deReference ( tmp[i] )
		local myDesc = tmp[i]:getDesc()
		local myAirportPosition = tmp[i]:getPoint()
	    local myDistance = getDistanceBetweenTwoPoints( myFromPosition , myAirportPosition )
		
		local myGetThisOne = true 
		if tmp[i]:getCategory() == 1 and myLocation.landonly ~= nil then
			myGetThisOne = false 
			-- if Debugging == true then printDebug ("EventHandler",  "We shouldn't be showing this airbase" .. tmp[i]:getName() , 10 ) end
		end 


		-- if Debugging == true then printDebug ("EventHandler", "Checking Airport: " .. tmp[i]:getName() ..  " Distance away: " .. myDistance , 10 ) end
		if (myDistance < myClosestAirport.distance) and ( myDistance >= myLocation.furtherthan ) and myGetThisOne then
			-- if Debugging == true then printDebug ("EventHandler", "Airport: " .. tmp[i]:getName() ..  " Distance away: " .. myDistance , 10 ) end
		-- if myDistance < myClosestAirport.distance and myGetThisOne then
			myClosestAirport.distance = myDistance
			myClosestAirport.name = tmp[i]:getName()
			--myClosestAirport.id = tmp[i]:getID()
			myClosestAirport.id = tmp[i]:getID()
			myClosestAirport.airport = tmp[i]
			myClosestAirport.position = tmp[i]:getPosition()
			myClosestAirport.point = tmp[i]:getPoint()
			myClosestAirport.desc = tmp[i]:getDesc()
			myClosestAirport.category = tmp[i]:getCategory()
			myClosestAirport.alt_meters = myClosestAirport.point.y
			myClosestAirport.alt_feet = myClosestAirport.point.y*3.280839895
			myClosestAirport.coalition = tmp[i]:getCoalition()
		end
		
		--if Debugging == true then printDebug ("EventHandler",  "Checking Airbase: " .. tmp[i]:getName() .. " distance: " .. myDistance .. " ID: " .. tmp[i]:getID() , 10 ) end
		-- if Debugging == true then printDebug ("EventHandler",  "Checking Airbase: " .. tmp[i]:getName() .. " distance: " .. myDistance .. " ID: " .. tmp[i]:getID(), 10 ) end
		--if Debugging == true then printDebug ("EventHandler",   tmp[i]:getName() , 10 ) end
		--deReference ( myClosestAirport )
    end

	-- FIND THE AIRPORT RUNWAY HEADING --
	myClosestAirport.bearing = (360/(math.pi*2) ) * math.atan2(myClosestAirport.position.x.z , myClosestAirport.position.x.x )
	myClosestAirport.angle = math.atan2(myClosestAirport.position.x.z , myClosestAirport.position.x.x )
	if myClosestAirport.bearing  < 0 then
		myClosestAirport.bearing  = 360 + myClosestAirport.bearing 
		myClosestAirport.angle = myClosestAirport.angle + (math.pi*2)
	end
	--deReference ( myClosestAirport )
	-- if Debugging == true then printDebug ("EventHandler",  "Found Airbase Closest to group: " .. myClosestAirport.name	.. " Feet " .. myClosestAirport.alt_feet.. " Meters " .. myClosestAirport.alt_meters , 10 ) end
	--if Debugging == true then printDebug ("EventHandler",  "Found Airbase Closest to group: " .. myClosestAirport.name	.. " ID: " .. myClosestAirport.id .." Feet " .. myClosestAirport.alt_feet.. " Meters " .. myClosestAirport.alt_meters , 10 ) end
	-- if Debugging == true then printDebug ("EventHandler", "Returning Airport: " .. myClosestAirport.name ..  " Distance away: " .. myClosestAirport.distance , 10 ) end
	return myClosestAirport
end

function findAirBaseInRange (input) -- TOOLBOX ROUTINE
	
	 
    local tmp = world.getAirbases()
	local myAirbasesInRange = {}
	local myOne = {}
	local myCountem = 0
	
	if input.zone ~= nil then
		input.point = centerZoneCoordinates ( input.zone )
	end
	
	if input.group ~= nil then
		myGroup = Group.getByName( input.group) 
		local myUnits = Group.getUnits(myGroup)
		for i=1,#myUnits do -- loop through all units one
			local myUnitName = myUnits[i]:getName() 
			input.point = centerUnitCoordinates ( myUnitName )		
		end
	end
	
	
    for i=1,#tmp do

		local myCurrentAirport = { point=tmp[i]:getPoint() }
		myCurrentAirport.distance = getDistanceBetweenTwoPoints( input.point , myCurrentAirport.point )
		-- if Debugging == true then printDebug ("EventHandler", "Airbase : " ..  tmp[i]:getName() .. " Distance: " .. myCurrentAirport.distance, 10 ) end -- print the match to logs
		local myGetThisOne = true 
		if tmp[i]:getCategory() == 1 and input.landonly ~= nil then
			myGetThisOne = false 
			-- if Debugging == true then printDebug ("EventHandler",  "We shouldn't be showing this airbase because its a ship " .. tmp[i]:getName() , 10 ) end
		end 
		
		if myCurrentAirport.distance > input.rangemin and myCurrentAirport.distance < input.rangemax and myGetThisOne then 
			myCountem = myCountem + 1
			myAirbasesInRange[myCountem] = {}
			
			myAirbasesInRange[myCountem].distance = myCurrentAirport.distance
			myAirbasesInRange[myCountem].name = tmp[i]:getName()
			myAirbasesInRange[myCountem].id = tmp[i]:getID()
			myAirbasesInRange[myCountem].airport = tmp[i]
			myAirbasesInRange[myCountem].position = tmp[i]:getPosition()
			myAirbasesInRange[myCountem].point = tmp[i]:getPoint()
			myAirbasesInRange[myCountem].desc = tmp[i]:getDesc()
			myAirbasesInRange[myCountem].category = tmp[i]:getCategory()
			myAirbasesInRange[myCountem].alt_meters = myAirbasesInRange[myCountem].point.y
			myAirbasesInRange[myCountem].alt_feet = myAirbasesInRange[myCountem].point.y*3.280839895
			myAirbasesInRange[myCountem].bearingto = getBearingTwoPoints(input.point , myAirbasesInRange[myCountem].point)
			myAirbasesInRange[myCountem].angleto = getAngleBetweenTwoPoints(input.point , myAirbasesInRange[myCountem].point)
			myAirbasesInRange[myCountem].coalition = tmp[i]:getCoalition()
			myAirbasesInRange[myCountem].bearing = (360/(math.pi*2) ) * math.atan2(myAirbasesInRange[myCountem].position.x.z , myAirbasesInRange[myCountem].position.x.x )
			myAirbasesInRange[myCountem].angle = math.atan2(myAirbasesInRange[myCountem].position.x.z , myAirbasesInRange[myCountem].position.x.x )
			if myAirbasesInRange[myCountem].bearing  < 0 then
				myAirbasesInRange[myCountem].bearing  = 360 + myAirbasesInRange[myCountem].bearing 
				myAirbasesInRange[myCountem].angle = myAirbasesInRange[myCountem].angle + (math.pi*2)
			end
	
			-- if Debugging == true then printDebug ("EventHandler", "Airbase in range: " ..  myAirbasesInRange[myCountem].name .. " ID: " .. myAirbasesInRange[myCountem].id .. " Bearing:" .. myAirbasesInRange[myCountem].bearingto , 10 ) end -- print the match to logs
		end
    end
	-- if Debugging == true then printDebug ("EventHandler", "Looked for some airbases in range " , 10 ) end -- print the match to logs
	return myAirbasesInRange
end

-- FIND AN AIRBASES OBJECT BY ID
function getAirbaseByID(myID)
    local tmp = world.getAirbases()
	local myOne = {}
    for i=1,#tmp do
		local myDesc = tmp[i]:getDesc()
		if myID == tmp[i]:getID() then 
			-- myOne.name = tmp[i]:getName()
			-- myOne.id = tmp[i]:getID()
			-- myOne.airport = tmp[i]
			-- myOne.category = Airbase.getDescByName(myOne.name).category 
			-- myOne.point = tmp[i]:getPoint()
			-- -- if Debugging == true then printDebug ("EventHandler", "Returning ID for: " ..  tmp[i]:getName() .. " ID: " .. tmp[i]:getID() .. " Category: " .. myDesc.category , 10 ) end -- print the match to logs
			myOne.name = tmp[i]:getName()
			myOne.id = tmp[i]:getID()
			myOne.airport = tmp[i]
			myOne.position = tmp[i]:getPosition()
			myOne.point = tmp[i]:getPoint()
			myOne.desc = tmp[i]:getDesc()
			myOne.category = tmp[i]:getCategory()
			myOne.alt_meters = myOne.point.y
			myOne.alt_feet = myOne.point.y*3.280839895	
			-- FIND THE AIRPORT RUNWAY HEADING --
			myOne.bearing = (360/(math.pi*2) ) * math.atan2(myOne.position.x.z , myOne.position.x.x )
			myOne.angle = math.atan2(myOne.position.x.z , myOne.position.x.x )
			if myOne.bearing  < 0 then
				myOne.bearing  = 360 + myOne.bearing 
				myOne.angle = myOne.angle + (math.pi*2)
			end			
			break
		end
    end
	return myOne
end

function findAirbasesOrderedByRange (input) -- TOOLBOX ROUTINE
	
    local tmp = world.getAirbases()
	local myAirbases = {}
	
	for i=1,#tmp do
		--if Debugging == true then printDebug ("EventHandler" , tmp[i]:getCategory()  , 10 ) end
		local myCurrentAirport = { point=tmp[i]:getPoint() }
		local myDistance =  tonumber (math.floor(getDistanceBetweenTwoPoints( input.point , myCurrentAirport.point )))

		myAirbases[myDistance] = {distance = myDistance}
		myAirbases[myDistance].distance = myDistance
		myAirbases[myDistance].name = tmp[i]:getName()
		myAirbases[myDistance].id = tmp[i]:getID()
		myAirbases[myDistance].airport = tmp[i]
		myAirbases[myDistance].position = tmp[i]:getPosition()
		myAirbases[myDistance].point = tmp[i]:getPoint()
		myAirbases[myDistance].desc = tmp[i]:getDesc()
		myAirbases[myDistance].category = tmp[i]:getCategory()
		myAirbases[myDistance].alt_meters = myAirbases[myDistance].point.y
		myAirbases[myDistance].alt_feet = myAirbases[myDistance].point.y*3.280839895
		myAirbases[myDistance].bearingto = getBearingTwoPoints(input.point , myAirbases[myDistance].point)
		myAirbases[myDistance].angleto = getAngleBetweenTwoPoints(input.point , myAirbases[myDistance].point)
	end 
	
	local mySortedCTable= {}
	local myReturnedAirbases = {}
	for n in pairs(myAirbases) do table.insert(mySortedCTable, n) end
	table.sort(mySortedCTable)
	
	local myAirportsCount = #mySortedCTable
	if input.slots ~= nil then myAirportsCount = input.slots end 
	local myCountem = 1 
	for airportKey , airportValue in ipairs(mySortedCTable) do 
		if myAirbases[airportValue].category == 4 and airportKey <= myAirportsCount then
			-- if Debugging == true then printDebug ("EventHandler" , myCountem .. " " .. myAirbases[airportValue].name , 10 ) end
			myReturnedAirbases[myCountem] = myAirbases[airportValue]
			myCountem = myCountem + 1
		end
	end
	
	return myReturnedAirbases
	
end	

function getParkingClosestToActive (input)
	-- local LegacyAirports = {}
	-- LegacyAirports["Soganlug"] = { legacyid=30 , }
	-- LegacyAirports["Batumi"] = { legacyid=22 ,  }
	-- LegacyAirports["Vaziani"] = { legacyid=31 ,  }
	-- LegacyAirports["Tbilisi-Lochini"] = { legacyid=29 , }
	-- LegacyAirports["Kobuleti"] = { legacyid=24 , }
	-- LegacyAirports["Senaki-Kolkhi"] = { legacyid=23 , }
	-- LegacyAirports["Anapa-Vityazevo"] = { legacyid=12 , }
	-- LegacyAirports["Krasnodar-Center"] = { legacyid=13 , }
	-- LegacyAirports["Novorossiysk"] = { legacyid=14 , }
	-- LegacyAirports["Krymsk"] = {legacyid=15 , }
	-- LegacyAirports["Maykop-Khanskaya"] = {legacyid=16 , }
	-- LegacyAirports["Gelendzhik"] = {legacyid=17 , }
	-- LegacyAirports["Sochi-Adler"] = {legacyid=18 , }
	-- LegacyAirports["Krasnodar-Pashkovsky"] = {legacyid=19 , }
	-- LegacyAirports["Sukhumi-Babushara"] = { legacyid=20 , }
	-- LegacyAirports["Gudauta"] = { legacyid=21 , }
	-- LegacyAirports["Kutaisi"] = { legacyid=25 ,}
	-- LegacyAirports["Mineralnye Vody"] = {legacyid=26 , }
	-- LegacyAirports["Nalchik"] = { legacyid=27 , }
	-- LegacyAirports["Mozdok"] = { legacyid=28 ,  }
	-- LegacyAirports["Beslan"] = { legacyid=32 ,}
 -- if Debugging == true then printDebug ("EventHandler", "Finding closest parking space" ,  10 ) end
	local allAirbases = world.getAirbases()

	for i=1,#allAirbases do
		local myTempId = allAirbases[i]:getID()
		-- if tonumber(myTempId) > 5000000 then 
			-- myTempId = LegacyAirports[allAirbases[i]:getName()].legacyid
		-- end 
		
		
		if myTempId == input.airfield then 
			myAirport = allAirbases[i] 
			break
		end	
	end
	-- for i=1,#allAirbases do
		-- local myTempId = allAirbases[i]:getID()
		-- if myTempId > 5000000 then myTempId = myTempId - 5000000 end 
		-- if myTempId == input.airfield then 
			-- myAirport = allAirbases[i] 
			-- break
		-- end	
	-- end
	
	local myParkingMap = Airbase.getParking(myAirport , true)
	--if Debugging == true then printDebug ("EventHandler", "Found " .. #myParkingMap  ,  10 ) end
	local myRawMap = {} -- for the ones we find
	local myAllSpaces = {} -- all the spaces in case we don't find anyF
	local myAvailableSpaces = {}
	local myMatchCount = 0 
	for hitKey , hitValue in pairs ( myParkingMap ) do
		--if Debugging == true then printDebug ("EventHandler",  "Contains:" .. hitValue.Term_Index ..  " " .. " Term_Type: " .. hitValue.Term_Type .. " " .. " Input : " ..input.type .. " " .. " Distance: " .. hitValue.fDistToRW,  10 ) end
		if input.type == hitValue.Term_Type and hitValue.fDistToRW ~= 0 then 
			myRawMap[hitValue.fDistToRW] = hitValue.Term_Index 	
			myMatchCount = myMatchCount + 1
		end
	end
 	
	if myMatchCount == 0   then -- we didn't find any large spaces
		if Debugging == true then printDebug ("Spawning",  "Didn't Find any large parking could be a ship or farp "  ,  10 ) end
		for hitKey , hitValue in pairs ( myParkingMap ) do	
			-- if  hitValue.Term_Type == 72  then 
				-- myRawMap[#myRawMap+1] = 4 -- hitValue.Term_Index 	
				-- myMatchCount = myMatchCount + 1
			-- end
			if  hitValue.Term_Type == 72 and input.spawn_type ~= Group.Category.HELICOPTER  then
				--if Debugging == true then printDebug ("Spawning",  "Found Space: " .. hitValue.Term_Index ..  " " .. " Term_Type: " .. hitValue.Term_Type .. " " .. " Wanted : " ..input.type .. " " .. " Distance: " .. hitValue.fDistToRW,  10 ) end
				myMatchCount = myMatchCount + 1
				local myAssignValue = hitValue.fDistToRW
				if hitValue.fDistToRW <= 0 then myAssignValue = myMatchCount end
				myRawMap[myAssignValue] = hitValue.Term_Index 
				
			end
		end
	end 
	
	if myMatchCount == 0   then -- we didn't find any large spaces or multispace ship spaces
		if Debugging == true then printDebug ("Spawning",  "Picking VTOL only: " .. #myRawMap ,  10 ) end
		for hitKey , hitValue in pairs ( myParkingMap ) do	
			if  hitValue.Term_Type == 40 then 
				myMatchCount = myMatchCount + 1
				--if Debugging == true then printDebug ("EventHandler",  "Found Space: " .. hitValue.Term_Index ..  " " .. " Term_Type: " .. hitValue.Term_Type .. " " .. " Wanted : " ..input.type .. " " .. " Distance: " .. hitValue.fDistToRW,  10 ) end
				myRawMap[myMatchCount] = hitValue.Term_Index 	
				
			end
		end
	end 
	
	local mySortedCTable= {}
	for n in pairs(myRawMap) do table.insert(mySortedCTable, n) end
	table.sort(mySortedCTable)
	for parkingKey , parkingValue in ipairs(mySortedCTable) do 
			myAvailableSpaces[#myAvailableSpaces+1] = myRawMap[parkingValue]
			--if Debugging == true then printDebug ("EventHandler",  parkingValue ..  " " .. myRawMap[parkingValue] ,  10 ) end
	end
	 -- table.remove(myAvailableSpaces,1)
	 return myAvailableSpaces
end

function getDistanceBetweenGroups( myGroup1, myGroup2 )
	local myUnit2 = Group.getByName(myGroup2) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = myUnit2:getPosition()	
	local myUnit1 = Group.getByName(myGroup1) -- Set Pilot name (not group name) of player slot to Player
	local myUnit1pos = myUnit1:getPosition()
	local xDiff = myUnit1pos.p.x - myUnit2pos.p.x
    local yDiff = myUnit1pos.p.z - myUnit2pos.p.z
    return math.sqrt(xDiff * xDiff + yDiff * yDiff) -- meters
end 

function getDistanceBetweenTwoPoints( myPoint1, myPoint2 )	
			local xDiff = myPoint1.x - myPoint2.x
			local zDiff = myPoint1.z - myPoint2.z
			return math.sqrt(xDiff * xDiff + zDiff * zDiff) -- meters
end 

function getDistanceBetweenUnits( myGroup1, myGroup2 )
	local myUnit2 = Unit.getByName(myGroup2) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = myUnit2:getPosition()	
	local myUnit1 = Unit.getByName(myGroup1) -- Set Pilot name (not group name) of player slot to Player
	local myUnit1pos = myUnit1:getPosition()
	local xDiff = myUnit1pos.p.x - myUnit2pos.p.x
    local yDiff = myUnit1pos.p.z - myUnit2pos.p.z
    return math.sqrt(xDiff * xDiff + yDiff * yDiff) -- meters
end 

function getDistanceBetweenPoint( myGroup, myPointX, myPointZ )	
			local myUnit1 = Unit.getByName(myGroup) -- Set Pilot name (not group name) of player slot to Player
			local myUnit1pos = myUnit1:getPosition()
			local xDiff = myUnit1pos.p.x - myPointX
			local zDiff = myUnit1pos.p.z - myPointZ
			return math.sqrt(xDiff * xDiff + zDiff * zDiff) -- meters
end 

function getDistanceBetweenUnitAndPoint( myUnit, myPos )	
			local myUnit1 = Unit.getByName(myUnit) -- Set Pilot name (not group name) of player slot to Player
			local myUnit1pos = myUnit1:getPosition()
			local xDiff = myUnit1pos.p.x - myPos.x
			local zDiff = myUnit1pos.p.z - myPos.z
			return math.sqrt(xDiff * xDiff + zDiff * zDiff) -- meters
end 

-- FUNCTION GET BEARING TO A ZONE
function getBearingFromZone(myZone, myUnit)
	local pos = trigger.misc.getZone(myZone)
	local centerPos = {} -- to hold the zones variables
	centerPos.x = ( pos.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos.z = ( pos.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	local myLocalGroup = Unit.getByName(myUnit) -- 
	local myLocalGroupPos = myLocalGroup:getPosition()
	local myLocalGroupPoint = myLocalGroup:getPoint()
	local bearing = math.atan2(centerPos.z - myLocalGroupPos.p.z  , centerPos.x - myLocalGroupPos.p.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
    return bearing    -- degrees
end

-- GET BEARING TO A POINT 
function getBearingToPoint(myUnitFrom , myPoint)

	local myLocalGroupFrom = Unit.getByName(myUnitFrom) -- 
	local myLocalGroupPosFrom = myLocalGroupFrom:getPosition()
	local myLocalGroupPointFrom = myLocalGroupFrom:getPoint()
	
	local bearing = math.atan2(myPoint.z - myLocalGroupPosFrom.p.z  , myPoint.x - myLocalGroupPosFrom.p.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
    return bearing    -- degrees
end

 -- FUNCTION GET BEARING TO GROUP but actually UNIT
function getBearingToGroup(myUnitFrom , myUnitTo)
	local myLocalGroupFrom = Unit.getByName(myUnitFrom) -- 
	local myLocalGroupPosFrom = myLocalGroupFrom:getPosition()
	local myLocalGroupPointFrom = myLocalGroupFrom:getPoint()
	local myLocalGroupTo = Unit.getByName(myUnitTo) -- 
	local myLocalGroupPosTo = myLocalGroupTo:getPosition()
	local myLocalGroupPointTo = myLocalGroupTo:getPoint()
	local bearing = math.atan2(myLocalGroupPosTo.p.z - myLocalGroupPosFrom.p.z  , myLocalGroupPosTo.p.x - myLocalGroupPosFrom.p.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
	--if Debugging == true then  printDebug ( "EventHandler" ,  "Function - Bearing to " .. myUnitTo .. " From: " ..  myUnitFrom .. " " .. bearing , 10 ) end
    return bearing    -- degrees
end

 -- FUNCTION GET BEARING TO UNIT
function getBearingToUnit(myUnitFrom , myUnitTo)
	local myLocalGroupFrom = Unit.getByName(myUnitFrom) -- 
	local myLocalGroupPosFrom = myLocalGroupFrom:getPosition()
	local myLocalGroupPointFrom = myLocalGroupFrom:getPoint()
	local myLocalGroupTo = Unit.getByName(myUnitTo) -- 
	local myLocalGroupPosTo = myLocalGroupTo:getPosition()
	local myLocalGroupPointTo = myLocalGroupTo:getPoint()
	local bearing = math.atan2(myLocalGroupPosTo.p.z - myLocalGroupPosFrom.p.z  , myLocalGroupPosTo.p.x - myLocalGroupPosFrom.p.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
    return bearing    -- degrees
end

function getBearingTwoPoints(myFirstPoint , mySecondPoint) -- TOOLBOX FUNCTION
	local bearing = math.atan2(mySecondPoint.z - myFirstPoint.z  , mySecondPoint.x - myFirstPoint.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
	-- if Debugging == true then  printDebug ( "EventHandler" , "Bearing to point " .. bearing , 10 ) end
    return bearing    -- degrees
end

function getClockBearingUnitToUnit ( unit1 , unit2 ) -- toolbox function 

	local myPlayerHeading = doGetUnitHeading ( {callsign=unit1, } )
	local myAngleTarget = getAngleBetweenTwoPointsV2(centerUnitCoordinates ( unit1 ) , centerUnitCoordinates ( unit2 )) 
	local myDifference =  (((math.pi*2 - myPlayerHeading.angle ) + myAngleTarget) * 1.9098593171027440292266051604702)
	--local myRemainder = myDifference % math.floor(myDifference) 
	if myDifference % math.floor(myDifference)  >= .5 then myDifference = math.ceil ( myDifference ) else myDifference = math.floor ( myDifference ) end
	if myDifference > 12 then myDifference = myDifference - 12 end
	return string.format("%d" ,myDifference)
end 

function getAngleBetweenTwoPoints(myFirstPoint , mySecondPoint) -- TOOLBOX FUNCTION
	local angle = math.atan2(mySecondPoint.z - myFirstPoint.z  , mySecondPoint.x - myFirstPoint.x  )
	-- if Debugging == true then  printDebug ( "EventHandler" , "Angle between points " .. angle , 10 ) end
    return angle    -- degrees
end

function getAngleBetweenTwoPointsV2(myFirstPoint , mySecondPoint) -- TOOLBOX FUNCTION
	local angle = math.atan2(mySecondPoint.z - myFirstPoint.z  , mySecondPoint.x - myFirstPoint.x  )
	
	if angle < 0 then
		angle = angle + (math.pi*2)
	end
	-- if Debugging == true then  printDebug ( "EventHandler" , "Angle between points " .. angle , 10 ) end
    return angle    -- degrees
end

function PointLeftOrRight ( input ) -- TOOLBOX FUNCTION
	local mySide = "Neither" 
	local myBearingToTarget = getBearingToPoint(input.unit , input.position )
	local myHeading = doGetUnitHeading ( { callsign=input.unit } )
		-- WHAT SIDE OF THE AIRCRAFT IS TARGET ON
	local myCorrectSidePosition = {} 
	 local diff = myBearingToTarget - myHeading.bearing
     if(diff < 0 ) then
         diff = diff + 360
	end
	
	myOffset = math.abs(diff)
	if myOffset > 180 then  myOffset = 360 - myOffset end
	
	if(diff > 180) then
	--	if Debugging == true then  printDebug ( "EventHandler" , input.unit .. " has point on left side offset: " .. myOffset .. " diff: " .. diff , 10 ) end 
		mySide = "left" 
	else
	--	if Debugging == true then  printDebug ( "EventHandler" , input.unit .. " has point on right side offset: " .. myOffset  .. " diff: " .. diff , 10 ) end 
		mySide = "right" 
	end
	return mySide 
end

function pairsByKeys (t, f) -- toolbox function to sort table by keys
  local a = {}
  for n in pairs(t) do table.insert(a, n) end
  table.sort(a, f)
  local i = 0      -- iterator variable
  local iter = function ()   -- iterator function
	i = i + 1
	if a[i] == nil then return nil
	else return a[i], t[a[i]]
	end
  end
  return iter
end

-- GET THE REVERSE BEARING 
function GetReverseBearing (bearing)
		-- DECIDE WHICH WAY THE OPPOSITE BEARING
		local myReverse = {}
		myReverse.bearing = 0
		if bearing < 180 then
			myReverse.bearing = bearing + 180 -- ITS ACTUALLY LESS THAN 180
		else
			myReverse.bearing = bearing - 180 -- ITS ACTUALLY MORE THAN 180
		end 
		return myReverse
end

function GetReverseAngle (angle)
		-- DECIDE WHICH WAY THE OPPOSITE BEARING
		local myReverse = {}
		myReverse.angle = 0
		if angle < math.pi then
			myReverse.angle = angle + math.pi -- ITS ACTUALLY LESS THAN 180
		else
			myReverse.angle = angle - math.pi  -- ITS ACTUALLY MORE THAN 180
		end 
		return myReverse
end

function angleInRange ( min , max , target ) -- toolbox function

	if min <= 0 then
	  min = ( (math.pi*2) - math.abs (min))
	  max = max + (math.pi*2)  --remembermax 
	  if max >= math.pi*2 and target < math.pi then
		target = target + math.pi*2
	  end 
	elseif max >= (math.pi*2) then
	   if max - target >= math.pi*2 then
		  target = math.pi*2 + target 
	   else
		 target = math.pi*2 -  ((math.pi*2) - target)
	   end
	end


	if min <= target and max >= target then
		myReturn = true
	else
		myReturn = false 
	end

	 return myReturn
end 

function getWindDirection(myUnit)
  local BRA = {}
  local wind = nil
  if Unit.getByName(myUnit) then
  local pos1 = Unit.getByName(myUnit):getPosition().p
	
  if pos1 ~= nil then
	if  pos1.y < 1 then  pos1.y =  pos1.y + 20 end -- BELOW SEA LEVEL GIVES SOME FUNKY VALUES
    wind = atmosphere.getWind(pos1)
    local dir = math.atan2(wind.z, wind.x) * 180 / math.pi
	local reversebearing = dir + 180
	local angle = math.atan2(wind.z, wind.x)
	local reverseangle = angle + math.pi 
	local speed = ((wind.x^2 + wind.y^2 + wind.z^2)^0.5) * 1.9438444924406046
	local speedmeters = ((wind.x^2 + wind.y^2 + wind.z^2)^0.5) --* 1.9438444924406046
    if dir < 0 then
      dir = 360 + dir
    end
	if reversebearing < 0 then
		reversebearing = 360 + reversebearing
	end
	if angle < 0 then
		angle = math.pi*2 + angle
	end
	if reverseangle < 0 then
		reverseangle = math.pi*2 - reverseangle
	 end
	BRA.bearing = dir
	BRA.reversebearing = reversebearing
	BRA.angle = angle
	BRA.speed = speed
	BRA.speedmeters = speedmeters
	BRA.reverseangle = reverseangle
	
  end
  end
  --BRA = string.format("Wind: %d, y: %d,", BRA, wind.y)
  --BRA = string.format("Wind: %d", BRA)
  return BRA
end

-- FIND THE ACTIVE RUNWAY WIND DIRECTION TRUE OR FALSE	 
function doActiveRunway ( myUnit , myRunwayHeading ) 
	local myWindArray = getWindDirection(myUnit)
	local myWindDirection =  math.ceil ( myWindArray.bearing )
	-- myWindDirection = 359
	-- myRunwayHeading = 178
	local  myDiff = myWindDirection - myRunwayHeading
	if myDiff > 269 or myDiff < -269 then myDiff = math.abs(myDiff) - 260 end
	local myDirText = ""
	local myActive = true 

	--if myDiff > 180 then myDiff = myDiff - 180 end 
	if myDiff > 180 or myDiff < -180 then 
		myActive = false  
		--myDirText = "With"
	else 
		myActive = true 
		--myDirText = "Against"
	end 

	--if Debugging == true then  printDebug ( "EventHandler" , myDirText .. " Wind: " .. string.format( "%d",myWindDirection ) .. " Runway: " .. string.format( "%d", myRunwayHeading)  .. " Diff: " .. string.format( "%d",myDiff) , 10 ) end
	-- else
	return myActive
end 

-- GET SURFACE TYPE
function getSurfaceTypePoint( myPoint )
	local surface = land.getSurfaceType{x = myPoint.x, y = myPoint.z}
	if surface == 3 then 
		surface = "Water" 	
	elseif surface == 2 then
		surface = "Shallow Water" 
	else
		surface = "Land" 
	end
	return surface
end

function findMatchingSurfaceTypeCircle ( input ) --TOOLBOX FUNCTION

	local myUnit = input.unit
	local mySample = input.samples
	local myDistance = input.distance
	local mySurfaceType = input.surface
	local myDivisor = (math.pi*2)/mySample
	local myTimesThru = 0 
	local myAngle = myDivisor
	local myLowestAngle = 0
	local myPosition = {}
	local myLowestPoint = {} 
	local myMatchingSurfaces = {} 
	
	if input.unit ~= nil then
		myPosition = centerUnitCoordinates ( input.unit )
	elseif input.position ~= nil then
		myPosition = input.position
	end 
	
	
	while myAngle <= (math.pi*2) do
		myTimesThru = myTimesThru +1
		local myTerrainTemp = getPointOnRadian ( { diameter=input.distance*2 , pos=myPosition , angle = myAngle })
		local myLandOnly = true 
		-- local mySurface =getSurfaceTypePoint( myTerrainTemp )
		local mySurface = getSurfaceTypeSampleSet( { point=myTerrainTemp , radius=(input.precision/2) } )
		local myMatching = {}
		if mySurface == mySurfaceType[1] or mySurfaceType[2]   then
			local myBearing = math.ceil (myAngle / (math.pi/180 )) 
			if myBearing == 360 then myBearing = 0 end -- READS NICER
			local myElevation = (land.getHeight{x = myTerrainTemp.x, y = myTerrainTemp.z})	
			myMatchingSurfaces[#myMatchingSurfaces+1] = { angle=myAngle , bearing=myBearing, elevation=myElevation, position=myTerrainTemp , surface=mySurface} 
		--	if Debugging == true then  printDebug ( "EventHandler" , "Found matching " .. mySurface.. " at angle " ..  string.format ( "%f.2" , myAngle ) , 10 ) end
		end
				
		myAngle = myAngle + myDivisor
	end
	-- if Debugging == true then  printDebug ( "EventHandler" , "Lowest Elevation is " .. string.format("%d", myLowestElevation) .. string.format(" Bearing of %d", math.ceil (myLowestAngle / (math.pi/180 ))) , 10 ) end
	
	return myMatchingSurfaces
end

-- FIND ALL THE POINTS IN A CIRCLE THAT MATCH 
function findMatchingSurfacePoints ( input )

	local myMatchingTrue = false
	local mySurfaceMatching = {surface=input.surfacetypes, unit=input.unit , position=input.position , distance=input.distance , samples=input.samples , precision=input.precision }
	local mySpeedBrake = 1
	local myTargetPos = {}
	local myEntireSet = {}
	local myReturn = {}
	
	while myMatchingTrue == false do

		local myMatchingSurfaces = findMatchingSurfaceTypeCircle ( mySurfaceMatching )
		
		
		if #myMatchingSurfaces >= 1 or mySpeedBrake > 50 then 
			myMatchingTrue = true
			if #myMatchingSurfaces >= 1 then 
				myTargetPos = myMatchingSurfaces[math.random(1,#myMatchingSurfaces)] 
				myEntireSet = myMatchingSurfaces
			end 
		end 
		mySurfaceMatching.distance=mySurfaceMatching.distance + ( 5000 * (mySpeedBrake/2)) 
		mySpeedBrake = mySpeedBrake + 1  
	end
	
	-- if Debugging == true then  printDebug ( "EventHandler" , " Count surfaces " .. #myMatchingSurfaces  , 10 ) end
	
	if myTargetPos.position == nil then -- ALL FOR MARIANAS MAP THAT HAS VERY LITTLE LAND
		local myUnitCoalition = Unit.getCoalition(Unit.getByName( input.unit ))
		if input.unit ~= nil then
			input.position = centerUnitCoordinates ( input.unit )
		end 
		
		local myAirportsInRange = findAirBaseInRange ({point=input.position , rangemin=1, rangemax=1e309 })  -- 1e309 IS infinite
		
		local myTableToSort = {} -- SORT BY DISTANCE  	
		for key , value in pairs(myAirportsInRange) do	
			myTableToSort[math.ceil(value.distance)] = value
		end                                                                
		
		local myCount = 0
		
		for key, value in pairsByKeys(myTableToSort) do -- CHECK FOR MATCHING
			-- if Debugging == true then  printDebug ( "EventHandler" , "Checking " .. value.name  .. " " .. value.coalition .. " " .. myUnitCoalition , 10 ) end
			if myTargetPos.position == nil and value.distance >= input.distance and value.coalition == myUnitCoalition then
				-- if Debugging == true then  printDebug ( "EventHandler" , key  .. " " .. value.name  .. " " .. value.distance .. " " .. input.distance, 10 ) end
				myTargetPos = { angle=value.angleto , bearing=value.bearingto , elevation=value.alt_meters , position=value.point , surface=input.surfacetypes } 
			end 
			myEntireSet[#myEntireSet+1] = { angle=value.angleto , bearing=value.bearingto , elevation=value.alt_meters , position=value.point   , surface=input.surfacetypes }
			if value.coalition == myUnitCoalition then
				myCount = key
			end
		end 
		if myTargetPos.position == nil then -- ALL THE AIRPORTS ARE WRONG COALITION OR TOO CLOSE
			myTargetPos = { angle=myTableToSort[myCount].angleto , bearing=myTableToSort[myCount].bearingto , elevation=myTableToSort[myCount].alt_meters , position=myTableToSort[myCount].point , surface=input.surfacetypes } 
		end 
	end 
	
	if input.allpoints ~= nil then 
		myReturn = myEntireSet
	else
		myReturn = myTargetPos
	end	
	
	return myReturn
end
 -- GET SURFACE TYPE SAMPLE SET
function getSurfaceTypeSampleSet( input ) --TOOLBOX FUNCTION
	local myPoint0 = input.point	
	local surface0 = land.getSurfaceType{x = myPoint0.x, y = myPoint0.z}
	local surface1 = land.getSurfaceType{x = myPoint0.x, y = myPoint0.z+input.radius}
	local surface2 = land.getSurfaceType{x = myPoint0.x, y = myPoint0.z-input.radius}
	local surface3 = land.getSurfaceType{x = myPoint0.x+input.radius, y = myPoint0.z}
	local surface4 = land.getSurfaceType{x = myPoint0.x-input.radius, y = myPoint0.z}
	
	if surface0 == 3 and surface1==3 and surface2==3 and surface3==3 and surface4==3 then 
		surface = "Water" 	
	elseif surface0 == 2 and surface1==2 and surface2==2 and surface3==2 and surface4==2 then 
		surface = "Shallow Water" 
	elseif surface0 == 1 and surface1==1 and surface2==1 and surface3==1 and surface4==1 then 
		surface = "Land" 
	else 
		surface = "Unknown"
	end
	return surface
end

function getAGL(myUnit)
	local myLocalGroup = Unit.getByName(myUnit) --say group mean unit
	local myLocalGroupPos = myLocalGroup:getPosition()
	local myLocalGroupPoint = myLocalGroup:getPoint()
	local elevation = land.getHeight{x = myLocalGroupPoint .x, y = myLocalGroupPoint .z}
	return ( myLocalGroupPoint.y - elevation) 
end

function getAGLfeet (myUnit)
	local myLocalGroup = Unit.getByName(myUnit) --say group mean unit
	local myLocalGroupPos = myLocalGroup:getPosition()
	local myLocalGroupPoint = myLocalGroup:getPoint()
	local elevation = land.getHeight{x = myLocalGroupPoint .x, y = myLocalGroupPoint .z}
	return ( myLocalGroupPoint.y - elevation) * 3.280839895
end

function getMSLfeet(myUnit)
		local myUnitObj = Unit.getByName(myUnit) -- say group mean unit
		local myUnitPoint = myUnitObj:getPoint()
		return myUnitPoint.y * 3.280839895
end

function getMSLmeters(myUnit)
		local myUnitObj = Unit.getByName(myUnit) -- say group mean unit
		local myUnitPoint = myUnitObj:getPoint()
		return myUnitPoint.y
end

function findLowestTerrain ( input ) -- toolbox function to find lowest terrain in 360 degree sample
	--myHighestTerrain = findLowestTerrain ( {unit=PlayerName|point=vec3, samples=8, distance=myDistance*1000 , land=true } ) 
	--local myUnit = input.unit
	local mySample = input.samples
	local myDistance = input.distance
	local myDivisor = (math.pi*2)/mySample
	local myTimesThru = 0 
	local myAngle = myDivisor
	local myLowestAngle = 0
	local myHigestAngle = 0
	--local myPosition = centerUnitCoordinates ( input.unit )
	local myPosition = {}
	local myLowestElevation = 100000
	local myLowestPoint = {} 
	local myHighestPoint = {}
	local myHighestElevation = 0
	
	if input.point ~= nil then
		myPosition = input.point
	elseif input.unit ~= nil then
		myPosition = centerUnitCoordinates ( input.unit )
	end
	
	
	while myAngle <= (math.pi*2) do
		myTimesThru = myTimesThru +1
		local myTerrainTemp = getPointOnRadian ( { diameter=input.distance*2 , pos=myPosition , angle = myAngle })
		
		local myLandOnly = true 
		local mySurface =getSurfaceTypePoint( myTerrainTemp )	
		if mySurface == "Water" and input.land ~= nil then myLandOnly = false end
		
		local myElevation = 0 
		for int,value in ipairs(myTerrainTemp.between) do
			myElevation = myElevation + (land.getHeight{x = value.x, y = value.z})		
		end
		myElevation = myElevation/#myTerrainTemp.between
		-- if Debugging == true then  printDebug ( "EventHandler" , "Average Elevation " .. string.format("%d", myElevation) .. " Angle " .. myAngle .. " Bearing " .. myAngle / (math.pi/180 ) , 10 ) end
		if (myElevation < myLowestElevation ) and myLandOnly then
			myLowestElevation = myElevation
			myLowestAngle = myAngle 
			myLowestPoint = myTerrainTemp
		end
		
		if (myElevation > myHighestElevation ) then 
			myHighestElevation = myElevation
			myHigestAngle = myAngle 
			myHighestPoint = myTerrainTemp
		end
		
		myAngle = myAngle + myDivisor
	end
	-- if Debugging == true then  printDebug ( "EventHandler" , "Lowest Elevation is " .. string.format("%d", myLowestElevation) .. string.format(" Bearing of %d", math.ceil (myLowestAngle / (math.pi/180 ))) , 10 ) end
	
	local  myReturn = {}
	myReturn.angle = myLowestAngle 
	myReturn.bearing = math.ceil (myLowestAngle / (math.pi/180 )) 
	myReturn.elevation = myLowestElevation
	myReturn.point = myLowestPoint
	
	myReturn.highest_angle = myHigestAngle
	myReturn.highest_bearing = math.ceil (myHigestAngle / (math.pi/180 )) 
	myReturn.highest_point = myHighestPoint
	myReturn.highest_elevation = myHighestElevation
		
	if myReturn.bearing == 360 then myReturn.bearing = 0 end -- READS NICER
	if myReturn.highest_bearing == 360 then myReturn.highest_bearing = 0 end -- READS NICER
	return myReturn
	
end

function findMinAndMaxTerrainElevation (input) -- TOOLBOX FUNCTION TO RETURN MAXIMUM AND MINIMUM ELEVATION IN AREA OF CIRCLE

	local myUnit = input.unit
	local mySample = input.samples
	local myDistance = input.diameter
	local myDivisor = (math.pi*2)/mySample
	
	local myTimesThru = 0 
	local myAngle = myDivisor
	local myLowestAngle = 0
	local myHighestAngle = 0
	local myPosition = {}
	
	if input.unit ~= nil then
		myPosition = centerUnitCoordinates ( input.unit )
	end 
	if input.point ~= nil then
		myPosition = input.point
	end 
	
	local myLowestElevation = 100000
	local myHighestElevation = 0 
	local myLowestPoint = {} 
	local myHigesetPoint = {} 
	
	while myAngle <= (math.pi*2) do
		myTimesThru = myTimesThru +1
		local myTerrainTemp = getPointOnRadian ( { diameter=input.diameter*2 , pos=myPosition , angle = myAngle })
		local myElevation = 0 
		for int,value in ipairs(myTerrainTemp.between) do
			myElevation = myElevation + (land.getHeight{x = value.x, y = value.z})		
			-- if Debugging == true then  printDebug ( "EventHandler" , "Average Elevation " .. string.format("%d", myElevation) .. " Angle " .. myAngle .. " Bearing " .. myAngle / (math.pi/180 ) , 10 ) end
			if myElevation < myLowestElevation then
				myLowestElevation = myElevation
				myLowestAngle = myAngle 
				myLowestPoint = {x=value.x , z=value.z, y=myElevation }
			end
			
			if myElevation > myHighestElevation then
				myHighestElevation = myElevation
				myHighestAngle = myAngle 
				myHigesetPoint =  {x=value.x , z=value.z, y=myElevation }
			end
		end
		myAngle = myAngle + myDivisor
	end
	
	-- if Debugging == true then  printDebug ( "EventHandler" , "Lowest Elevation is " .. string.format("%d", myLowestElevation) .. string.format(" Bearing of %d", math.ceil (myLowestAngle / (math.pi/180 ))) , 10 ) end
	-- if Debugging == true then  printDebug ( "EventHandler" , "Higest Elevation is " .. string.format("%d", myHighestElevation) .. string.format(" Bearing of %d", math.ceil (myHighestAngle / (math.pi/180 ))) , 10 ) end
	
	local  myReturn = {}
	myReturn.loweangle = myLowestAngle 
	myReturn.lowbearing = math.ceil (myLowestAngle / (math.pi/180 )) 
	myReturn.lowelevation = myLowestElevation
	myReturn.lowpoint = myLowestPoint
	
	myReturn.highangle = myHighestAngle 
	myReturn.highbearing = math.ceil (myHighestAngle / (math.pi/180 )) 
	myReturn.highelevation = myHighestElevation
	myReturn.highpoint = myHigesetPoint

	if myReturn.lowbearing == 360 then myReturn.lowbearing = 0 end -- READS NICER
	if myReturn.highbearing == 360 then myReturn.highbearing = 0 end -- READS NICER
	
	return myReturn

end

function FindMaxTerrainBetweenPoints ( input ) -- TOOLBOX FUNCTION

	local myAngle = getAngleBetweenTwoPoints(input.point1 , input.point2)
	local myDistance = getDistanceBetweenTwoPoints( input.point1, input.point2 )	
	--local myPoints = getPointOnRadian ( { diameter=myDistance , pos=input.point1 , angle = myAngle })
	local myHighestAlt = 0 
	local myHighestPoint = {}
	local myDivisions = 500
	local myDivisor = myDistance/myDivisions
	local myPoint = {}
	
	-- for key , value in ipairs(myPoints.between) do
	for i=1,myDivisor do
		myPoint.x = input.point1.x + math.cos(myAngle) * (myDivisions*i) --point for x
		myPoint.z = input.point1.z + math.sin(myAngle) * (myDivisions*i) --point for x
		local myCurrentAlt = land.getHeight{x = myPoint.x, y = myPoint.z}
		if myCurrentAlt > myHighestAlt then 
			myHighestAlt = myCurrentAlt 
			myHighestPoint = value
		end
		--trigger.action.smoke({x=value.x , y=land.getHeight{x = value .x, y = value .z}, z=value.z }, 1 )
	end
	--trigger.action.smoke({x=myHighestPoint.x , y=land.getHeight{x = myHighestPoint .x, y = myHighestPoint .z}, z=myHighestPoint.z }, 1 )	
	return myHighestAlt
	
end 

function FindSpawnAltBasedYear ( input ) -- TOOLBOX ROUTINE find altitude based ona year

	local myRandom = math.random ( 1, 5 )
	local myTerrainYear = 1960 -- ERA WHERE TERRAIN HEIGHT NO LONGER MATTERS
	local myAlt = 10 -- no hots for era gets FLT level 10

	
	local myEras = {	[1] = { year=1940 , alt_max = 1 } , 
						[2] = { year=1950 , alt_max = 10 } ,
						[3] = { year=1960 , alt_max = 20 } ,
						[4] = { year=1970 , alt_max = 25 } ,
	}
		
	for i=1,#myEras do
		if  input.year >= myEras[i].year  then
			myAlt =  myEras[i].alt_max + myRandom
		end 
	end 


	local myTerrainElevation = findLowestTerrain ( {point=input.position, samples=8, distance=5000 , } ) 
	local myRoundedTerrain = 0	
	if (myTerrainElevation.highest_elevation*3.280839895) + 1000 > (myAlt*1000) then 
		myRoundedTerrain =  math.floor((myTerrainElevation.highest_elevation*3.280839895)/1000+ 1 * 0.5) * 1000-- ROUND TO NEAREST 1000
	end 
	
	local myAlt = (myAlt*1000) + myRoundedTerrain
		
	return myAlt
end 

--- GET VELOCITY OF OBJECT returned in knots
function doGetVelocity (input)
	-- pass in array  myUnit.callsign  
	local myUnitID = (Unit.getByName(input) ) -- GET THE UNIT 
	local myVelocityObj = myUnitID:getVelocity( ) -- GET THE VELOCITY VECTORS
	myVelocity = math.sqrt((myVelocityObj.x^2) + (myVelocityObj.y^2) + (myVelocityObj.z^2)) -- CALCULATE SPEED
	--local myAltConversion = getMSLfeet(input)
	--myAltConversion = (myAltConversion / 1000) * 1 --.0149
	
	myVelocity = (myVelocity * 1.9438444924406046) -- CONVERT TO KNOTS
	return myVelocity  -- RETURN IT
end

function doGetVelocityMeters (input)
	local myUnitID = (Unit.getByName(input) ) -- GET THE UNIT 
	local myVelocityObj = myUnitID:getVelocity( ) -- GET THE VELOCITY VECTORS
	myVelocity = math.sqrt((myVelocityObj.x^2) + (myVelocityObj.y^2) + (myVelocityObj.z^2)) -- CALCULATE SPEED
	return myVelocity  -- RETURN IT
end

function getAirspeed ( input ) -- TOOLBOX ROUTINE
	
	local myPlayerSpeed = doGetVelocity (input) 
	local myWindArray = getWindDirection(input) 
	local myPlayerHeadingTable = doGetUnitHeading ({callsign=input})
	local myPlayerGroundSpeed = string.format("%.2f", myPlayerSpeed )
	local myPlayerAGL = getAGL ( input ) 
	local myPlayerMSL = getMSLmeters ( input )
	local myPlayerMSLFeet = getMSLfeet(input) 
	--local myALTMod = myPlayerMSL * 0.0107
	--local myALTMod = 1 - (myPlayerMSLFeet * 0.0000149)
	local myALTMod = 1 - (myPlayerMSLFeet * 0.0000129)

	local myAirspeedMod =  myWindArray.speed / (math.pi/2) 
	
	local myWindDifference = math.pi - myWindArray.angle 
	local myWindModify = myWindArray.angle + myWindDifference
	local myHeadingModify = math.abs(myPlayerHeadingTable.angle + myWindDifference)
	if myHeadingModify >= (math.pi*2) then myHeadingModify = myHeadingModify -math.pi*2 end
	
	local myFlyingDirection = "into"
	local myRightWindOffset =  (math.pi/2) - math.abs((math.pi*2) - (myWindArray.angle  - myPlayerHeadingTable.reverseangle))
	local myLeftWindOffset =   (math.pi/2) - math.abs(myWindArray.angle  - myPlayerHeadingTable.reverseangle)
	local myModifier = 1
	if myHeadingModify  <= (myWindModify+ math.pi/2) and myHeadingModify  >= (myWindModify - math.pi/2) then
		myFlyingDirection = "with"
		myRightWindOffset =  (math.pi/2) - math.abs((math.pi*2)  - (myWindArray.angle  - myPlayerHeadingTable.angle))
		myLeftWindOffset =   (math.pi/2) - math.abs(myWindArray.angle  - myPlayerHeadingTable.angle)
		myModifier = -1
	end 
	
	if myLeftWindOffset < -math.pi then myLeftWindOffset = math.abs(myLeftWindOffset + math.pi) end
	
	local myWindAdjust = ((myAirspeedMod * myRightWindOffset) ) * myModifier
	if myRightWindOffset < 0 then 
		myWindAdjust =  (( myAirspeedMod * myLeftWindOffset)  ) * myModifier
	end
	
	--local myCalibratedAS = ( (myPlayerSpeed - myALTMod ) + myWindAdjust ) 
	local myCalibratedAS = ( (myPlayerSpeed * myALTMod ) + myWindAdjust ) 
	local myPerformance = { airspeed=myCalibratedAS , agl=myPlayerAGL , msl=myPlayerMSL , airspeedmps=myCalibratedAS*0.514444444 }
		
	return myPerformance
	
end 

function doGetPitchAndRoll ( myUnit ) -- USED FOR GENERAL SPACIAL AWARENESS OF AIRCRAFT
	-- RETURNS ARRAY OF PITCH ANGLE, ROLL ANGLE , ROLL LEFT ,ROLL RIGHT, PITCH UP ,PITCH DOWN , TEXT OF EVERYTHING
	local myUnit2 = Unit.getByName(myUnit.callsign) -- Set Pilot name (not group name) of the C130 in the editor to C130
	local myUnit2pos = Unit.getPosition(myUnit2)
	
	local myPitchDown = 1.58 -- HOW FAR A LEVEL 
	local myPitchUp = 1.47
	local myRollLeft = 1.52
	local myRollRight = 1.65
	
	--local myAerobaticsDown = 1.40 -- HOW FAR A LEVEL 
	local myAerobaticsUp = 1.30

	
	local myStatus = {}
	myStatus.velocity = doGetVelocity ( myUnit.callsign ) 
	myStatus.alt = getMSLfeet ( myUnit.callsign  )
	
	--local myPitchAndRoll = " X=" .. string.format( "%.3f" , myUnit2pos.y.x )  .. " Y=" .. string.format( "%.3f" , myUnit2pos.y.y )   .. " Z=" .. string.format( "%.3f" , myUnit2pos.y.z )  
	local myPitchStatus = ""
	local myRollStatus = ""
	local myPitch = math.atan2(myUnit2pos.y.y , myUnit2pos.x.y )
	local myRoll = math.atan2(myUnit2pos.y.y , myUnit2pos.z.y )
	myStatus.pitchangle = myPitch
	myStatus.rollangle = myRoll
	if myPitch < myPitchDown and myPitch > myPitchUp then myStatus.pitch = "Level" 
	elseif myPitch > myPitchDown then myStatus.pitch = "Down"  
	elseif myPitch < myPitchUp  then myStatus.pitch = "Up" 
	end
	
	if myPitch < myPitchDown and myPitch > myAerobaticsUp then myStatus.aerobatics_pitch = "Level" 
	elseif myPitch > myPitchDown then myStatus.aerobaticspitch = "Down"  
	elseif myPitch < myAerobaticsUp  then myStatus.aerobaticspitch = "Up" 
	end 
	
	if myRoll < myRollRight and myRoll > myRollLeft then myStatus.roll = "Level" 
	elseif myRoll > myRollRight then myStatus.roll = "Right"  
	elseif myRoll < myRollLeft  then myStatus.roll = "Left" 
	end
	
	if ( myStatus.roll == "Level" and myStatus.pitch == "Level" ) then myStatus.overall = "Level" else myStatus.overall = "NotLevel" end
	if ( myStatus.roll == "Level" and myStatus.aerobatics_pitch == "Level" ) then myStatus.aerobatics_overall = "Level" else myStatus.aerobatics_overall = "NotLevel" end
	
	myStatus.text =  "Pitch " .. myStatus.pitch  .. string.format( " (%.3f) ", myStatus.pitchangle)   .. "Roll " .. myStatus.roll .. string.format( " (%.3f) " , myStatus.rollangle) .. " Speed " .. string.format( " %d" , myStatus.velocity) .. " Alt " .. string.format( " %d" , myStatus.alt)

	return myStatus 
end

function printThis (myWhatToPrint, myHowLong)
	--trigger.action.outTextForCoalition( 1 , myWhatToPrint , myHowLong , 0 ) --whoops probably is stuck and cant get to helo
	--trigger.action.outTextForGroup(1, myWhatToPrint, myHowLong , 0 )
	--trigger.action.outTextForCountry(country.id.USA, myWhatToPrint, myHowLong , 0 )
	trigger.action.outText(myWhatToPrint, myHowLong , 0 )
	if Debugging == true then  printDebug ( "Printing" , "Outputing To Everyone: " .. myWhatToPrint , 10 ) end 
end

function printThisToGroup (myGroup, myWhatToPrint, myHowLong)
	--trigger.action.outTextForCoalition( 1 , myWhatToPrint , myHowLong , 0 ) --whoops probably is stuck and cant get to helo
	trigger.action.outTextForGroup(myGroup, myWhatToPrint, myHowLong , 0 )
	--trigger.action.outTextForCountry(country.id.USA, myWhatToPrint, myHowLong , 0 )
	--trigger.action.outText(myWhatToPrint, myHowLong , 0 )
end

function printDebug (myWhere, myWhatToPrint, myHowLong)
	env.info ( myWhere .. " - "  .. myWhatToPrint )
	if string.match(myWhere, DebugFilter)  or DebugFilter == "ALL" then
		if ( Debugging == true and myHowLong > 1 ) then
			trigger.action.outText(myWhere ..": " .. myWhatToPrint, myHowLong , false )
		elseif ( EventDebugging == true and Debugging == true and myHowLong == 1 ) then
			trigger.action.outText(myWhere ..": " .. myWhatToPrint, myHowLong , false )
		end
	end
end

function randomZoneCoordinates ( myZone )
	local pos = trigger.misc.getZone(myZone)
	local ranpos = {} -- to hold random positions variables
	ranpos.x = ( pos.point.x + (math.random(pos.radius * -1, pos.radius)) )
	ranpos.z = ( pos.point.z + (math.random(pos.radius * -1, pos.radius)) )
--ranpos.y = ( pos.point.y + (math.random(pos.radius * -1, pos.radius)) *.60 )
	return ranpos
end

function centerZoneCoordinates ( myZone )
	local pos = trigger.misc.getZone(myZone)
	local centerPos = {} -- to hold random positions variables
	centerPos.x = ( pos.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos.z = ( pos.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	return centerPos
end

function centerVec2ZoneCoordinates ( myZone )
	local pos = trigger.misc.getZone(myZone)
	local centerPos = {} -- to hold random positions variables
	centerPos.x = ( pos.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos.y = ( pos.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	return centerPos
end

function SearchAreaForObjects ( input ) -- toolbox routine
		local foundObjects = {}
		local volS = {
		   id = world.VolumeType.SPHERE,
		   params = {
			 point = input.point,
			 radius = input.radius
		   }
		 }
	 
		local ifFound = function(foundItem, val)
			if input.ignore ~= nil then 
				if input.ignore ~= foundItem:getName() then
					foundObjects[#foundObjects + 1] = foundItem:getName()
				end
			else 
				foundObjects[#foundObjects + 1] = foundItem:getName()
			end 
			return true
		end
		world.searchObjects(input.category, volS, ifFound)
		return foundObjects
end 

 -- FIND THE COORDINATES OF A UNIT
function centerUnitCoordinates ( myUnit )
	--if Debugging == true then printDebug ( "Waypoints" , "Finding Center Unit Coordinates using ".. myUnit , 10 ) end 
	pos = {}
	pos = Unit.getByName(myUnit):getPoint()
	return pos
end

function centerUnitVec2Coordinates ( myUnit )
	--if Debugging == true then printDebug ( "Waypoints" , "Finding Center Unit Coordinates using ".. myUnit , 10 ) end 
	pos = {}
	pos = Unit.getByName(myUnit):getPoint()
--	pos.x = ( pos.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	pos.y = ( pos.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	return pos
end

function getHeadingZoneToZoneDegrees(myZone2, myZone)
	local pos = trigger.misc.getZone(myZone)
	local centerPos = {} -- to hold the zones variables
	centerPos.x = ( pos.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos.z = ( pos.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	
	local pos2 = trigger.misc.getZone(myZone2)
	local centerPos2 = {} -- to hold the zones variables
	centerPos2.x = ( pos2.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos2.z = ( pos2.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	
	local bearing = math.atan2(centerPos.z - centerPos2.z  , centerPos.x - centerPos2.x  )
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
    return bearing    -- degrees
end

function getHeadingZoneToZoneVec(myZone, myZone2)
	local pos = trigger.misc.getZone(myZone)
	local centerPos = {} -- to hold the zones variables
	centerPos.x = ( pos.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos.z = ( pos.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	
	local pos2 = trigger.misc.getZone(myZone2)
	local centerPos2 = {} -- to hold the zones variables
	centerPos2.x = ( pos2.point.x ) -- + (math.random(pos.radius * -1, pos.radius)) *.60 )
	centerPos2.z = ( pos2.point.z ) --+ (math.random(pos.radius * -1, pos.radius)) *.60 )
	
	local bearing = math.atan2(centerPos.z - centerPos2.z  , centerPos.x - centerPos2.x  )
    return bearing    -- degrees
end

function randomHeavyAircraft ()
	local myrandomAirplane = math.random(1, 4) -- SEED RANDOM
	if ( myrandomAirplane == 1 ) then
		myPlaneType  = "KC-135"
		aircraftLivery = "Standard USAF"
	elseif ( myrandomAirplane == 2) then
		myPlaneType = "IL-76MD"
		aircraftLivery = "Standard USAF"
	elseif ( myrandomAirplane == 3) then
		myPlaneType = "KC130"
		aircraftLivery = "Standard USAF"
	elseif ( myrandomAirplane == 4) then
		myPlaneType = "C-17A"
		aircraftLivery = "Standard USAF"
	--elseif ( myrandomAirplane == 5) then
	--	myPlaneType = "E-3A"
	end
	return myPlaneType
end

function randomHeavyAircraftCivilian ()
	local myrandomAirplane = math.random(1, 2) -- SEED RANDOM
	aircraftLivery = "Clean"
	aircraftCalled = "Tango"
	if ( myrandomAirplane == 1 ) then
		myPlaneType  = "B_727"
		local myrandomSkin = math.random(1, 6) -- SEED RANDOM
		if ( myrandomSkin == 1 ) then 
			aircraftLivery = "Pan Am"
			aircraftCalled = "Clipper"
		elseif ( myrandomSkin == 2) then
			aircraftLivery = "American Airlines"
			aircraftCalled = "American"
		elseif ( myrandomSkin == 3) then
			aircraftLivery = "Alaska"
			aircraftCalled = "Alaska"
		elseif ( myrandomSkin == 4) then
			aircraftLivery = "United"
			aircraftCalled = "United"
		elseif ( myrandomSkin == 5) then
			aircraftLivery = "Delta Airlines"
			aircraftCalled = "Delta"
		elseif ( myrandomSkin == 6) then
			aircraftLivery = "Clean"
			aircraftCalled = "Tango"
		end
	elseif ( myrandomAirplane == 2) then
		myPlaneType = "B_737"
		local myrandomSkin = math.random(1, 6) -- SEED RANDOM
		if ( myrandomSkin == 1 ) then 
			aircraftLivery = "Pan Am"
			aircraftCalled = "Clipper"
		elseif ( myrandomSkin == 2) then
			aircraftLivery = "American_Airlines"
			aircraftCalled = "American"
		elseif ( myrandomSkin == 3) then
			aircraftLivery = "Disney"
			aircraftCalled = "Disney"
		elseif ( myrandomSkin == 4) then
			aircraftLivery = "UPS"
			aircraftCalled = "UPS"
		elseif ( myrandomSkin == 5) then
			aircraftLivery = "British Airways"
			aircraftCalled = "Speedbird"
		elseif ( myrandomSkin == 6) then
			aircraftLivery = "Clean"
			aircraftCalled = "Tango"
		end
	end
	--aircraftLivery = "Clean"
	return myPlaneType
end
-- CONVERT KNOTS TO METERS PER SECOND
function doConvertKnotsToMetersPerSec ( mySpeed ) 
	 --mySpeed = ((mySpeed * 0.514444) * 1.081081081)  -- convert to meters per second from knots
	 mySpeed = ((mySpeed * 0.5144444444444445))  -- convert to meters per second from knots
	 return mySpeed
end

function scheduledGroupDeactivate ()
	trigger.action.deactivateGroup(Group.getByName(deactivateThisGroup))
end

function distanceToZone ( myZoneID , myUnit )
	local centerTriggerZone = {} 
	local centerTriggerZone = centerZoneCoordinates( myZoneID) --find the center of the1 zone
	local myLocalGroup = Unit.getByName(myUnit) -- get the units object
	local myLocalGroupPos = myLocalGroup:getPosition()
	local myLocalGroupPoint = myLocalGroup:getPoint()
	local xDiff = myLocalGroupPos.p.x - centerTriggerZone.x
	local yDiff = myLocalGroupPos.p.z - centerTriggerZone.z
	local myDistance = math.sqrt(xDiff * xDiff + yDiff * yDiff) -- meters
	return myDistance
end

function calculateFuelLoad ( myAircraftFuelWeightLBS , myLoadAircraftFuel ) 
	local myFuelModifier = 0.453630481667864
	local wetWeight = ((myLoadAircraftFuel/100) * myAircraftFuelWeightLBS) * myFuelModifier
	return wetWeight -- how much fuel to load
end

function getAllGroups (myCoalition)
	for i, gp in pairs(coalition.getGroups(myCoalition)) do
	if Debugging == true then printDebug("Events" , "Active Group: "  .. Group.getName(gp) , 10 ) end
	end
end

function sayOpening ( ) 
   printThis ( "Player Group ID: " .. PlayerGroupID , 10 )
	printThis ( "Player Group Name: " .. PlayerGroupName , 10 )
   printThis ( "Player Unit Name: " .. PlayerName , 10 )
   printThis ( "Player Unit ID: " .. PlayerUnitID , 10 )
   printThis ( "Player Unit Num: " .. PlayerUnitNum , 10 )
end

----
----- DO CONTROL TASKS -----------
----
-- SEND THE OPTION TO A GROUP
function SendOptionToGroup ( myGroup , myOptionID, myOptionValue ) 
	--if Debugging == true then printDebug ("Controller" ,  "Starting Options Control for " .. myGroup, 10 ) end
	local groupName = Group.getName(Group.getByName(myGroup))
	-- if Debugging == true then printDebug ("Controller" ,  "Sending Option for: " .. groupName, 10 ) end
	local _group = Group.getByName(myGroup) ;
	-- if Debugging == true then printDebug ( "Controller" , "Getting GroupID For: " .. myGroup, 10 ) end
	local _controller = Group.getController(_group) 
	-- if Debugging == true then printDebug ( "Controller" , "Getting Controller for: " .. myGroup, 10 )	end
	_controller.setOption(_controller, myOptionID, myOptionValue ) 
	if Debugging == true then printDebug ( "Controller" , "Sent option to: " .. myGroup, 10 ) end
end

function scheduleSendOptionToGroup ( input ) -- TOOLBOX FUNCTION 
	SendOptionToGroup (  input.group , input.id , input.value )
end 
--- SEND CONTROLLER TO GROUP ---
function SendControlToGroup ( myGroup , myTask , myPush) 
	-- if Debugging == true then printDebug ("Controller" ,  "Starting Control for: " .. myGroup, 10 ) end
	--local groupName = Group.getName(Group.getByName(myGroup))
	-- if Debugging == true then printDebug ("Controller" ,  "Have group name for: " .. groupName, 10 ) end
	local _group = Group.getByName(myGroup) ;
	-- if Debugging == true then printDebug ( "Controller" , "Getting Group For: " .. myGroup, 10 ) end
	local _controller = Group.getController(_group) 
	-- if Debugging == true then printDebug ( "Controller" , "Getting Control for: " .. myGroup, 10 )	end
	Controller.setOnOff(_controller, true )
	if ( myPush  == true ) then 
		_controller.pushTask(_controller, myTask) 
		if Debugging == true then printDebug ( "Controller" ,"Pushing task for: " .. myGroup, 10 ) end
	else 
		_controller.setTask(_controller, myTask)
		if Debugging == true then printDebug ( "Controller" ,"Setting task for: " .. myGroup, 10 ) end
	end 
	-- if Debugging == true then printDebug ( "Controller" , "Sucess Sending Control to: " .. myGroup, 10 ) end
end
function ScheduleSendControlToGroup ( input ) -- TOOLBOX ROUTINE FOR SCHEDULING TASK
	SendControlToGroup ( input.group , input.task , input.push )
end
--- SEND CONTROLLER TO UNIT ---
function SendControlToUnit ( myUnit , myTask , myPush) 
	local muUnitName = Unit.getName(Unit.getByName(myUnit))
	 if Debugging == true then printDebug ("Controller" ,  "Running Unit Control for: " .. muUnitName, 10 ) end
	local _unit = Unit.getByName(myUnit) ;
	if Debugging == true then printDebug ( "Controller" , "Getting Unit For: " .. myUnit, 10 ) end
	local _controller = Unit.getController(_unit) 
	if Debugging == true then printDebug ( "Controller" , "Getting Unit Control for: " .. myUnit, 10 )	end
	Controller.setOnOff(_controller, true )
	if Debugging == true then printDebug ( "Controller" , "has set SetOnOff for: " .. myUnit, 10 )	end
	if ( myPush  == true ) then 
		_controller.pushTask(_controller, myTask) 
		if Debugging == true then printDebug ( "Controller" ,"Pushing Unit task for: " .. myUnit, 10 ) end
	else 
		_controller.setTask(_controller, myTask)
		if Debugging == true then printDebug ( "Controller" ,"Setting Unit task for: " .. myUnit, 10 ) end
	end 
	if Debugging == true then printDebug ( "Controller" , "Sucess Sending Unit Control to: " .. myUnit, 10 ) end
end

function ResetGroupController ( myGroup ) 
	local _group = Group.getByName(myGroup) ;
	local _controller = _group.getController(_group) 
	Controller.setOnOff(_controller, true ) 
	Controller.resetTask(_controller )
	--printThis ( "Reset Control to: " .. myGroup, 10 )
	-- if Debugging == true then  printDebug ( "EventHandler" , "Controller Reset " .. myGroup, 10 ) end
end

function ResetUnitController ( myUnit ) -- TOOLBOX ROUTING
	local _unit = Unit.getByName(myUnit) ;
	local _controller = _unit.getController(_unit) 
	Controller.setOnOff(_controller, true ) 
	Controller.resetTask(_controller )
	--printThis ( "Reset Control to: " .. myGroup, 10 )
	-- if Debugging == true then  printDebug ( "EventHandler" , "Controller Reset " .. myUnit, 10 ) end
end


--- GET TROOPS READY TO EMBARK
function doEmbarkTroopsToTransport ( myGroup )
	 if  Debugging == true then printDebug ( "Commands" ,  myGroup.callsign .. " is embarking to transport"  , 10 ) end
		--myUnit = Unit.getID(Unit.getByName(input.pickup) )
		local myEmbarkingPoint = centerVec2ZoneCoordinates(myGroup.zone) --find the vec2 center of the zone
		EmbarkToTransport = { id = "EmbarkToTransport",  params = {  x = (myEmbarkingPoint.x+myGroup.offset), y = (myEmbarkingPoint.y+myGroup.offset), zoneRadius = 100}}
		SendControlToGroup ( myGroup.callsign , EmbarkToTransport , true ) 
	  if  Debugging == true then printDebug ( "Commands" ,  myGroup.callsign .. " is ready to embark to transport"  , 10 ) end
end

-- HELECOPTER LANDING EMARCATION
function doLandForEmarking ( myTransport , myPickup )
	 if  Debugging == true then printDebug ( "Commands" ,  myTransport.callsign .. " is staying " .. myTransport.duration .. " for emarking troops " .. myPickup  , 10 ) end
		local myEmbarkingPoint = centerVec2ZoneCoordinates(myTransport.zone) --find the vec2 center of the zone
		local mySpeed = doConvertKnotsToMetersPerSec(myTransport.speed)
		local myPickupID = Group.getID(Group.getByName(myPickup) )

	local Embarking = { id = 'Mission',  params = { taskSelected = true , route = { 
		   points = { 
			 [1] = { 
									 ["alt"] = (myTransport.alt * 0.3048),
                                            ["action"] = "Turning Point",
                                            ["alt_type"] = "BARO",
                                            ["speed"] = mySpeed ,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                        [1] = 
                                                        {
                                                            ["number"] = 1,
                                                            ["auto"] = false,
                                                            ["id"] = "Embarking",
                                                            ["enabled"] = true,
                                                            ["params"] = 
                                                            {
                                                                ["distribution"] = 
                                                                {
                                                                }, -- end of ["distribution"]
                                                                ["x"] = myEmbarkingPoint.x - 100  ,
                                                                ["distributionFlag"] = false,  
                                                                ["y"] = myEmbarkingPoint.y - 100 ,
                                                                ["groupsForEmbarking"] = 
                                                                {
																	[1] = myPickupID -- + 1
                                                                }, -- end of ["groupsForEmbarking"]
                                                                ["duration"] = 5 ,
                                                                ["durationFlag"] = true ,
                                                            }, -- end of ["params"]
                                                        }, -- end of [1]
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Turning Point",
                                            ["ETA"] = 1.7422239217233,
                                            ["ETA_locked"] = false,
                                            ["y"] = myEmbarkingPoint.y - myTransport.offset ,
                                            ["x"] = myEmbarkingPoint.x  + myTransport.offset ,
                                            ["name"] = "DictKey_WptName_30",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
			 }, 
		   } 
		 }, 
	   } 
	 } 
		--sendThisMessage
	 SendControlToGroup ( myTransport.callsign , Embarking , true )
	 if  Debugging == true then printDebug ( "Commands" ,  myTransport.callsign .. " is inbound for pick up"  , 10 ) end
end
----
----- DO COMMANDS -----------
----
function SendCommandToGroup ( myGroup , myTask  )
	_group = Group.getByName(myGroup) ;
	-- if Debugging == true then printDebug ("Tasking" , myGroup .. "  is the group to control "   , 10 ) end
	_controller = _group.getController(_group) 
	-- if Debugging == true then printDebug ("Tasking" , myGroup .. "  has a controller "   , 10 ) end
	Controller.setOnOff(_controller, true ) 
	-- if Debugging == true then printDebug ("Tasking" , myGroup .. "  controller is turned on "   , 10 ) end
	_controller.setCommand (_controller, myTask) 
	local myID = "unknown"
	if myTask.id ~= nil then myID = myTask.id end 
	if Debugging == true then printDebug ("Command" , myGroup .. "  has been issued a command "  .. myID , 10 ) end
end

function SendCommandToUnit ( myUnit , myTask  )
	_unit = Unit.getByName(myUnit) ;
	if Debugging == true then printDebug ("Tasking" , myUnit .. "  is the group to control "   , 10 ) end
	_controller = _unit.getController(_unit) 
	if Debugging == true then printDebug ("Tasking" , myUnit .. "  has a controller "   , 10 ) end
	Controller.setOnOff(_controller, true ) 
	if Debugging == true then printDebug ("Tasking" , myUnit .. "  controller is turned on "   , 10 ) end
	_controller.setCommand (_controller, myTask) 
	if Debugging == true then printDebug ("Tasking" , myUnit .. "  set the task"   , 10 ) end
end

--- START TRANSMITTING --
function doTransmitMessage ( myMessage )
-- USING
-- local sendThisMessage = {}
-- sendThisMessage = { group = input.callsign , frequency = "30" , modulation = "FM" , message = "--.. -- Morse Code .. -- .. --" , file = "ResKey_Action_69" , loop=true} 
-- doTransmitMessage ( sendThisMessage )
	if Debugging == true then printDebug ("EventHandler" , "Prepare to send message"   , 10 ) end
	if myMessage.power == nil then myMessage.power = 10 end
	if myMessage.modulation == "FM" then 
		--myMessage.frequency = myMessage.frequency .. "000000" 
		myMessage.convert_frequency = myMessage.frequency * 1000000
		myMessage.convert_modulation = 1 
	else 
		myMessage.convert_frequency = myMessage.frequency * 1000000 -- convert megahertz to hertz 
		myMessage.convert_modulation = 0
	end

	if myMessage.group ~= nil then 
		if Debugging == true then printDebug ("EventHandler" , myMessage.group .. "  is setting frequency ".. myMessage.frequency .. " " .. myMessage.modulation    , 10 ) end
		SetFrequency = { id = 'SetFrequency', params = { frequency = myMessage.convert_frequency , modulation = myMessage.convert_modulation , } }
		SendCommandToGroup ( myMessage.group , SetFrequency  )
		TransmitMessage = { id = 'TransmitMessage', params = {subtitle = myMessage.message,loop = myMessage.loop ,file = myMessage.file ,power=myMessage.power } }	
		SendCommandToGroup ( myMessage.group , TransmitMessage )
		if Debugging == true then printDebug ("EventHandler" , myMessage.group .. "  has started transmitting message "   , 10 ) end
	elseif myMessage.point ~= nil then
		--if myMessage.point.y == nil then myMessage.point.y = 0 end 
		trigger.action.radioTransmission(myMessage.file, myMessage.point, myMessage.convert_modulation, myMessage.loop,  myMessage.convert_frequency, myMessage.power, myMessage.message)
		if Debugging == true then printDebug ("EventHandler" , "A point is setting frequency ".. myMessage.frequency .. " " .. myMessage.modulation    , 10 ) end
	end
end 

--- ACTIVATE TACAN --
function ActivateTacan (input) -- TOOLBOX ROUTINE
	-- local input = {}
	-- input.group = BlueCarrier
	-- input.channel = 126 -- 0 to 126
	-- input.mode = "Y"
	-- input.callsign = "SOS"
	
	if input.AA == nil then input.AA = false end 
	if input.system == nil then input.system = 3 end 

	--local myUnitID = Unit.getID(Unit.getByName(input.group) )
	local modeYStart = 1087000000
	local modeXStart = 961000000
	local oneChannel = 1000000
	local baseTwo = 126000000
	local frequency = 0
	local system = 3 -- START OUT AIRBORN TACAN
	local modeStart = modeYStart -- START OUT WITH Y FREQ
	local frequency = modeStart + oneChannel
	
	if input.mode == "X" then 
		modeStart = modeXStart
	else
		baseTwo = -baseTwo
	end 
	
	if input.channel > 63 then 
		frequency = modeStart+(input.channel*oneChannel) + baseTwo
	else
		frequency = modeStart+(input.channel*oneChannel) 
	end 
		
	
	DeactivateBeacon = {  id = 'DeactivateBeacon',  params = {  } }
	SendCommandToGroup ( input.group , DeactivateBeacon  )
	
	ActivateBeacon = { 
	id = 'ActivateBeacon', 
	params = { 
			["type"] = 4,
			["AA"] = input.AA,
			["callsign"] = input.callsign,
			["modeChannel"] = input.mode,
			["channel"] = input.channel,
			["system"] = input.system ,
			["bearing"] = true,
			["frequency"] = frequency ,
		} 
	}
	SendCommandToGroup ( input.group , ActivateBeacon  )
    -- if Debugging == true then  printDebug ( "EventHandler" , "Activate TACAN Channel " .. input.channel .. " Frequency " .. frequency .. " Mode " ..  input.mode .. " Callsign " .. input.callsign , 2 ) end
end

function ActivateCarrierICLS (input) -- TOOLBOX ROUTINE
	
	local myUnitId = Unit.getID(Unit.getByName(input.unit))
	
	ActivateICLS = { 
	id = 'ActivateICLS', 
	params = { 
			["channel"] = input.channel,
			["type"] = 131584,
			["name"] = input.name,
			["unitId"] = myUnitId,
		}
	}
	SendCommandToUnit ( input.unit , ActivateICLS  )
 --  if Debugging == true then  printDebug ( "EventHandler" , "Activate toolbox ICLS for " .. myUnitId , 2 ) end
   
end

function GetRandomFrequency () -- TOOLBOX FUNCTION 
		local myCallSigns = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",}
		local myFMmhzHundreds = math.random(1,3)
		local myFMmhzTens = math.random(3,7)
		local myFMmhzOnes = math.random(0,9)
		local myFMmhzDecimal = math.random(0,9)
		local myFMmhzDecimalHundreds = math.random(1,2)
	
		local myAMkhzHundreds = math.random(1,9)
		local myAMkhzTens = math.random(0,9)
		local myAMkhzOnes = math.random(0,9)
		
		local myAMMhzHundreds = math.random(2,3)
		local myAMMhzPointOnes = math.random(0,9)
		
		local myDecimalHundreds = {"00", "50"}
		
		local myFMVHFfrequency = myFMmhzTens .. myFMmhzOnes .. "." .. myFMmhzDecimal .. myDecimalHundreds[myFMmhzDecimalHundreds]
		local myFMUHFfrequency = myFMmhzHundreds .. myFMmhzTens .. myFMmhzOnes .. "." .. myDecimalHundreds[myFMmhzDecimalHundreds] .. myFMmhzDecimal 
		
		local myAMKHZFrequency = "." .. myAMkhzHundreds .. myAMkhzTens .. myAMkhzOnes .. myDecimalHundreds[myFMmhzDecimalHundreds]
		
		local myAMMHZFrequency = myAMMhzHundreds .. myAMkhzTens .. myAMkhzOnes .. "." .. myAMMhzPointOnes .. myDecimalHundreds[myFMmhzDecimalHundreds]
		
		local myAMKHZCallSign = myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)]
		local myAMMHZCallSign = myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)]
		local myFMUHFCallSign = myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)]
		local myFMVHFCallSign = myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)] .. myCallSigns[math.random(1,24)]
		
		local myBeacons = {}
		myBeacons["AMKHZ"] = { name="NDB AM KHZ" , callsign=myAMKHZCallSign, type="AMKHZ" ,  frequency = tonumber(myAMKHZFrequency)  , modulation = "AM"  , desc=string.format("%.2f" , myAMKHZFrequency*1000) .. " AM Khz" ,}
		myBeacons["AMMHZ"] = { name="NDB AM MHZ" , callsign=myAMMHZCallSign, type="AMMHZ" , frequency = tonumber(myAMMHZFrequency) , modulation = "AM" , desc=myAMMHZFrequency .. " AM Mhz" , }
		myBeacons["FMUHF"] = { name="NDB FM UHF" , callsign=myFMUHFCallSign, type="FMUHF" , frequency = tonumber(myFMUHFfrequency)  , modulation = "FM" , desc=myFMUHFfrequency .. " FM UHF", }
		myBeacons["FMVHF"] = { name="NDB FM VHF" , callsign=myFMVHFCallSign, type="FMVHF" , frequency = tonumber(myFMVHFfrequency) , modulation = "FM"  , desc=myFMVHFfrequency .. " FM VHF", }

		
		return myBeacons 

	end

function doRandomTACAN (input) -- TOOLBOX ROUTINE
	if input.mode == nil then input.mode = "X" end
	local myRandomFrequency = math.random(1,126)
	local myAvailableCallsigns = {"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",} 
	local myCallsign = myAvailableCallsigns[math.random(1,24)] .. myAvailableCallsigns[math.random(1,24)] .. myAvailableCallsigns[math.random(1,24)]
	local myTACAN = { channel=myRandomFrequency , mode=input.mode , callsign=myCallsign }
	return myTACAN
end 

function printCallsign ( myCallsign , myAlt , myTime )
	if Debugging == true then printDebug ("Delay" , myCallsign .. " Roger that @ " .. myAlt, 10 ) end
end
----
---- WAYPOINT ACTIONS
----
--FLY A ROUTE SCHEDULEABLE
function doScheduleFlyRoute ( myInfo )
	local myName 
	local myRoute = myInfo.route
	local myPush = myInfo.push
	local mySpeedModifier = 0.92592592592592592592592592592593
	----------- HOW TO USE 
	----------- myGroup is name of group.  myRoute can be zone or group in nested table with points, information alt and speed

		
	local myTask = { id = 'Mission', params = { route = { points = {  }  }, } }
	-- local myTask = ""
	-- if myInfo.task ~= nil then
		 -- myTask = myInfo.task
	-- end
	-- local myTask = { id = 'Mission', params = {  route = { points = {  }  }, } }

	if ( myInfo.group ~= nil ) then 
		if Debugging == true then printDebug ( "Waypoints" , "Calculating Waypoints For Group: " .. myInfo.group  , 10 ) end 
		myName = "Group: " .. myInfo.group
	elseif ( myInfo.unit ~= nil ) then
		if Debugging == true then printDebug ( "Waypoints" , "Calculating Waypoints For Unit: " .. myInfo.unit  , 10 ) end
		myName = "Unit: " .. myInfo.unit
	end
	local whereWeflying = "Somewhere"
	local myActualPoint = {}
	local myVec3Zone = {}

	
	for k, callSign in pairs(myInfo.route) do

		-- WE ARE FLYING TO A ZONE
		if myInfo.route[k].zone ~= nil then
			whereWeflying = myInfo.route[k].zone
			
			myVec3Zone = trigger.misc.getZone(myInfo.route[k].zone)
			myActualPoint.x= myVec3Zone.point.x
			myActualPoint.y = myVec3Zone.point.z
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myName .. " to zone: " .. myInfo.route[k].zone  , 10 ) end 
		end
		
		-- WE ARE FLYING TO LAST KNOW POSITION OF GROUP
		if myInfo.route[k].group ~= nil then
			myVec3Zone = centerUnitCoordinates(myInfo.route[k].group)
			myActualPoint.x = myVec3Zone.x
			myActualPoint.y = myVec3Zone.z
			whereWeflying = myInfo.route[k].group
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myName .. " to last known position " .. myInfo.route[k].group  , 10 ) end 
		end
		-- FLYING TO A POINT
		if myInfo.route[k].pointX ~= nil then
			myActualPoint.x = myInfo.route[k].pointX 
			myActualPoint.y = myInfo.route[k].pointZ 
			whereWeflying = "Points"
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myName .. " to point x= " .. myActualPoint.x .. " point z=" .. myActualPoint.y , 10 ) end 
		end
				-- FLYING TO A POINT
		if myInfo.route[k].pos ~= nil then
			myActualPoint.x = myInfo.route[k].pos.x 
			myActualPoint.y = myInfo.route[k].pos.z 
			whereWeflying = "Pos"
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myName .. " to pos x= " .. myActualPoint.x .. " pos z=" .. myActualPoint.y , 10 ) end 
		end
		
		if myInfo.route[k].altType == nil and myInfo.route[k].alt_type ~= nil then myInfo.route[k].altType = myInfo.route[k].alt_type end 


		if myInfo.route[k].x ~= nil then myActualPoint.x = myActualPoint.x + myInfo.route[k].x end
		if myInfo.route[k].y ~= nil then myActualPoint.y = myActualPoint.y + myInfo.route[k].y end

		--myInfo.route[k].speed = ((myInfo.route[k].speed  * 0.514444) * 1.081081081 ) -- convert to meters per second from knots	
		myInfo.route[k].speed = myInfo.route[k].speed/1.9438444924406046
		myInfo.route[k].alt = (myInfo.route[k].alt * 0.3048) -- convert feet to meters

		
		if Debugging == true then printDebug ( "Waypoints" , "Do move to " .. whereWeflying ..": ".. k .. string.format(" At: %d MPS", myInfo.route[k].speed) .. string.format(" Alt :%d Meters", myInfo.route[k].alt) .. " Action: " .. myInfo.route[k].action  .. " Using: " .. myRoute[k].altType , 10 ) end 
		myTask.params.route.points[#myTask.params.route.points+1] = {type = myInfo.route[k].type , action = myInfo.route[k].action , x = myActualPoint.x , y = myActualPoint.y , alt=myInfo.route[k].alt , alt_type=myInfo.route[k].altType,  speed=myInfo.route[k].speed , }
		
		if myInfo.tasks ~= nil then 
			myTask.params.route.points[#myTask.params.route.points].task =  {["id"] = "ComboTask",["params"] = {["tasks"] = myInfo.tasks,},}    
			--if Debugging == true then printDebug ( "EventHandler" , "Added tasks to " ..  myInfo.group .. " WAYPOINT " .. k ,  10 ) end 
		end 
		if Debugging == true then printDebug ( "Waypoints" , "Finished building waypoint for: " .. myName  ,  10 ) end 
	end
	if ( myInfo.group ~= nil ) then 
		if Debugging == true then printDebug ( "Waypoints" , "sending control to group: " .. myInfo.group ,  10 ) end 
		SendControlToGroup ( myInfo.group , myTask , myPush )
		if Debugging == true then printDebug ( "Waypoints" , "finished control to group: " .. myInfo.group ,  10 ) end 
	elseif ( myInfo.unit ~= nil ) then
		SendControlToUnit ( myInfo.unit , myTask , myPush ) 
	end

	--deReference ( myTask )
end


 -- FLY A ROUTE
function doFlyRoute(myGroup, myRoute , myPush )
	----------- HOW TO USE 
	----------- myGroup is name of group.  myRoute can be zone or group in nested table with points, information alt and speed
	local myTask = { id = 'Mission', params = { route = { points = {  }  }, } }
	if Debugging == true then printDebug ( "Waypoints" , "Calculating Waypoints For " .. myGroup  , 10 ) end 
	local whereWeflying = "Somewhere"
	local myActualPoint = {}
	local myVec3Zone = {}
	for k, callSign in pairs(myRoute) do

		-- WE ARE FLYING TO A ZONE
		if myRoute[k].zone ~= nil then
			whereWeflying = myRoute[k].zone
			
			myVec3Zone = trigger.misc.getZone(myRoute[k].zone)
			myActualPoint.x= myVec3Zone.point.x
			myActualPoint.y = myVec3Zone.point.z
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myGroup .. " to " .. myRoute[k].zone  , 10 ) end 
		end
		
		-- WE ARE FLYING TO LAST KNOW POSITION OF GROUP
		if myRoute[k].group ~= nil then
			myVec3Zone = centerUnitCoordinates(myRoute[k].group)
			myActualPoint.x = myVec3Zone.x
			myActualPoint.y = myVec3Zone.z
			whereWeflying = myRoute[k].group
			if Debugging == true then printDebug ( "Waypoints" , "Building " .. myGroup .. " to " .. myRoute[k].group  , 10 ) end 
		end
		
		if myRoute[k].x ~= nil then myActualPoint.x = myActualPoint.x + myRoute[k].x end
		if myRoute[k].y ~= nil then myActualPoint.y = myActualPoint.y + myRoute[k].y end
			
		myRoute[k].speed = ((myRoute[k].speed  * 0.514444) * 1.081081081 ) -- convert to meters per second from knots	
		myRoute[k].alt = (myRoute[k].alt * 0.3048) -- convert feet to meters	
		if Debugging == true then printDebug ( "Waypoints" , "Do Fly to point: ".. k .." " .. whereWeflying .. string.format(" At:%d MPS", myRoute[k].speed) .. string.format(" Alt:%d MET", myRoute[k].alt), 10 ) end 
		myTask.params.route.points[#myTask.params.route.points+1] = {type = myRoute[k].type , action = myRoute[k].action , x = myActualPoint.x , y = myActualPoint.y , alt=myRoute[k].alt , alt_type=myRoute[k].altType,  speed=myRoute[k].speed }
	end
	SendControlToGroup ( myGroup , myTask , myPush )
 end 

 --- FLY TO AN SINGLE WAYPOINT
function doFlyToWaypoint(myInfo)

	if Debugging == true then printDebug ( "Waypoints" , myInfo.callsign  .. " is changing course" , 10 ) end 
	-- if myInfo.route[1].zone ~= nil then
		-- if Debugging == true then printDebug ( "Waypoints" , myInfo.callsign  .. " is heading to zone " .. myInfo.route[1].zone , 10 ) end 
		-- myVec2Zone = centerVec2ZoneCoordinates(myInfo.route[1].zone) --find the vec2 center of the zone
		-- local whereWeflying = myInfo.route.zone
	-- end
	
	-- if myInfo.route[1].unit ~= nil then
		 -- myVec2Zone = centerUnitCoordinates ( myInfo.route[1].unit )
		 -- myVec2Zone.y = myVec2Zone.z
		 -- whereWeflying = myInfo.route[1].unit
		-- if Debugging == true then printDebug ( "Waypoints" , myInfo.callsign  .. " is heading to unit " .. myInfo.route[1].unit , 10 ) end 
	-- end
	 
	 
	--local myMetersPerSecond = (myInfo.route[1].speed * 0.514444) * 1.081081081  -- convert to meters per second from knots
	
	local myTask = { 
	  id = 'SwitchWaypoint', 
	  params = { 
		fromWaypointIndex = 3,  
		goToWaypointIndex = 2, 
  } 
}
	SendControlToUnit ( myInfo.callsign , myTask , true )
	printThis ( "Do Fly to Way point: " .. myInfo.callsign, 10 )

 end 
 
-- --- FLY TO AN AIRPORT AND LAND
-- function doLandAtAirport(myGroup, myPush , myZone , myAirfield , myAlt , mySpeed )
    -- landingSpot = landingSpot + 1
	
	-- --local myVec3Zone = {} -- to hold random positions variables
	 -- --myVec3Zone = centerZoneCoordinates(myZone) --find the center of the zone
	 -- myVec3Zone = trigger.misc.getZone(myZone)
	-- local myMetersPerSecond = (mySpeed * 0.514444) * 1.081081081  -- convert to meters per second from knots
	-- -- landingSpot = landingSpot + 1	
	-- if (landingSpot > 3 ) then -- we have filled our spots
		-- landingSpot = 1 -- reset the landing spots
	-- end
	-- local myTask = { 
		-- id = 'Mission', 
	   -- params = { taskSelected = true ,
		 -- route = { 
		   -- points = { 
			 -- [1] = { 
			   -- type = "Land" , 
			   -- airdromeId = myAirfield , 
			   -- -- helipadId = Airbase.ID, 
			   -- action = "Fin Point" , 
			   -- x = myVec3Zone.point.x , 
			   -- y = myVec3Zone.point.z , 
			   -- alt = (myAlt * 0.3048) , 
			   -- -- alt_type = enum AI.Task.AltitudeType, 
			   -- speed = myMetersPerSecond ,
			   -- --parking_landing_id = 17
			   -- parking_landing_id = LandingMap[landingSpot] ,
			   -- --parking_landing = 23
			   -- --parking_id = 17
			   -- -- speed_locked = boolean, 
			   -- -- ETA = Time, 
			   -- -- ETA_locked = boolean, 
			   -- -- name = string, 
			   -- -- task = Task 
			 -- }, 
		   -- } 
		 -- }, 
	   -- } 
	 -- } 
	-- SendControlToGroup ( myGroup , myTask , myPush )
 -- end 
 
 function doBuildRoute ( route )
 
 
 end
  -- GROUND TRAVEL A ROUTE
--function doGroundRoute(myGroup, myZoneStart, myZoneFinish , mySpeed, myPush )
-- function doGroundRoute(myGroup, myRoute, myPush )
	-- local myTask = { id = 'Mission', params = { route = { points = {  }  }, } }
	-- printThis ( "Do Fly Route: " .. myGroup, 10 )
	-- for k, callSign in pairs(myRoute) do

		-- myVec3Zone = trigger.misc.getZone(myRoute[k].zone)

		-- myRoute[k].speed = ((myRoute[k].speed  * 0.514444) * 1.081081081 ) -- convert to meters per second from knots
		-- myRoute[k].alt = (myRoute[k].alt * 0.3048) -- convert feet to meters

		-- myTask.params.route.points[#myTask.params.route.points+1] = {type = myRoute[k].type , action = myRoute[k].action , x = myVec3Zone.point.x , y = myVec3Zone.point.z , alt=myRoute[k].alt , speed=myRoute[k].speed }
		-- if Debugging == true then printDebug ( "Waypoints" , "Do Fly to Way point: ".. k .." " .. myRoute[k].zone .. string.format(" At:%d Mps", myRoute[k].speed) .. string.format(" Alt:%d M", myRoute[k].alt), 10 ) end 
	-- end


	-- SendControlToGroup ( myGroup , myTask , myPush )
 -- end 
  

 
 -- FLY HOLD OVER A WAYPOINT --USE LIKE BELOW COMMMNET
-- myLocation = { callsign = MyWingman , unit=TaskGroupName , type = "Race-Track"|"Circle"  , alt = "600" , speed = "60" , racetrackwidth = -2500 }  -- "Race-Track" or "Circle" -- zone = "TaskGroupSpawnZone"
-- timer.scheduleFunction(doHoldPattern, myLocation, timer.getTime() + 20 )
-- function doHoldPattern(myLocation ) -- PASS AN ARRAY OF ZONE OR GROUP
	-- if Debugging == true then printDebug ( "Waypoints" , "Started a finding holding pattern" , 10 ) end

	-- local myGroup = myLocation.callsign
	-- ----------------- HOW TO USE IT 
	-- ----------------- myGroup table that contains zone or group.  Circle or racetrack patterns can be specified
	-- ----------------- note a moving group will only continue to circle in orginal location unless cleared with another command with delay
	-- --if Debugging == true then printDebug ( "Waypoints" , "Started a finding a unit for the holding pattern" , 10 ) end

	-- local myVec2Zone = {}
	-- local myVec2Zone2 = {}
	-- local whereWeflying = "Somewhere"
	
	-- if myLocation.zone ~= nil then
		-- if Debugging == true then printDebug ( "Waypoints" , myGroup  .. " is holding over waypoint " .. myLocation.zone .. " Type " .. myLocation.type, 10 ) end 
		-- myVec2Zone = centerVec2ZoneCoordinates(myLocation.zone) --find the vec2 center of the zone
		-- whereWeflying = myLocation.zone

	-- end
	-- if myLocation.unit ~= nil then
		 -- myVec2Zone = centerUnitCoordinates ( myLocation.unit )
		 -- myVec2Zone.y = myVec2Zone.z
		 -- whereWeflying = myLocation.unit
		 -- if Debugging == true then printDebug ( "Waypoints" , myGroup  .. " is holding over " ..myLocation.unit .. " X=" .. myVec2Zone.x .. " Z=" .. myVec2Zone.y, 10 ) end 
	-- end
	-- local myVec2Zone2 = {} -- to hold random positions variables
	
	-- myVec2Zone2.x = myVec2Zone.x + myLocation.racetrackwidth  -- space out the racetrack hold patter
	-- --myVec2Zone2.y = myVec2Zone.y + myLocation.racetrackwidth -- space out the racetrack hold patter

	-- local myMetersPerSecond = (myLocation.speed * 0.514444) * 1.081081081  -- convert to meters per second from knots
	-- local myTask = {id = 'Orbit', params = {pattern = myLocation.type, point = myVec2Zone , point2 = myVec2Zone2 , altitude  = (myLocation.alt * 0.3048) , speed = myMetersPerSecond, }}
	-- if Debugging == true then printDebug ( "Waypoints" , "Ready to send command" , 10 ) end 
	-- SendControlToGroup ( myGroup , myTask , true )
	-- --SendControlToUnit ( myGroup , myTask , true )
	-- if Debugging == true then printDebug ( "Waypoints" , "Finished finding holding pattern location ".. myGroup .. " to " .. whereWeflying, 10 ) end 

	
-- end 

function doHoldPattern(myLocation ) -- PASS AN ARRAY OF ZONE OR GROUP
	

	local myHolder = "I don't know "
	if myLocation.callsign_unit ~= nil then
		myHolder = myLocation.callsign_unit 
	elseif myLocation.callsign_group ~= nil then 
		myHolder = myLocation.callsign_group
	else
		myHolder = myLocation.callsign
	end
	
	if Debugging == true then printDebug ( "Waypoints" , myHolder .. " has Started a finding holding pattern" , 10 ) end
		
	----------------- HOW TO USE IT 
	----------------- myGroup table that contains zone or group.  Circle or racetrack patterns can be specified
	----------------- note a moving group will only continue to circle in orginal location unless cleared with another command with delay
	--if Debugging == true then printDebug ( "Waypoints" , "Started a finding a unit for the holding pattern" , 10 ) end

	local myVec2Zone = {}
	local myVec2Zone2 = {}
	local whereWeflying = "Somewhere"
	
	if myLocation.zone ~= nil then
		if Debugging == true then printDebug ( "Waypoints" , myHolder  .. " is holding over zone " .. myLocation.zone .. " Type " .. myLocation.type, 10 ) end 
		myVec2Zone = centerVec2ZoneCoordinates(myLocation.zone) --find the vec2 center of the zone
		whereWeflying = myLocation.zone

	end
	if myLocation.unit ~= nil then
		 myVec2Zone = centerUnitCoordinates ( myLocation.unit )
		 myVec2Zone.y = myVec2Zone.z
		 whereWeflying = myLocation.unit
		 if Debugging == true then printDebug ( "Waypoints" , myHolder  .. " is holding over " ..myLocation.unit .. " X=" .. myVec2Zone.x .. " Z=" .. myVec2Zone.y, 10 ) end 
	end
	local myVec2Zone2 = {} -- to hold random positions variables
	
	if myLocation.point ~= nil then
		myVec2Zone.x = myLocation.point.x
		myVec2Zone.y = myLocation.point.z
		if Debugging == true then printDebug ( "Waypoints" , myHolder  .. " is holding over a point X=" .. myVec2Zone.x .. " Z=" .. myVec2Zone.y, 10 ) end
	end 
	
	if myLocation.racetrack_point ~= nil and myLocation.type == "Race-Track" then
		myVec2Zone2.x = myLocation.racetrack_point.x
		myVec2Zone2.y = myLocation.racetrack_point.z
		if Debugging == true then printDebug ( "Waypoints" , myHolder  .. " is holding over a point X=" .. myVec2Zone.x .. " Z=" .. myVec2Zone.y, 10 ) end
	end 
	
	if myLocation.racetrackwidth ~= nil then 
		myVec2Zone2.x = myVec2Zone.x + myLocation.racetrackwidth  -- space out the racetrack hold patter
		myVec2Zone2.y = myVec2Zone.y + myLocation.racetrackwidth -- space out the racetrack hold patter
	end
	 
	local myMetersPerSecond = (myLocation.speed * 0.514444) --* 1.081081081  -- convert to meters per second from knots
	local myTask = {id = 'Orbit', params = {pattern = myLocation.type, point = myVec2Zone , point2 = myVec2Zone2 , altitude  = (myLocation.alt * 0.3048) , speed = myMetersPerSecond, }}
	if Debugging == true then printDebug ( "Waypoints" , "Ready to send command" , 10 ) end 

	if myLocation.callsign_unit ~= nil then
		SendControlToUnit ( myLocation.callsign_unit , myTask , true )	
		if Debugging == true then printDebug ( "Waypoints" , "Ready to command to unit " ..  myLocation.callsign_unit , 10 ) end 
	elseif myLocation.callsign_group ~= nil then 
		SendControlToGroup ( myLocation.callsign_group , myTask , true )
		if Debugging == true then printDebug ( "Waypoints" , "Ready to command to group " ..  myLocation.callsign_group , 10 ) end 
	else
		SendControlToGroup ( myLocation.callsign , myTask , true )
		if Debugging == true then printDebug ( "Waypoints" , "Ready to command to callsign " ..  myLocation.callsign , 10 ) end 
	end
	
	if Debugging == true then printDebug ( "Waypoints" , "Finished finding holding pattern location ".. myHolder .. " to " .. whereWeflying .. " at " .. myLocation.alt , 10 ) end 
	-- if Debugging == true then printDebug ( "EventHandler" , "Holding at " ..myLocation.alt , 10 ) end 
	
end 
-- ATTACK A GROUP 
function doScheduleAttackGroup ( input ) -- NOTE TASK VALUE ON THE SPAWN HAS TO AN ATTACK TYPE VALUE 
local myAttacker = input.attacker 
	local	myTargeting = input.target
	if Debugging == true then printDebug ("Controller" , myAttacker .. " has started attacking group " .. myTargeting   , 10 ) end
	local targetGroupID = Group.getID(Group.getByName(myTargeting) )
	if Debugging == true then printDebug ("Controller" , myAttacker .. " is building attack tables for ID: " .. targetGroupID   , 10 ) end
	local AttackGroup = { id = 'AttackGroup', params = {  groupId = targetGroupID } }-- BUNCH MORE PARAMETERS AVAILABLE NOT INCLUDED HERE
	SendControlToGroup ( myAttacker , AttackGroup , true )
	if Debugging == true then printDebug ("Controller" , myAttacker .. "  is finished building attack tables for " .. myTargeting   , 10 ) end
end

-- -- ATTACK A GROUP 
-- function doAttackGroup ( myAttacker , myTargeting ) -- NOTE TASK VALUE ON THE SPAWN HAS TO AN ATTACK TYPE VALUE 
-- if Debugging == true then printDebug ("Controller" , myAttacker .. " has started attacking group " .. myTargeting.group   , 10 ) end
-- local targetGroupID = Group.getID(Group.getByName(myTargeting.group) )
-- if Debugging == true then printDebug ("Controller" , myAttacker .. " is building attack tables for ID: " .. targetGroupID   , 10 ) end
-- local AttackGroup = { id = 'AttackGroup', params = {  groupId = targetGroupID } }-- BUNCH MORE PARAMETERS AVAILABLE NOT INCLUDED HERE
-- SendControlToGroup ( myAttacker , AttackGroup , true )
-- if Debugging == true then printDebug ("Controller" , myAttacker .. "  is finished building attack tables for " .. myTargeting.group   , 10 ) end
-- end

-- ATTACK A GROUP 
function doAttackGroup ( myAttacker , myTargeting ) -- NOTE TASK VALUE ON THE SPAWN HAS TO AN ATTACK TYPE VALUE 
	-- if Debugging == true then printDebug ("Controller" , myAttacker .. " has started attacking group " .. myTargeting.group   , 10 ) end
	local targetGroupID = Group.getID(Group.getByName(myTargeting.group) )
	-- if Debugging == true then printDebug ("Controller" , myAttacker .. " is building attack tables for ID: " .. targetGroupID   , 10 ) end

	local myParams = {}
	if myTargeting.group ~= nil then myParams.groupId = Group.getID(Group.getByName(myTargeting.group) ) end


	local AttackGroup = { id = 'AttackGroup', params = myParams }-- BUNCH MORE PARAMETERS AVAILABLE NOT INCLUDED HERE
	SendControlToGroup ( myAttacker , AttackGroup , true )
	-- if Debugging == true then printDebug ("Controller" , myAttacker .. "  is finished building attack tables for " .. myTargeting.group   , 10 ) end
end

-- ENGAGE TARGETS
function doEngageTargets ( myAttacker , myTargeting ) -- TOOLBOX FUNCTION 
	local EngageTargets = { 
	  id = 'EngageTargets', 
	  params = { 
		maxDist = myTargeting.distance , 
		targetTypes = myTargeting.types , 
		priority = myTargeting.priority , 
	  } 
	}
	SendControlToGroup ( myAttacker , EngageTargets , true )
end

function AerobaticsTypes ( input ) -- TOOLBOX ROUTINE
	-- IF LEFT OR RIDE SIDE MANEUVER
	if input.side == nil then 
		input.side = 0 
	elseif input.side == "left" then 
		input.side = 0 
	elseif input.side == "right" then 
		input.side = 1
	end 
	-- -- NUMBER OF TIMES
	if input.count == nil then input.count = 1 end 
	if input.rollrate == nil then input.rollrate = 50 end 
	if input.finalspeed == nil then input.finalspeed = 150 end 
	if input.roll == nil then input.roll = 60 end
	if input.degrees == nil then input.degrees = 180 end
	if input.immediately == nil then input.immediately = 1 end
	if input.updown == nil then input.updown = 0 end
	if input.angle == nil then input.angle = 45 end
	if input.duration == nil then input.duration = 10 end
	if input.finalalt == nil then input.finalalt = 4000 end
	if input.alt == nil then input.alt = 2000 end 
	if input.speed == nil then input.speed = 300 end
	if input.smoke ~= nil then
		if input.smoke == false then input.smoke = 0 else input.smoke=1 end
	else
		input.smoke = 1
	end 
	local myManeuver = {}
	
	if input.type == "loop" then
	  myManeuver = {
					["displayName"] = "Loop",
					["name"] = "LOOP",
					["params"] = 
					{
						["InitSpeed"] = 
						{
							["order"] = 3,
							["value"] = 443.99999999999,
						}, -- end of ["InitSpeed"]
						["InitAltitude"] = 
						{
							["order"] = 2,
							["value"] = 2000,
						}, -- end of ["InitAltitude"]
						["StartImmediatly"] = 
						{
							["order"] = 5,
							["value"] = input.immediately,
						}, -- end of ["StartImmediatly"]
						["UseSmoke"] = 
						{
							["order"] = 4,
							["value"] = input.smoke ,
						}, -- end of ["UseSmoke"]
						["RepeatQty"] = 
						{
							["min_v"] = 1,
							["max_v"] = 10,
							["value"] = input.count ,
							["order"] = 1,
						}, -- end of ["RepeatQty"]
					}, -- end of ["params"]
				}
	end
	if input.type == "barrelroll" then
		myManeuver = 	{
						["displayName"] = "Barrel roll",
						["name"] = "BARREL_ROLL",
						["params"] = 
						{
							["InitAltitude"] = 
							{ 
								["order"] = 2,
								["value"] = 2000,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["SIDE"] = 
							{
								["order"] = 6,
								["value"] = input.side ,
							}, -- end of ["SIDE"]
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 443.99999999999,
							}, -- end of ["InitSpeed"]
							["RollRate"] = 
							{
								["min_v"] = 15,
								["max_v"] = 450,
								["value"] = input.rollrate,
								["step"] = 5,
								["order"] = 7,
							}, -- end of ["RollRate"]
							["SECTOR"] = 
							{
								["order"] = 8,
								["value"] = 360,
							}, -- end of ["SECTOR"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end
	if input.type == "straightflight" then
		myManeuver = 	{ 
						["displayName"] = "Straight flight",
						["name"] = "STRAIGHT_FLIGHT",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = input.speed ,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = input.alt ,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["FlightTime"] = 
							{
								["min_v"] = 1,
								["max_v"] = 200,
								["value"] = input.duration ,
								["step"] = 0.1,
								["order"] = 6,
							}, -- end of ["FlightTime"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
						}
	end
	if input.type == "immelman" then
		myManeuver = 	{       
						["displayName"] = "Immelman",
						["name"] = "IMMELMAN",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 2000,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end 
	if input.type == "splits" then
		myManeuver =	{
						["displayName"] = "Split S",
						["name"] = "SPLIT_S",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 2000,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["FinalSpeed"] = 
							{
								["order"] = 6,
								["value"] = input.finalspeed ,
							}, -- end of ["FinalSpeed"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end
	if input.type == "aileronroll" then
		myManeuver = 	{
						["displayName"] = "Aileron roll",
						["name"] = "AILERON_ROLL",
						["params"] = 
						{
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["SIDE"] = 
							{
								["order"] = 6,
								["value"] = input.side ,
							}, -- end of ["SIDE"]
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 305.25,
							}, -- end of ["InitSpeed"]
							["RollRate"] = 
							{
								["min_v"] = 15,
								["max_v"] = 450,
								["value"] = input.rollrate,
								["step"] = 5,
								["order"] = 7,
							}, -- end of ["RollRate"]
							["FIXSECTOR"] = 
							{
								["min_v"] = 0,
								["max_v"] = 180,
								["value"] = 0,
								["step"] = 5,
								["order"] = 9,
							}, -- end of ["FIXSECTOR"]
							["SECTOR"] = 
							{
								["order"] = 8,
								["value"] = 360,
							}, -- end of ["SECTOR"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end 
	if input.type == "turn" then
		myManeuver = 	{
						["displayName"] = "Turn",
						["name"] = "TURN",
						["params"] = 
						{
							["Ny_req"] = 
							{
								["order"] = 6,
								["value"] = 2,
							}, -- end of ["Ny_req"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["SIDE"] = 
							{
								["order"] = 9,
								["value"] = input.side,
							}, -- end of ["SIDE"]
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 443.99999999999,
							}, -- end of ["InitSpeed"]
							["ROLL"] = 
							{
								["order"] = 7,
								["value"] = input.roll,
							}, -- end of ["ROLL"]
							["SECTOR"] = 
							{
								["order"] = 8,
								["value"] = input.degrees,
							}, -- end of ["SECTOR"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = 1,
								["order"] = input.count,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	
	end
	if input.type == "spiral" then
		myManeuver = 	{
						["displayName"] = "Spiral",
						["name"] = "SPIRAL",
						["params"] = 
						{
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["ROLL"] = 
							{
								["order"] = 7,
								["value"] = input.roll,
							}, -- end of ["ROLL"]
							["SIDE"] = 
							{
								["order"] = 8,
								["value"] = input.side,
							}, -- end of ["SIDE"]
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 443.99999999999,
							}, -- end of ["InitSpeed"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["Angle"] = 
							{
								["min_v"] = 5,
								["max_v"] = 80,
								["value"] = input.angle,
								["step"] = 5,
								["order"] = 10,
							}, -- end of ["Angle"]
							["UPDOWN"] = 
							{
								["order"] = 9,
								["value"] = input.updown,
							}, -- end of ["UPDOWN"]
							["SECTOR"] = 
							{
								["order"] = 6,
								["value"] = input.degrees,
							}, -- end of ["SECTOR"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end
	if input.type == "wingover" then
		myManeuver =	{
						["displayName"] = "Wingover Flight",
						["name"] = "WINGOVER_FLIGHT",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["FlightTime"] = 
							{
								["min_v"] = 1,
								["max_v"] = 200,
								["value"] = input.duration,
								["step"] = 0.1,
								["order"] = 6,
							}, -- end of ["FlightTime"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end
	if input.type == "tailslide" then
		myManeuver =	{
						["displayName"] = "Tailslide",
						["name"] = "CANDLE",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
						}, -- end of ["params"]
					}
	end
	if input.type == "chandelle" then
		myManeuver =	{
						["displayName"] = "Military Turn",
						["name"] = "MILITARY_TURN",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 370.00000000001,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["SIDE"] = 
							{
								["order"] = 6,
								["value"] = input.side,
							}, -- end of ["SIDE"]
						}, -- end of ["params"]
					}
	end 
	if input.type == "climb" then
		myManeuver =	{
						["displayName"] = "Climb",
						["name"] = "CLIMB",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 609.6,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["Angle"] = 
							{
								["min_v"] = 15,
								["max_v"] = 90,
								["value"] = input.angle,
								["step"] = 5,
								["order"] = 6,
							}, -- end of ["Angle"]
							["FinalAltitude"] = 
							{
								["order"] = 7,
								["value"] = input.finalalt,
							}, -- end of ["FinalAltitude"]
						}, -- end of ["params"]
					}
	end
	if input.type == "dive" then
		myManeuver =	{
						["displayName"] = "Dive",
						["name"] = "DIVE",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 914.4,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.count,
							}, -- end of ["UseSmoke"]
							["Angle"] = 
							{
								["min_v"] = 15,
								["max_v"] = 90,
								["value"] = input.angle,
								["step"] = 5,
								["order"] = 6,
							}, -- end of ["Angle"]
							["FinalAltitude"] = 
							{
								["order"] = 7,
								["value"] = input.finalalt ,
							}, -- end of ["FinalAltitude"]
						}, -- end of ["params"]
					}
	end 
	if input.type == "edgeflight" then
		myManeuver =	{
						["displayName"] = "Edge Flight",
						["name"] = "EDGE_FLIGHT",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 240.5,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 914.4,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["FlightTime"] = 
							{
								["min_v"] = 1,
								["max_v"] = 200,
								["value"] = input.duration,
								["step"] = 0.1,
								["order"] = 6,
							}, -- end of ["FlightTime"]
							["SIDE"] = 
							{
								["order"] = 7,
								["value"] = input.side,
							}, -- end of ["SIDE"]
						}, -- end of ["params"]
					}
	end 
	if input.type == "skewedloop" then
		myManeuver =	{
						["displayName"] = "Skewed Loop",
						["name"] = "SKEWED_LOOP",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 443.99999999999,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 304.8,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] = input.immediately,
							}, -- end of ["StartImmediatly"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count ,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["ROLL"] = 
							{
								["order"] = 6,
								["value"] = input.roll,
							}, -- end of ["ROLL"]
							["SIDE"] = 
							{
								["order"] = 7,
								["value"] = input.side,
							}, -- end of ["SIDE"]
						}, -- end of ["params"]
					}
	end
	if input.type == "hammerhead" then
		myManeuver =  	{
						["displayName"] = "Hammerhead",
						["name"] = "HUMMERHEAD",
						["params"] = 
						{
							["InitSpeed"] = 
							{
								["order"] = 3,
								["value"] = 370.00000000001,
							}, -- end of ["InitSpeed"]
							["InitAltitude"] = 
							{
								["order"] = 2,
								["value"] = 304.8,
							}, -- end of ["InitAltitude"]
							["StartImmediatly"] = 
							{
								["order"] = 5,
								["value"] =  input.immediately,
							}, -- end of ["StartImmediatly"]
							["UseSmoke"] = 
							{
								["order"] = 4,
								["value"] = input.smoke,
							}, -- end of ["UseSmoke"]
							["RepeatQty"] = 
							{
								["min_v"] = 1,
								["max_v"] = 10,
								["value"] = input.count,
								["order"] = 1,
							}, -- end of ["RepeatQty"]
							["SIDE"] = 
							{
								["order"] = 6,
								["value"] = input.side,
							}, -- end of ["SIDE"]
						}, -- end of ["params"]
					}
	end
	
	
	return myManeuver	
end

-- follow a group in formation ---
function doFollowFormation ( myInput)
	--if Debugging == true then  printDebug ( "Tasking" , "Starting to calculate formation"  , 10 ) end
	local myLead = Group.getID(Group.getByName(myInput.lead) )
	local myTrail = Group.getID(Group.getByName(myInput.trail) )

	if Debugging == true then  printDebug ( "Tasking" , "Group: " .. myInput.trail .. " ID: " .. myTrail .. " Is following group: " .. myInput.lead .. " ID: " ..myLead , 10 ) end
  -- local myTask = {
  -- id = 'Follow',
  -- params = {
    -- groupId = myLead ,
    -- pos = {x = 200, y = 0, z = -100, } } }
	-- SendControlToGroup ( myInput.trail , myTask , true )

 
	    local myTask = {                                   -- ["enabled"] = true,
                                                          --  ["auto"] = false,
                                                            ["id"] = "Follow",
                                                          --  ["number"] = 1,
                                                            ["params"] = 
                                                            {
                                                               ["lastWptIndexFlagChangedManually"] = false,
                                                                ["groupId"] = myLead,
                                                               -- ["lastWptIndex"] = 7,
                                                               ["lastWptIndexFlag"] = false,
                                                                ["pos"] = 
                                                                {
                                                                    -- ["y"] = myInput.above ,
                                                                    -- ["x"] = myInput.center ,
                                                                    -- ["z"] = myInput.behind ,
																	y = myInput.above ,
                                                                    x = myInput.center ,
                                                                    z = myInput.behind ,
                                                                }, -- end of ["pos"]
                                                            }, -- end of ["params"]
						}
						
   if Debugging == true then  printDebug ( "Tasking" , "Has finshed calulating a formation flight" , 10 ) end
   SendControlToGroup ( myInput.trail , myTask , true )
end
 -- LAND OFF AIRPORT IN HELO
function doLandVTOL ( myLandingZone )
	-- USE LIKE THIS
	-- myLanding = { group = myGroup , zone = myZone , stayOnGround=false , timeOnGround = 5 , offset=20 } --BUILD THE LANDING TABLE offset so it won't land center of the zone
	-- timer.scheduleFunction(doLandVTOL, myLanding, timer.getTime()+1) -- you should delay the command
	if myLandingZone.group ~= nil then myLandingZone.callsign = myLandingZone.group end
	if  Debugging == true then printDebug ( "Commands" ,  myLandingZone.callsign .. " is landing"  , 10 ) end
	
	local myLandingPoint = {}
	if myLandingZone.zone ~= nil then
		myLandingPoint = centerVec2ZoneCoordinates(myLandingZone.zone) --find the vec2 center of the zone
	end
	if myLandingZone.position ~= nil then
		myLandingPoint.x = myLandingZone.position.x
		myLandingPoint.y = myLandingZone.position.z
	end 
	
	myLandingPoint.y = myLandingPoint.y + myLandingZone.offset
	myLandingPoint.x = myLandingPoint.x + myLandingZone.offset
	landingSite = {id= 'Land', params = {  point = myLandingPoint , durationFlag = myLandingZone.stayOnGround , duration = myLandingZone.timeOnGround }}
    SendControlToGroup ( myLandingZone.callsign , landingSite , true )
	if  Debugging == true then printDebug ( "Commands" ,  myLandingZone.callsign .. " has landed"  , 10 ) end
 end

--- FLY AI TO AN AIRPORT AND LAND
function doLandAtAirport(myGroup, mySpawn , myPush )
	--if Debugging == true then printDebug ( "EventHandler" , myGroup  .. " Needs to land" , 10 ) end 
    landingSpot = landingSpot + 1
	local myRamp = {}
	myRamp.speed = doConvertKnotsToMetersPerSec ( mySpawn.speed )  -- CONVERT KNOTS TO MPS
	
	if mySpawn.zone ~= nil then -- IS THE ZONE A SPAWNING LOCATION GROUP OVERRIDES
		--if Debugging == true then printDebug ( "EventHandler" , myGroup  .. " is heading to land at " .. mySpawn.airfield  .. " via zone " .. mySpawn.zone , 10 ) end 
		myVec3Zone = centerZoneCoordinates(mySpawn.zone)
		myRamp.x = myVec3Zone.x
		myRamp.y = myVec3Zone.z
	end
	if mySpawn.group ~= ni then -- DOES THE GROUP CONTAIN A SPAWING LOCATION
			 myVec3Zone = centerUnitCoordinates ( mySpawn.group )
			-- myVec3Zone.y = myVec3Zone.z
			 myRamp.y = myVec3Zone.z
			 myRamp.x = myVec3Zone.x
			--if Debugging == true then printDebug ( "EventHandler" , myGroup  .. " is heading to land at " .. mySpawn.airfield  .. "via group " .. mySpawn.group , 10 ) end 
	end
	
	--local myMetersPerSecond = (mySpeed * 0.514444) * 1.081081081  -- convert to meters per second from knots
	-- landingSpot = landingSpot + 1	
	if (landingSpot > 3 ) then -- we have filled our spots
		landingSpot = 1 -- reset the landing spots
	end
	local myTask = { 
		id = 'Mission', 
	   params = { 
	   
	    ["modulation"] = 0,
                                ["tasks"] = 
                                {
                                }, -- end of ["tasks"]
                                ["radioSet"] = false,
                                ["task"] = "Transport",
                                ["uncontrolled"] = false,
								--taskSelected = true ,
		 route = { 
		   points = { 
		  [1] = 
                                        {
                                            ["alt"] = myGroup.alt ,
                                            ["action"] = "Landing",
                                            ["alt_type"] = "BARO",
                                            ["linkUnit"] = 2 ,
                                            ["helipadId"] =  2 ,
                                            ["speed"] = 41.666666666667,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Land",
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = true,
                                            ["y"] = myVec3Zone.z,
                                            ["x"] = myVec3Zone.x,
                                            ["name"] = "DictKey_WptName_8",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
                                        }, -- end of [1]
		   } 
		 }, 
	   } 
	 } 
	SendControlToGroup ( myGroup , myTask , myPush )
 end 

function doUnitLandClosestAirfield ( input ) -- TOOLBOX ROUTINE
	
	local myPosition = centerUnitCoordinates (input.unit)
	local myAirport = {}
	if input.notcoalition ~= nil then 
		myAirport = findClosestAirbase ({position=myPosition ,notcoalition=input.coalition })
	elseif input.coalition ~= nil then 
		myAirport = findClosestAirbase ({position=myPosition ,coalition=input.coalition })
	elseif input.airbase ~= nil then 
		myAirport = getAirbaseByID(input.airbase)
	else 
		myAirport = findClosestAirbase ({position=myPosition })
	end 
	
	if input.speed == nil then input.speed = 52 end
	if input.alt == nil then input.alt = myAirport.alt_meters+304  end
	
	--if Debugging == true then printDebug ("EventHandler" ,  "Direct AI " .. input.unit .. " to fly to airbase " .. myAirport.name .. " at " .. input.alt , 10 ) end 
	
	local myTask = { 
		id = 'Mission', 
	   params = { 
	   
	    ["modulation"] = 0,
                                ["tasks"] = 
                                {
                                }, -- end of ["tasks"]
                                ["radioSet"] = false,
                                ["task"] = "Transport",
                                ["uncontrolled"] = false,
								--taskSelected = true ,
		 route = { 
		   points = { 
		  [1] = 
                                        {
                                           -- ["alt"] = myAirport.alt_meters+304 ,
											["alt"] = input.alt ,
                                            ["action"] = "Landing",
                                            ["alt_type"] = "BARO",
                                            ["linkUnit"] = 2 ,
                                            ["helipadId"] =  2 ,
                                            ["speed"] = input.speed ,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Land",
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = true,
                                            ["y"] = myAirport.point.z,
                                            ["x"] = myAirport.point.x,
                                            ["name"] = "DictKey_WptName_8",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
                                        }, -- end of [1]
		   } 
		 }, 
	   } 
	 } 
	 
	SendControlToUnit ( input.unit , myTask , true )

 end

function delayRampSpawn (myCallSign , myAirField)
	local myLivery = string.sub(myCallSign, 1 , 3 )
	local myGroup = Group.getByName(myCallSign)
	local myUnit = Unit.getByName(myCallSign)
	local myAircraftLivery = "Clean"
	printThis ( "Delay Ramp Callsign: " .. LiveryTable727[myLivery],  10 )
	local myAircraftType = myUnit:getTypeName() 
	printThis ( "Delay Ramp Type: " .. myAircraftType,  10 )
	local centerTriggerZone = myUnit:getPosition()
	if (myAircraftType == "B_727" ) then  myAircraftLivery = LiveryTable727[myLivery] else myAircraftLivery = LiveryTable737[myLivery] end
	--centerTriggerZone = centerZoneCoordinates("Departing Aircraft Zone") --find the center of the zone
	parkingSpot = 2 
	printThis ( "Find Trigger Zone: " .. myAircraftType,  10 )
	deactivateThisGroup = createParkedAircraft ( myCallSign, myAircraftType, myAircraftLivery,  0, parkingSpot, centerTriggerZone , myAirField  , "Hot", "9000" )
	--deactivateThisGroup = createParkedAircraft(myCallSign, myAircraftType, "Tango",  0 , parkingSpot , centerTriggerZone , myAirField , "Hot" , "9000" )
	printThis ( "Activate Group: " .. myAircraftType,  10 )
	coalition.addGroup(country.id.USA, Group.Category.AIRPLANE, myAircraft) -- SPAWN THE Group
  end
 
function doGoAround (myCallSign,myPush, myZone , myAlt , mySpeed )
	local myLivery = string.sub(myCallSign, 1 , 3 )
	local myGroup = Group.getByName(myCallSign)
	local myUnit = Unit.getByName(myCallSign)
	local myAircraftLivery = "Clean"
	local myLocalGroupPoint = myUnit:getPoint()
	local myAircraftType = myUnit:getTypeName() 

	--local myZone = myUnit:getPosition()
	local myHeading = myUnit:getPosition().p
	local myAlt = getAGL(myCallSign) 



	local centerTriggerZone = myUnit:getPoint()

	if (myAircraftType == "B_727" ) then  myAircraftLivery = LiveryTable727[myLivery] else myAircraftLivery = LiveryTable737[myLivery] end

	-- trigger.action.deactivateGroup(myGroup)
	-- deactivateThisGroup =  createAirborneAircraft ( myCallSign, myAircraftType, myAircraftLivery, 10 , centerTriggerZone , myHeading , myAlt + 5000 , 180 )
	-- --deactivateThisGroup = createParkedAircraft(myCallSign, myAircraftType, "Tango",  0 , parkingSpot , myZone , airfield , "Hot" , "9000" )
	-- coalition.addGroup(country.id.USA, Group.Category.AIRPLANE, myAircraft) -- SPAWN THE Grou
	-- SendControlToGroup ( myGroup , myTask , myPush )
  end
---------------
-- SPAWING --
---------------
 -- CREATE AIRCRAFT SPAWN
function createAircraftSpawn (mySpawn)
if Debugging == true then printDebug("Spawning" , "Building Aircraft Spawn" , 10 ) end


currentTakeoffActivate = currentTakeoffActivate + 1 
local mySpeed  = doConvertKnotsToMetersPerSec ( mySpawn.speed ) 

if mySpawn.lateActivation ~= nil then 
	myLateActivation = mySpawn.lateActivation
else
	myLateActivation = false
end
if mySpawn.zone ~= nil then -- IS THE ZONE A SPAWNING LOCATION GROUP OVERRIDES
	if Debugging == true then printDebug ( "Spawning" , mySpawn.callsign  .. " is spawning in zone " .. mySpawn.zone .. " at " .. mySpawn.speed .. " MPS", 10 ) end 
	myVec3Zone = centerZoneCoordinates(mySpawn.zone)
	if mySpawn.offset ~= nil then -- should we spawn just off center
		if Debugging == true then printDebug ( "Spawning" , mySpawn.callsign  .. " is spawning offset center zone by: " .. mySpawn.offset , 10 ) end 
		myVec3Zone.x = myVec3Zone.x + mySpawn.offset
		myVec3Zone.z = myVec3Zone.z + mySpawn.offset
	end
end
if mySpawn.group ~= nil then -- DOES THE GROUP CONTAIN A SPAWING LOCATION
		 myVec3Zone = centerUnitCoordinates ( mySpawn.group )
		 myVec3Zone.y = myVec3Zone.z
		if Debugging == true then printDebug ( "Spawning" , mySpawn.callsign  .. " is spawning over group " .. mySpawn.group .. " at " .. mySpawn.speed .. " MPS", 10 ) end 
end

if mySpawn.position ~= nil then -- DOES THE GROUP CONTAIN A SPAWING LOCATION
		 myVec3Zone = mySpawn.position
		if Debugging == true then printDebug ( "Spawning" , mySpawn.callsign  .. " is spawning at position X: " .. myVec3Zone.x .. " Z: " .. myVec3Zone.z .. " at " .. mySpawn.speed .. " MPS", 10 ) end 
end

if mySpawn.livery == nil then mySpawn.livery = "" end

local myRamp = {}
if Debugging == true then printDebug("Spawning" , "Spawing: " .. mySpawn.callsign .. " " .. mySpawn.transport .. " " .. mySpawn.vehicletype .. " " .. mySpawn.livery  .. string.format(" Heading: %d", mySpawn.heading)   , 10 ) end
	if string.match(mySpawn.spawnFrom, "TakeOff") then -- match mySpawn.spawnFrom == "TakeOffParkingHot" or mySpawn.spawnFrom == "TakeOff" then  
		if Debugging == true then printDebug("Spawning" , "Spawning on the ground" , 10 ) end
		if ( mySpawn.transport == "Helicopter" ) then -- its a helo
			if Debugging == true then printDebug("Spawning" , "Spawning a rotary wing from " .. mySpawn.spawnFrom , 10 ) end
			 myRamp = {
														--["action"] = "From Ground Area Hot",
														["alt"] = mySpawn.alt * 0.3048  ,
														["alt_type"] =  mySpawn.altType,												
														["type"] = mySpawn.spawnFrom ,
														["ETA"] = 0,
														["ETA_locked"] = true,
														["name"] = "DictKey_WptName_29",
														["formation_template"] = "",
														-- ["linkUnit"] = mySpawn.airfield ,
														-- ["helipadId"] = mySpawn.airfield ,
														--["airdromeId"] = airfield ,
														["speed_locked"] = true,
													} -- end of myParking
													
													-- if ( tonumber(mySpawn.airfield) < 10  ) then
														-- myRamp.linkUnit = mySpawn.airfield 
														-- myRamp.helipadId = mySpawn.airfield 
														-- if Debugging == true then printDebug("EventHandler" , "Spawning Frow Ship:" .. mySpawn.airfield  .. " in helipadID " .. mySpawn.airfield , 10 ) end
													-- elseif (string.match(mySpawn.spawnFrom, "TakeOffGround")) then
														-- if Debugging == true then printDebug("Spawning" , "Spawning off airport " , 10 ) end
													-- else
														-- myRamp.airdromeId = airfield
														-- if Debugging == true then printDebug("Spawning" , "Spawning From Airport: " .. mySpawn.airfield  .. " in parking " .. parkingMap[mySpawn.parking] , 10 ) end
													-- end
													
														
			else  -- its an airplane
				if Debugging == true then printDebug("Spawning" , "Spawning a fixed wing " .. mySpawn.spawnFrom , 10 ) end											
				 myRamp = {
															--["action"] = "From Parking Hot",
															["alt"] = mySpawn.alt * 0.3048  ,
															["alt_type"] = mySpawn.altType,
															["type"] = mySpawn.spawnFrom ,
															["ETA"] = 0,
															["ETA_locked"] = true,
															["name"] = "DictKey_WptName_29",
															["formation_template"] = "",
														--	["airdromeId"] = mySpawn.airfield ,
															["speed_locked"] = true,
														} -- end of myParking
			--	if Debugging == true then printDebug("Spawning" , "Spawning From Airport" .. mySpawn.airfield  .. " in parking " .. parkingMap[mySpawn.parking] , 10 ) end
			end 
			
		-- DOES THE SPAWN HAPPEN FROM A SHIP or FARP?
		--if ( tonumber(mySpawn.airfield) > 1000  ) or ( tonumber(mySpawn.airfield) < 10  ) then
		local myAirbaseObj = getAirbaseByID(mySpawn.airfield)
		--local myAirbaseDesc = Airbase.getDescByName(myAirbaseObj.name)
		if ( myAirbaseObj.category == 2 or  myAirbaseObj.category == 1 )  then		
--		if ( tonumber(mySpawn.airfield) > 1000  )  then
			myRamp.linkUnit = mySpawn.airfield 
			myRamp.helipadId = mySpawn.airfield 
			--myRamp.action = "From Runway"
			if Debugging == true then printDebug("Spawning" , "Spawning From Ship:" .. mySpawn.airfield  .. " in helipadID " .. mySpawn.airfield , 10 ) end
		elseif (string.match(mySpawn.spawnFrom, "TakeOffGround")) then
			if Debugging == true then printDebug("Spawning" , "Spawning off airport " , 10 ) end
		else
			myRamp.airdromeId = mySpawn.airfield
			--if Debugging == true then printDebug("Spawning" , "Spawning From Airport: " .. mySpawn.airfield  .. " in parking " .. parkingMap[mySpawn.parking] , 10 ) end
			if Debugging == true then printDebug("Spawning" , "Spawning From Airport: " .. mySpawn.airfield  , 10 ) end
		end
													
													
	else -- its airborne spawn

		myRamp = {      
                                            --["action"] = "Fly Over Point",
											--["action"] = "Turning Point",
											["alt"] = mySpawn.alt * 0.3048  ,
											["alt_type"] = mySpawn.altType ,
                                            ["speed"] = mySpeed,
											["task"] = { ["id"] = "ComboTask", ["params"] = { ["tasks"] = mySpawn.tasks ,},  },
                                            ["type"] = "Turning Point",
											--["type"] = mySpawn.spawnFrom ,
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = true,
											["y"] = myVec3Zone.z,
											["x"] = myVec3Zone.x,
                                            ["name"] = mySpawn.callsign .. " Spawn Point",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
		
		} -- starting with ramp spawn empty
		if Debugging == true then printDebug("Spawning" , "Spawning from the air "  , 10 ) end
	end 
	
-- FIGURE OUT ACTION TYPE
-- "TakeOffParkingHot" -- TakeOffParkingHot --TakeOffParking --TakeOff --Airborne --TakeOffGroundHot
myRamp.action = "Turning Point" -- DEFAULT TURNING POINT
local myPSIheading = (mySpawn.heading  * math.pi/180 ) * -1 
if mySpawn.spawnFrom  == "TakeOffParkingHot" then 
	myRamp.action = "From Parking Hot"
	myPSIheading = 0
elseif mySpawn.spawnFrom  == "TakeOffParking" then
	myRamp.action = "From Parking Area"
	myPSIheading = 0
elseif mySpawn.spawnFrom  == "TakeOffGroundHot" then
	myRamp.action = "From Ground Area Hot" 
elseif mySpawn.spawnFrom  == "TakeOff" then
	myRamp.action = "From Runway" 
	myPSIheading = 0
end

-- create a waypoint to fly to
local myWayPointPos = getPointOnRadian ( { diameter=1609344 , pos=myVec3Zone , angle = ( mySpawn.heading * math.pi/180) } ) -- get a point on radian converting bearing to radian
--local myWayPointPos = getPointOnRadian ( { diameter=10 , pos=myVec3Zone , angle = 0 } ) -- get a point on radian converting bearing to radian
local myWayPoint = {   -- create a waypoint   
                                            -- ["action"] = "Turning Point",
											-- ["alt"] = mySpawn.alt * 0.3048  ,
											-- ["alt_type"] = mySpawn.altType ,
                                            -- ["speed"] = mySpeed,
											-- ["type"] =  "Turning Point",
                                            -- ["ETA"] = 0,
                                            -- ["ETA_locked"] = true,
											-- ["y"] = myWayPointPos.z,
											-- ["x"] = myWayPointPos.x,
                                            -- ["name"] = mySpawn.callsign .. " Way Point",
                                            -- ["formation_template"] = "",
                                            -- ["speed_locked"] = true,
											["alt"] = mySpawn.alt * 0.3048,
                                            ["action"] = "Turning Point",
                                            ["alt_type"] = "BARO",
                                            ["speed"] = mySpeed,
											["task"] = { ["id"] = "ComboTask", ["params"] = { ["tasks"] = mySpawn.tasks ,},  },
                                            ["type"] = "Turning Point",
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = false,
                                            ["y"] = myWayPointPos.z, 
                                            ["x"] = myWayPointPos.x ,
                                            ["name"] = mySpawn.callsign .. " Way Point",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
		} -- starting with ramp spawn empty

-- CREATE THE UNITS ---
--- FIGURE OUT WHAT PARKING Space
local myParkingMap = {}
if mySpawn.spawnFrom ==  "TakeOffParkingHot" or  mySpawn.spawnFrom == "TakeOffParking"  then --need to add and actual spcified parking space overrides it
	myParkingMap = getParkingClosestToActive ({ type=104 , airfield=mySpawn.airfield })
end	
		
		
local myUnitObj = {}
for key,value in pairs(mySpawn.units) do -- LOOP THROUGH ANY UNITS
		--if Debugging == true then printDebug ( "EventHandler" , "Parking Space " .. mySpawn.units[key].parking, 10 ) end 
		if (mySpawn.units[key].offset == nil ) then -- if offset not included don't spawn on top of each other
			mySpawn.units[key].offset = {}
			mySpawn.units[key].offset.z = 20*#myUnitObj
			mySpawn.units[key].offset.x = 20*#myUnitObj
			if Debugging == true then printDebug("Spawning" , "No unit offset included. Making one up", 10 ) end
		end
		
		local myParkingID = ""
		local myParking = tostring(myParkingMap[#myUnitObj+1]) -- GET THE NEXT SPACE IN THE ARRAY
		if mySpawn.units[key].parking ~= nil then -- the parking space has been specified
			myParkingID = mySpawn.units[key].parking
			myParking = tonumber(mySpawn.units[key].parking )		
			if Debugging == true then printDebug ( "Spawning" , "Override Parking Space lookup for: " .. myParkingID, 10 ) end 
		else
			if Debugging == true then printDebug ( "Spawning" , "ParkingID: " .. myParkingID .. " Parking: " .. myParking .. " Alt: " .. mySpawn.units[key].alt , 10 ) end
		end

 
		
		myUnitObj[#myUnitObj+1] = { 
			alt = mySpawn.units[key].alt * 0.3048  ,
			hardpoint_racks = mySpawn.units[key].hardpoints ,
			alt_type = mySpawn.units[key].altType ,
			livery_id = mySpawn.units[key].livery ,
			skill = mySpawn.units[key].skill ,
			parking_landing_id = LandingMap[mySpawn.units[key].parking] ,
			parking = myParking ,
			-- parking =  tonumber(mySpawn.units[key].parking ),
			parking_id = myParkingID,
			--parking_id = mySpawn.units[key].parking ,
			-- AddPropAircraft = {["OuterBoard"] = 0,["InnerBoard"] = 0,}, 
			speed = mySpeed,
			type = mySpawn.units[key].vehicletype ,
			--unitId = 1 ,
			psi = myPSIheading ,
			--psi = ( mySpawn.units[key].heading  * math.pi/180 ) * -1 ,
			-- ["y"] = myZone.z,
			-- ["x"] = myZone.x,
			y = myVec3Zone.z+mySpawn.units[key].offset.z,
			x = myVec3Zone.x+mySpawn.units[key].offset.x,
			
			name = mySpawn.units[key].callsign  ,

			payload = mySpawn.units[key].payload ,
			--heading = mySpawn.units[key].heading * math.pi/180 ,
			--heading = ( mySpawn.units[key].heading  * math.pi/180 ) * -1 ,
			heading = myPSIheading ,
			callsign = 
			{
				[1] = 1,
				[2] = 1,
				[3] = 1,
				["name"] = mySpawn.units[key].callsign ,
			}, -- end of ["callsign"]
			onboard_num = "0" .. currentTakeoffActivate .. #myUnitObj ,
			-- ["onboard_num"] = "010",
			-- heading = mySpawn.units[key].heading / 180 * math.pi ,

		} -- end of [1]
	if Debugging == true then printDebug ( "Spawning" , "Building Unit Number " .. key .. ": " .. myUnitObj[key].name .. " psi: " .. myUnitObj[key].psi  , 10 ) end 

end

	local myGroupCreated = {
								  ["modulation"] = 0,
									["tasks"] = 
									{
									}, -- end of ["tasks"]
									["radioSet"] = false,
									["task"] = mySpawn.task ,
									["lateActivation"] = myLateActivation ,
									["uncontrolled"] = false,
									["taskSelected"] = true,
									["route"] = {["points"] = { [1] = {} , [2] = {} },}, -- end of ["route"]
									["groupId"] = currentTakeoffActivate,
									["hidden"] = false,
									["units"] = myUnitObj ,
									["y"] = myVec3Zone.z,
									["x"] = myVec3Zone.x,
									["name"] = mySpawn.callsign ,
									["communication"] = true,
									["start_time"] = mySpawn.starttime,
									["frequency"] = 251,
	} -- end of [1]
	myGroupCreated.route.points[1] = myRamp
	myGroupCreated.route.points[2] = myWayPoint
	
	if Debugging == true then printDebug("Spawning" , "Spawn Successfully Built for " .. mySpawn.callsign .. " Action " .. myRamp.action , 10 ) end
	
-- deReference ( myGroupCreated )
	
	return myGroupCreated --return the group to the calling function
end

-- CREATE GROUND SPAWN
function createGroundSpawn (mySpawn, myZone )
local myLateActivation = true
if Debugging == true then printDebug("Spawning" , "Building Ground Spawn" , 10 ) end
currentTakeoffActivate = currentTakeoffActivate + 1 

if Debugging == true then printDebug("Spawning" , "Spawing: " .. mySpawn.callsign .. " " .. mySpawn.transport .. " " .. mySpawn.vehicletype .. " " .. mySpawn.livery  .. string.format(" Heading:%d", mySpawn.heading)   , 10 ) end
if Debugging == true then printDebug("Spawning" , "Spawning Dir Coordinates: " .. mySpawn.heading / 180 * math.pi  , 10 ) end 

if mySpawn.lateActivation ~= nil then 
	myLateActivation = mySpawn.lateActivation
else
	myLateActivation = false
end


local myUnitObj = {}
for key,value in pairs(mySpawn.units) do
		if Debugging == true then printDebug("Spawing" , "Spawning Unit heading of: " .. mySpawn.units[key].heading , 10 ) end 
		if (mySpawn.units[key].offset == nil ) then
			mySpawn.units[key].offset = {}
			mySpawn.units[key].offset.z = 20*#myUnitObj
			mySpawn.units[key].offset.x = 20*#myUnitObj
			if Debugging == true then printDebug("Spawning" , "No offset included. Making one up", 10 ) end
		end
		
		myUnitObj[#myUnitObj+1] = { 
			-- alt = mySpawn.alt * 0.3048  ,
            -- alt_type = mySpawn.altType ,
			type = mySpawn.units[key].vehicletype ,
			transportable = {["randomTransportable"] = false, }, -- end of ["transportable"]
			unitId= key ,
			skill = mySpawn.units[key].skill , 
			y = myZone.z + mySpawn.units[key].offset.z ,
			x = myZone.x + mySpawn.units[key].offset.x ,
			name = mySpawn.units[key].callsign ,
			heading = ( mySpawn.units[key].heading  * math.pi/180 ) ,
			--heading = mySpawn.units[key].heading ,
			--psi = mySpawn.units[key].heading ,
			--psi = ( mySpawn.units[key].heading  * math.pi/180 ) * -1 ,
			playerCanDrive = true,
			-- callsign = 
											-- {
												-- [1] = 1,
												-- [2] = 1,
												-- [3] = 1,
												-- ["name"] = mySpawn.units[key].callsign ,
											-- }, -- end of ["callsign"]
	}
	
	if mySpawn.units[key].modulation ~= nil then myUnitObj[#myUnitObj].modulation = mySpawn.units[key].modulation end
	if mySpawn.units[key].frequency ~= nil then myUnitObj[#myUnitObj].frequency = mySpawn.units[key].frequency end
	
	if Debugging == true then printDebug ( "Spawning" , "Building unit number " .. key .. ": " .. myUnitObj[key].name , 10 ) end 
end

local myTasks = {}
if mySpawn.tasks ~= nil then myTasks = mySpawn.tasks end 

myBuiltSpawn = {
	["visible"] = false,
	["lateActivation"] = myLateActivation ,
	["taskSelected"] = true,
	["uncontrollable"] = false,
	["task"] = "Ground Nothing",
	["route"] = 
	{["points"] = { }, -- end of ["points"]
	}, -- end of ["route"]
	-- ["groupId"] = currentTakeoffActivate,
	-- ["groupId"] = currentTakeoffActivate,
	["tasks"] = myTasks , -- end of ["tasks"]
	["hidden"] = false,
	["units"] = myUnitObj ,
	["y"] = myZone.z,
	["x"] = myZone.x,
	["name"] = mySpawn.callsign ,
	["start_time"] = mySpawn.starttime ,
	--["task"] = myTask ,
  } -- end of [1]
  
 -- if mySpawn.tasks == nil then myInitalPoint.task =  {["id"] = "ComboTask",["params"] = {["tasks"] = {},},} else myInitalPoint.task =  {["id"] = "ComboTask",["params"] = {["tasks"] = mySpawn.tasks,},}  end
  
	if Debugging == true then printDebug("Spawning" , "Spawn Completed for " .. mySpawn.callsign , 10 ) end
	-- deReference ( myBuiltSpawn )	
	return myBuiltSpawn
	

end -- end create ground
--------------------
-- SPAWN Controller FOR ANY TYPE (AIRCRAFT, GROUND, SHIP, )
--------------------
function doBuildSpawn ( mySpawn )
--currentTakeoffActivate = currentTakeoffActivate + 1
if mySpawnCount == nil then mySpawnCount = 1 else 
	mySpawnCount = mySpawnCount + 1 

end
if Debugging == true then printDebug ( "Spawning" , "Current Spawn Count = " .. mySpawnCount , 10 ) end 
if gUnitCount == nil then
	gUnitCount = 19999
end 
gUnitCount = gUnitCount + 1

gSpawnCount = mySpawnCount


local myKNOTS=1.9438444924406046
local myMILES=0.000621371
local myFEET=3.28084
local myKnotsToMPS= 0.5144444444444445
local myFeetToMeters = 0.3048
---------------------
-- GROUP INFO 
---------------------
-- SET UNIVERSAL DEFAULTS
local myGroup = {}
if mySpawn.lateActivation == nil then myGroup.lateActivation = false else myGroup.lateActivation = mySpawn.lateActivation end
if mySpawn.groupTasks == nil then myGroup.tasks = {} else myGroup.groupTasks = mySpawn.groupTasks end
if mySpawn.groupId ~= nil then myGroup.groupId = mySpawn.groupId end
if mySpawn.hidden == nil then myGroup.hidden = false else myGroup.hidden = mySpawn.hidden end
if mySpawn.name == nil then myGroup.name = "Group: " .. mySpawnCount else myGroup.name = mySpawn.name end
if mySpawn.start_time == nil then myGroup.start_time = 0 else myGroup.start_time = mySpawn.start_time end

--- FIND CORRECT SPAWN LOCATION
local myVec3Zone = {}
if mySpawn.zone ~= nil then -- IS THE ZONE A SPAWNING LOCATION GROUP OVERRIDES
	if Debugging == true then printDebug ( "Spawning" , myGroup.name  .. " is spawning in zone " .. mySpawn.zone , 10 ) end 
	 myVec3Zone = centerZoneCoordinates(mySpawn.zone)
end
if mySpawn.group ~= nil then -- DOES THE GROUP CONTAIN A SPAWING LOCATION
		local myUnits = Group.getUnits(Group.getByName(mySpawn.group))
		 myVec3Zone = centerUnitCoordinates ( myUnits[1]:getName()  )
		 myVec3Zone.y = myVec3Zone.z
		if Debugging == true then printDebug ( "Spawning" , myGroup.name  .. " is spawning over group " .. mySpawn.group , 10 ) end 
end

if mySpawn.position ~= nil then -- HAS THE POSITION BE SPECIFIED
		 myVec3Zone = mySpawn.position
		if Debugging == true then printDebug ( "Spawning" , myGroup.name  .. " is spawning at position X: " .. myVec3Zone.x .. " Z: " .. myVec3Zone.z , 10 ) end 
end
if mySpawn.position == nil and mySpawn.group == nil and mySpawn.zone == nil then 
	myVec3Zone.z = 617813.60743464
	myVec3Zone.x = -355842.97690747
	if Debugging == true then printDebug ( "Spawning" , myGroup.name  .. " No position specified so I made one up at X: " .. myVec3Zone.x .. " Z: " .. myVec3Zone.z , 10 ) end 
end 

myGroup.y = myVec3Zone.z -- 617813.60743464
myGroup.x = myVec3Zone.x ---355842.97690747
--if Debugging == true then  printDebug ( "Spawning" , "Created a Group named " .. myGroup.name , 10 ) end
---------------------
--- INITIAL SPAWN POINTS
------------------------
-- SET UNIVERSAL DEFAULTS INITIAL SPAWN POINTS
local myInitalPoint = {}
if mySpawn.ETA == nil then myInitalPoint.ETA = 0 else myInitalPoint.ETA = mySpawn.ETA end
if mySpawn.ETA_locked == nil then myInitalPoint.ETA_locked = true else myInitalPoint.ETA_locked = mySpawn.ETA_locked end
-- if mySpawn.name == nil then myInitalPoint.name = tostring(math.random(1,100)) else myInitalPoint.name = mySpawn.name end
if mySpawn.formation_template == nil then myInitalPoint.formation_template = "" else myInitalPoint.formation_template = mySpawn.formation_template end
if mySpawn.uncontrollable == nil then myGroup.uncontrollable = true else myGroup.uncontrollable = mySpawn.uncontrollable end
if mySpawn.tasks == nil then 
	myInitalPoint.task =  {["id"] = "ComboTask",["params"] = {["tasks"] = {},},} 
else 
	myInitalPoint.task =  {["id"] = "ComboTask",["params"] = {["tasks"] = mySpawn.tasks,},}  
end
if mySpawn.alt_type == nil then myInitalPoint.alt_type = "BARO" else myInitalPoint.alt_type = mySpawn.alt_type end
if mySpawn.speed_locked == nil then myInitalPoint.speed_locked = true else myInitalPoint.speed_locked = mySpawn.speed_locked end
if mySpawn.alt == nil then myInitalPoint.alt = 1000 else myInitalPoint.alt = mySpawn.alt  end
myInitalPoint.y = myGroup.y
myInitalPoint.x = myGroup.x 
myInitalPoint.name = myGroup.name .. " Spawn Point"


-- SPAWN AIRCRAFT LAND OR SEA TYPE DIFFERENCES 
--SET AIRCRAFT SPECIFIC DEFAULTS IF SPAWN TYPE NOT SPECIFIED GETS AIRBORNE SPAWN
if ( mySpawn.spawn_type == Group.Category.AIRPLANE or mySpawn.spawn_type == Group.Category.HELICOPTER or mySpawn.spawn_type == nil ) then 
	if Debugging == true then  printDebug ( "Spawning" , myGroup.name .. " is an aircraft type group" , 10 ) end
	--if Debugging == true and mySpawn.spawn_type == nil then  printDebug ( "EventHandler" , "Spawn Type is missing " , 10 ) end
	-- GROUP VARIABLES
	if mySpawn.modulation == nil then myGroup.modulation = 0 else myGroup.modulation = mySpawn.modulation end
	if mySpawn.task == nil then myGroup.task = "Fighter Sweep" else myGroup.task = mySpawn.task end
	if mySpawn.taskSelected == nil then myGroup.taskSelected = true else myGroup.taskSelected = mySpawn.taskSelected end
	if mySpawn.uncontrolled == nil then myGroup.uncontrolled = false else myGroup.uncontrolled = mySpawn.uncontrolled end
	if mySpawn.communication == nil then myGroup.communication = true else myGroup.communication = mySpawn.communication end
	if mySpawn.frequency == nil then myGroup.frequency = 124 + mySpawnCount else myGroup.frequency = mySpawn.frequency end
	if mySpawn.radioSet == nil then myGroup.radioSet = true else myGroup.radioSet = mySpawn.radioSet end
	-- INITAL POINT VARIABLES
	
	
	-- ACTION  IS BASED ON SPAWN FROM
	if mySpawn.spawnFrom == nil or mySpawn.spawnFrom == "Turning Point" then -- nothing specified spawn airborne
		mySpawn.spawnFrom = "Turning Point" -- make it turning point in case mising
		myInitalPoint.action = "Turning Point"
	elseif mySpawn.spawnFrom == "TakeOffParkingHot" then
		myInitalPoint.action = "From Parking Area Hot"
	elseif mySpawn.spawnFrom == "TakeOffParking" then
		myInitalPoint.action = "From Parking Area"
	elseif mySpawn.spawnFrom == "TakeOff" then
		myInitalPoint.action = "From Runway"
	elseif mySpawn.spawnFrom == "Land" then
		myInitalPoint.action = "Landing"
	elseif mySpawn.spawnFrom == "TakeOffGround" then
		myInitalPoint.action = "From Ground Area"
	elseif mySpawn.spawnFrom == "TakeOffGroundHot" then
		myInitalPoint.action = "From Ground Area Hot"
	else -- its the wrong type so it gets airborne
		mySpawn.spawnFrom = "Turning Point" -- make it turning point in case mising
		myInitalPoint.action = "Turning Point"
	end
	myInitalPoint.type = mySpawn.spawnFrom
	
	
	if mySpawn.speed == nil then myInitalPoint.speed = 125 else myInitalPoint.speed = mySpawn.speed end
	if mySpawn.airfield ~= nil then
		local myAirbaseObj = getAirbaseByID(mySpawn.airfield)
		if ( myAirbaseObj.category == 2 or  myAirbaseObj.category == 1 )  then	--is this airfield helipad or ship
			myInitalPoint.linkUnit = mySpawn.airfield 
			myInitalPoint.helipadId = mySpawn.airfield 
			if Debugging == true then  printDebug ( "Spawning" , myGroup.name .. " is spawning on ship or FARP" , 10 ) end
		else
			myInitalPoint.airdromeId = mySpawn.airfield
			-- if Debugging == true then  printDebug ( "EventHandler" , myGroup.name .. " airfield spawning " .. myInitalPoint.airdromeId , 10 ) end
			--if mySpawn.action ~= "Turning Point" then myGroup.radioSet = false else myGroup.radioSet = mySpawn.radioSet end
		end
	else 
		mySpawn.airfield = 22
		myInitalPoint.airdromeId = mySpawn.airfield

	end
	
else -- ITS A GROUND VEHICLE OR SHIP
	if mySpawn.visible == nil then myGroup.visible = false else myGroup.visible = mySpawn.visible end
	-- if mySpawn.uncontrollable == nil then myGroup.uncontrollable = false else myGroup.uncontrollable = mySpawn.uncontrollable end
	myInitalPoint.alt = 0
	if mySpawn.speed == nil then myInitalPoint.speed = 25 else myInitalPoint.speed = mySpawn.speed end
	--SET GROUND VEHICLE DEFAULTS
	if ( mySpawn.spawn_type == Group.Category.GROUND ) then 
		if mySpawn.task == nil then myGroup.task = "Ground Nothing" else myGroup.task = mySpawn.task end
		if mySpawn.taskSelected == nil then myGroup.taskSelected = true else myGroup.taskSelected = mySpawn.taskSelected end
		myInitalPoint.alt = 0
		if mySpawn.spawnFrom == nil then myInitalPoint.type = "Turning Point" else myInitalPoint.type = mySpawn.spawnFrom end
		if mySpawn.action == nil then myInitalPoint.action = "On Road" else myInitalPoint.action = mySpawn.action end
		if Debugging == true then  printDebug ( "Spawning" , "Creating ground vehicle group named " ..  myGroup.name .. " action " .. myInitalPoint.action , 10 ) end
	end
		--SET SHIP DEFAULTS
	if ( mySpawn.spawn_type == Group.Category.SHIP ) then 
		if mySpawn.alt == nil then myInitalPoint.alt = 0 else myInitalPoint.alt = mySpawn.alt end
		if mySpawn.spawnFrom == nil then myInitalPoint.type = "Turning Point" else myInitalPoint.type = mySpawn.spawnFrom end
		if mySpawn.action == nil then myInitalPoint.action = "Turning Point" else myInitalPoint.action = mySpawn.action end
		if Debugging == true then  printDebug ( "Spawning" , "Creating ship group named " ..  myGroup.name .. " action " .. myInitalPoint.action , 10 ) end
	end
end
myGroup.route = {}
myGroup.route.points = {}
myGroup.route.points[1] = myInitalPoint
---------------------
--- UNITS ------
---------------------
-- THERE WAS NO UNIT SPECIFIED
if mySpawn.units == nil then
	if Debugging == true then printDebug ( "Spawning" , "No Unit Specified so building one" , 10 ) end
	local myMissingUnit = {}
	mySpawn.units = {}
	if mySpawn.name == nil then myMissingUnit.name = "Unit: " .. mySpawnCount else myMissingUnit.name = mySpawn.name end
	if mySpawn.skill == nil then myMissingUnit.skill = "High" else myMissingUnit.skill = mySpawn.skill end
	if mySpawn.heading == nil then myMissingUnit.heading = "0" else myMissingUnit.heading = mySpawn.heading end
	-- if mySpawn.unitId == nil then myMissingUnit.unitId = mySpawnCount else myMissingUnit.unitId = mySpawn.unitId end
	mySpawn.unitId = gUnitCount
	if mySpawn.livery_id == nil then myMissingUnit.livery_id = "Default" else myMissingUnit.livery_id = mySpawn.livery_id end
	if ( mySpawn.spawn_type == Group.Category.AIRPLANE or mySpawn.spawn_type == Group.Category.HELICOPTER or mySpawn.spawn_type == nil ) then  
		if mySpawn.speed == nil then myMissingUnit.speed = 125 else myMissingUnit.speed = mySpawn.speed  end
		if mySpawn.alt == nil then myMissingUnit.alt = 1000 else myMissingUnit.alt = mySpawn.alt  end
		if mySpawn.parking ~= nil then myMissingUnit.parking = mySpawn.parking  end	
		if mySpawn.heavyparking ~= nil then myMissingUnit.heavyparking = mySpawn.heavyparking  end
		if mySpawn.type == nil then myMissingUnit.type = "TF-51D" else myMissingUnit.type = mySpawn.type end
		if mySpawn.parking_landing_id == nil then myMissingUnit.parking_landing_id = "1" else myMissingUnit.parking_landing_id = mySpawn.parking_landing_id end
		if mySpawn.onboard_num == nil then myMissingUnit.onboard_num = "0" .. mySpawnCount  else myMissingUnit.onboard_num = mySpawn.onboard_num end
		--if mySpawn.AddPropAircraft == nil then myMissingUnit.AddPropAircraft = {} else myMissingUnit.AddPropAircraft = mySpawn.AddPropAircraft end
		-- PYLONS AND FUEL 
		--myMissingUnit.payload = {{  ["fuel"] = 0 , ["pylons"] = {}, ["flare"] = 0, ["chaff"] = 0, ["gun"] = 0 } }
		myMissingUnit.payload = {}
		
		if mySpawn.payload ~= nil then myMissingUnit.payload = mySpawn.payload 
		else
			if mySpawn.fuel == nil  then myMissingUnit.payload.fuel = 1000 else myMissingUnit.payload.fuel  = mySpawn.fuel end
			if mySpawn.flare == nil  then myMissingUnit.payload.flare = 200 else myMissingUnit.payload.flare  = mySpawn.flare end
			if mySpawn.chaff == nil  then myMissingUnit.payload.chaff = 200 else myMissingUnit.payload.chaff  = mySpawn.chaff end
			if mySpawn.gun == nil  then myMissingUnit.payload.gun = 100 else myMissingUnit.payload.gun  = mySpawn.gun end
			if mySpawn.pylons == nil then myMissingUnit.payload.pylons = {} else myMissingUnit.payload.pylons  = mySpawn.pylons end
		end 
		-- HELICOPTERS ONLY
		if mySpawn.hardpoint_racks ~= nil then myMissingUnit.hardpoint_racks = mySpawn.hardpoint_racks end
		if mySpawn.ropeLength ~= nil then myMissingUnit.ropeLength = mySpawn.ropeLength end
		if Debugging == true then printDebug ( "Spawning" , "No Unit Specified so we made a default aircraft unit named " .. myMissingUnit.name .. " of " .. myMissingUnit.type , 10 ) end 
		
	elseif mySpawn.spawn_type == Group.Category.GROUND then
		if mySpawn.type == nil then myMissingUnit.type = "M 818" else myMissingUnit.type = mySpawn.type end
		if Debugging == true then printDebug ( "Spawning" , "No Unit Specified so we made a default land unit named " .. myMissingUnit.name .. " of " .. myMissingUnit.type , 10 ) end
	elseif mySpawn.spawn_type == Group.Category.SHIP then
		if mySpawn.type == nil then myMissingUnit.type = "Speedboat" else myMissingUnit.type = mySpawn.type end
		 if mySpawn.alt == nil then myMissingUnit.alt = 0 else myMissingUnit.alt = mySpawn.alt  end
		 if mySpawn.alt_type == nil then myMissingUnit.alt_type = "BARO" else myMissingUnit.alt_type =  mySpawn.alt_type end
		if Debugging == true then printDebug ( "Spawning" , "No Unit Specified so we made a default ship unit named " .. myMissingUnit.name .. " of " .. myMissingUnit.type , 10 ) end
	end
	
	mySpawn.units[1] = myMissingUnit
end

--- WHAT PARKING SPACES ARE AVAILABLE 
local myParkingMap = {}
if mySpawn.spawnFrom ==  "TakeOffParkingHot" or  mySpawn.spawnFrom == "TakeOffParking"  then
	if mySpawn.units[1].spawn_type == nil then
		local myDesc = Unit.getDescByName(mySpawn.units[1].type)
		mySpawn.units[1].spawn_type = myDesc.category
		if Debugging == true then printDebug ("Spawning",  "No spawn type specified  for parking. Looking up for: " .. mySpawn.units[1].type .. " catagory: " .. mySpawn.units[1].spawn_type ,  10 ) end
	end 
	myParkingMap = getParkingClosestToActive ({ type=104 , airfield=mySpawn.airfield , spawn_type=mySpawn.units[1].spawn_type })
end	

-- BUILD THE UNITS OBJECT
local myUnitObj = {}
local myOffset = 0 
local myUnitNumber = 0
for key,value in pairs(mySpawn.units) do -- LOOP THROUGH ANY UNITS
	myUnitNumber = myUnitNumber + 1
	gUnitCount = gUnitCount + 1
	local myBuildingUnit = {}
	-- WHERE SHOULD THEY SPAWN?
	if (mySpawn.units[key].position == nil ) then -- if position not included off set the units
			mySpawn.units[key].position = {}
			mySpawn.units[key].position.z = myGroup.y + myOffset*#myUnitObj
			mySpawn.units[key].position.x = myGroup.x + myOffset*#myUnitObj
			myOffset = myOffset + 30
			if mySpawn.spawn_type == Group.Category.SHIP then myOffset = myOffset + 1000 end 
			if Debugging == true then printDebug("Spawning" , "No unit offset included. Seperating any next units by " .. myOffset .. " meters" , 10 ) end	
	end
	myBuildingUnit.x = mySpawn.units[key].position.x
	myBuildingUnit.y = mySpawn.units[key].position.z
	--if Debugging == true then printDebug("Spawning" , myBuildingUnit.x .. " " .. myBuildingUnit.y , 10 ) end
	-- EVERYONE HAS THESE
	if mySpawn.units[key].name == nil then myBuildingUnit.name = myGroup.name .. " Unit " .. myUnitNumber else myBuildingUnit.name = mySpawn.units[key].name end
	if mySpawn.units[key].skill == nil then myBuildingUnit.skill = "High" else myBuildingUnit.skill = mySpawn.units[key].skill end
	--if mySpawn.units[key].unitId == nil then myBuildingUnit.unitId = myUnitNumber else myBuildingUnit.unitId = mySpawn.units[key].unitId end
	mySpawn.units[key].unitId = gUnitCount 
		-- CALCULATE HEADING
	if mySpawn.units[key].heading == nil and mySpawn.spawn_type ~= Group.Category.GROUND then 
		myBuildingUnit.heading = "3.14" -- HEAD SOUTH IF NO HEADING GIVEN
		myBuildingUnit.psi = "3.14" -- HEAD SOUTH IF NO HEADING GIVEN
	elseif mySpawn.units[key].heading == nil and mySpawn.spawn_type == Group.Category.GROUND then
		myBuildingUnit.heading = "180"
	elseif mySpawn.spawn_type == Group.Category.GROUND then
		myBuildingUnit.heading = mySpawn.units[key].heading
	else 
		local myPSIheading = (mySpawn.units[key].heading  * math.pi/180 ) * -1 --given in degrees convert to radians
		myBuildingUnit.heading = myPSIheading
		myBuildingUnit.psi = myPSIheading
	end

	--if mySpawn.units[key].heading == nil then myBuildingUnit.heading = "0" else myBuildingUnit.heading = mySpawn.units[key].heading end
	-- if mySpawn.units[key].x == nil then myBuildingUnit.x = mySpawn.units[key].position.x else myBuildingUnit.x = mySpawn.units[key].x end
	-- if mySpawn.units[key].z == nil then myBuildingUnit.y = mySpawn.units[key].position.z else myBuildingUnit.y = mySpawn.units[key].z end
	
	-- AIRCRAFT OR IF NO TYPE SPECIFIED WE MAKE IT AN AIRCRAFT
	if ( mySpawn.spawn_type == Group.Category.AIRPLANE or mySpawn.spawn_type == Group.Category.HELICOPTER or mySpawn.spawn_type == nil ) then 
		if mySpawn.units[key].type == nil then myBuildingUnit.type = "TF-51D" else myBuildingUnit.type = mySpawn.units[key].type end
		if mySpawn.units[key].alt == nil then myBuildingUnit.alt = mySpawn.alt else myBuildingUnit.alt = mySpawn.units[key].alt  end
		if mySpawn.units[key].alt_type == nil then myBuildingUnit.alt_type = myInitalPoint.alt_type else myBuildingUnit.alt_type = mySpawn.units[key].alt_type end
		if mySpawn.units[key].speed == nil then myBuildingUnit.speed = mySpawn.speed  else myBuildingUnit.speed = mySpawn.units[key].speed end
		if mySpawn.units[key].livery_id == nil then myBuildingUnit.livery_id = "" else myBuildingUnit.livery_id = mySpawn.units[key].livery_id end
		if mySpawn.units[key].radio ~= nil then myBuildingUnit.Radio = mySpawn.units[key].radio end
		if mySpawn.units[key].AddPropAircraft == nil then myBuildingUnit.AddPropAircraft = {} else myBuildingUnit.AddPropAircraft = mySpawn.units[key].AddPropAircraft end
		--if mySpawn.units[key].payload == nil then myBuildingUnit.payload = {} else myBuildingUnit.payload = mySpawn.units[key].payload end
		if mySpawn.units[key].onboard_num == nil then myBuildingUnit.onboard_num = "0" .. mySpawnCount .. #myUnitObj else myBuildingUnit.onboard_num = mySpawn.units[key].onboard_num end
		-- PYLONS AND FUEL
		--myBuildingUnit.payload = {{  ["fuel"] = 0 , ["pylons"] = {}, ["flare"] = 0, ["chaff"] = 0, ["gun"] = 0 } }
		myBuildingUnit.payload = { }
		if mySpawn.units[key].payload.fuel == nil then myBuildingUnit.payload.fuel = 1000 else myBuildingUnit.payload.fuel  = mySpawn.units[key].payload.fuel end
		if mySpawn.units[key].payload.flare == nil  then myBuildingUnit.payload.flare = 100 else myBuildingUnit.payload.flare  = mySpawn.units[key].payload.flare end
		if mySpawn.units[key].payload.chaff == nil  then myBuildingUnit.payload.chaff = 100 else myBuildingUnit.payload.chaff  = mySpawn.units[key].payload.chaff end
		if mySpawn.units[key].payload.gun == nil  then myBuildingUnit.payload.gun = 100 else myBuildingUnit.payload.gun  = mySpawn.units[key].payload.gun end
		if mySpawn.units[key].payload.ammo_type ~= nil  then myBuildingUnit.payload.ammo_type  = mySpawn.units[key].payload.ammo_type end
		if mySpawn.units[key].payload.pylons == nil  then myBuildingUnit.payload.pylons = {} else myBuildingUnit.payload.pylons  = mySpawn.units[key].payload.pylons end
		-- HELICOPTERS ONLY
		if mySpawn.units[key].hardpoint_racks ~= nil then myBuildingUnit.hardpoint_racks = mySpawn.units[key].hardpoint_racks end
		if mySpawn.units[key].ropeLength ~= nil then myBuildingUnit.ropeLength = mySpawn.units[key].ropeLength end
		
		-- PARKING SPACE AVAILABLE if spawning from parking area
		if mySpawn.spawnFrom ==  "TakeOffParkingHot" or  mySpawn.spawnFrom == "TakeOffParking"  then 

			local myParkingID = ""
			local myParking = tostring(myParkingMap[#myUnitObj+1]) -- GET THE NEXT SPACE IN THE ARRAY

			if mySpawn.units[key].parking ~= nil then -- the parking space has been specified
				myParkingID = mySpawn.units[key].parking
				myParking = tonumber(mySpawn.units[key].parking )		
				if Debugging == true then printDebug ( "Spawning" , "Override Parking Space lookup requested : " .. myParkingID .. " got: " .. myParking .. " for " .. mySpawn.units[key].name , 10 ) end 
			else 
				if Debugging == true then printDebug ( "Spawning" , "Looked up an available parking space " .. myParking .. " for " .. mySpawn.units[key].name , 10 ) end 
			end
			if  mySpawn.units[key].heavyparking == nil then 
				myBuildingUnit.parking = myParking
				if mySpawn.units[key].parking == nil then 
					myBuildingUnit.parking_id = myParkingID
				end
			end
			
			
			-- if Debugging == true then printDebug ( "EventHandler" , "Parking Space " .. myBuildingUnit.parking .. " Parking ID " .. myBuildingUnit.parking , 10 ) end 
		end	
		-- LANDING PARKING SPACE AVAILABLE 
		local myLanding = tostring(myParkingMap[#myUnitObj+2]) -- GET THE NEXT SPACE IN THE ARRAY
		if mySpawn.units[key].parking_landing_id == nil then myBuildingUnit.parking_landing_id = myLanding else myBuildingUnit.parking_landing_id = mySpawn.units[key].parking_landing_id end
		if Debugging == true then printDebug ( "Spawning" , "Landing parking space " .. myBuildingUnit.parking_landing_id , 10 ) end 
		-- CALLSIGN
		myBuildingUnit.callsign =  { [1] = 1,[2] = 1,[3] = #myUnitObj+1, ["name"] = "Enfield1" ..#myUnitObj+1 ,}
	end
	-- GROUND VEHICLE OR SHIP
	if ( mySpawn.spawn_type == Group.Category.GROUND or mySpawn.spawn_type == Group.Category.SHIP ) then
		-- ALL GROUND VEHICLES AND SHIPS GET THIS
		myBuildingUnit.psi = nil -- erase this heading value which was created above since ships and ground don't use it not sure if included will be an issue
		if mySpawn.units[key].transportable == nil then myBuildingUnit.transportable = {["randomTransportable"] = false,} else myBuildingUnit.transportable = mySpawn.units[key].transportable end
		if mySpawn.units[key].livery_id == nil then myBuildingUnit.livery_id = "" else myBuildingUnit.livery_id = mySpawn.units[key].livery_id end
		if ( mySpawn.spawn_type == Group.Category.GROUND) then
			if mySpawn.units[key].playerCanDrive == nil then myBuildingUnit.playerCanDrive = false else myBuildingUnit.playerCanDrive = mySpawn.units[key].playerCanDrive end
			if mySpawn.units[key].type == nil then myBuildingUnit.type = "M 818" else myBuildingUnit.type = mySpawn.units[key].type end
			if mySpawn.units[key].type == "Train" then
				if mySpawn.units[key].wagons == nil then myBuildingUnit.wagons = {[1] = "DRG_Class_86" } else myBuildingUnit.wagons = mySpawn.units[key].wagons end
				if Debugging == true then printDebug ( "Spawning" , "This spawn is a train", 10 ) end 
			end 
		end
		if ( mySpawn.spawn_type == Group.Category.SHIP) then
			myBuildingUnit.heading = math.abs(myBuildingUnit.heading)
			if mySpawn.units[key].alt == nil then myBuildingUnit.alt = 0 else myBuildingUnit.alt = mySpawn.units[key].alt  end
			if mySpawn.units[key].alt_type == nil then myBuildingUnit.alt_type = "BARO" else myBuildingUnit.alt_type = mySpawn.units[key].alt_type end
			if mySpawn.units[key].modulation == nil then myBuildingUnit.modulation = 0 else myBuildingUnit.modulation = mySpawn.units[key].modulation end
			if mySpawn.units[key].frequency == nil then myBuildingUnit.frequency = (126500000 + (1000000*mySpawnCount)) else myBuildingUnit.frequency = mySpawn.units[key].frequency end
			if mySpawn.units[key].type == nil then myBuildingUnit.type = "Speedboat" else myBuildingUnit.type = mySpawn.units[key].type end
		end
	end
	
	if Debugging == true then  printDebug ( "Spawning" , "Created Unit " .. myBuildingUnit.name .. " type " .. myBuildingUnit.type , 10 ) end
	myUnitObj[#myUnitObj+1] = myBuildingUnit
end -- DONE CREATING UNITS
											
myGroup.units = myUnitObj -- ASSIGN THE UNITS TO THE GROUP


-----------------
--- WAYPOINTS ---
-----------------
if mySpawn.waypoints == nil then -- WAYPOINTS WERE PASSED IN SO BUILD ONE SAME VECTOR AS HEADING 
	-- spawn in straight and level
	local myRadianDistance = 2500 
	if ( mySpawn.spawn_type == Group.Category.GROUND ) then myRadianDistance = 50 end -- too large of distance over water for ground causes a hang
	--local myWayPointPos = getPointOnRadian ( { diameter=myRadianDistance , pos=myVec3Zone , angle = (  myGroup.units[1].heading * math.pi/180) } ) -- get a point on radian converting bearing to radian
	local myWayPointPos = getPointOnRadian ( { diameter=myRadianDistance , pos=myVec3Zone , angle = math.abs(myGroup.units[1].heading)   } ) -- get a point on radian converting bearing to radian
	myGroup.route.points[#myGroup.route.points+1] = {   -- create a waypoint   
											["alt"] = myInitalPoint.alt ,
                                            ["action"] = myInitalPoint.action ,
                                            ["alt_type"] = myInitalPoint.alt_type,
                                            ["speed"] = myInitalPoint.speed ,
											["task"] = { ["id"] = "ComboTask", ["params"] = { ["tasks"] = myInitalPoint.tasks ,},  },
                                            ["type"] = "Turning Point",
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = false,
                                            ["y"] = myWayPointPos.z, 
                                            ["x"] = myWayPointPos.x ,
                                            ["name"] = myInitalPoint.name .. " Way Point " .. #myGroup.route.points+1 ,
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
		} -- starting with ramp spawn empty
		if Debugging == true then  printDebug ( "Spawning" , "No Waypoint included so I made one up named " .. myGroup.route.points[#myGroup.route.points].name .. " heading " .. myGroup.units[1].heading , 10 ) end	
		
else -- WAYPOINTS WERE PASSED IN SO BUILD ONE SAME VECTOR AS HEADING 
	for key,value in pairs(mySpawn.waypoints) do 
		local myBuildingWaypoint = {}			
		if mySpawn.waypoints[key].alt == nil then myBuildingWaypoint.alt = myInitalPoint.alt else myBuildingWaypoint.alt = mySpawn.waypoints[key].alt  end
		if mySpawn.waypoints[key].action == nil then myBuildingWaypoint.action = myInitalPoint.action else myBuildingWaypoint.action = mySpawn.waypoints[key].action end
		if mySpawn.waypoints[key].alt_type == nil then myBuildingWaypoint.alt_type = myInitalPoint.alt_type else myBuildingWaypoint.alt_type = mySpawn.waypoints[key].alt_type end
		if mySpawn.waypoints[key].speed == nil then myBuildingWaypoint.speed = myInitalPoint.speed else myBuildingWaypoint.speed = mySpawn.waypoints[key].speed end
		if mySpawn.waypoints[key].task == nil then myBuildingWaypoint.task = myInitalPoint.task else myBuildingWaypoint.task = { ["id"] = "ComboTask", ["params"] = { ["tasks"] = mySpawn.waypoints[key].task ,},  }  end
		if mySpawn.waypoints[key].type == nil then myBuildingWaypoint.type = "Turning Point" else myBuildingWaypoint.type = mySpawn.waypoints[key].type end
		if mySpawn.waypoints[key].ETA == nil then myBuildingWaypoint.ETA = 0 else myBuildingWaypoint.ETA = mySpawn.waypoints[key].ETA end
		if mySpawn.waypoints[key].ETA_locked == nil then myBuildingWaypoint.ETA_locked = false else myBuildingWaypoint.ETA_locked = mySpawn.waypoints[key].ETA_locked end
		if mySpawn.waypoints[key].pos.z == nil then myBuildingWaypoint.y = myWayPointPos.z else myBuildingWaypoint.y = mySpawn.waypoints[key].pos.z end
		if mySpawn.waypoints[key].pos.x == nil then myBuildingWaypoint.x = myWayPointPos.x else myBuildingWaypoint.x = mySpawn.waypoints[key].pos.x end
		if mySpawn.waypoints[key].name == nil then myBuildingWaypoint.name = myInitalPoint.name .. " Way Point " .. #myGroup.route.points+1 else myBuildingWaypoint.name = mySpawn.waypoints[key].name end
		if mySpawn.waypoints[key].formation_template == nil then myBuildingWaypoint.formation_template = "" else myBuildingWaypoint.formation_template = mySpawn.waypoints[key].formation_template end
		if mySpawn.waypoints[key].speed_locked == nil then myBuildingWaypoint.speed_locked = true else myBuildingWaypoint.speed_locked = mySpawn.waypoints[key].speed_locked end
		myGroup.route.points[#myGroup.route.points+1] = myBuildingWaypoint   -- save the waypoint 
		-- WAYPOINT IS TYPE Landing
		if mySpawn.waypoints[key].action == "Landing" then 
			mySpawn.waypoints[key].type = "Land" 
			if mySpawn.waypoints[key].airdromeId ~= nil then mySpawn.waypoints[key].airdromeId = myBuildingWaypoint.airdromeId else mySpawn.waypoints[key].airdromeId =21 end
			-- if Debugging == true then  printDebug ( "EventHandler" , "Landing at waypoint "  .. mySpawn.waypoints[key].type  , 10 ) end	
		end
		if Debugging == true then  printDebug ( "Spawning" , "Added way point " .. myBuildingWaypoint.name .. " Count " .. #myGroup.route.points .. " key " .. key , 10 ) end			
	end
end
 
----------------
-- DO ALL THE METERS and KNOTS CONVERSIONS
----------------
for key,value in pairs(myGroup.route.points) do
	myGroup.route.points[key].alt = myGroup.route.points[key].alt * myFeetToMeters
	myGroup.route.points[key].speed = myGroup.route.points[key].speed * myKnotsToMPS
end
if ( mySpawn.spawn_type == Group.Category.AIRPLANE or mySpawn.spawn_type == Group.Category.HELICOPTER or mySpawn.spawn_type == nil ) then 
	for key,value in pairs(myGroup.units) do
		myGroup.units[key].alt = myGroup.units[key].alt * myFeetToMeters
		myGroup.units[key].speed = myGroup.units[key].speed * myKnotsToMPS
	end
end
if Debugging == true then  printDebug ( "Spawning" , "Group Builder has finished creating the group " .. myGroup.name .. " with " .. # myGroup.units .. " units" , 10 ) end

--deReference ( myGroup )
return myGroup
end

function PreSpawnAircraft (input) -- toolbox function 
	mySpawn = {
                                ["lateActivation"] = input.lateActivation ,
                                ["tasks"] = 
                                {
                                }, -- end of ["tasks"]
                                ["task"] = "Nothing",
                                ["uncontrolled"] = false,
                                ["taskSelected"] = true,
                                ["route"] = 
                                {
                                    ["routeRelativeTOT"] = true,
                                    ["points"] = 
                                    {
                                        [1] = 
                                        {
                                            ["alt"] = 2000,
                                            ["action"] = "Turning Point",
                                            ["alt_type"] = "BARO",
                                            ["speed"] = 174.72222222222,
                                            ["task"] = 
                                            {
                                                ["id"] = "ComboTask",
                                                ["params"] = 
                                                {
                                                    ["tasks"] = 
                                                    {
                                                    }, -- end of ["tasks"]
                                                }, -- end of ["params"]
                                            }, -- end of ["task"]
                                            ["type"] = "Turning Point",
                                            ["ETA"] = 0,
                                            ["ETA_locked"] = true,
                                            ["y"] = 635253.46374956,
                                            ["x"] = -319161.86420692,
                                            ["name"] = "DictKey_WptName_70",
                                            ["formation_template"] = "",
                                            ["speed_locked"] = true,
                                        }, -- end of [1]
                                    }, -- end of ["points"]
                                }, -- end of ["route"]
                                ["groupId"] = 2,
                                ["hidden"] = false,
                                ["units"] = 
                                {
                                    [1] = 
                                    {
                                        ["alt"] = 2000,
                                        ["alt_type"] = "BARO",
                                        ["livery_id"] = "default",
                                        ["skill"] = input.skill ,
                                        ["speed"] = 174.72222222222,
                                        ["type"] = input.type ,
                                        ["unitId"] = 2,
                                        ["psi"] = 0,
                                        ["y"] = 635253.46374956,
                                        ["x"] = -319161.86420692,
                                        ["name"] = input.name ,
                                        ["payload"] = 
                                        {
                                            ["pylons"] = 
                                            {
                                            }, -- end of ["pylons"]
                                            ["fuel"] = 30000,
                                            ["flare"] = 60,
                                            ["chaff"] = 120,
                                            ["gun"] = 100,
                                        }, -- end of ["payload"]
                                        ["heading"] = 0,
                                        ["callsign"] = 
                                        {
                                            [1] = 1,
                                            [2] = 1,
                                            [3] = 1,
                                            ["name"] = "Texaco11",
                                        }, -- end of ["callsign"]
                                        ["onboard_num"] = "011",
                                    }, -- end of [1]
                                }, -- end of ["units"]
                                ["y"] = 635253.46374956,
                                ["x"] = -319161.86420692,
                                ["name"] = input.name ,
                                ["communication"] = true,
                                ["start_time"] = 0,
                                ["modulation"] = 0,
                                ["frequency"] = 251,
                            }
							
							
return mySpawn 
end

function doBuildStaticSpawn(input)  -- TOOLBOX FUNCTION
	-- if Debugging == true then printDebug ("EventHandler" , "Creating Static Object"   , 10 ) end	
    local myStatic = {}
	if input.heading == nil then myStatic.heading = 0 else  myStatic.heading = input.heading end
	if input.dead == nil then myStatic.dead = false else  myStatic.dead = input.dead end
	if input.category == nil then myStatic.category = "Planes" else  myStatic.category = input.category end
	if input.type == nil then myStatic.type = "A-10A" else  myStatic.type = input.type end
	if input.name == nil then myStatic.name = "Static " .. math.random( 0,100000) else  myStatic.name = "Static " .. input.name end
	if input.shape_name ~= nil then myStatic.shape_name = input.shape_name end
	if input.lenghtRope ~= nil then myStatic.lenghtRope = input.lenghtRope end
	if input.rate ~= nil then myStatic.rate = input.rate end
	
	-- CARGO
	if input.category == "Cargos" then
		myStatic.canCargo = true 
		if input.shape_name == nil then myStatic.shape_name = "ab-212_cargo" else myStatic.shape_name = input.shape_name end
		if input.type == nil then myStatic.type = "uh1h_cargo" else myStatic.type = input.type end
		if input.mass == nil then myStatic.mass = 1000 else myStatic.mass = input.mass end
	end 
	
	if input.position == nil then
		myStatic.y = 617813.60743464 
		myStatic.x = -355842.97690747 
	else
		myStatic.y = input.position.z
		myStatic.x = input.position.x
	end 

	if input.livery_id ~= nil then myStatic.livery_id = input.livery_id end				
	-- if Debugging == true then printDebug ("EventHandler" , "Finished creating Static Object "..  myStatic.name  , 10 ) end
	--deReference ( myStatic )
	return myStatic 	
end

function deReference ( myTable )

	local myTabs = { "\t" ,  "\t\t" ,  "\t\t\t" , "\t\t\t\t" ,  "\t\t\t\t\t" , "\t\t\t\t\t" , }
	local myTab = ""
	local myTabCount = 1
	local function getPairs ( myPairs )	
			local myRemKey = ""
			for tablekey,tablevalue in pairs(myPairs) do
				if (type(tablevalue) == "table") then
					myRemKey = tablekey
					if Debugging == true then printDebug("Spawning" ,   myTabs[myTabCount] .. tablekey .. " Table " , 10 ) end
					 getPairs ( tablevalue )
					 myTabCount = myTabCount + 1
				else
					if Debugging == true then printDebug("Spawning" ,    myTabs[myTabCount]  .. tablekey .. " = " ..  tostring(tablevalue)  , 10 ) end
				end 
			end
			if Debugging == true then printDebug("Spawning" ,  myTabs[myTabCount]  .. " end "  .. myRemKey , 10 ) end
			myTabCount = myTabCount - 1
	end
	
		for key,value in pairs(myTable) do 
		myTabCount = 1
			if (type(value) == "table") then
				if Debugging == true then printDebug("Spawning" ,  key .. " Table " , 10 ) end
				 getPairs ( value )
			else
				if Debugging == true then printDebug("Spawning" , key .. " = " ..  tostring(value)  , 10 ) end
			end
		

	end	
	
end
if Debugging == true then printDebug ("Files" ,"Toolbox File Has Loaded" , 10 ) end